/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmAComponent.java
 * version 3
 */
package TsmRTE.TsmComponent;

import TsmRTE.TsmSupervisor.*;

/**
 * Active Component
 */
public class TsmAComponent extends TsmComponent
{
  private TsmThread mThread;

  public TsmThread getThread()
  {
    return mThread;
  }

  public void setThread( TsmThread oThread )
  {
    this.mThread = oThread;
  }

  public TsmAComponent()
  {
    mThread = new TsmThread();
  }

  @Override 
  public boolean IsActive()
  {
    return true;
  }

  @Override 
  public String ThreadId()
  {
    return "," + mThread.mSequence;
  }

  @Override 
  public void TsmInitialise( Object oObject )
  {
    mThread.Prepare( this.TsmName );
  }

  @Override 
  public void TsmConnectAll( Object oObject )
  {
    super.TsmConnectAll( mThread.getIntQueue() );
  }

  @Override 
  public void TsmPrepare( Object oObject )
  {
    mThread.Run();
  }

  @Override 
  public void TsmHalt( Object oObject )
  {
    mThread.Halt();
  }

  @Override 
  public void TsmCease( Object oObject )
  {
    mThread.Cease();
  }
}
