/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmClass.java
 * version 4
 */
package TsmRTE.TsmComponent;

import java.util.Vector;
import TsmRTE.TsmGen.*;
import TsmRTE.TsmState.*;

public class TsmClass extends TsmBase
{
  public final int  NativePortId = -1;
  public TsmFsm []  oFsms;
  public boolean    IsMock = false;
  public String     SnapState = null;
  public String     SnapCall = "";
  public int        SeqId;

  public void SetProxyUser( TsmProxyUser oProxyUser )
  {
    // ignore
  }

  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    throw new TsmException(
      String.format( "9500: GetProvidedInterface should be overriden for '%s' @ '%s", sPortName, this ) );
  }

  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    throw new TsmException(
      String.format( "9510: SetRequiredInterface should be overriden for '%s' @ '%s", sPortName, this ) );
  }

  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
  }

  public void ExecuteNative( int iCmd )
  {
    TsmTrigger lTrigger = new TsmTrigger( iCmd );
    lTrigger.PortId = NativePortId;
    ExecuteTrigger( lTrigger );
  }

  public void TsmInitialise( Object oObject )
  {
  }

  public void TsmConnect( Object oObject )
  {
  }

  public void TsmPrepare( Object oObject )
  {
  }

  public void TsmRun( Object oObject )
  {
  }

  public void TsmHalt( Object oObject )
  {
  }

  public void TsmCease( Object oObject )
  {
  }

  public void TsmDisconnect( Object oObject )
  {
  }

  public void TsmTerminate( Object oObject )
  {
  }

  public void TsmMention( Object oObject )
  {
    @SuppressWarnings("unchecked")
    Vector<TsmClass> ClassList = (Vector<TsmClass>) oObject;

    ClassList.add( this );
    this.SeqId = Tsm.SeqClass( this.FullName() );
  }

  public void TsmReset1()
  {
    for ( int i=0; i<oFsms.length; i++ )
    {
      oFsms[i].TsmReset1( new TsmHandler( this ) );
    }
    SnapState = null; // Invalidate SnapState
  }

  public void TsmReset2()
  {
    for ( int i=0; i<oFsms.length; i++ )
    {
      oFsms[i].TsmReset2( new TsmHandler( this ) );
    }
  }

  public String TsmSnap()
  {
    if ( null == SnapState )
    {
      StringBuilder sb = new StringBuilder();
      sb.append( "{" + this.TsmName );
      for ( int i=0; i<oFsms.length; i++ )
      {
        sb.append( "/" + oFsms[i].TsmSnap() );
      }
      SnapState = sb.toString() + "}";
    }
    return SnapState + SnapCall;
  }

  public void TsmCheckVisit()
  {
    for ( int i=0; i<oFsms.length; i++ )
    {
      oFsms[i].TsmCheckVisit();
    }
  }
}
