/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmComponent.java
 * version 2
 */
package TsmRTE.TsmComponent;

import TsmRTE.TsmGen.Tsm;

public class TsmComponent extends TsmClass
{
  public int             mNrClasses = 0;
  public TsmClass []     mClasses = null;
  public int             mNrComponents = 0;
  public TsmComponent [] mComponents = null;

  protected void DoAssembly( TsmClass Client, String sRequired, TsmClass Server, String sProvided )
  {
    TsmInterfacePort lPort;

    lPort = Server.GetProvidedInterface( sProvided );
    Client.SetRequiredInterface( sRequired, lPort );
  }

  public boolean IsActive()
  {
    return false;
  }

  public String ThreadId()
  {
    return "";
  }

  public void TsmInitialiseAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmInitialise( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmInitialiseAll( oObject );
    }

    this.TsmInitialise( oObject );
  }

  public void TsmConnectAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmConnect( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmConnectAll( oObject );
    }

    this.TsmConnect( oObject );
  }

  public void TsmPrepareAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmPrepare( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmPrepareAll( oObject );
    }

    this.TsmPrepare( oObject );
  }

  public void TsmRunAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmRun( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmRunAll( oObject );
    }

    this.TsmRun( oObject );
  }

  public void TsmHaltAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmHalt( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmHaltAll( oObject );
    }

    this.TsmHalt( oObject );
  }

  public void TsmCeaseAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmCease( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmCeaseAll( oObject );
    }

    this.TsmCease( oObject );
  }

  public void TsmDisconnectAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmDisconnect( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmDisconnectAll( oObject );
    }

    this.TsmDisconnect( oObject );
  }

  public void TsmTerminateAll( Object oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmTerminate( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmTerminateAll( oObject );
    }

    this.TsmTerminate( oObject );
  }

  public void TsmMentionAll( Object oObject )
  {
    int i;

    Tsm.Seq( "Comp," + this.FullName() + this.ThreadId() );
    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmMention( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmMentionAll( oObject );
    }
  }

  public void TsmCheckVisitAll()
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i].TsmCheckVisit();
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i].TsmCheckVisitAll();
    }
  }
}
