/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmTrigger.java
 * version 4
 */
package TsmRTE.TsmGen;

import TsmRTE.TsmSupervisor.*;

/**
 * Trigger message
 */
public class TsmTrigger
{
  public int          PortId;
  public int          Command;
  public TsmRvState   RvState = TsmRvState.IDLE;
  public boolean      IsForeign = false;
  
  public TsmTrigger( int iCmd )
  {
    this.Command = iCmd;
  }

  public void Ready()
  {
    switch ( RvState )
    {
    case IDLE:
      TsmRecorder.SyncReturnError( "**** RENDEZ-VOUS IDLE " );
      break;

    case WAIT:
      RvState = TsmRvState.READY;
      break;

    case READY:
      TsmRecorder.SyncReturnError( "**** RENDEZ-VOUS READY " );
      break;
    }
  }

  public String Snap()
  {
    return " " + PortId + "." + Command;
  }
}
