/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmHandlerAction.java
 * version 2
 */
package TsmRTE.TsmState;

public class TsmHandlerAction
{
  public static final int NONE          = 0;
  public static final int NOK           = 1;
  public static final int FINAL         = 2;
  public static final int GUARD         = 4;
  public static final int OK            = 8;
  public static final int TRANSITION    = 16;
  public static final int ENTER         = 32;
  public static final int INITIAL       = 64;
  public static final int ENTRYPOINT    = 128;
  public static final int QUIT          = 256;
  public static final int EXITPOINT     = 512;
  public static final int TACTRANSITION = 1024;

  public static boolean hasTransition( int action )
  {
    int v = TsmHandlerAction.TRANSITION
          | TsmHandlerAction.TACTRANSITION;
    return (action & v) != 0;
  }

  public static boolean isFinalNok( int action )
  {
    int v = TsmHandlerAction.FINAL
          | TsmHandlerAction.NOK;    
    return action == v;
  }
}
