/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmSubFsm.java
 * version 2
 */
package TsmRTE.TsmState;

import TsmRTE.TsmGen.TsmBase;

public class TsmSubFsm extends TsmState
{
  protected TsmFsm oFsm;

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    int ProspectSelf = GetProspect( oHandler.Trigger.PortId, oHandler.Trigger.Command );
    oHandler.Prospect |= ProspectSelf;

    oFsm.ExecuteTrigger( oHandler );
    oFsm.ExecuteHandler( oHandler );

    if ( oHandler.Action == TsmHandlerAction.FINAL )
    {
      ExecuteTriggerless( oHandler );
    }
    else
    if ( oHandler.Action == TsmHandlerAction.QUIT )
    {
      ExecuteTriggerless( oHandler );
    }
    else
    if ( ! oHandler.bTaken )
    {
      // Process the trigger itself, if transition available.
      ExecuteTriggerSubFsm( oHandler );
    }
  }

  public void ExecuteTriggerSubFsm( TsmHandler oHandler )
  {
    // Override for all the SubFsm triggers
    oHandler.Action = TsmHandlerAction.NOK;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );

    if ( oHandler.Action == TsmHandlerAction.FINAL )
    {
      ExecuteTriggerless( oHandler );
    }

    if ( oHandler.Action == TsmHandlerAction.QUIT )
    {
      ExecuteTriggerless( oHandler );
    }
  }

  public void AtMyExit( TsmHandler oHandler )
  {
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    oFsm.AtExit( oHandler );
    this.AtMyExit( oHandler );
  }

  public TsmFsm SwapFsms( TsmFsm Target2Source )
  {
    TsmFsm h = oFsm;
    TsmBase hp = oFsm.TsmParent;
    oFsm = Target2Source;
    h.TsmParent = Target2Source.TsmParent;
    oFsm.TsmParent = hp;
    return h;
  }

  @Override
  public String TsmSnap()
  {
    return this.TsmName + "+" + oFsm.TsmSnap();
  }

  @Override
  public void TsmCheckVisit()
  {
    oFsm.TsmCheckVisit();
  }
}
