/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmCbWorker.java
 * version 5
 */
package TsmRTE.TsmSupervisor;

import TsmRTE.TsmGen.*;

public class TsmCbWorker extends TsmWorker
{
  public TsmCbWorker( TsmCbThread oTsmThread )
  {
    super( oTsmThread );
  }

  @Override
  public void run()
  {
    TsmEnvelope lEnvelope;

    while ( ! mbHalt )
    {
      // Wait for message controlled by Supervisor
      TsmSupervisor.SetState( TsmThreadState.WAITING_MSG );

      lEnvelope = oTsmThread.mExternalQueue.Dequeue();
      if ( null != lEnvelope )
      {
        if ( !lEnvelope.getTrigger().IsForeign )
        {
          Tsm.Seq( "F" );
        }
        try
        {
          oTsmThread.CbHandle( lEnvelope );
        }
        catch( TsmRzVousException e )
        { /*
           * Escape from processing.
           */
          TsmSupervisor.SetState( TsmThreadState.INTERRUPTED );
          Tsm.Lgl( 5, "@q : escape" );
        }
        catch ( Exception e )
        {
          Tsm.ShowException( "@q", e );
        }
      }
      else
      {
        lEnvelope = oTsmThread.mInternalQueue.Dequeue();
        if ( null != lEnvelope )
        {
          if ( !lEnvelope.getTrigger().IsForeign )
          {
            Tsm.Seq( "J" );
          }
          try
          {
            oTsmThread.Handle( lEnvelope );
          }
          catch( TsmRzVousException e )
          { /*
             * Escape from processing.
             */
            TsmSupervisor.SetState( TsmThreadState.INTERRUPTED );
            Tsm.Lgl( 5, "@s : escape" );
          }
          catch ( Exception e )
          {
            Tsm.ShowException( "@s", e );
          }
        }
      }
    }
  }  
}
