/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmQueue.java
 * version 4
 */
package TsmRTE.TsmSupervisor;

import java.util.Vector;
import TsmRTE.TsmGen.TsmEnvelope;

@SuppressWarnings("serial")
public class TsmQueue extends Vector<TsmEnvelope>
{
  private int mMaxQueueSize = 0;
  private int mSeqId;

  public int getMaxQueueSize()
  {
    return mMaxQueueSize;
  }

  public int getSeqId()
  {
    return mSeqId;
  }

  public void setSeqId( int SeqId )
  {
    mSeqId = SeqId;
  }

  public synchronized void Put( TsmEnvelope oEnvelope )
  {
    if ( ! TsmSupervisor.QueueOverflow( this.size() ) )
    {
      this.addElement( oEnvelope );
      mMaxQueueSize = Math.max( mMaxQueueSize, this.size() );
    }
  }

  public synchronized TsmEnvelope Dequeue()
  {
    TsmEnvelope lEnvelope = null;

    if ( ! this.isEmpty() )
    {
      lEnvelope = this.remove(0);
    }
    return lEnvelope;
  }

  public synchronized String Snap()
  {
    StringBuilder sb = new StringBuilder();

    for ( TsmEnvelope tEnv : this )
    {
      sb.append( tEnv.Snap() + "," );
    }
    return sb.toString();
  }
}