/*
 * TismTool © Tis Veugen, 2010-2012
 * Application, Simulation, Verification
 *
 * TsmRzVousSem.java
 * version 1
 */
package TsmRTE.TsmSupervisor;

import java.util.concurrent.Semaphore;

public class TsmRzVousSem
{
  private Semaphore mSem;
  private boolean   mbRendezVous = false;

  public TsmRzVousSem()
  {
    mSem = new Semaphore( 0 );
  }

  public void WaitOne()
  {
    //Tsm.Assert( ! mbRendezVous );
    mbRendezVous = true;
    try
    {
      mSem.acquire();
    }
    catch ( InterruptedException e )
    {
      throw new TsmRzVousException();
    }
    mbRendezVous = false;
  }

  public void Release()
  {
    //Tsm.Assert( mbRendezVous );
    mSem.release();
  }

  public void Reset()
  {
    if ( mbRendezVous )
    {
      mbRendezVous = false;
      // Easiest way to reset the semaphore.
      mSem = new Semaphore( 0 );
    }
  }
}
