/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmWorker.java
 * version 5
 */
package TsmRTE.TsmSupervisor;

import TsmRTE.TsmGen.*;

public class TsmWorker extends Thread
{
  protected TsmThread oTsmThread;
  protected boolean   mbHalt = false;

  public TsmWorker( TsmThread oTsmThread )
  {
    this.oTsmThread = oTsmThread;
  }

  public void MyHalt()
  {
    mbHalt = true;
  }

  public void run()
  {
    TsmEnvelope lEnvelope;
    TsmRvState  lRvState = TsmRvState.IDLE;

    while ( ! mbHalt )
    {
      // Wait for message controlled by Supervisor
      TsmSupervisor.SetState( TsmThreadState.WAITING_MSG );

      lEnvelope = oTsmThread.mInternalQueue.Dequeue();
      if ( null != lEnvelope )
      {
        lEnvelope.getTrigger().RvState = lRvState;

        if ( !lEnvelope.getTrigger().IsForeign )
        {
          Tsm.Seq( "I," + oTsmThread.mSequence );
        }
        try
        {
          lRvState = oTsmThread.Handle( lEnvelope );
        }
        catch( TsmRzVousException e )
        { /*
           * Escape from processing.
           */
          lRvState = TsmRvState.IDLE;
          TsmSupervisor.SetState( TsmThreadState.INTERRUPTED );
        }
        catch ( Exception e )
        {
          Tsm.ShowException( "@S", e );
        }
      }
      else
      {
        lEnvelope = oTsmThread.mExternalQueue.Dequeue();
        if ( null != lEnvelope )
        {
          if ( lEnvelope.getTrigger().RvState == TsmRvState.WAIT )
          {
            lRvState = TsmRvState.WAIT;
          }
          else
          {
            lEnvelope.getTrigger().RvState = lRvState;
          }

          if ( !lEnvelope.getTrigger().IsForeign )
          {
            Tsm.Seq( "E," + oTsmThread.mSequence );
          }
          try
          {
            lRvState = oTsmThread.Handle( lEnvelope );
          }
          catch( TsmRzVousException e )
          { /*
             * Escape from processing.
             */
            lRvState = TsmRvState.IDLE;
            TsmSupervisor.SetState( TsmThreadState.INTERRUPTED );
          }
          catch ( Exception e )
          {
            Tsm.ShowException( "@Q", e );
          }
        }
      }
    }
  }
}
