/*
 * File: TsmSystem.java
 * Date: 11 aug 2012
 * Time: 22:30:17
 * Generated by TismTool version 0.9
 */
package MediaPlayer;

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     20 ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
 *     21 ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
 *     84 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
 *     85 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
 *     86 ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
 *    461 ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
 *    462 ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
 *    527 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
 *    583 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
 *    660 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
 *    716 ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
 *    803 ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
 *    841 ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
 *    888 ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
 *    927 ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
 *    970 ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > Port )
 *   1033 ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
 *   1082 ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
 * Triggers:
 *      1 void IReaderClient___CbOpened()
 *      2 void IReaderClient___CbStopped()
 *      3 void IReaderClient___CbDone()
 *      4 void IReaderClient___CbError( int Sector )
 *      5 void IReaderClient___CbClosed()
 *      6 void IReaderClient___CbReading()
 *      7 void IReaderClient___CbFilled()
 *      8 eRV IProxyReaderServer___Px_Open( int FileHandle )
 *      9 void IProxyReaderServer___Px_Close()
 *     10 void IProxyReaderServer___Px_Stop()
 *     11 void IProxyReaderServer___Px_Clear()
 *     12 eRV IProxyReaderServer___Px_Read( tChunk Chunk )
 *     13 void IProxyReaderServer___Px_IsFilled()
 *     14 eRV IPlayerServer___Start( String TitleId, tTime AtTime )
 *     15 eRV IPlayerServer___Pause()
 *     16 eRV IPlayerServer___Continue()
 *     17 void IPlayerServer___Stop()
 *     18 void IProxyReaderClient___Px_CbOpened()
 *     19 void IProxyReaderClient___Px_CbStopped()
 *     20 void IProxyReaderClient___Px_CbDone()
 *     21 void IProxyReaderClient___Px_CbError( int BadSector )
 *     22 void IProxyReaderClient___Px_CbClosed()
 *     23 void IProxyReaderClient___Px_CbReading()
 *     24 void IProxyReaderClient___Px_CbFilled()
 *     25 void IProxyDisplayClient___Px_CbContinued()
 *     26 void IProxyDisplayClient___Px_CbFinished()
 *     27 void IProxyDisplayClient___Px_CbPaused()
 *     28 void IProxyDisplayClient___Px_CbPrepared()
 *     29 void IProxyDisplayClient___Px_CbStarted()
 *     30 void IProxyDisplayClient___Px_CbStopped()
 *     31 void IProxyDisplayClient___Px_CbSynclost( tTime BadTime )
 *     32 void IProxyDisplayServer___Px_Continue()
 *     33 eRV IProxyDisplayServer___Px_Pause()
 *     34 void IProxyDisplayServer___Px_Prepare()
 *     35 void IProxyDisplayServer___Px_Start()
 *     36 void IProxyDisplayServer___Px_Stop()
 *     37 void IDisplayClient___CbPrepared()
 *     38 void IDisplayClient___CbStarted()
 *     39 void IDisplayClient___CbPaused()
 *     40 void IDisplayClient___CbContinued()
 *     41 void IDisplayClient___CbFinished()
 *     42 void IDisplayClient___CbSynclost( tTime BadTime )
 *     43 void IDisplayClient___CbStopped()
 *     44 void IPlayerClient___CbStarted()
 *     45 void IPlayerClient___CbPaused()
 *     46 void IPlayerClient___CbContinued()
 *     47 void IPlayerClient___CbStopped()
 *     48 void IPlayerClient___CbFinish()
 *     49 void IPlayerClient___CbError()
 *     50 void IReaderServer___Close()
 *     51 void IReaderServer___Stop()
 *     52 eRV IReaderServer___Open( int FileHandle )
 *     53 eRV IReaderServer___Read( tChunk Chunk )
 *     54 void IReaderServer___Clear()
 *     55 int ITitlebaseServer___OpenTitle( String TitleId )
 *     56 void ITitlebaseServer___CloseTitle()
 *     57 eRV ITitlebaseServer___SetTime( tTime AtTime )
 *     58 tChunk ITitlebaseServer___GetChunk()
 *     59 void ITitlebaseServer___ReportReadError( int BadSector )
 *     60 void ITitlebaseServer___ReportSynclost( tTime BadTime )
 *     61 eRV ITitlebaseServer___GetResult()
 *     62 void IDisplayServer___Prepare()
 *     63 void IDisplayServer___Start()
 *     64 eRV IDisplayServer___Pause()
 *     65 void IDisplayServer___Continue()
 *     66 void IDisplayServer___Stop()
 * Natives:
 *    542 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Paused )
 *        Px_CbPaused();
 *    544 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
 *        Px_CbContinued();
 *    561 ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Ready )
 *        Px_CbPrepared();
 *    568 ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Paused )
 *        Px_CbPaused();
 *    570 ( ProxyDisplayServerPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
 *        Px_CbStarted();
 *    572 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
 *        Px_CbFinished();
 *    573 ( ProxyDisplayServerPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    574 ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    575 ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
 *        Px_CbSynclost( BadTime );
 *    581 ( ProxyDisplayServerPsm >> Stopping ) ->
 *        ( ProxyDisplayServerPsm >> CompoundState )
 *        Px_CbStopped();
 *   -607 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -609 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -612 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -614 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -616 ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -635 ( ProxyDisplayClientPsm >> CompoundState >> Idle ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -637 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -639 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -641 ( ProxyDisplayClientPsm >> CompoundState >> Starting ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Start();
 *   -642 ( ProxyDisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -644 ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -648 ( ProxyDisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Pause();
 *   -649 ( ProxyDisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        Px_Continue();
 *   -650 ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) ->
 *        ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
 *        Px_Prepare();
 *   -654 ( ProxyDisplayClientPsm >> CompoundState ) ->
 *        ( ProxyDisplayClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -656 ( ProxyDisplayClientPsm >> Stopping ) ->
 *        ( ProxyDisplayClientPsm >> ChoiceState )
 *        Px_Stop();
 *    684 ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
 *        Px_CbFilled();
 *    685 ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbDone();
 *    693 ( ProxyReaderServerPsm >> CompoundState >> Reading ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Error )
 *        Px_CbError( BadSector );
 *    704 ( ProxyReaderServerPsm >> Opening ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbOpened();
 *    707 ( ProxyReaderServerPsm >> Stopping ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Open )
 *        Px_CbStopped();
 *    709 ( ProxyReaderServerPsm >> Seeking ) ->
 *        ( ProxyReaderServerPsm >> CompoundState >> Reading )
 *        Px_CbReading();
 *    713 ( ProxyReaderServerPsm >> Closing ) ->
 *        ( ProxyReaderServerPsm >> Idle )
 *        Px_CbClosed();
 *   -746 ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        RV=Px_Read( Chunk );
 *   -748 ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        Px_IsFilled();
 *   -750 ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
 *        Px_IsFilled();
 *   -755 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *   -756 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -757 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> Open )
 *        Px_Clear();
 *   -758 ( ProxyReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Px_Read( Chunk );
 *   -770 ( ProxyReaderClientPsm >> Idle ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -773 ( ProxyReaderClientPsm >> Closing ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -774 ( ProxyReaderClientPsm >> Opening ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *   -776 ( ProxyReaderClientPsm >> CompoundState ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -778 ( ProxyReaderClientPsm >> Stopping ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -779 ( ProxyReaderClientPsm >> Opening ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Close();
 *   -783 ( ProxyReaderClientPsm >> Seeking ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        Px_Stop();
 *   -788 ( ProxyReaderClientPsm >> Seeking ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Read( Chunk );
 *   -790 ( ProxyReaderClientPsm >> Idle ) ->
 *        ( ProxyReaderClientPsm >> ChoiceState )
 *        RV=Px_Open( FileHandle );
 *    817 ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Paused )
 *        CbPaused();
 *    819 ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
 *        CbContinued();
 *    821 ( PlayerServerPsm >> Active >> Running >> Busy ) ->
 *        ( PlayerServerPsm >> Active >> Finishing )
 *        CbFinish();
 *    828 ( PlayerServerPsm >> Active >> Starting ) ->
 *        ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
 *        CbStarted();
 *    829 ( PlayerServerPsm >> Active >> Running ) ->
 *        ( PlayerServerPsm >> Active >> Error )
 *        CbError();
 *    830 ( PlayerServerPsm >> Active >> Starting ) ->
 *        ( PlayerServerPsm >> Active >> Error )
 *        CbError();
 *    837 ( PlayerServerPsm >> Stopping ) ->
 *        ( PlayerServerPsm >> Idle )
 *        CbStopped();
 *   -858 ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) ->
 *        ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
 *        RV=Pause();
 *   -866 ( PlayerClientPsm >> Active >> Running >> Paused ) ->
 *        ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
 *        RV=Continue();
 *   -881 ( PlayerClientPsm >> Idle ) ->
 *        ( PlayerClientPsm >> ChoiceState )
 *        RV=Start(TitleId,AtTime);
 *   -882 ( PlayerClientPsm >> Active ) ->
 *        ( PlayerClientPsm >> Stopping )
 *        Stop();
 *    901 ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) ->
 *        ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
 *        CbFilled();
 *    906 ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbDone();
 *    907 ( ReaderServerPsm >> CompoundState >> Reading ) ->
 *        ( ReaderServerPsm >> CompoundState >> Error )
 *        CbError( Sector );
 *    917 ( ReaderServerPsm >> Opening ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbOpened();
 *    918 ( ReaderServerPsm >> Seeking ) ->
 *        ( ReaderServerPsm >> CompoundState >> Reading )
 *        CbReading();
 *    919 ( ReaderServerPsm >> Stopping ) ->
 *        ( ReaderServerPsm >> CompoundState >> Open )
 *        CbStopped();
 *    920 ( ReaderServerPsm >> Closing ) ->
 *        ( ReaderServerPsm >> Idle )
 *        CbClosed();
 *   -944 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> CompoundState >> Open )
 *        Clear();
 *   -945 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> Closing )
 *        Close();
 *   -948 ( ReaderClientPsm >> CompoundState >> Open ) ->
 *        ( ReaderClientPsm >> CompoundState >> ChoiceState )
 *        RV=Read( Chunk );
 *   -958 ( ReaderClientPsm >> CompoundState ) ->
 *        ( ReaderClientPsm >> Stopping )
 *        Stop();
 *   -961 ( ReaderClientPsm >> Idle ) ->
 *        ( ReaderClientPsm >> ChoiceState )
 *        RV=Open( FileHandle );
 *  -1015 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> Play )
 *        ReportReadError( BadSector );
 *  -1016 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        Chunk=GetChunk();
 *  -1017 ( TbClientPsm >> CompoundState ) ->
 *        ( TbClientPsm >> Idle )
 *        CloseTitle();
 *  -1018 ( TbClientPsm >> CompoundState >> Play ) ->
 *        ( TbClientPsm >> CompoundState >> Play )
 *        ReportSynclost( BadTime );
 *  -1019 ( TbClientPsm >> CompoundState >> Ready ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        RV=SetTime( AtTime );
 *  -1022 ( TbClientPsm >> CompoundState >> End ) ->
 *        ( TbClientPsm >> CompoundState >> ChoiceState )
 *        RV=GetResult();
 *  -1028 ( TbClientPsm >> Idle ) ->
 *        ( TbClientPsm >> ChoiceState )
 *        FileHandle=OpenTitle(TitleId);
 *  -1046 ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) ->
 *        ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
 *        RV=Pause();
 *  -1060 ( DisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( DisplayClientPsm >> CompoundState >> Starting )
 *        Start();
 *  -1061 ( DisplayClientPsm >> CompoundState >> Ready ) ->
 *        ( DisplayClientPsm >> CompoundState >> StartPausing )
 *        RV=Pause();#TSM_ASSERT(RV==eRV.OK);
 *  -1063 ( DisplayClientPsm >> CompoundState >> Idle ) ->
 *        ( DisplayClientPsm >> CompoundState >> Preparing )
 *        Prepare();
 *  -1064 ( DisplayClientPsm >> CompoundState >> Paused ) ->
 *        ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
 *        Continue();
 *  -1073 ( DisplayClientPsm >> CompoundState ) ->
 *        ( DisplayClientPsm >> Stopping )
 *        Stop();
 *   1095 ( DisplayServerPsm >> Active >> Busy >> Pausing ) ->
 *        ( DisplayServerPsm >> Active >> Paused )
 *        CbPaused();
 *   1096 ( DisplayServerPsm >> Active >> Busy >> Continuing ) ->
 *        ( DisplayServerPsm >> Active >> Busy >> Play )
 *        CbContinued();
 *   1108 ( DisplayServerPsm >> Active >> Preparing ) ->
 *        ( DisplayServerPsm >> Active >> Ready )
 *        CbPrepared();
 *   1110 ( DisplayServerPsm >> Active >> Starting ) ->
 *        ( DisplayServerPsm >> Active >> Busy >> Play )
 *        CbStarted();
 *   1111 ( DisplayServerPsm >> Active >> Starting ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *   1113 ( DisplayServerPsm >> Active >> StartPausing ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *   1114 ( DisplayServerPsm >> Active >> StartPausing ) ->
 *        ( DisplayServerPsm >> Active >> Paused )
 *        CbPaused();
 *   1117 ( DisplayServerPsm >> Active >> Busy ) ->
 *        ( DisplayServerPsm >> Active >> Synclost )
 *        CbSynclost( BadTime );
 *   1118 ( DisplayServerPsm >> Active >> Busy ) ->
 *        ( DisplayServerPsm >> Active >> Finishing )
 *        CbFinished();
 *   1121 ( DisplayServerPsm >> Stopping ) ->
 *        ( DisplayServerPsm >> Active )
 *        CbStopped();
 */

import TsmRTE.TsmGen.*;
import TsmRTE.TsmComponent.*;
import TsmRTE.TsmState.*;
import TsmRTE.TsmSupervisor.*;

class tChunk
{
  public int BeginSector;
  public int NofSectors;
}

class tTime
{
  public int Hours;
  public int Minutes;
  public int Seconds;
}

enum eRV
{
  OK,
  OK_RACE,
  INVALID_PARAM,
  NO_RESOURCE,
  FAILURE
}

 // ( Xmi > Data > Repository > Display > Display )
class Com_0003_0004 extends TsmPComponent
{
  public Com_0003_0004( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Display )
 ********************************************************************/

 // ( Xmi > Data > Repository > Display )
class Pac_0002_0003 extends TsmPackage
{
  public Pac_0002_0003( TsmBase oParent )
  {
    TsmName = "Display";
    TsmParent = oParent;
  }
}

 // ( Xmi > Data > Repository > Reader > Reader )
class Com_0005_0006 extends TsmPComponent
{
  public Com_0005_0006( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Reader )
 ********************************************************************/

 // ( Xmi > Data > Repository > Reader )
class Pac_0002_0005 extends TsmPackage
{
  public Pac_0002_0005( TsmBase oParent )
  {
    TsmName = "Reader";
    TsmParent = oParent;
  }
}

 // ( Xmi > Data > Repository > User > User )
class Com_0007_0008 extends TsmPComponent
{
  public Com_0007_0008( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > User )
 ********************************************************************/

 // ( Xmi > Data > Repository > User )
class Pac_0002_0007 extends TsmPackage
{
  public Pac_0002_0007( TsmBase oParent )
  {
    TsmName = "User";
    TsmParent = oParent;
  }
}

 // ( Xmi > Data > Repository > Titlebase > Titlebase )
class Com_0009_0010 extends TsmPComponent
{
  public Com_0009_0010( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Titlebase )
 ********************************************************************/

 // ( Xmi > Data > Repository > Titlebase )
class Pac_0002_0009 extends TsmPackage
{
  public Pac_0002_0009( TsmBase oParent )
  {
    TsmName = "Titlebase";
    TsmParent = oParent;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> InitialState )
class Ini_0088_0089 extends TsmPseudo
{
  public Ini_0088_0089( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 149, "( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 149; // TRLS ( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 149: // UP: ( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> InitialState )
class Ini_0154_0155 extends TsmPseudo
{
  public Ini_0154_0155( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 168, "( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 168; // TRLS ( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 168: // UP: ( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> FinalState )
class Fin_0154_0156 extends TsmFinal
{
  public Fin_0154_0156( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0154_0169( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 169:
      Tra_0154_0169( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> InitialState )
class Ini_0432_0433 extends TsmPseudo
{
  public Ini_0432_0433( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 457, "( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 457; // TRLS ( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 457: // UP: ( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> FinalState )
class Fin_0432_0434 extends TsmFinal
{
  public Fin_0432_0434( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0447_0456( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 456:
      Tra_0447_0456( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> InitialState )
class Ini_0436_0437 extends TsmPseudo
{
  public Ini_0436_0437( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 445, "( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 445; // TRLS ( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 445: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
class Cho_0436_0438 extends TsmPseudo
{
  public Cho_0436_0438( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 444, "( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 442, "( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 444; // TRLS ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 442; // TRLS ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0436_0441( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 444: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
      bHigher = true;
      break;
    case 442: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait )
      bHigher = true;
      break;
    case 441:
      Tra_0436_0441( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Base )
class Lea_0436_0439 extends TsmLeaf
{
  public Lea_0436_0439( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 441, "( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )" );
  }

  public void Tra_0436_0445( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 441; // TRLS ( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0436_0443( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1043( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 445:
      Tra_0436_0445( oHandler );
      break;
    case 441: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
      bHigher = true;
      break;
    case 443:
      Tra_0436_0443( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Wait )
class Lea_0436_0440 extends TsmLeaf
{
  public Lea_0436_0440( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 443, "( BackendFsm > Tac_Stop >> CS_Display >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base ) : ??" );
  }

  public void Tra_0436_0442( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 443; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 442:
      Tra_0436_0442( oHandler );
      break;
    case 443: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >)
class Reg_0435_0436 extends TsmRegion
{
  private Ini_0436_0437 oIni_0436_0437; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> InitialState )
  private Cho_0436_0438 oCho_0436_0438; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
  private Lea_0436_0439 oLea_0436_0439; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Base )
  private Lea_0436_0440 oLea_0436_0440; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Wait )

  public Reg_0435_0436( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0436_0437 = new Ini_0436_0437( this );
    oCho_0436_0438 = new Cho_0436_0438( this );
    oLea_0436_0439 = new Lea_0436_0439( this );
    oLea_0436_0440 = new Lea_0436_0440( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0436_0437;
    mStates[ 1 ] = oCho_0436_0438;
    mStates[ 2 ] = oLea_0436_0439;
    mStates[ 3 ] = oLea_0436_0440;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0436_0437.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Display >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
  public void Tra_0436_0445( TsmHandler oHandler )
  {
    mCurrentState = oLea_0436_0439; // At: ( BackendFsm > Tac_Stop >> CS_Display >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Display >> Wait )
  public void Tra_0436_0442( TsmHandler oHandler )
  {
    mCurrentState = oLea_0436_0440; // At: ( BackendFsm > Tac_Stop >> CS_Display >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Display >> Base ) => ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
  public void Tra_0436_0441( TsmHandler oHandler )
  {
    mCurrentState = oCho_0436_0438; // At: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Display >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Display >> Base )
  public void Tra_0436_0443( TsmHandler oHandler )
  {
    mCurrentState = oLea_0436_0439; // At: ( BackendFsm > Tac_Stop >> CS_Display >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 445:
      Tra_0436_0445( oHandler );
      break;
    case 444: // Up: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
      mCurrentState = null;
      bHigher = true;
      break;
    case 442:
      Tra_0436_0442( oHandler );
      break;
    case 441:
      Tra_0436_0441( oHandler );
      break;
    case 443:
      Tra_0436_0443( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display )
class Com_0432_0435 extends TsmCompound
{
  private Reg_0435_0436 oReg_0435_0436; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >)

  public Com_0432_0435( TsmBase oParent )
  {
    TsmName = "CS_Display";
    TsmParent = oParent;
    oReg_0435_0436 = new Reg_0435_0436( this );
    mRegions.add( oReg_0435_0436 );
    mNrTransitions = 0;
  }

  public void Tra_0432_0457( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 457:
      Tra_0432_0457( oHandler );
      break;
    case 444: // UP: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> InitialState )
class Ini_0447_0448 extends TsmPseudo
{
  public Ini_0447_0448( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 455, "( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 455; // TRLS ( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 455: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
class Cho_0447_0449 extends TsmPseudo
{
  public Cho_0447_0449( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 456, "( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 454, "( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 456; // TRLS ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 454; // TRLS ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0447_0452( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 456: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
      bHigher = true;
      break;
    case 454: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait )
      bHigher = true;
      break;
    case 452:
      Tra_0447_0452( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Base )
class Lea_0447_0450 extends TsmLeaf
{
  public Lea_0447_0450( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 452, "( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )" );
  }

  public void Tra_0447_0455( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 452; // TRLS ( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0447_0453( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1044( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 455:
      Tra_0447_0455( oHandler );
      break;
    case 452: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
      bHigher = true;
      break;
    case 453:
      Tra_0447_0453( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Wait )
class Lea_0447_0451 extends TsmLeaf
{
  public Lea_0447_0451( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 453, "( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base ) : ??" );
  }

  public void Tra_0447_0454( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 453; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 454:
      Tra_0447_0454( oHandler );
      break;
    case 453: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >)
class Reg_0446_0447 extends TsmRegion
{
  private Ini_0447_0448 oIni_0447_0448; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> InitialState )
  private Cho_0447_0449 oCho_0447_0449; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
  private Lea_0447_0450 oLea_0447_0450; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Base )
  private Lea_0447_0451 oLea_0447_0451; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Wait )

  public Reg_0446_0447( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0447_0448 = new Ini_0447_0448( this );
    oCho_0447_0449 = new Cho_0447_0449( this );
    oLea_0447_0450 = new Lea_0447_0450( this );
    oLea_0447_0451 = new Lea_0447_0451( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0447_0448;
    mStates[ 1 ] = oCho_0447_0449;
    mStates[ 2 ] = oLea_0447_0450;
    mStates[ 3 ] = oLea_0447_0451;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0447_0448.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Reader >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
  public void Tra_0447_0455( TsmHandler oHandler )
  {
    mCurrentState = oLea_0447_0450; // At: ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Wait )
  public void Tra_0447_0454( TsmHandler oHandler )
  {
    mCurrentState = oLea_0447_0451; // At: ( BackendFsm > Tac_Stop >> CS_Reader >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Reader >> Base ) => ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
  public void Tra_0447_0452( TsmHandler oHandler )
  {
    mCurrentState = oCho_0447_0449; // At: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Reader >> Wait ) => ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
  public void Tra_0447_0453( TsmHandler oHandler )
  {
    mCurrentState = oLea_0447_0450; // At: ( BackendFsm > Tac_Stop >> CS_Reader >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 455:
      Tra_0447_0455( oHandler );
      break;
    case 456: // Up: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 454:
      Tra_0447_0454( oHandler );
      break;
    case 452:
      Tra_0447_0452( oHandler );
      break;
    case 453:
      Tra_0447_0453( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader )
class Com_0432_0446 extends TsmCompound
{
  private Reg_0446_0447 oReg_0446_0447; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >)

  public Com_0432_0446( TsmBase oParent )
  {
    TsmName = "CS_Reader";
    TsmParent = oParent;
    oReg_0446_0447 = new Reg_0446_0447( this );
    mRegions.add( oReg_0446_0447 );
    mNrTransitions = 0;
  }

  public void Tra_0436_0444( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 444:
      Tra_0436_0444( oHandler );
      break;
    case 456: // UP: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >)
class Reg_0431_0432 extends TsmRegion
{
  private Ini_0432_0433 oIni_0432_0433; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> InitialState )
  private Fin_0432_0434 oFin_0432_0434; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> FinalState )
  private Com_0432_0435 oCom_0432_0435; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display )
  private Com_0432_0446 oCom_0432_0446; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader )

  public Reg_0431_0432( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0432_0433 = new Ini_0432_0433( this );
    oFin_0432_0434 = new Fin_0432_0434( this );
    oCom_0432_0435 = new Com_0432_0435( this );
    oCom_0432_0446 = new Com_0432_0446( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0432_0433;
    mStates[ 1 ] = oFin_0432_0434;
    mStates[ 2 ] = oCom_0432_0435;
    mStates[ 3 ] = oCom_0432_0446;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0432_0433.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> InitialState ) => ( BackendFsm > Tac_Stop >> CS_Display )
  public void Tra_0432_0457( TsmHandler oHandler )
  {
    mCurrentState = oCom_0432_0435; // At: ( BackendFsm > Tac_Stop >> CS_Display )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Display >> ChoiceState ) => ( BackendFsm > Tac_Stop >> CS_Reader )
  public void Tra_0436_0444( TsmHandler oHandler )
  {
    mCurrentState = oCom_0432_0446; // At: ( BackendFsm > Tac_Stop >> CS_Reader )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Stop >> CS_Reader >> ChoiceState ) => ( BackendFsm > Tac_Stop >> FinalState )
  public void Tra_0447_0456( TsmHandler oHandler )
  {
    mCurrentState = oFin_0432_0434; // At: ( BackendFsm > Tac_Stop >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 457:
      Tra_0432_0457( oHandler );
      break;
    case 444:
      Tra_0436_0444( oHandler );
      break;
    case 456:
      Tra_0447_0456( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
class Fsm_0087_0431 extends TsmFsm
{
  private Reg_0431_0432 oReg_0431_0432; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >)

  public Fsm_0087_0431( TsmBase oParent )
  {
    TsmName = "Tac_Stop";
    TsmParent = oParent;
    oReg_0431_0432 = new Reg_0431_0432( this );
    mRegions.add( oReg_0431_0432 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> Stop )
class Sub_0154_0157 extends TsmSubFsm
{
  public Sub_0154_0157( TsmBase oParent )
  {
    TsmName = "Stop";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0431( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 170, "( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )" );
  }

  public void Tra_0154_0168( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 170; // TRLS ( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 168:
      Tra_0154_0168( oHandler );
      break;
    case 170: // UP: ( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> InitialState )
class Ini_0159_0160 extends TsmPseudo
{
  public Ini_0159_0160( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 164, "( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 164; // TRLS ( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 164: // UP: ( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> ChoiceState )
class Cho_0159_0161 extends TsmPseudo
{
  public Cho_0159_0161( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 169, "( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 167, "( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 169; // TRLS ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 167; // TRLS ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0159_0166( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 169: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
      bHigher = true;
      break;
    case 167: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait )
      bHigher = true;
      break;
    case 166:
      Tra_0159_0166( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Base )
class Lea_0159_0162 extends TsmLeaf
{
  public Lea_0159_0162( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 166, "( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )" );
  }

  public void Tra_0159_0164( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 166; // TRLS ( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0159_0165( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1028( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 164:
      Tra_0159_0164( oHandler );
      break;
    case 166: // UP: ( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )
      bHigher = true;
      break;
    case 165:
      Tra_0159_0165( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Wait )
class Lea_0159_0163 extends TsmLeaf
{
  public Lea_0159_0163( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 165, "( BackendFsm > Stopping >> CS_Close >> Wait ) => ( BackendFsm > Stopping >> CS_Close >> Base ) : ??" );
  }

  public void Tra_0159_0167( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 165; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 167:
      Tra_0159_0167( oHandler );
      break;
    case 165: // UP: ( BackendFsm > Stopping >> CS_Close >> Wait ) => ( BackendFsm > Stopping >> CS_Close >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >)
class Reg_0158_0159 extends TsmRegion
{
  private Ini_0159_0160 oIni_0159_0160; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> InitialState )
  private Cho_0159_0161 oCho_0159_0161; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> ChoiceState )
  private Lea_0159_0162 oLea_0159_0162; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Base )
  private Lea_0159_0163 oLea_0159_0163; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Wait )

  public Reg_0158_0159( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0159_0160 = new Ini_0159_0160( this );
    oCho_0159_0161 = new Cho_0159_0161( this );
    oLea_0159_0162 = new Lea_0159_0162( this );
    oLea_0159_0163 = new Lea_0159_0163( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0159_0160;
    mStates[ 1 ] = oCho_0159_0161;
    mStates[ 2 ] = oLea_0159_0162;
    mStates[ 3 ] = oLea_0159_0163;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0159_0160.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> CS_Close >> InitialState ) => ( BackendFsm > Stopping >> CS_Close >> Base )
  public void Tra_0159_0164( TsmHandler oHandler )
  {
    mCurrentState = oLea_0159_0162; // At: ( BackendFsm > Stopping >> CS_Close >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> CS_Close >> Wait )
  public void Tra_0159_0167( TsmHandler oHandler )
  {
    mCurrentState = oLea_0159_0163; // At: ( BackendFsm > Stopping >> CS_Close >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> CS_Close >> Base ) => ( BackendFsm > Stopping >> CS_Close >> ChoiceState )
  public void Tra_0159_0166( TsmHandler oHandler )
  {
    mCurrentState = oCho_0159_0161; // At: ( BackendFsm > Stopping >> CS_Close >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> CS_Close >> Wait ) => ( BackendFsm > Stopping >> CS_Close >> Base )
  public void Tra_0159_0165( TsmHandler oHandler )
  {
    mCurrentState = oLea_0159_0162; // At: ( BackendFsm > Stopping >> CS_Close >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 164:
      Tra_0159_0164( oHandler );
      break;
    case 169: // Up: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 167:
      Tra_0159_0167( oHandler );
      break;
    case 166:
      Tra_0159_0166( oHandler );
      break;
    case 165:
      Tra_0159_0165( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close )
class Com_0154_0158 extends TsmCompound
{
  private Reg_0158_0159 oReg_0158_0159; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >)

  public Com_0154_0158( TsmBase oParent )
  {
    TsmName = "CS_Close";
    TsmParent = oParent;
    oReg_0158_0159 = new Reg_0158_0159( this );
    mRegions.add( oReg_0158_0159 );
    mNrTransitions = 0;
  }

  public void Tra_0154_0170( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 170:
      Tra_0154_0170( oHandler );
      break;
    case 169: // UP: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >)
class Reg_0153_0154 extends TsmRegion
{
  private Ini_0154_0155 oIni_0154_0155; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> InitialState )
  private Fin_0154_0156 oFin_0154_0156; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> FinalState )
  private Sub_0154_0157 oSub_0154_0157; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> Stop )
  private Com_0154_0158 oCom_0154_0158; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close )

  public Reg_0153_0154( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0154_0155 = new Ini_0154_0155( this );
    oFin_0154_0156 = new Fin_0154_0156( this );
    oSub_0154_0157 = new Sub_0154_0157( this );
    oCom_0154_0158 = new Com_0154_0158( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0154_0155;
    mStates[ 1 ] = oFin_0154_0156;
    mStates[ 2 ] = oSub_0154_0157;
    mStates[ 3 ] = oCom_0154_0158;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0154_0155.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> InitialState ) => ( BackendFsm > Stopping >> Stop )
  public void Tra_0154_0168( TsmHandler oHandler )
  {
    mCurrentState = oSub_0154_0157; // At: ( BackendFsm > Stopping >> Stop )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> Stop ) => ( BackendFsm > Stopping >> CS_Close )
  public void Tra_0154_0170( TsmHandler oHandler )
  {
    mCurrentState = oCom_0154_0158; // At: ( BackendFsm > Stopping >> CS_Close )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
  public void Tra_0154_0169( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1027( oHandler );
    mCurrentState = oFin_0154_0156; // At: ( BackendFsm > Stopping >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 168:
      Tra_0154_0168( oHandler );
      break;
    case 170:
      Tra_0154_0170( oHandler );
      break;
    case 169:
      Tra_0154_0169( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping )
class Fsm_0087_0153 extends TsmFsm
{
  private Reg_0153_0154 oReg_0153_0154; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >)

  public Fsm_0087_0153( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    oReg_0153_0154 = new Reg_0153_0154( this );
    mRegions.add( oReg_0153_0154 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Stopping )
class Sub_0088_0090 extends TsmSubFsm
{
  public Sub_0088_0090( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0153( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping )
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 152, "( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )" );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 152; // TRLS ( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0088_0151( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 152: // UP: ( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 151:
      Tra_0088_0151( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> InitialState )
class Ini_0092_0093 extends TsmPseudo
{
  public Ini_0092_0093( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 97, "( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 97; // TRLS ( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 97: // UP: ( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
class Cho_0092_0094 extends TsmPseudo
{
  public Cho_0092_0094( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 98, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )" );
    mTransitions[ 1 ] = new TsmTransition( 100, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1012( TitleId, AtTime ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 98; // TRLS ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 100; // TRLS ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0092_0099( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 98: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
      bHigher = true;
      break;
    case 100: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      bHigher = true;
      break;
    case 99:
      Tra_0092_0099( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
class Cho_0092_0095 extends TsmPseudo
{
  public Cho_0092_0095( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 101, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )" );
    mTransitions[ 1 ] = new TsmTransition( 99, "( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1017( TitleId, AtTime ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 101; // TRLS ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 99; // TRLS ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0092_0102( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 101: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      bHigher = true;
      break;
    case 99: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )
      bHigher = true;
      break;
    case 102:
      Tra_0092_0102( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> Base )
class Lea_0092_0096 extends TsmLeaf
{
  public Lea_0092_0096( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 102, "( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState ) : pp_player->Start" );
  }

  public void Tra_0092_0097( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void pp_player___Start( String TitleId, tTime AtTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 102; // pp_player.Start
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 14: // pp_player___Start
        {
          TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;

          pp_player___Start( lTrigger.TitleId, lTrigger.AtTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 97:
      Tra_0092_0097( oHandler );
      break;
    case 102: // UP: ( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >)
class Reg_0091_0092 extends TsmRegion
{
  private Ini_0092_0093 oIni_0092_0093; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> InitialState )
  private Cho_0092_0094 oCho_0092_0094; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
  private Cho_0092_0095 oCho_0092_0095; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> ChoiceState )
  private Lea_0092_0096 oLea_0092_0096; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >> Base )

  public Reg_0091_0092( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0092_0093 = new Ini_0092_0093( this );
    oCho_0092_0094 = new Cho_0092_0094( this );
    oCho_0092_0095 = new Cho_0092_0095( this );
    oLea_0092_0096 = new Lea_0092_0096( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0092_0093;
    mStates[ 1 ] = oCho_0092_0094;
    mStates[ 2 ] = oCho_0092_0095;
    mStates[ 3 ] = oLea_0092_0096;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0092_0093.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Idle >> InitialState ) => ( BackendFsm >> Idle >> Base )
  public void Tra_0092_0097( TsmHandler oHandler )
  {
    mCurrentState = oLea_0092_0096; // At: ( BackendFsm >> Idle >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )
  public void Tra_0092_0099( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1020( oHandler );
    mCurrentState = oCho_0092_0094; // At: ( BackendFsm >> Idle >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState )
  public void Tra_0092_0102( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1228( oHandler );
    mCurrentState = oCho_0092_0095; // At: ( BackendFsm >> Idle >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 97:
      Tra_0092_0097( oHandler );
      break;
    case 98: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
      mCurrentState = null;
      bHigher = true;
      break;
    case 100: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      mCurrentState = null;
      bHigher = true;
      break;
    case 101: // Up: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
      mCurrentState = null;
      bHigher = true;
      break;
    case 99:
      Tra_0092_0099( oHandler );
      break;
    case 102:
      Tra_0092_0102( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle )
class Com_0088_0091 extends TsmCompound
{
  private Reg_0091_0092 oReg_0091_0092; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle >)

  public Com_0088_0091( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    oReg_0091_0092 = new Reg_0091_0092( this );
    mRegions.add( oReg_0091_0092 );
    mNrTransitions = 0;
  }

  public void Tra_0088_0149( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0088_0152( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

   // ToSuper: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public void Tra_0092_0100( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1016( oHandler );
    Initial( oHandler );
  }

   // ToSuper: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public void Tra_0092_0101( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1019( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 149:
      Tra_0088_0149( oHandler );
      break;
    case 152:
      Tra_0088_0152( oHandler );
      break;
    case 98: // UP: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 100:
      Tra_0092_0100( oHandler );
      break;
    case 101:
      Tra_0092_0101( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
class Jun_0104_0105 extends TsmPseudo
{
  public Jun_0104_0105( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 144, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 144; // TRLS ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0104_0141( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0104_0137( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 144: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    case 141:
      Tra_0104_0141( oHandler );
      break;
    case 137:
      Tra_0104_0137( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
class Jun_0104_0106 extends TsmPseudo
{
  public Jun_0104_0106( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 130, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 130; // TRLS ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0104_0136( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0104_0135( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0104_0142( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 130: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )
      bHigher = true;
      break;
    case 136:
      Tra_0104_0136( oHandler );
      break;
    case 135:
      Tra_0104_0135( oHandler );
      break;
    case 142:
      Tra_0104_0142( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
class Jun_0104_0107 extends TsmPseudo
{
  public Jun_0104_0107( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 150, "( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )" );
  }

  public void Tra_0104_0144( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 150; // TRLS ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0104_0140( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0104_0145( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 144:
      Tra_0104_0144( oHandler );
      break;
    case 150: // UP: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )
      bHigher = true;
      break;
    case 140:
      Tra_0104_0140( oHandler );
      break;
    case 145:
      Tra_0104_0145( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting > ConnExitRef )
class Con_0108_0109 extends TsmState
{
  public Con_0108_0109( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 141, "( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 141; // TRLS ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 141: // UP: ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> InitialState )
class Ini_0371_0372 extends TsmPseudo
{
  public Ini_0371_0372( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 396, "( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 396; // TRLS ( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 396: // UP: ( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> FinalState )
class Fin_0371_0373 extends TsmFinal
{
  public Fin_0371_0373( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0371_0401( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 401:
      Tra_0371_0401( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> JuncState )
class Jun_0371_0374 extends TsmPseudo
{
  public Jun_0371_0374( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 399, "( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 399; // TRLS ( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0371_0398( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0371_0397( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 399: // UP: ( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )
      bHigher = true;
      break;
    case 398:
      Tra_0371_0398( oHandler );
      break;
    case 397:
      Tra_0371_0397( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
class Con_0375_0376 extends TsmState
{
  public Con_0375_0376( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 400, "( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 400; // TRLS ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 400: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
class Con_0375_0377 extends TsmState
{
  public Con_0375_0377( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 398, "( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 398; // TRLS ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 398: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> InitialState )
class Ini_0192_0193 extends TsmPseudo
{
  public Ini_0192_0193( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 235, "( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 235; // TRLS ( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 235: // UP: ( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> FinalState )
class Fin_0192_0194 extends TsmFinal
{
  public Fin_0192_0194( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0222_0231( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 231:
      Tra_0222_0231( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
class Cho_0192_0195 extends TsmPseudo
{
  public Cho_0192_0195( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 233, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )" );
    mTransitions[ 1 ] = new TsmTransition( 234, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1030() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 233; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 234; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0192_0236( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 233: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )
      bHigher = true;
      break;
    case 234: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )
      bHigher = true;
      break;
    case 236:
      Tra_0192_0236( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
class Cho_0192_0196 extends TsmPseudo
{
  public Cho_0192_0196( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 236, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 238, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1031() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 236; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 238; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0192_0237( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 236: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      bHigher = true;
      break;
    case 238: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )
      bHigher = true;
      break;
    case 237:
      Tra_0192_0237( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
class Cho_0192_0197 extends TsmPseudo
{
  public Cho_0192_0197( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 240, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )" );
    mTransitions[ 1 ] = new TsmTransition( 239, "( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1033() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 240; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 239; // TRLS ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0210_0220( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 240: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )
      bHigher = true;
      break;
    case 239: // UP: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )
      bHigher = true;
      break;
    case 220:
      Tra_0210_0220( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState )
class Ini_0199_0200 extends TsmPseudo
{
  public Ini_0199_0200( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 208, "( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 208; // TRLS ( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 208: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
class Cho_0199_0201 extends TsmPseudo
{
  public Cho_0199_0201( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 206, "( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 204, "( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 206; // TRLS ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 204; // TRLS ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0199_0207( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 206: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
      bHigher = true;
      break;
    case 204: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
      bHigher = true;
      break;
    case 207:
      Tra_0199_0207( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
class Lea_0199_0202 extends TsmLeaf
{
  public Lea_0199_0202( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 207, "( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )" );
  }

  public void Tra_0199_0208( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 207; // TRLS ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0199_0205( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1034( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 208:
      Tra_0199_0208( oHandler );
      break;
    case 207: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
      bHigher = true;
      break;
    case 205:
      Tra_0199_0205( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
class Lea_0199_0203 extends TsmLeaf
{
  public Lea_0199_0203( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 205, "( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) : ??" );
  }

  public void Tra_0199_0204( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 205; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 204:
      Tra_0199_0204( oHandler );
      break;
    case 205: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >)
class Reg_0198_0199 extends TsmRegion
{
  private Ini_0199_0200 oIni_0199_0200; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState )
  private Cho_0199_0201 oCho_0199_0201; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
  private Lea_0199_0202 oLea_0199_0202; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
  private Lea_0199_0203 oLea_0199_0203; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )

  public Reg_0198_0199( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0199_0200 = new Ini_0199_0200( this );
    oCho_0199_0201 = new Cho_0199_0201( this );
    oLea_0199_0202 = new Lea_0199_0202( this );
    oLea_0199_0203 = new Lea_0199_0203( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0199_0200;
    mStates[ 1 ] = oCho_0199_0201;
    mStates[ 2 ] = oLea_0199_0202;
    mStates[ 3 ] = oLea_0199_0203;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0199_0200.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
  public void Tra_0199_0208( TsmHandler oHandler )
  {
    mCurrentState = oLea_0199_0202; // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
  public void Tra_0199_0204( TsmHandler oHandler )
  {
    mCurrentState = oLea_0199_0203; // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
  public void Tra_0199_0207( TsmHandler oHandler )
  {
    mCurrentState = oCho_0199_0201; // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
  public void Tra_0199_0205( TsmHandler oHandler )
  {
    mCurrentState = oLea_0199_0202; // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 208:
      Tra_0199_0208( oHandler );
      break;
    case 206: // Up: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
      mCurrentState = null;
      bHigher = true;
      break;
    case 204:
      Tra_0199_0204( oHandler );
      break;
    case 207:
      Tra_0199_0207( oHandler );
      break;
    case 205:
      Tra_0199_0205( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare )
class Com_0192_0198 extends TsmCompound
{
  private Reg_0198_0199 oReg_0198_0199; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >)

  public Com_0192_0198( TsmBase oParent )
  {
    TsmName = "CS_Prepare";
    TsmParent = oParent;
    oReg_0198_0199 = new Reg_0198_0199( this );
    mRegions.add( oReg_0198_0199 );
    mNrTransitions = 0;
  }

  public void Tra_0192_0238( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 238:
      Tra_0192_0238( oHandler );
      break;
    case 206: // UP: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> InitialState )
class Ini_0210_0211 extends TsmPseudo
{
  public Ini_0210_0211( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 217, "( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 217; // TRLS ( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 217: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
class Cho_0210_0212 extends TsmPseudo
{
  public Cho_0210_0212( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 220, "( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 215, "( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 220; // TRLS ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 215; // TRLS ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0210_0219( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 220: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      bHigher = true;
      break;
    case 215: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait )
      bHigher = true;
      break;
    case 219:
      Tra_0210_0219( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Base )
class Lea_0210_0213 extends TsmLeaf
{
  public Lea_0210_0213( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 219, "( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )" );
  }

  public void Tra_0210_0217( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 219; // TRLS ( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0210_0216( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1035( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 217:
      Tra_0210_0217( oHandler );
      break;
    case 219: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
      bHigher = true;
      break;
    case 216:
      Tra_0210_0216( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Wait )
class Lea_0210_0214 extends TsmLeaf
{
  public Lea_0210_0214( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 216, "( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base ) : ??" );
  }

  public void Tra_0210_0215( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 216; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 215:
      Tra_0210_0215( oHandler );
      break;
    case 216: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >)
class Reg_0209_0210 extends TsmRegion
{
  private Ini_0210_0211 oIni_0210_0211; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> InitialState )
  private Cho_0210_0212 oCho_0210_0212; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
  private Lea_0210_0213 oLea_0210_0213; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Base )
  private Lea_0210_0214 oLea_0210_0214; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Wait )

  public Reg_0209_0210( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0210_0211 = new Ini_0210_0211( this );
    oCho_0210_0212 = new Cho_0210_0212( this );
    oLea_0210_0213 = new Lea_0210_0213( this );
    oLea_0210_0214 = new Lea_0210_0214( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0210_0211;
    mStates[ 1 ] = oCho_0210_0212;
    mStates[ 2 ] = oLea_0210_0213;
    mStates[ 3 ] = oLea_0210_0214;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0210_0211.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Read >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
  public void Tra_0210_0217( TsmHandler oHandler )
  {
    mCurrentState = oLea_0210_0213; // At: ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Wait )
  public void Tra_0210_0215( TsmHandler oHandler )
  {
    mCurrentState = oLea_0210_0214; // At: ( BackendFsm > Tac_StartRead >> CS_Read >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Read >> Base ) => ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
  public void Tra_0210_0219( TsmHandler oHandler )
  {
    mCurrentState = oCho_0210_0212; // At: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Read >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
  public void Tra_0210_0216( TsmHandler oHandler )
  {
    mCurrentState = oLea_0210_0213; // At: ( BackendFsm > Tac_StartRead >> CS_Read >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 217:
      Tra_0210_0217( oHandler );
      break;
    case 220: // Up: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 215:
      Tra_0210_0215( oHandler );
      break;
    case 219:
      Tra_0210_0219( oHandler );
      break;
    case 216:
      Tra_0210_0216( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read )
class Com_0192_0209 extends TsmCompound
{
  private Reg_0209_0210 oReg_0209_0210; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >)

  public Com_0192_0209( TsmBase oParent )
  {
    TsmName = "CS_Read";
    TsmParent = oParent;
    oReg_0209_0210 = new Reg_0209_0210( this );
    mRegions.add( oReg_0209_0210 );
    mNrTransitions = 0;
  }

  public void Tra_0199_0206( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 206:
      Tra_0199_0206( oHandler );
      break;
    case 220: // UP: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState )
class Ini_0222_0223 extends TsmPseudo
{
  public Ini_0222_0223( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 230, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 230; // TRLS ( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 230: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
class Cho_0222_0224 extends TsmPseudo
{
  public Cho_0222_0224( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 231, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 229, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 231; // TRLS ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 229; // TRLS ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0222_0227( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 231: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
      bHigher = true;
      break;
    case 229: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
      bHigher = true;
      break;
    case 227:
      Tra_0222_0227( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
class Lea_0222_0225 extends TsmLeaf
{
  public Lea_0222_0225( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 227, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )" );
  }

  public void Tra_0222_0230( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 227; // TRLS ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0222_0228( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1036( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 230:
      Tra_0222_0230( oHandler );
      break;
    case 227: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
      bHigher = true;
      break;
    case 228:
      Tra_0222_0228( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
class Lea_0222_0226 extends TsmLeaf
{
  public Lea_0222_0226( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 228, "( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) : ??" );
  }

  public void Tra_0222_0229( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 228; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 229:
      Tra_0222_0229( oHandler );
      break;
    case 228: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >)
class Reg_0221_0222 extends TsmRegion
{
  private Ini_0222_0223 oIni_0222_0223; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState )
  private Cho_0222_0224 oCho_0222_0224; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
  private Lea_0222_0225 oLea_0222_0225; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
  private Lea_0222_0226 oLea_0222_0226; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )

  public Reg_0221_0222( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0222_0223 = new Ini_0222_0223( this );
    oCho_0222_0224 = new Cho_0222_0224( this );
    oLea_0222_0225 = new Lea_0222_0225( this );
    oLea_0222_0226 = new Lea_0222_0226( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0222_0223;
    mStates[ 1 ] = oCho_0222_0224;
    mStates[ 2 ] = oLea_0222_0225;
    mStates[ 3 ] = oLea_0222_0226;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0222_0223.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> InitialState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
  public void Tra_0222_0230( TsmHandler oHandler )
  {
    mCurrentState = oLea_0222_0225; // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
  public void Tra_0222_0229( TsmHandler oHandler )
  {
    mCurrentState = oLea_0222_0226; // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
  public void Tra_0222_0227( TsmHandler oHandler )
  {
    mCurrentState = oCho_0222_0224; // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Wait ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
  public void Tra_0222_0228( TsmHandler oHandler )
  {
    mCurrentState = oLea_0222_0225; // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 230:
      Tra_0222_0230( oHandler );
      break;
    case 231: // Up: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 229:
      Tra_0222_0229( oHandler );
      break;
    case 227:
      Tra_0222_0227( oHandler );
      break;
    case 228:
      Tra_0222_0228( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled )
class Com_0192_0221 extends TsmCompound
{
  private Reg_0221_0222 oReg_0221_0222; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >)

  public Com_0192_0221( TsmBase oParent )
  {
    TsmName = "CS_IsFilled";
    TsmParent = oParent;
    oReg_0221_0222 = new Reg_0221_0222( this );
    mRegions.add( oReg_0221_0222 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 218, "( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError ) : rpp_reader->Px_CbError" );
  }

  public void Tra_0192_0240( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 218; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 240:
      Tra_0192_0240( oHandler );
      break;
    case 231: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 218: // UP: ( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> LeafState )
class Lea_0192_0232 extends TsmLeaf
{
  public Lea_0192_0232( TsmBase oParent )
  {
    TsmName = "LeafState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 237, "( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )" );
  }

  public void Tra_0192_0235( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 237; // TRLS ( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1037( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 235:
      Tra_0192_0235( oHandler );
      break;
    case 237: // UP: ( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >)
class Reg_0191_0192 extends TsmRegion
{
  private Ini_0192_0193 oIni_0192_0193; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> InitialState )
  private Fin_0192_0194 oFin_0192_0194; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> FinalState )
  private Cho_0192_0195 oCho_0192_0195; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  private Cho_0192_0196 oCho_0192_0196; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  private Cho_0192_0197 oCho_0192_0197; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> ChoiceState )
  private Com_0192_0198 oCom_0192_0198; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare )
  private Com_0192_0209 oCom_0192_0209; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read )
  private Com_0192_0221 oCom_0192_0221; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled )
  private Lea_0192_0232 oLea_0192_0232; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> LeafState )

  public Reg_0191_0192( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0192_0193 = new Ini_0192_0193( this );
    oFin_0192_0194 = new Fin_0192_0194( this );
    oCho_0192_0195 = new Cho_0192_0195( this );
    oCho_0192_0196 = new Cho_0192_0196( this );
    oCho_0192_0197 = new Cho_0192_0197( this );
    oCom_0192_0198 = new Com_0192_0198( this );
    oCom_0192_0209 = new Com_0192_0209( this );
    oCom_0192_0221 = new Com_0192_0221( this );
    oLea_0192_0232 = new Lea_0192_0232( this );
    mNrStates = 9;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0192_0193;
    mStates[ 1 ] = oFin_0192_0194;
    mStates[ 2 ] = oCho_0192_0195;
    mStates[ 3 ] = oCho_0192_0196;
    mStates[ 4 ] = oCho_0192_0197;
    mStates[ 5 ] = oCom_0192_0198;
    mStates[ 6 ] = oCom_0192_0209;
    mStates[ 7 ] = oCom_0192_0221;
    mStates[ 8 ] = oLea_0192_0232;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0192_0193.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> InitialState ) => ( BackendFsm > Tac_StartRead >> LeafState )
  public void Tra_0192_0235( TsmHandler oHandler )
  {
    mCurrentState = oLea_0192_0232; // At: ( BackendFsm > Tac_StartRead >> LeafState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
  public void Tra_0192_0236( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1032( oHandler );
    mCurrentState = oCho_0192_0195; // At: ( BackendFsm > Tac_StartRead >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Prepare )
  public void Tra_0192_0238( TsmHandler oHandler )
  {
    mCurrentState = oCom_0192_0198; // At: ( BackendFsm > Tac_StartRead >> CS_Prepare )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_IsFilled )
  public void Tra_0192_0240( TsmHandler oHandler )
  {
    mCurrentState = oCom_0192_0221; // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Prepare >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> CS_Read )
  public void Tra_0199_0206( TsmHandler oHandler )
  {
    mCurrentState = oCom_0192_0209; // At: ( BackendFsm > Tac_StartRead >> CS_Read )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_Read >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
  public void Tra_0210_0220( TsmHandler oHandler )
  {
    mCurrentState = oCho_0192_0197; // At: ( BackendFsm > Tac_StartRead >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> CS_IsFilled >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> FinalState )
  public void Tra_0222_0231( TsmHandler oHandler )
  {
    mCurrentState = oFin_0192_0194; // At: ( BackendFsm > Tac_StartRead >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartRead >> LeafState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
  public void Tra_0192_0237( TsmHandler oHandler )
  {
    mCurrentState = oCho_0192_0196; // At: ( BackendFsm > Tac_StartRead >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 235:
      Tra_0192_0235( oHandler );
      break;
    case 233: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitNoData )
      mCurrentState = null;
      bHigher = true;
      break;
    case 234: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitReadFailure )
      mCurrentState = null;
      bHigher = true;
      break;
    case 236:
      Tra_0192_0236( oHandler );
      break;
    case 238:
      Tra_0192_0238( oHandler );
      break;
    case 240:
      Tra_0192_0240( oHandler );
      break;
    case 239: // Up: ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead > ExitChunkError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 206:
      Tra_0199_0206( oHandler );
      break;
    case 220:
      Tra_0210_0220( oHandler );
      break;
    case 231:
      Tra_0222_0231( oHandler );
      break;
    case 237:
      Tra_0192_0237( oHandler );
      break;
    case 218: // Up: ( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
class Fsm_0087_0191 extends TsmFsm
{
  private Reg_0191_0192 oReg_0191_0192; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >)

  public Fsm_0087_0191( TsmBase oParent )
  {
    TsmName = "Tac_StartRead";
    TsmParent = oParent;
    oReg_0191_0192 = new Reg_0191_0192( this );
    mRegions.add( oReg_0191_0192 );
    mNrTransitions = 0;
  }

  public void Tra_0192_0233( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 241; // ExitNoData
  }

  public void Tra_0192_0234( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 243; // ExitReadFailure
  }

  public void Tra_0192_0239( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 244; // ExitChunkError
  }

  public void Tra_0210_0218( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1245( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 242; // ExitReadError
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 233:
      Tra_0192_0233( oHandler );
      break;
    case 234:
      Tra_0192_0234( oHandler );
      break;
    case 239:
      Tra_0192_0239( oHandler );
      break;
    case 218:
      Tra_0210_0218( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead )
class Sub_0371_0375 extends TsmSubFsm
{
  private Con_0375_0376 oCon_0375_0376; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )
  private Con_0375_0377 oCon_0375_0377; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead > ConnExitRef )

  public Sub_0371_0375( TsmBase oParent )
  {
    TsmName = "StartRead";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0191( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
    oCon_0375_0376 = new Con_0375_0376( this );
    oCon_0375_0377 = new Con_0375_0377( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 404, "( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )" );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 404; // TRLS ( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0383_0394( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 404: // UP: ( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 242: // UmlConnExit(Ref)
      oCon_0375_0376.Initial( oHandler );
      break;
    case 241: // UmlConnExit(Ref)
    case 243: // UmlConnExit(Ref)
    case 244: // UmlConnExit(Ref)
      oCon_0375_0377.Initial( oHandler );
      break;
    case 400: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 398: // UP: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 394:
      Tra_0383_0394( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover > ConnExitRef )
class Con_0378_0379 extends TsmState
{
  public Con_0378_0379( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 397, "( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 397; // TRLS ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 397: // UP: ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> InitialState )
class Ini_0280_0281 extends TsmPseudo
{
  public Ini_0280_0281( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 293, "( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 293; // TRLS ( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 293: // UP: ( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> FinalState )
class Fin_0280_0282 extends TsmFinal
{
  public Fin_0280_0282( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0280_0290( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 290:
      Tra_0280_0290( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> Stop )
class Sub_0280_0283 extends TsmSubFsm
{
  public Sub_0280_0283( TsmBase oParent )
  {
    TsmName = "Stop";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0431( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop )
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 288, "( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )" );
  }

  public void Tra_0280_0293( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 288; // TRLS ( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0280_0292( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 293:
      Tra_0280_0293( oHandler );
      break;
    case 288: // UP: ( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 292:
      Tra_0280_0292( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
class Con_0284_0285 extends TsmState
{
  public Con_0284_0285( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 289, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 289; // TRLS ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 289: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
class Con_0284_0286 extends TsmState
{
  public Con_0284_0286( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 292, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 292; // TRLS ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 292: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
class Con_0284_0287 extends TsmState
{
  public Con_0284_0287( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 291, "( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 291; // TRLS ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 291: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead )
class Sub_0280_0284 extends TsmSubFsm
{
  private Con_0284_0285 oCon_0284_0285; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
  private Con_0284_0286 oCon_0284_0286; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )
  private Con_0284_0287 oCon_0284_0287; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead > ConnExitRef )

  public Sub_0280_0284( TsmBase oParent )
  {
    TsmName = "StartRead";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0191( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead )
    oCon_0284_0285 = new Con_0284_0285( this );
    oCon_0284_0286 = new Con_0284_0286( this );
    oCon_0284_0287 = new Con_0284_0287( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 290, "( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )" );
  }

  public void Tra_0280_0288( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 290; // TRLS ( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 288:
      Tra_0280_0288( oHandler );
      break;
    case 290: // UP: ( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 241: // UmlConnExit(Ref)
      oCon_0284_0285.Initial( oHandler );
      break;
    case 242: // UmlConnExit(Ref)
      oCon_0284_0286.Initial( oHandler );
      break;
    case 243: // UmlConnExit(Ref)
    case 244: // UmlConnExit(Ref)
      oCon_0284_0287.Initial( oHandler );
      break;
    case 289: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 292: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 291: // UP: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >)
class Reg_0279_0280 extends TsmRegion
{
  private Ini_0280_0281 oIni_0280_0281; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> InitialState )
  private Fin_0280_0282 oFin_0280_0282; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> FinalState )
  private Sub_0280_0283 oSub_0280_0283; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> Stop )
  private Sub_0280_0284 oSub_0280_0284; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >> StartRead )

  public Reg_0279_0280( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0280_0281 = new Ini_0280_0281( this );
    oFin_0280_0282 = new Fin_0280_0282( this );
    oSub_0280_0283 = new Sub_0280_0283( this );
    oSub_0280_0284 = new Sub_0280_0284( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0280_0281;
    mStates[ 1 ] = oFin_0280_0282;
    mStates[ 2 ] = oSub_0280_0283;
    mStates[ 3 ] = oSub_0280_0284;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0280_0281.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Recover >> InitialState ) => ( BackendFsm > Tac_Recover >> Stop )
  public void Tra_0280_0293( TsmHandler oHandler )
  {
    mCurrentState = oSub_0280_0283; // At: ( BackendFsm > Tac_Recover >> Stop )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Recover >> Stop ) => ( BackendFsm > Tac_Recover >> StartRead )
  public void Tra_0280_0288( TsmHandler oHandler )
  {
    mCurrentState = oSub_0280_0284; // At: ( BackendFsm > Tac_Recover >> StartRead )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Recover >> StartRead ) => ( BackendFsm > Tac_Recover >> FinalState )
  public void Tra_0280_0290( TsmHandler oHandler )
  {
    mCurrentState = oFin_0280_0282; // At: ( BackendFsm > Tac_Recover >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover >> Stop )
  public void Tra_0280_0292( TsmHandler oHandler )
  {
    mCurrentState = oSub_0280_0283; // At: ( BackendFsm > Tac_Recover >> Stop )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 293:
      Tra_0280_0293( oHandler );
      break;
    case 288:
      Tra_0280_0288( oHandler );
      break;
    case 290:
      Tra_0280_0290( oHandler );
      break;
    case 289: // Up: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitNoData )
      mCurrentState = null;
      bHigher = true;
      break;
    case 292:
      Tra_0280_0292( oHandler );
      break;
    case 291: // Up: ( BackendFsm > Tac_Recover >> StartRead > ConnExitRef ) => ( BackendFsm > Tac_Recover > ExitReadFailure )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
class Fsm_0087_0279 extends TsmFsm
{
  private Reg_0279_0280 oReg_0279_0280; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover >)

  public Fsm_0087_0279( TsmBase oParent )
  {
    TsmName = "Tac_Recover";
    TsmParent = oParent;
    oReg_0279_0280 = new Reg_0279_0280( this );
    mRegions.add( oReg_0279_0280 );
    mNrTransitions = 0;
  }

  public void Tra_0280_0289( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 294; // ExitNoData
  }

  public void Tra_0280_0291( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 295; // ExitReadFailure
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 289:
      Tra_0280_0289( oHandler );
      break;
    case 291:
      Tra_0280_0291( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover )
class Sub_0371_0378 extends TsmSubFsm
{
  private Con_0378_0379 oCon_0378_0379; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover > ConnExitRef )

  public Sub_0371_0378( TsmBase oParent )
  {
    TsmName = "Recover";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0279( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
    oCon_0378_0379 = new Con_0378_0379( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 403, "( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )" );
  }

  public void Tra_0371_0400( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 403; // TRLS ( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 400:
      Tra_0371_0400( oHandler );
      break;
    case 403: // UP: ( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 294: // UmlConnExit(Ref)
    case 295: // UmlConnExit(Ref)
      oCon_0378_0379.Initial( oHandler );
      break;
    case 397: // UP: ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay > ConnExitRef )
class Con_0380_0381 extends TsmState
{
  public Con_0380_0381( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 402, "( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 402; // TRLS ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 402: // UP: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> InitialState )
class Ini_0172_0173 extends TsmPseudo
{
  public Ini_0172_0173( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 187, "( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 187; // TRLS ( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 187: // UP: ( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> FinalState )
class Fin_0172_0174 extends TsmFinal
{
  public Fin_0172_0174( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0176_0184( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 184:
      Tra_0176_0184( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> InitialState )
class Ini_0176_0177 extends TsmPseudo
{
  public Ini_0176_0177( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 185, "( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 185; // TRLS ( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 185: // UP: ( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
class Cho_0176_0178 extends TsmPseudo
{
  public Cho_0176_0178( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 184, "( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 183, "( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 184; // TRLS ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 183; // TRLS ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0176_0181( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 184: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
      bHigher = true;
      break;
    case 183: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait )
      bHigher = true;
      break;
    case 181:
      Tra_0176_0181( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Base )
class Lea_0176_0179 extends TsmLeaf
{
  public Lea_0176_0179( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 181, "( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )" );
  }

  public void Tra_0176_0185( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 181; // TRLS ( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0176_0182( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1029( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 185:
      Tra_0176_0185( oHandler );
      break;
    case 181: // UP: ( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
      bHigher = true;
      break;
    case 182:
      Tra_0176_0182( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Wait )
class Lea_0176_0180 extends TsmLeaf
{
  public Lea_0176_0180( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 182, "( BackendFsm > Tac_StartPlay >> CS >> Wait ) => ( BackendFsm > Tac_StartPlay >> CS >> Base ) : ??" );
  }

  public void Tra_0176_0183( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 182; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 183:
      Tra_0176_0183( oHandler );
      break;
    case 182: // UP: ( BackendFsm > Tac_StartPlay >> CS >> Wait ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >)
class Reg_0175_0176 extends TsmRegion
{
  private Ini_0176_0177 oIni_0176_0177; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> InitialState )
  private Cho_0176_0178 oCho_0176_0178; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
  private Lea_0176_0179 oLea_0176_0179; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Base )
  private Lea_0176_0180 oLea_0176_0180; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Wait )

  public Reg_0175_0176( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0176_0177 = new Ini_0176_0177( this );
    oCho_0176_0178 = new Cho_0176_0178( this );
    oLea_0176_0179 = new Lea_0176_0179( this );
    oLea_0176_0180 = new Lea_0176_0180( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0176_0177;
    mStates[ 1 ] = oCho_0176_0178;
    mStates[ 2 ] = oLea_0176_0179;
    mStates[ 3 ] = oLea_0176_0180;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0176_0177.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> CS >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
  public void Tra_0176_0185( TsmHandler oHandler )
  {
    mCurrentState = oLea_0176_0179; // At: ( BackendFsm > Tac_StartPlay >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> CS >> Wait )
  public void Tra_0176_0183( TsmHandler oHandler )
  {
    mCurrentState = oLea_0176_0180; // At: ( BackendFsm > Tac_StartPlay >> CS >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> CS >> Base ) => ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
  public void Tra_0176_0181( TsmHandler oHandler )
  {
    mCurrentState = oCho_0176_0178; // At: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> CS >> Wait ) => ( BackendFsm > Tac_StartPlay >> CS >> Base )
  public void Tra_0176_0182( TsmHandler oHandler )
  {
    mCurrentState = oLea_0176_0179; // At: ( BackendFsm > Tac_StartPlay >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 185:
      Tra_0176_0185( oHandler );
      break;
    case 184: // Up: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 183:
      Tra_0176_0183( oHandler );
      break;
    case 181:
      Tra_0176_0181( oHandler );
      break;
    case 182:
      Tra_0176_0182( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS )
class Com_0172_0175 extends TsmCompound
{
  private Reg_0175_0176 oReg_0175_0176; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >)

  public Com_0172_0175( TsmBase oParent )
  {
    TsmName = "CS";
    TsmParent = oParent;
    oReg_0175_0176 = new Reg_0175_0176( this );
    mRegions.add( oReg_0175_0176 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 186, "( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError ) : rpp_reader->Px_CbError" );
    mTransitions[ 1 ] = new TsmTransition( 188, "( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost ) : rpp_display->Px_CbSynclost" );
  }

  public void Tra_0172_0187( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 186; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 188; // rpp_display.Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 85
    case 86: // Port rpp_display
      switch ( oHandler.Trigger.Command )
      {
      case 31: // rpp_display___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          rpp_display___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 187:
      Tra_0172_0187( oHandler );
      break;
    case 184: // UP: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 186: // UP: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 188: // UP: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >)
class Reg_0171_0172 extends TsmRegion
{
  private Ini_0172_0173 oIni_0172_0173; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> InitialState )
  private Fin_0172_0174 oFin_0172_0174; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> FinalState )
  private Com_0172_0175 oCom_0172_0175; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS )

  public Reg_0171_0172( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0172_0173 = new Ini_0172_0173( this );
    oFin_0172_0174 = new Fin_0172_0174( this );
    oCom_0172_0175 = new Com_0172_0175( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0172_0173;
    mStates[ 1 ] = oFin_0172_0174;
    mStates[ 2 ] = oCom_0172_0175;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0172_0173.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> InitialState ) => ( BackendFsm > Tac_StartPlay >> CS )
  public void Tra_0172_0187( TsmHandler oHandler )
  {
    mCurrentState = oCom_0172_0175; // At: ( BackendFsm > Tac_StartPlay >> CS )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPlay >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPlay >> FinalState )
  public void Tra_0176_0184( TsmHandler oHandler )
  {
    mCurrentState = oFin_0172_0174; // At: ( BackendFsm > Tac_StartPlay >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 187:
      Tra_0172_0187( oHandler );
      break;
    case 184:
      Tra_0176_0184( oHandler );
      break;
    case 186: // Up: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 188: // Up: ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
class Fsm_0087_0171 extends TsmFsm
{
  private Reg_0171_0172 oReg_0171_0172; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >)

  public Fsm_0087_0171( TsmBase oParent )
  {
    TsmName = "Tac_StartPlay";
    TsmParent = oParent;
    oReg_0171_0172 = new Reg_0171_0172( this );
    mRegions.add( oReg_0171_0172 );
    mNrTransitions = 0;
  }

  public void Tra_0172_0186( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1246( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 189; // ExitReadError
  }

  public void Tra_0172_0188( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1251( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 190; // ExitSynclost
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 186:
      Tra_0172_0186( oHandler );
      break;
    case 188:
      Tra_0172_0188( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay )
class Sub_0371_0380 extends TsmSubFsm
{
  private Con_0380_0381 oCon_0380_0381; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay > ConnExitRef )

  public Sub_0371_0380( TsmBase oParent )
  {
    TsmName = "StartPlay";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0171( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
    oCon_0380_0381 = new Con_0380_0381( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 401, "( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )" );
  }

  public void Tra_0371_0404( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0371_0403( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 401; // TRLS ( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 404:
      Tra_0371_0404( oHandler );
      break;
    case 403:
      Tra_0371_0403( oHandler );
      break;
    case 401: // UP: ( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 189: // UmlConnExit(Ref)
    case 190: // UmlConnExit(Ref)
      oCon_0380_0381.Initial( oHandler );
      break;
    case 402: // UP: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> InitialState )
class Ini_0383_0384 extends TsmPseudo
{
  public Ini_0383_0384( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 391, "( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 391; // TRLS ( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 391: // UP: ( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
class Cho_0383_0385 extends TsmPseudo
{
  public Cho_0383_0385( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 390, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 392, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 390; // TRLS ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 392; // TRLS ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0383_0389( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 390: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
      bHigher = true;
      break;
    case 392: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait )
      bHigher = true;
      break;
    case 389:
      Tra_0383_0389( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
class Cho_0383_0386 extends TsmPseudo
{
  public Cho_0383_0386( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 394, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )" );
    mTransitions[ 1 ] = new TsmTransition( 395, "( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )" );
  }

  public void Tra_0383_0390( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1039() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 394; // TRLS ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 395; // TRLS ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 390:
      Tra_0383_0390( oHandler );
      break;
    case 394: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
      bHigher = true;
      break;
    case 395: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Base )
class Lea_0383_0387 extends TsmLeaf
{
  public Lea_0383_0387( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 389, "( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )" );
  }

  public void Tra_0383_0391( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 389; // TRLS ( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0383_0393( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1040( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 391:
      Tra_0383_0391( oHandler );
      break;
    case 389: // UP: ( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
      bHigher = true;
      break;
    case 393:
      Tra_0383_0393( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Wait )
class Lea_0383_0388 extends TsmLeaf
{
  public Lea_0383_0388( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 393, "( BackendFsm > Starting >> CS_Open >> Wait ) => ( BackendFsm > Starting >> CS_Open >> Base ) : ??" );
  }

  public void Tra_0383_0392( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 393; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 392:
      Tra_0383_0392( oHandler );
      break;
    case 393: // UP: ( BackendFsm > Starting >> CS_Open >> Wait ) => ( BackendFsm > Starting >> CS_Open >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >)
class Reg_0382_0383 extends TsmRegion
{
  private Ini_0383_0384 oIni_0383_0384; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> InitialState )
  private Cho_0383_0385 oCho_0383_0385; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
  private Cho_0383_0386 oCho_0383_0386; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> ChoiceState )
  private Lea_0383_0387 oLea_0383_0387; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Base )
  private Lea_0383_0388 oLea_0383_0388; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Wait )

  public Reg_0382_0383( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0383_0384 = new Ini_0383_0384( this );
    oCho_0383_0385 = new Cho_0383_0385( this );
    oCho_0383_0386 = new Cho_0383_0386( this );
    oLea_0383_0387 = new Lea_0383_0387( this );
    oLea_0383_0388 = new Lea_0383_0388( this );
    mNrStates = 5;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0383_0384;
    mStates[ 1 ] = oCho_0383_0385;
    mStates[ 2 ] = oCho_0383_0386;
    mStates[ 3 ] = oLea_0383_0387;
    mStates[ 4 ] = oLea_0383_0388;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0383_0384.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> InitialState ) => ( BackendFsm > Starting >> CS_Open >> Base )
  public void Tra_0383_0391( TsmHandler oHandler )
  {
    mCurrentState = oLea_0383_0387; // At: ( BackendFsm > Starting >> CS_Open >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
  public void Tra_0383_0390( TsmHandler oHandler )
  {
    mCurrentState = oCho_0383_0386; // At: ( BackendFsm > Starting >> CS_Open >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> CS_Open >> Wait )
  public void Tra_0383_0392( TsmHandler oHandler )
  {
    mCurrentState = oLea_0383_0388; // At: ( BackendFsm > Starting >> CS_Open >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> Base ) => ( BackendFsm > Starting >> CS_Open >> ChoiceState )
  public void Tra_0383_0389( TsmHandler oHandler )
  {
    mCurrentState = oCho_0383_0385; // At: ( BackendFsm > Starting >> CS_Open >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> Wait ) => ( BackendFsm > Starting >> CS_Open >> Base )
  public void Tra_0383_0393( TsmHandler oHandler )
  {
    mCurrentState = oLea_0383_0387; // At: ( BackendFsm > Starting >> CS_Open >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 391:
      Tra_0383_0391( oHandler );
      break;
    case 390:
      Tra_0383_0390( oHandler );
      break;
    case 392:
      Tra_0383_0392( oHandler );
      break;
    case 394: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
      mCurrentState = null;
      bHigher = true;
      break;
    case 395: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 389:
      Tra_0383_0389( oHandler );
      break;
    case 393:
      Tra_0383_0393( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open )
class Com_0371_0382 extends TsmCompound
{
  private Reg_0382_0383 oReg_0382_0383; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >)

  public Com_0371_0382( TsmBase oParent )
  {
    TsmName = "CS_Open";
    TsmParent = oParent;
    oReg_0382_0383 = new Reg_0382_0383( this );
    mRegions.add( oReg_0382_0383 );
    mNrTransitions = 0;
  }

  public void Tra_0371_0396( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 396:
      Tra_0371_0396( oHandler );
      break;
    case 394: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 395: // UP: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >)
class Reg_0370_0371 extends TsmRegion
{
  private Ini_0371_0372 oIni_0371_0372; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> InitialState )
  private Fin_0371_0373 oFin_0371_0373; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> FinalState )
  private Jun_0371_0374 oJun_0371_0374; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> JuncState )
  private Sub_0371_0375 oSub_0371_0375; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartRead )
  private Sub_0371_0378 oSub_0371_0378; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> Recover )
  private Sub_0371_0380 oSub_0371_0380; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> StartPlay )
  private Com_0371_0382 oCom_0371_0382; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open )

  public Reg_0370_0371( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0371_0372 = new Ini_0371_0372( this );
    oFin_0371_0373 = new Fin_0371_0373( this );
    oJun_0371_0374 = new Jun_0371_0374( this );
    oSub_0371_0375 = new Sub_0371_0375( this );
    oSub_0371_0378 = new Sub_0371_0378( this );
    oSub_0371_0380 = new Sub_0371_0380( this );
    oCom_0371_0382 = new Com_0371_0382( this );
    mNrStates = 7;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0371_0372;
    mStates[ 1 ] = oFin_0371_0373;
    mStates[ 2 ] = oJun_0371_0374;
    mStates[ 3 ] = oSub_0371_0375;
    mStates[ 4 ] = oSub_0371_0378;
    mStates[ 5 ] = oSub_0371_0380;
    mStates[ 6 ] = oCom_0371_0382;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0371_0372.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> InitialState ) => ( BackendFsm > Starting >> CS_Open )
  public void Tra_0371_0396( TsmHandler oHandler )
  {
    mCurrentState = oCom_0371_0382; // At: ( BackendFsm > Starting >> CS_Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> StartRead ) => ( BackendFsm > Starting >> StartPlay )
  public void Tra_0371_0404( TsmHandler oHandler )
  {
    mCurrentState = oSub_0371_0380; // At: ( BackendFsm > Starting >> StartPlay )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> Recover )
  public void Tra_0371_0400( TsmHandler oHandler )
  {
    mCurrentState = oSub_0371_0378; // At: ( BackendFsm > Starting >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> StartRead > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
  public void Tra_0371_0398( TsmHandler oHandler )
  {
    mCurrentState = oJun_0371_0374; // At: ( BackendFsm > Starting >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> Recover ) => ( BackendFsm > Starting >> StartPlay )
  public void Tra_0371_0403( TsmHandler oHandler )
  {
    mCurrentState = oSub_0371_0380; // At: ( BackendFsm > Starting >> StartPlay )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> Recover > ConnExitRef ) => ( BackendFsm > Starting >> JuncState )
  public void Tra_0371_0397( TsmHandler oHandler )
  {
    mCurrentState = oJun_0371_0374; // At: ( BackendFsm > Starting >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> StartPlay ) => ( BackendFsm > Starting >> FinalState )
  public void Tra_0371_0401( TsmHandler oHandler )
  {
    mCurrentState = oFin_0371_0373; // At: ( BackendFsm > Starting >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting >> StartRead )
  public void Tra_0383_0394( TsmHandler oHandler )
  {
    mCurrentState = oSub_0371_0375; // At: ( BackendFsm > Starting >> StartRead )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 396:
      Tra_0371_0396( oHandler );
      break;
    case 399: // Up: ( BackendFsm > Starting >> JuncState ) => ( BackendFsm > Starting > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 404:
      Tra_0371_0404( oHandler );
      break;
    case 400:
      Tra_0371_0400( oHandler );
      break;
    case 398:
      Tra_0371_0398( oHandler );
      break;
    case 403:
      Tra_0371_0403( oHandler );
      break;
    case 397:
      Tra_0371_0397( oHandler );
      break;
    case 401:
      Tra_0371_0401( oHandler );
      break;
    case 402: // Up: ( BackendFsm > Starting >> StartPlay > ConnExitRef ) => ( BackendFsm > Starting > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 394:
      Tra_0383_0394( oHandler );
      break;
    case 395: // Up: ( BackendFsm > Starting >> CS_Open >> ChoiceState ) => ( BackendFsm > Starting > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting )
class Fsm_0087_0370 extends TsmFsm
{
  private Reg_0370_0371 oReg_0370_0371; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >)

  public Fsm_0087_0370( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    oReg_0370_0371 = new Reg_0370_0371( this );
    mRegions.add( oReg_0370_0371 );
    mNrTransitions = 0;
  }

  public void Tra_0371_0399( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 405; // ExitError
  }

  public void Tra_0371_0402( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 405; // ExitError
  }

  public void Tra_0383_0395( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 405; // ExitError
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 399:
      Tra_0371_0399( oHandler );
      break;
    case 402:
      Tra_0371_0402( oHandler );
      break;
    case 395:
      Tra_0383_0395( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting )
class Sub_0104_0108 extends TsmSubFsm
{
  private Con_0108_0109 oCon_0108_0109; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting > ConnExitRef )

  public Sub_0104_0108( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0370( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting )
    oCon_0108_0109 = new Con_0108_0109( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 128, "( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )" );
  }

  public void Tra_0092_0098( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 128; // TRLS ( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 98:
      Tra_0092_0098( oHandler );
      break;
    case 128: // UP: ( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 405: // UmlConnExit(Ref)
      oCon_0108_0109.Initial( oHandler );
      break;
    case 141: // UP: ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
class Con_0110_0111 extends TsmState
{
  public Con_0110_0111( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 137, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 137; // TRLS ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 137: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
class Con_0110_0112 extends TsmState
{
  public Con_0110_0112( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 136, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 136; // TRLS ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 136: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
class Con_0110_0113 extends TsmState
{
  public Con_0110_0113( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 133, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 133; // TRLS ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 133: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
class Con_0110_0114 extends TsmState
{
  public Con_0110_0114( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 134, "( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TACTRANSITION;
    oHandler.Index  = 134; // TRLS ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 134: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> InitialState )
class Ini_0297_0298 extends TsmPseudo
{
  public Ini_0297_0298( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 312, "( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 312; // TRLS ( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 312: // UP: ( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
class Jun_0297_0299 extends TsmPseudo
{
  public Jun_0297_0299( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 321, "( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 321; // TRLS ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0297_0317( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0297_0313( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 321: // UP: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
      bHigher = true;
      break;
    case 317:
      Tra_0297_0317( oHandler );
      break;
    case 313:
      Tra_0297_0313( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
class Jun_0297_0300 extends TsmPseudo
{
  public Jun_0297_0300( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 322, "( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 322; // TRLS ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0297_0316( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0297_0314( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 322: // UP: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
      bHigher = true;
      break;
    case 316:
      Tra_0297_0316( oHandler );
      break;
    case 314:
      Tra_0297_0314( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
class Con_0301_0302 extends TsmState
{
  public Con_0301_0302( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 310, "( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 310; // TRLS ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 310: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
class Con_0301_0303 extends TsmState
{
  public Con_0301_0303( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 315, "( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 315; // TRLS ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 315: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover )
class Sub_0297_0301 extends TsmSubFsm
{
  private Con_0301_0302 oCon_0301_0302; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )
  private Con_0301_0303 oCon_0301_0303; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover > ConnExitRef )

  public Sub_0297_0301( TsmBase oParent )
  {
    TsmName = "Recover";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0279( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
    oCon_0301_0302 = new Con_0301_0302( this );
    oCon_0301_0303 = new Con_0301_0303( this );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 308, "( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )" );
    mTransitions[ 1 ] = new TsmTransition( 319, "( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover ) : pp_player->Pause" );
  }

  public void Tra_0297_0321( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0297_0322( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 308; // TRLS ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )
    mTransitions[ 0 ].bVisit = true;
  }

  public void pp_player___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TACTRANSITION;
    oHandler.TacSubFsm = this;
    oHandler.Index  = 319; // pp_player.Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerSubFsm( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 15: // pp_player___Pause
        {
          pp_player___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 321:
      Tra_0297_0321( oHandler );
      break;
    case 322:
      Tra_0297_0322( oHandler );
      break;
    case 308: // UP: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 294: // UmlConnExit(Ref)
      oCon_0301_0302.Initial( oHandler );
      break;
    case 295: // UmlConnExit(Ref)
      oCon_0301_0303.Initial( oHandler );
      break;
    case 310: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 315: // UP: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 319: // UP: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
class Con_0304_0305 extends TsmState
{
  public Con_0304_0305( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 316, "( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 316; // TRLS ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 316: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
class Con_0304_0306 extends TsmState
{
  public Con_0304_0306( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 317, "( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 317; // TRLS ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 317: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay )
class Sub_0297_0304 extends TsmSubFsm
{
  private Con_0304_0305 oCon_0304_0305; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )
  private Con_0304_0306 oCon_0304_0306; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay > ConnExitRef )

  public Sub_0297_0304( TsmBase oParent )
  {
    TsmName = "StartPlay";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0171( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
    oCon_0304_0305 = new Con_0304_0305( this );
    oCon_0304_0306 = new Con_0304_0306( this );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 311, "( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )" );
    mTransitions[ 1 ] = new TsmTransition( 320, "( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart ) : pp_player->Pause" );
  }

  public void Tra_0297_0308( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 311; // TRLS ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  public void pp_player___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 320; // pp_player.Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerSubFsm( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 15: // pp_player___Pause
        {
          pp_player___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 308:
      Tra_0297_0308( oHandler );
      break;
    case 311: // UP: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 190: // UmlConnExit(Ref)
      oCon_0304_0305.Initial( oHandler );
      break;
    case 189: // UmlConnExit(Ref)
      oCon_0304_0306.Initial( oHandler );
      break;
    case 316: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 317: // UP: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 320: // UP: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Base )
class Lea_0297_0307 extends TsmLeaf
{
  public Lea_0297_0307( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 318, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause ) : pp_player->Pause" );
    mTransitions[ 1 ] = new TsmTransition( 313, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState ) : rpp_reader->Px_CbError" );
    mTransitions[ 2 ] = new TsmTransition( 309, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished ) : rpp_display->Px_CbFinished" );
    mTransitions[ 3 ] = new TsmTransition( 314, "( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState ) : rpp_display->Px_CbSynclost" );
  }

  public void Tra_0297_0312( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0297_0311( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void pp_player___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 318; // pp_player.Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 313; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void rpp_display___Px_CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 309; // rpp_display.Px_CbFinished
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 314; // rpp_display.Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 26:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 15: // pp_player___Pause
        {
          pp_player___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 84
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 85
    case 86: // Port rpp_display
      switch ( oHandler.Trigger.Command )
      {
      case 26: // rpp_display___Px_CbFinished
        {
          rpp_display___Px_CbFinished( oHandler );
        }
        break;
      case 31: // rpp_display___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          rpp_display___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 312:
      Tra_0297_0312( oHandler );
      break;
    case 311:
      Tra_0297_0311( oHandler );
      break;
    case 318: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
      bHigher = true;
      break;
    case 313: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
      bHigher = true;
      break;
    case 309: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished )
      bHigher = true;
      break;
    case 314: // UP: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >)
class Reg_0296_0297 extends TsmRegion
{
  private Ini_0297_0298 oIni_0297_0298; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> InitialState )
  private Jun_0297_0299 oJun_0297_0299; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
  private Jun_0297_0300 oJun_0297_0300; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> JuncState )
  private Sub_0297_0301 oSub_0297_0301; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Recover )
  private Sub_0297_0304 oSub_0297_0304; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> StartPlay )
  private Lea_0297_0307 oLea_0297_0307; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >> Base )

  public Reg_0296_0297( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0297_0298 = new Ini_0297_0298( this );
    oJun_0297_0299 = new Jun_0297_0299( this );
    oJun_0297_0300 = new Jun_0297_0300( this );
    oSub_0297_0301 = new Sub_0297_0301( this );
    oSub_0297_0304 = new Sub_0297_0304( this );
    oLea_0297_0307 = new Lea_0297_0307( this );
    mNrStates = 6;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0297_0298;
    mStates[ 1 ] = oJun_0297_0299;
    mStates[ 2 ] = oJun_0297_0300;
    mStates[ 3 ] = oSub_0297_0301;
    mStates[ 4 ] = oSub_0297_0304;
    mStates[ 5 ] = oLea_0297_0307;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0297_0298.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> InitialState ) => ( BackendFsm > Play >> Base )
  public void Tra_0297_0312( TsmHandler oHandler )
  {
    mCurrentState = oLea_0297_0307; // At: ( BackendFsm > Play >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
  public void Tra_0297_0321( TsmHandler oHandler )
  {
    mCurrentState = oSub_0297_0301; // At: ( BackendFsm > Play >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> JuncState ) => ( BackendFsm > Play >> Recover )
  public void Tra_0297_0322( TsmHandler oHandler )
  {
    mCurrentState = oSub_0297_0301; // At: ( BackendFsm > Play >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play >> StartPlay )
  public void Tra_0297_0308( TsmHandler oHandler )
  {
    mCurrentState = oSub_0297_0304; // At: ( BackendFsm > Play >> StartPlay )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play >> Base )
  public void Tra_0297_0311( TsmHandler oHandler )
  {
    mCurrentState = oLea_0297_0307; // At: ( BackendFsm > Play >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
  public void Tra_0297_0316( TsmHandler oHandler )
  {
    mCurrentState = oJun_0297_0300; // At: ( BackendFsm > Play >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> StartPlay > ConnExitRef ) => ( BackendFsm > Play >> JuncState )
  public void Tra_0297_0317( TsmHandler oHandler )
  {
    mCurrentState = oJun_0297_0299; // At: ( BackendFsm > Play >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
  public void Tra_0297_0313( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1247( oHandler );
    mCurrentState = oJun_0297_0299; // At: ( BackendFsm > Play >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
  public void Tra_0297_0314( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1252( oHandler );
    mCurrentState = oJun_0297_0300; // At: ( BackendFsm > Play >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.OK|TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 312:
      Tra_0297_0312( oHandler );
      break;
    case 321:
      Tra_0297_0321( oHandler );
      break;
    case 322:
      Tra_0297_0322( oHandler );
      break;
    case 308:
      Tra_0297_0308( oHandler );
      break;
    case 310: // Up: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 315: // Up: ( BackendFsm > Play >> Recover > ConnExitRef ) => ( BackendFsm > Play > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 311:
      Tra_0297_0311( oHandler );
      break;
    case 316:
      Tra_0297_0316( oHandler );
      break;
    case 317:
      Tra_0297_0317( oHandler );
      break;
    case 319: // Up: ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
      mCurrentState = null;
      bHigher = true;
      break;
    case 320: // Up: ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
      mCurrentState = null;
      bHigher = true;
      break;
    case 318: // Up: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
      mCurrentState = null;
      bHigher = true;
      break;
    case 313:
      Tra_0297_0313( oHandler );
      break;
    case 309: // Up: ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 314:
      Tra_0297_0314( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play )
class Fsm_0087_0296 extends TsmFsm
{
  private Reg_0296_0297 oReg_0296_0297; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play >)

  public Fsm_0087_0296( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    oReg_0296_0297 = new Reg_0296_0297( this );
    mRegions.add( oReg_0296_0297 );
    mNrTransitions = 0;
  }

  public void Tra_0297_0310( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 323; // ExitFinished
  }

  public void Tra_0297_0315( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 324; // ExitError
  }

  public void Tra_0297_0319( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1230( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 326; // ExitPauseRecover
  }

  public void Tra_0297_0320( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1232( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 327; // ExitPauseStart
  }

  public void Tra_0297_0318( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1234( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 325; // ExitPause
  }

  public void Tra_0297_0309( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 323; // ExitFinished
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 310:
      Tra_0297_0310( oHandler );
      break;
    case 315:
      Tra_0297_0315( oHandler );
      break;
    case 319:
      Tra_0297_0319( oHandler );
      break;
    case 320:
      Tra_0297_0320( oHandler );
      break;
    case 318:
      Tra_0297_0318( oHandler );
      break;
    case 309:
      Tra_0297_0309( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play )
class Sub_0104_0110 extends TsmSubFsm
{
  private Con_0110_0111 oCon_0110_0111; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  private Con_0110_0112 oCon_0110_0112; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  private Con_0110_0113 oCon_0110_0113; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )
  private Con_0110_0114 oCon_0110_0114; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play > ConnExitRef )

  public Sub_0104_0110( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0296( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Play )
    oCon_0110_0111 = new Con_0110_0111( this );
    oCon_0110_0112 = new Con_0110_0112( this );
    oCon_0110_0113 = new Con_0110_0113( this );
    oCon_0110_0114 = new Con_0110_0114( this );
    mNrTransitions = 0;
  }

  public void Tra_0104_0128( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0104_0139( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 128:
      Tra_0104_0128( oHandler );
      break;
    case 324: // UmlConnExit(Ref)
      oCon_0110_0111.Initial( oHandler );
      break;
    case 323: // UmlConnExit(Ref)
      oCon_0110_0112.Initial( oHandler );
      break;
    case 325: // UmlConnExit(Ref)
    case 327: // UmlConnExit(Ref)
      oCon_0110_0113.Initial( oHandler );
      break;
    case 326: // UmlConnExit(Ref)
      oCon_0110_0114.Initial( oHandler );
      break;
    case 137: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 136: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 133: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 134: // UP: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 139:
      Tra_0104_0139( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnEntryRef )
class Con_0115_0116 extends TsmState
{
  public Con_0115_0116( TsmBase oParent )
  {
    TsmName = "ConnEntryRef";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnEntryRef )
class Con_0115_0117 extends TsmState
{
  public Con_0115_0117( TsmBase oParent )
  {
    TsmName = "ConnEntryRef";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
class Con_0115_0118 extends TsmState
{
  public Con_0115_0118( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 135, "( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 135; // TRLS ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 135: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
class Con_0115_0119 extends TsmState
{
  public Con_0115_0119( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 140, "( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 140; // TRLS ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 140: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> FinalState )
class Fin_0246_0247 extends TsmFinal
{
  public Fin_0246_0247( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0246_0256( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 256:
      Tra_0246_0256( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
class Con_0248_0249 extends TsmState
{
  public Con_0248_0249( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 259, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 259; // TRLS ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 259: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
class Con_0248_0250 extends TsmState
{
  public Con_0248_0250( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 260, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 260; // TRLS ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 260: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
class Con_0248_0251 extends TsmState
{
  public Con_0248_0251( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 262, "( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 262; // TRLS ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 262: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> InitialState )
class Ini_0407_0408 extends TsmPseudo
{
  public Ini_0407_0408( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 425, "( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 425; // TRLS ( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 425: // UP: ( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> FinalState )
class Fin_0407_0409 extends TsmFinal
{
  public Fin_0407_0409( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0411_0422( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 422:
      Tra_0411_0422( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> InitialState )
class Ini_0411_0412 extends TsmPseudo
{
  public Ini_0411_0412( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 420, "( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 420; // TRLS ( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 420: // UP: ( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
class Cho_0411_0413 extends TsmPseudo
{
  public Cho_0411_0413( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 421, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 419, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 421; // TRLS ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 419; // TRLS ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0411_0417( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 421: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
      bHigher = true;
      break;
    case 419: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
      bHigher = true;
      break;
    case 417:
      Tra_0411_0417( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
class Cho_0411_0414 extends TsmPseudo
{
  public Cho_0411_0414( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 422, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )" );
    mTransitions[ 1 ] = new TsmTransition( 423, "( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )" );
  }

  public void Tra_0411_0421( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0080_0082)oHandler.Owner).Guard_1041() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 422; // TRLS ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 423; // TRLS ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 421:
      Tra_0411_0421( oHandler );
      break;
    case 422: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
      bHigher = true;
      break;
    case 423: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Base )
class Lea_0411_0415 extends TsmLeaf
{
  public Lea_0411_0415( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 417, "( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )" );
  }

  public void Tra_0411_0420( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 417; // TRLS ( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0411_0418( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1042( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 420:
      Tra_0411_0420( oHandler );
      break;
    case 417: // UP: ( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
      bHigher = true;
      break;
    case 418:
      Tra_0411_0418( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Wait )
class Lea_0411_0416 extends TsmLeaf
{
  public Lea_0411_0416( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 418, "( BackendFsm > Tac_StartPause >> CS >> Wait ) => ( BackendFsm > Tac_StartPause >> CS >> Base ) : ??" );
  }

  public void Tra_0411_0419( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0411_0423( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 418; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 419:
      Tra_0411_0419( oHandler );
      break;
    case 423:
      Tra_0411_0423( oHandler );
      break;
    case 418: // UP: ( BackendFsm > Tac_StartPause >> CS >> Wait ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >)
class Reg_0410_0411 extends TsmRegion
{
  private Ini_0411_0412 oIni_0411_0412; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> InitialState )
  private Cho_0411_0413 oCho_0411_0413; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  private Cho_0411_0414 oCho_0411_0414; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  private Lea_0411_0415 oLea_0411_0415; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Base )
  private Lea_0411_0416 oLea_0411_0416; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Wait )

  public Reg_0410_0411( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0411_0412 = new Ini_0411_0412( this );
    oCho_0411_0413 = new Cho_0411_0413( this );
    oCho_0411_0414 = new Cho_0411_0414( this );
    oLea_0411_0415 = new Lea_0411_0415( this );
    oLea_0411_0416 = new Lea_0411_0416( this );
    mNrStates = 5;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0411_0412;
    mStates[ 1 ] = oCho_0411_0413;
    mStates[ 2 ] = oCho_0411_0414;
    mStates[ 3 ] = oLea_0411_0415;
    mStates[ 4 ] = oLea_0411_0416;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0411_0412.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
  public void Tra_0411_0420( TsmHandler oHandler )
  {
    mCurrentState = oLea_0411_0415; // At: ( BackendFsm > Tac_StartPause >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  public void Tra_0411_0421( TsmHandler oHandler )
  {
    mCurrentState = oCho_0411_0414; // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
  public void Tra_0411_0419( TsmHandler oHandler )
  {
    mCurrentState = oLea_0411_0416; // At: ( BackendFsm > Tac_StartPause >> CS >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> CS >> Wait )
  public void Tra_0411_0423( TsmHandler oHandler )
  {
    mCurrentState = oLea_0411_0416; // At: ( BackendFsm > Tac_StartPause >> CS >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> Base ) => ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
  public void Tra_0411_0417( TsmHandler oHandler )
  {
    mCurrentState = oCho_0411_0413; // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> Wait ) => ( BackendFsm > Tac_StartPause >> CS >> Base )
  public void Tra_0411_0418( TsmHandler oHandler )
  {
    mCurrentState = oLea_0411_0415; // At: ( BackendFsm > Tac_StartPause >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 420:
      Tra_0411_0420( oHandler );
      break;
    case 421:
      Tra_0411_0421( oHandler );
      break;
    case 419:
      Tra_0411_0419( oHandler );
      break;
    case 422: // Up: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 423:
      Tra_0411_0423( oHandler );
      break;
    case 417:
      Tra_0411_0417( oHandler );
      break;
    case 418:
      Tra_0411_0418( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS )
class Com_0407_0410 extends TsmCompound
{
  private Reg_0410_0411 oReg_0410_0411; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >)

  public Com_0407_0410( TsmBase oParent )
  {
    TsmName = "CS";
    TsmParent = oParent;
    oReg_0410_0411 = new Reg_0410_0411( this );
    mRegions.add( oReg_0410_0411 );
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 424, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError ) : rpp_reader->Px_CbError" );
    mTransitions[ 1 ] = new TsmTransition( 427, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished ) : rpp_display->Px_CbFinished" );
    mTransitions[ 2 ] = new TsmTransition( 426, "( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost ) : rpp_display->Px_CbSynclost" );
  }

  public void Tra_0407_0425( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 424; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rpp_display___Px_CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 427; // rpp_display.Px_CbFinished
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 426; // rpp_display.Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 26:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 85
    case 86: // Port rpp_display
      switch ( oHandler.Trigger.Command )
      {
      case 26: // rpp_display___Px_CbFinished
        {
          rpp_display___Px_CbFinished( oHandler );
        }
        break;
      case 31: // rpp_display___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          rpp_display___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 425:
      Tra_0407_0425( oHandler );
      break;
    case 422: // UP: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 424: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 427: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 426: // UP: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >)
class Reg_0406_0407 extends TsmRegion
{
  private Ini_0407_0408 oIni_0407_0408; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> InitialState )
  private Fin_0407_0409 oFin_0407_0409; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> FinalState )
  private Com_0407_0410 oCom_0407_0410; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS )

  public Reg_0406_0407( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0407_0408 = new Ini_0407_0408( this );
    oFin_0407_0409 = new Fin_0407_0409( this );
    oCom_0407_0410 = new Com_0407_0410( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0407_0408;
    mStates[ 1 ] = oFin_0407_0409;
    mStates[ 2 ] = oCom_0407_0410;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0407_0408.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> InitialState ) => ( BackendFsm > Tac_StartPause >> CS )
  public void Tra_0407_0425( TsmHandler oHandler )
  {
    mCurrentState = oCom_0407_0410; // At: ( BackendFsm > Tac_StartPause >> CS )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Tac_StartPause >> CS >> ChoiceState ) => ( BackendFsm > Tac_StartPause >> FinalState )
  public void Tra_0411_0422( TsmHandler oHandler )
  {
    mCurrentState = oFin_0407_0409; // At: ( BackendFsm > Tac_StartPause >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 425:
      Tra_0407_0425( oHandler );
      break;
    case 422:
      Tra_0411_0422( oHandler );
      break;
    case 424: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 427: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 426: // Up: ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause )
class Fsm_0087_0406 extends TsmFsm
{
  private Reg_0406_0407 oReg_0406_0407; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >)

  public Fsm_0087_0406( TsmBase oParent )
  {
    TsmName = "Tac_StartPause";
    TsmParent = oParent;
    oReg_0406_0407 = new Reg_0406_0407( this );
    mRegions.add( oReg_0406_0407 );
    mNrTransitions = 0;
  }

  public void Tra_0407_0424( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1248( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 428; // ExitReadError
  }

  public void Tra_0407_0427( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 430; // ExitFinished
  }

  public void Tra_0407_0426( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1253( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 429; // ExitSynclost
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 424:
      Tra_0407_0424( oHandler );
      break;
    case 427:
      Tra_0407_0427( oHandler );
      break;
    case 426:
      Tra_0407_0426( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause )
class Sub_0246_0248 extends TsmSubFsm
{
  private Con_0248_0249 oCon_0248_0249; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
  private Con_0248_0250 oCon_0248_0250; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )
  private Con_0248_0251 oCon_0248_0251; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause > ConnExitRef )

  public Sub_0246_0248( TsmBase oParent )
  {
    TsmName = "StartPause";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0406( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause )
    oCon_0248_0249 = new Con_0248_0249( this );
    oCon_0248_0250 = new Con_0248_0250( this );
    oCon_0248_0251 = new Con_0248_0251( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 256, "( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )" );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 256; // TRLS ( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0246_0263( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0246_0255( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 256: // UP: ( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 428: // UmlConnExit(Ref)
      oCon_0248_0249.Initial( oHandler );
      break;
    case 429: // UmlConnExit(Ref)
      oCon_0248_0250.Initial( oHandler );
      break;
    case 430: // UmlConnExit(Ref)
      oCon_0248_0251.Initial( oHandler );
      break;
    case 259: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 260: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 262: // UP: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 263:
      Tra_0246_0263( oHandler );
      break;
    case 255:
      Tra_0246_0255( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
class Con_0252_0253 extends TsmState
{
  public Con_0252_0253( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 257, "( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 257; // TRLS ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 257: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
class Con_0252_0254 extends TsmState
{
  public Con_0252_0254( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 258, "( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 258; // TRLS ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 258: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover )
class Sub_0246_0252 extends TsmSubFsm
{
  private Con_0252_0253 oCon_0252_0253; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )
  private Con_0252_0254 oCon_0252_0254; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover > ConnExitRef )

  public Sub_0246_0252( TsmBase oParent )
  {
    TsmName = "Recover";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0279( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
    oCon_0252_0253 = new Con_0252_0253( this );
    oCon_0252_0254 = new Con_0252_0254( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 263, "( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )" );
  }

  public void Tra_0246_0259( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0246_0260( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 263; // TRLS ( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0246_0261( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oFsm = oHandler.TacSubFsm.SwapFsms( oFsm );
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 259:
      Tra_0246_0259( oHandler );
      break;
    case 260:
      Tra_0246_0260( oHandler );
      break;
    case 263: // UP: ( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 294: // UmlConnExit(Ref)
      oCon_0252_0253.Initial( oHandler );
      break;
    case 295: // UmlConnExit(Ref)
      oCon_0252_0254.Initial( oHandler );
      break;
    case 257: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 258: // UP: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 261:
      Tra_0246_0261( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >)
class Reg_0245_0246 extends TsmRegion
{
  private Fin_0246_0247 oFin_0246_0247; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> FinalState )
  private Sub_0246_0248 oSub_0246_0248; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> StartPause )
  private Sub_0246_0252 oSub_0246_0252; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >> Recover )

  public Reg_0245_0246( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oFin_0246_0247 = new Fin_0246_0247( this );
    oSub_0246_0248 = new Sub_0246_0248( this );
    oSub_0246_0252 = new Sub_0246_0252( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oFin_0246_0247;
    mStates[ 1 ] = oSub_0246_0248;
    mStates[ 2 ] = oSub_0246_0252;
  }

   // At: ( BackendFsm > Pausing >> StartPause ) => ( BackendFsm > Pausing >> FinalState )
  public void Tra_0246_0256( TsmHandler oHandler )
  {
    mCurrentState = oFin_0246_0247; // At: ( BackendFsm > Pausing >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
  public void Tra_0246_0259( TsmHandler oHandler )
  {
    mCurrentState = oSub_0246_0252; // At: ( BackendFsm > Pausing >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing >> Recover )
  public void Tra_0246_0260( TsmHandler oHandler )
  {
    mCurrentState = oSub_0246_0252; // At: ( BackendFsm > Pausing >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Pausing >> Recover ) => ( BackendFsm > Pausing >> StartPause )
  public void Tra_0246_0263( TsmHandler oHandler )
  {
    mCurrentState = oSub_0246_0248; // At: ( BackendFsm > Pausing >> StartPause )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )
  public void Tra_0246_0255( TsmHandler oHandler )
  {
    mCurrentState = oSub_0246_0248; // Down: ( BackendFsm > Pausing >> StartPause )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )
  public void Tra_0246_0261( TsmHandler oHandler )
  {
    mCurrentState = oSub_0246_0252; // Down: ( BackendFsm > Pausing >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 256:
      Tra_0246_0256( oHandler );
      break;
    case 259:
      Tra_0246_0259( oHandler );
      break;
    case 260:
      Tra_0246_0260( oHandler );
      break;
    case 262: // Up: ( BackendFsm > Pausing >> StartPause > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 263:
      Tra_0246_0263( oHandler );
      break;
    case 257: // Up: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 258: // Up: ( BackendFsm > Pausing >> Recover > ConnExitRef ) => ( BackendFsm > Pausing > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 255:
      Tra_0246_0255( oHandler );
      break;
    case 261:
      Tra_0246_0261( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseStart )
class Con_0245_0264 extends TsmState
{
  public Con_0245_0264( TsmBase oParent )
  {
    TsmName = "EntryPauseStart";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 255, "( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 255; // TRLS ( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 255: // UP: ( BackendFsm > Pausing > EntryPauseStart ) => ( BackendFsm > Pausing >> StartPause )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseRecover )
class Con_0245_0265 extends TsmState
{
  public Con_0245_0265( TsmBase oParent )
  {
    TsmName = "EntryPauseRecover";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 261, "( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TACTRANSITION;
    oHandler.Index  = 261; // TRLS ( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 261: // UP: ( BackendFsm > Pausing > EntryPauseRecover ) => ( BackendFsm > Pausing >> Recover )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing )
class Fsm_0087_0245 extends TsmFsm
{
  private Reg_0245_0246 oReg_0245_0246; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing >)
  private Con_0245_0264 oCon_0245_0264; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseStart )
  private Con_0245_0265 oCon_0245_0265; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing > EntryPauseRecover )

  public Fsm_0087_0245( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    oReg_0245_0246 = new Reg_0245_0246( this );
    oCon_0245_0264 = new Con_0245_0264( this );
    oCon_0245_0265 = new Con_0245_0265( this );
    mRegions.add( oReg_0245_0246 );
    mNrTransitions = 0;
  }

  @Override
  public void Entrypoint( TsmHandler oHandler )
  {
    oReg_0245_0246.Reset();
    switch ( oHandler.Index )
    {
    case 264:
      oCon_0245_0264.Initial( oHandler );
      break;
    case 265:
      oCon_0245_0265.Initial( oHandler );
      break;
    }
    ExecuteHandler( oHandler );
  }

  public void Tra_0246_0262( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 267; // ExitFinished
  }

  public void Tra_0246_0257( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 267; // ExitFinished
  }

  public void Tra_0246_0258( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 266; // ExitError
  }

  public void Tra_0246_0255( TsmHandler oHandler )
  {
    oReg_0245_0246.ExecuteHandler( oHandler );
  }

  public void Tra_0246_0261( TsmHandler oHandler )
  {
    oReg_0245_0246.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 262:
      Tra_0246_0262( oHandler );
      break;
    case 257:
      Tra_0246_0257( oHandler );
      break;
    case 258:
      Tra_0246_0258( oHandler );
      break;
    case 255:
      Tra_0246_0255( oHandler );
      break;
    case 261:
      Tra_0246_0261( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing )
class Sub_0104_0115 extends TsmSubFsm
{
  private Con_0115_0118 oCon_0115_0118; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )
  private Con_0115_0119 oCon_0115_0119; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing > ConnExitRef )

  public Sub_0104_0115( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0245( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Pausing )
    oCon_0115_0118 = new Con_0115_0118( this );
    oCon_0115_0119 = new Con_0115_0119( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 132, "( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )" );
  }

  public void Tra_0104_0133( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTRYPOINT;
    oHandler.Index = 264;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0104_0134( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTRYPOINT;
    oHandler.Index = 265;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 132; // TRLS ( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 133:
      Tra_0104_0133( oHandler );
      break;
    case 134:
      Tra_0104_0134( oHandler );
      break;
    case 132: // UP: ( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 267: // UmlConnExit(Ref)
      oCon_0115_0118.Initial( oHandler );
      break;
    case 266: // UmlConnExit(Ref)
      oCon_0115_0119.Initial( oHandler );
      break;
    case 135: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 140: // UP: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused > ConnExitRef )
class Con_0120_0121 extends TsmState
{
  public Con_0120_0121( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 143, "( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 143; // TRLS ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 143: // UP: ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> InitialState )
class Ini_0269_0270 extends TsmPseudo
{
  public Ini_0269_0270( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 274, "( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 274; // TRLS ( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 274: // UP: ( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> FinalState )
class Fin_0269_0271 extends TsmFinal
{
  public Fin_0269_0271( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0269_0277( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 277:
      Tra_0269_0277( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> Base )
class Lea_0269_0272 extends TsmLeaf
{
  public Lea_0269_0272( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 277, "( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState ) : pp_player->Continue" );
    mTransitions[ 1 ] = new TsmTransition( 275, "( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError ) : rpp_reader->Px_CbError" );
  }

  public void Tra_0269_0274( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void pp_player___Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 277; // pp_player.Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 275; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 16: // pp_player___Continue
        {
          pp_player___Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 84
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 274:
      Tra_0269_0274( oHandler );
      break;
    case 277: // UP: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState )
      bHigher = true;
      break;
    case 275: // UP: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> ReadError )
class Lea_0269_0273 extends TsmLeaf
{
  public Lea_0269_0273( TsmBase oParent )
  {
    TsmName = "ReadError";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 276, "( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError ) : pp_player->Continue" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void pp_player___Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 276; // pp_player.Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0269_0275( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 16: // pp_player___Continue
        {
          pp_player___Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 276: // UP: ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
      bHigher = true;
      break;
    case 275:
      Tra_0269_0275( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >)
class Reg_0268_0269 extends TsmRegion
{
  private Ini_0269_0270 oIni_0269_0270; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> InitialState )
  private Fin_0269_0271 oFin_0269_0271; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> FinalState )
  private Lea_0269_0272 oLea_0269_0272; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> Base )
  private Lea_0269_0273 oLea_0269_0273; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >> ReadError )

  public Reg_0268_0269( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0269_0270 = new Ini_0269_0270( this );
    oFin_0269_0271 = new Fin_0269_0271( this );
    oLea_0269_0272 = new Lea_0269_0272( this );
    oLea_0269_0273 = new Lea_0269_0273( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0269_0270;
    mStates[ 1 ] = oFin_0269_0271;
    mStates[ 2 ] = oLea_0269_0272;
    mStates[ 3 ] = oLea_0269_0273;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0269_0270.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Paused >> InitialState ) => ( BackendFsm > Paused >> Base )
  public void Tra_0269_0274( TsmHandler oHandler )
  {
    mCurrentState = oLea_0269_0272; // At: ( BackendFsm > Paused >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState )
  public void Tra_0269_0277( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1240( oHandler );
    mCurrentState = oFin_0269_0271; // At: ( BackendFsm > Paused >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError )
  public void Tra_0269_0275( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1249( oHandler );
    mCurrentState = oLea_0269_0273; // At: ( BackendFsm > Paused >> ReadError )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 274:
      Tra_0269_0274( oHandler );
      break;
    case 277:
      Tra_0269_0277( oHandler );
      break;
    case 276: // Up: ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 275:
      Tra_0269_0275( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused )
class Fsm_0087_0268 extends TsmFsm
{
  private Reg_0268_0269 oReg_0268_0269; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused >)

  public Fsm_0087_0268( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    oReg_0268_0269 = new Reg_0268_0269( this );
    mRegions.add( oReg_0268_0269 );
    mNrTransitions = 0;
  }

  public void Tra_0269_0276( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1242( oHandler );
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 278; // ExitReadError
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 276:
      Tra_0269_0276( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused )
class Sub_0104_0120 extends TsmSubFsm
{
  private Con_0120_0121 oCon_0120_0121; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused > ConnExitRef )

  public Sub_0104_0120( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0268( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Paused )
    oCon_0120_0121 = new Con_0120_0121( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 138, "( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )" );
  }

  public void Tra_0104_0132( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 138; // TRLS ( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 132:
      Tra_0104_0132( oHandler );
      break;
    case 138: // UP: ( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 278: // UmlConnExit(Ref)
      oCon_0120_0121.Initial( oHandler );
      break;
    case 143: // UP: ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnEntryRef )
class Con_0122_0123 extends TsmState
{
  public Con_0122_0123( TsmBase oParent )
  {
    TsmName = "ConnEntryRef";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
class Con_0122_0124 extends TsmState
{
  public Con_0122_0124( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 145, "( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 145; // TRLS ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 145: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
class Con_0122_0125 extends TsmState
{
  public Con_0122_0125( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 142, "( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 142; // TRLS ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 142: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> InitialState )
class Ini_0329_0330 extends TsmPseudo
{
  public Ini_0329_0330( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 353, "( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 353; // TRLS ( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 353: // UP: ( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
class Fin_0329_0331 extends TsmFinal
{
  public Fin_0329_0331( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0343_0349( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 349:
      Tra_0343_0349( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
class Fin_0329_0332 extends TsmFinal
{
  public Fin_0329_0332( TsmBase oParent )
  {
    TsmName = "FinalState";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0329_0361( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 361:
      Tra_0329_0361( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
class Jun_0329_0333 extends TsmPseudo
{
  public Jun_0329_0333( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 366, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 366; // TRLS ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0329_0358( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0329_0356( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 366: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
      bHigher = true;
      break;
    case 358:
      Tra_0329_0358( oHandler );
      break;
    case 356:
      Tra_0329_0356( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
class Jun_0329_0334 extends TsmPseudo
{
  public Jun_0329_0334( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 364, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 364; // TRLS ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0329_0359( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0329_0357( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 364: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )
      bHigher = true;
      break;
    case 359:
      Tra_0329_0359( oHandler );
      break;
    case 357:
      Tra_0329_0357( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
class Jun_0329_0335 extends TsmPseudo
{
  public Jun_0329_0335( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 365, "( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )" );
  }

  public void Tra_0329_0364( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 365; // TRLS ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0329_0363( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 364:
      Tra_0329_0364( oHandler );
      break;
    case 365: // UP: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
      bHigher = true;
      break;
    case 363:
      Tra_0329_0363( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
class Con_0336_0337 extends TsmState
{
  public Con_0336_0337( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 354, "( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 354; // TRLS ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 354: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
class Con_0336_0338 extends TsmState
{
  public Con_0336_0338( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 360, "( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 360; // TRLS ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 360: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover )
class Sub_0329_0336 extends TsmSubFsm
{
  private Con_0336_0337 oCon_0336_0337; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )
  private Con_0336_0338 oCon_0336_0338; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover > ConnExitRef )

  public Sub_0329_0336( TsmBase oParent )
  {
    TsmName = "Recover";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0279( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Recover )
    oCon_0336_0337 = new Con_0336_0337( this );
    oCon_0336_0338 = new Con_0336_0338( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 355, "( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )" );
  }

  public void Tra_0329_0366( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0329_0365( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 355; // TRLS ( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 366:
      Tra_0329_0366( oHandler );
      break;
    case 365:
      Tra_0329_0365( oHandler );
      break;
    case 355: // UP: ( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 294: // UmlConnExit(Ref)
      oCon_0336_0337.Initial( oHandler );
      break;
    case 295: // UmlConnExit(Ref)
      oCon_0336_0338.Initial( oHandler );
      break;
    case 354: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 360: // UP: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
class Con_0339_0340 extends TsmState
{
  public Con_0339_0340( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 359, "( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 359; // TRLS ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 359: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
class Con_0339_0341 extends TsmState
{
  public Con_0339_0341( TsmBase oParent )
  {
    TsmName = "ConnExitRef";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 358, "( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 358; // TRLS ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 358: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay )
class Sub_0329_0339 extends TsmSubFsm
{
  private Con_0339_0340 oCon_0339_0340; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )
  private Con_0339_0341 oCon_0339_0341; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay > ConnExitRef )

  public Sub_0329_0339( TsmBase oParent )
  {
    TsmName = "StartPlay";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0171( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay )
    oCon_0339_0340 = new Con_0339_0340( this );
    oCon_0339_0341 = new Con_0339_0341( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 361, "( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )" );
  }

  public void Tra_0329_0355( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 361; // TRLS ( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 355:
      Tra_0329_0355( oHandler );
      break;
    case 361: // UP: ( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 189: // UmlConnExit(Ref)
      oCon_0339_0340.Initial( oHandler );
      break;
    case 190: // UmlConnExit(Ref)
      oCon_0339_0341.Initial( oHandler );
      break;
    case 359: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 358: // UP: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> InitialState )
class Ini_0343_0344 extends TsmPseudo
{
  public Ini_0343_0344( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 350, "( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 350; // TRLS ( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 350: // UP: ( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> ChoiceState )
class Cho_0343_0345 extends TsmPseudo
{
  public Cho_0343_0345( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 349, "( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 348, "( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 349; // TRLS ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 348; // TRLS ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0343_0352( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 349: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
      bHigher = true;
      break;
    case 348: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait )
      bHigher = true;
      break;
    case 352:
      Tra_0343_0352( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Base )
class Lea_0343_0346 extends TsmLeaf
{
  public Lea_0343_0346( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 352, "( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )" );
  }

  public void Tra_0343_0350( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 352; // TRLS ( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0343_0351( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    ((Cla_0080_0082)oHandler.Owner).Function_1038( oHandler );
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 350:
      Tra_0343_0350( oHandler );
      break;
    case 352: // UP: ( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )
      bHigher = true;
      break;
    case 351:
      Tra_0343_0351( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Wait )
class Lea_0343_0347 extends TsmLeaf
{
  public Lea_0343_0347( TsmBase oParent )
  {
    TsmName = "Wait";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 351, "( BackendFsm > Continuing >> CS >> Wait ) => ( BackendFsm > Continuing >> CS >> Base ) : ??" );
  }

  public void Tra_0343_0348( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 351; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 348:
      Tra_0343_0348( oHandler );
      break;
    case 351: // UP: ( BackendFsm > Continuing >> CS >> Wait ) => ( BackendFsm > Continuing >> CS >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >)
class Reg_0342_0343 extends TsmRegion
{
  private Ini_0343_0344 oIni_0343_0344; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> InitialState )
  private Cho_0343_0345 oCho_0343_0345; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> ChoiceState )
  private Lea_0343_0346 oLea_0343_0346; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Base )
  private Lea_0343_0347 oLea_0343_0347; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Wait )

  public Reg_0342_0343( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0343_0344 = new Ini_0343_0344( this );
    oCho_0343_0345 = new Cho_0343_0345( this );
    oLea_0343_0346 = new Lea_0343_0346( this );
    oLea_0343_0347 = new Lea_0343_0347( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0343_0344;
    mStates[ 1 ] = oCho_0343_0345;
    mStates[ 2 ] = oLea_0343_0346;
    mStates[ 3 ] = oLea_0343_0347;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0343_0344.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS >> InitialState ) => ( BackendFsm > Continuing >> CS >> Base )
  public void Tra_0343_0350( TsmHandler oHandler )
  {
    mCurrentState = oLea_0343_0346; // At: ( BackendFsm > Continuing >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> CS >> Wait )
  public void Tra_0343_0348( TsmHandler oHandler )
  {
    mCurrentState = oLea_0343_0347; // At: ( BackendFsm > Continuing >> CS >> Wait )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS >> Base ) => ( BackendFsm > Continuing >> CS >> ChoiceState )
  public void Tra_0343_0352( TsmHandler oHandler )
  {
    mCurrentState = oCho_0343_0345; // At: ( BackendFsm > Continuing >> CS >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS >> Wait ) => ( BackendFsm > Continuing >> CS >> Base )
  public void Tra_0343_0351( TsmHandler oHandler )
  {
    mCurrentState = oLea_0343_0346; // At: ( BackendFsm > Continuing >> CS >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 350:
      Tra_0343_0350( oHandler );
      break;
    case 349: // Up: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 348:
      Tra_0343_0348( oHandler );
      break;
    case 352:
      Tra_0343_0352( oHandler );
      break;
    case 351:
      Tra_0343_0351( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS )
class Com_0329_0342 extends TsmCompound
{
  private Reg_0342_0343 oReg_0342_0343; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >)

  public Com_0329_0342( TsmBase oParent )
  {
    TsmName = "CS";
    TsmParent = oParent;
    oReg_0342_0343 = new Reg_0342_0343( this );
    mRegions.add( oReg_0342_0343 );
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 357, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState ) : rpp_reader->Px_CbError" );
    mTransitions[ 1 ] = new TsmTransition( 362, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished ) : rpp_display->Px_CbFinished" );
    mTransitions[ 2 ] = new TsmTransition( 356, "( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState ) : rpp_display->Px_CbSynclost" );
  }

  public void Tra_0329_0353( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 357; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rpp_display___Px_CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 362; // rpp_display.Px_CbFinished
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void rpp_display___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 356; // rpp_display.Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 26:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 85
    case 86: // Port rpp_display
      switch ( oHandler.Trigger.Command )
      {
      case 26: // rpp_display___Px_CbFinished
        {
          rpp_display___Px_CbFinished( oHandler );
        }
        break;
      case 31: // rpp_display___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          rpp_display___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 353:
      Tra_0329_0353( oHandler );
      break;
    case 349: // UP: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 357: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 362: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 356: // UP: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >)
class Reg_0328_0329 extends TsmRegion
{
  private Ini_0329_0330 oIni_0329_0330; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> InitialState )
  private Fin_0329_0331 oFin_0329_0331; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
  private Fin_0329_0332 oFin_0329_0332; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> FinalState )
  private Jun_0329_0333 oJun_0329_0333; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  private Jun_0329_0334 oJun_0329_0334; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  private Jun_0329_0335 oJun_0329_0335; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> JuncState )
  private Sub_0329_0336 oSub_0329_0336; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> Recover )
  private Sub_0329_0339 oSub_0329_0339; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> StartPlay )
  private Com_0329_0342 oCom_0329_0342; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS )

  public Reg_0328_0329( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0329_0330 = new Ini_0329_0330( this );
    oFin_0329_0331 = new Fin_0329_0331( this );
    oFin_0329_0332 = new Fin_0329_0332( this );
    oJun_0329_0333 = new Jun_0329_0333( this );
    oJun_0329_0334 = new Jun_0329_0334( this );
    oJun_0329_0335 = new Jun_0329_0335( this );
    oSub_0329_0336 = new Sub_0329_0336( this );
    oSub_0329_0339 = new Sub_0329_0339( this );
    oCom_0329_0342 = new Com_0329_0342( this );
    mNrStates = 9;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0329_0330;
    mStates[ 1 ] = oFin_0329_0331;
    mStates[ 2 ] = oFin_0329_0332;
    mStates[ 3 ] = oJun_0329_0333;
    mStates[ 4 ] = oJun_0329_0334;
    mStates[ 5 ] = oJun_0329_0335;
    mStates[ 6 ] = oSub_0329_0336;
    mStates[ 7 ] = oSub_0329_0339;
    mStates[ 8 ] = oCom_0329_0342;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0329_0330.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> InitialState ) => ( BackendFsm > Continuing >> CS )
  public void Tra_0329_0353( TsmHandler oHandler )
  {
    mCurrentState = oCom_0329_0342; // At: ( BackendFsm > Continuing >> CS )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
  public void Tra_0329_0366( TsmHandler oHandler )
  {
    mCurrentState = oSub_0329_0336; // At: ( BackendFsm > Continuing >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0364( TsmHandler oHandler )
  {
    mCurrentState = oJun_0329_0335; // At: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> JuncState ) => ( BackendFsm > Continuing >> Recover )
  public void Tra_0329_0365( TsmHandler oHandler )
  {
    mCurrentState = oSub_0329_0336; // At: ( BackendFsm > Continuing >> Recover )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> Recover ) => ( BackendFsm > Continuing >> StartPlay )
  public void Tra_0329_0355( TsmHandler oHandler )
  {
    mCurrentState = oSub_0329_0339; // At: ( BackendFsm > Continuing >> StartPlay )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> StartPlay ) => ( BackendFsm > Continuing >> FinalState )
  public void Tra_0329_0361( TsmHandler oHandler )
  {
    mCurrentState = oFin_0329_0332; // At: ( BackendFsm > Continuing >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0359( TsmHandler oHandler )
  {
    mCurrentState = oJun_0329_0334; // At: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> StartPlay > ConnExitRef ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0358( TsmHandler oHandler )
  {
    mCurrentState = oJun_0329_0333; // At: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS >> ChoiceState ) => ( BackendFsm > Continuing >> FinalState )
  public void Tra_0343_0349( TsmHandler oHandler )
  {
    mCurrentState = oFin_0329_0331; // At: ( BackendFsm > Continuing >> FinalState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0363( TsmHandler oHandler )
  {
    mCurrentState = oJun_0329_0335; // Down: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0357( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1250( oHandler );
    mCurrentState = oJun_0329_0334; // At: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
  public void Tra_0329_0356( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1254( oHandler );
    mCurrentState = oJun_0329_0333; // At: ( BackendFsm > Continuing >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 353:
      Tra_0329_0353( oHandler );
      break;
    case 366:
      Tra_0329_0366( oHandler );
      break;
    case 364:
      Tra_0329_0364( oHandler );
      break;
    case 365:
      Tra_0329_0365( oHandler );
      break;
    case 355:
      Tra_0329_0355( oHandler );
      break;
    case 354: // Up: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 360: // Up: ( BackendFsm > Continuing >> Recover > ConnExitRef ) => ( BackendFsm > Continuing > ExitError )
      mCurrentState = null;
      bHigher = true;
      break;
    case 361:
      Tra_0329_0361( oHandler );
      break;
    case 359:
      Tra_0329_0359( oHandler );
      break;
    case 358:
      Tra_0329_0358( oHandler );
      break;
    case 349:
      Tra_0343_0349( oHandler );
      break;
    case 363:
      Tra_0329_0363( oHandler );
      break;
    case 357:
      Tra_0329_0357( oHandler );
      break;
    case 362: // Up: ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing > ExitFinished )
      mCurrentState = null;
      bHigher = true;
      break;
    case 356:
      Tra_0329_0356( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing > EntryReadError )
class Con_0328_0367 extends TsmState
{
  public Con_0328_0367( TsmBase oParent )
  {
    TsmName = "EntryReadError";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 363, "( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 363; // TRLS ( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 363: // UP: ( BackendFsm > Continuing > EntryReadError ) => ( BackendFsm > Continuing >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing )
class Fsm_0087_0328 extends TsmFsm
{
  private Reg_0328_0329 oReg_0328_0329; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >)
  private Con_0328_0367 oCon_0328_0367; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing > EntryReadError )

  public Fsm_0087_0328( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    oReg_0328_0329 = new Reg_0328_0329( this );
    oCon_0328_0367 = new Con_0328_0367( this );
    mRegions.add( oReg_0328_0329 );
    mNrTransitions = 0;
  }

  @Override
  public void Entrypoint( TsmHandler oHandler )
  {
    oReg_0328_0329.Reset();
    switch ( oHandler.Index )
    {
    case 367:
      oCon_0328_0367.Initial( oHandler );
      break;
    }
    ExecuteHandler( oHandler );
  }

  public void Tra_0329_0354( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 368; // ExitFinished
  }

  public void Tra_0329_0360( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 369; // ExitError
  }

  public void Tra_0329_0363( TsmHandler oHandler )
  {
    oReg_0328_0329.ExecuteHandler( oHandler );
  }

  public void Tra_0329_0362( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.EXITPOINT;
    oHandler.Index  = 368; // ExitFinished
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 354:
      Tra_0329_0354( oHandler );
      break;
    case 360:
      Tra_0329_0360( oHandler );
      break;
    case 363:
      Tra_0329_0363( oHandler );
      break;
    case 362:
      Tra_0329_0362( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing )
class Sub_0104_0122 extends TsmSubFsm
{
  private Con_0122_0124 oCon_0122_0124; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )
  private Con_0122_0125 oCon_0122_0125; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing > ConnExitRef )

  public Sub_0104_0122( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    oFsm = new Fsm_0087_0328( this ); // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing )
    oCon_0122_0124 = new Con_0122_0124( this );
    oCon_0122_0125 = new Con_0122_0125( this );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 139, "( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )" );
  }

  public void Tra_0104_0138( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTER;
    oFsm.ExecuteHandler( oHandler );
  }

  public void Tra_0104_0143( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.Action = TsmHandlerAction.ENTRYPOINT;
    oHandler.Index = 367;
    oFsm.ExecuteHandler( oHandler );
  }

  @Override
  public void ExecuteTriggerless( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 139; // TRLS ( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 138:
      Tra_0104_0138( oHandler );
      break;
    case 143:
      Tra_0104_0143( oHandler );
      break;
    case 139: // UP: ( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 369: // UmlConnExit(Ref)
      oCon_0122_0124.Initial( oHandler );
      break;
    case 368: // UmlConnExit(Ref)
      oCon_0122_0125.Initial( oHandler );
      break;
    case 145: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 142: // UP: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Finishing )
class Lea_0104_0126 extends TsmLeaf
{
  public Lea_0104_0126( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 131, "( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing ) : pp_player->Pause" );
    mTransitions[ 1 ] = new TsmTransition( 148, "( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing ) : rpp_reader->Px_CbError" );
  }

  public void Tra_0104_0130( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0104_0131( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1236( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void pp_player___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 131; // pp_player.Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0104_0148( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rpp_reader___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 148; // rpp_reader.Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 15: // pp_player___Pause
        {
          pp_player___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 84
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 21: // rpp_reader___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          rpp_reader___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 130:
      Tra_0104_0130( oHandler );
      break;
    case 131:
      Tra_0104_0131( oHandler );
      break;
    case 148:
      Tra_0104_0148( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Error )
class Lea_0104_0127 extends TsmLeaf
{
  public Lea_0104_0127( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 146, "( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error ) : ??" );
    mTransitions[ 1 ] = new TsmTransition( 129, "( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error ) : pp_player->Pause" );
  }

  public void Tra_0088_0150( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0104_0146( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1026( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Tra_0104_0129( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1238( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void pp_player___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 129; // pp_player.Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.OK|TsmProspect.ANY;
      case 16:
        return TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 15: // pp_player___Pause
        {
          pp_player___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }

    if ( ! oHandler.bTaken )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 146; // AnyTransition
      oHandler.bTaken = true;
      mTransitions[ 0 ].bVisit = true;

    }

  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 150:
      Tra_0088_0150( oHandler );
      break;
    case 146:
      Tra_0104_0146( oHandler );
      break;
    case 129:
      Tra_0104_0129( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >)
class Reg_0103_0104 extends TsmRegion
{
  private Jun_0104_0105 oJun_0104_0105; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  private Jun_0104_0106 oJun_0104_0106; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  private Jun_0104_0107 oJun_0104_0107; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> JuncState )
  private Sub_0104_0108 oSub_0104_0108; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Starting )
  private Sub_0104_0110 oSub_0104_0110; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Play )
  private Sub_0104_0115 oSub_0104_0115; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Pausing )
  private Sub_0104_0120 oSub_0104_0120; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Paused )
  private Sub_0104_0122 oSub_0104_0122; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Continuing )
  private Lea_0104_0126 oLea_0104_0126; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Finishing )
  private Lea_0104_0127 oLea_0104_0127; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >> Error )

  public Reg_0103_0104( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oJun_0104_0105 = new Jun_0104_0105( this );
    oJun_0104_0106 = new Jun_0104_0106( this );
    oJun_0104_0107 = new Jun_0104_0107( this );
    oSub_0104_0108 = new Sub_0104_0108( this );
    oSub_0104_0110 = new Sub_0104_0110( this );
    oSub_0104_0115 = new Sub_0104_0115( this );
    oSub_0104_0120 = new Sub_0104_0120( this );
    oSub_0104_0122 = new Sub_0104_0122( this );
    oLea_0104_0126 = new Lea_0104_0126( this );
    oLea_0104_0127 = new Lea_0104_0127( this );
    mNrStates = 10;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oJun_0104_0105;
    mStates[ 1 ] = oJun_0104_0106;
    mStates[ 2 ] = oJun_0104_0107;
    mStates[ 3 ] = oSub_0104_0108;
    mStates[ 4 ] = oSub_0104_0110;
    mStates[ 5 ] = oSub_0104_0115;
    mStates[ 6 ] = oSub_0104_0120;
    mStates[ 7 ] = oSub_0104_0122;
    mStates[ 8 ] = oLea_0104_0126;
    mStates[ 9 ] = oLea_0104_0127;
  }

   // Down: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
  public void Tra_0092_0098( TsmHandler oHandler )
  {
    mCurrentState = oSub_0104_0108; // Down: ( BackendFsm >> Active >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0144( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0107; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )
  public void Tra_0104_0130( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1021( oHandler );
    mCurrentState = oLea_0104_0126; // At: ( BackendFsm >> Active >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )
  public void Tra_0088_0150( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1022( oHandler );
    mCurrentState = oLea_0104_0127; // At: ( BackendFsm >> Active >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )
  public void Tra_0104_0128( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1023( oHandler );
    mCurrentState = oSub_0104_0110; // At: ( BackendFsm >> Active >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Starting > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0141( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0105; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0137( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0105; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0136( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0106; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
  public void Tra_0104_0133( TsmHandler oHandler )
  {
    mCurrentState = oSub_0104_0115; // At: ( BackendFsm >> Active >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Play > ConnExitRef ) => ( BackendFsm >> Active >> Pausing > ConnEntryRef )
  public void Tra_0104_0134( TsmHandler oHandler )
  {
    mCurrentState = oSub_0104_0115; // At: ( BackendFsm >> Active >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )
  public void Tra_0104_0132( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1024( oHandler );
    mCurrentState = oSub_0104_0120; // At: ( BackendFsm >> Active >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0135( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0106; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Pausing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0140( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0107; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Paused ) => ( BackendFsm >> Active >> Continuing )
  public void Tra_0104_0138( TsmHandler oHandler )
  {
    mCurrentState = oSub_0104_0122; // At: ( BackendFsm >> Active >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Paused > ConnExitRef ) => ( BackendFsm >> Active >> Continuing > ConnEntryRef )
  public void Tra_0104_0143( TsmHandler oHandler )
  {
    mCurrentState = oSub_0104_0122; // At: ( BackendFsm >> Active >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )
  public void Tra_0104_0139( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1025( oHandler );
    mCurrentState = oSub_0104_0110; // At: ( BackendFsm >> Active >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0145( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0107; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active >> Continuing > ConnExitRef ) => ( BackendFsm >> Active >> JuncState )
  public void Tra_0104_0142( TsmHandler oHandler )
  {
    mCurrentState = oJun_0104_0106; // At: ( BackendFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.ANY;
      case 15:
        return TsmProspect.OK|TsmProspect.ANY;
      case 16:
        return TsmProspect.OK|TsmProspect.ANY;
      case 17:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 98:
      Tra_0092_0098( oHandler );
      break;
    case 144:
      Tra_0104_0144( oHandler );
      break;
    case 130:
      Tra_0104_0130( oHandler );
      break;
    case 150:
      Tra_0088_0150( oHandler );
      break;
    case 128:
      Tra_0104_0128( oHandler );
      break;
    case 141:
      Tra_0104_0141( oHandler );
      break;
    case 137:
      Tra_0104_0137( oHandler );
      break;
    case 136:
      Tra_0104_0136( oHandler );
      break;
    case 133:
      Tra_0104_0133( oHandler );
      break;
    case 134:
      Tra_0104_0134( oHandler );
      break;
    case 132:
      Tra_0104_0132( oHandler );
      break;
    case 135:
      Tra_0104_0135( oHandler );
      break;
    case 140:
      Tra_0104_0140( oHandler );
      break;
    case 138:
      Tra_0104_0138( oHandler );
      break;
    case 143:
      Tra_0104_0143( oHandler );
      break;
    case 139:
      Tra_0104_0139( oHandler );
      break;
    case 145:
      Tra_0104_0145( oHandler );
      break;
    case 142:
      Tra_0104_0142( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active )
class Com_0088_0103 extends TsmCompound
{
  private Reg_0103_0104 oReg_0103_0104; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active >)

  public Com_0088_0103( TsmBase oParent )
  {
    TsmName = "Active";
    TsmParent = oParent;
    oReg_0103_0104 = new Reg_0103_0104( this );
    mRegions.add( oReg_0103_0104 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 151, "( BackendFsm >> Active ) => ( BackendFsm >> Stopping ) : pp_player->Stop" );
    mTransitions[ 1 ] = new TsmTransition( 147, "( BackendFsm >> Active ) => ( BackendFsm >> Active ) : rpp_reader->Px_CbDone" );
  }

  public void Tra_0092_0098( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0103_0104.ExecuteHandler( oHandler );
  }

  public void pp_player___Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 151; // pp_player.Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0104_0147( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1244( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rpp_reader___Px_CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 147; // rpp_reader.Px_CbDone
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 17:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 20:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 84: // Port pp_player
      switch ( oHandler.Trigger.Command )
      {
      case 17: // pp_player___Stop
        {
          pp_player___Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 84
    case 85: // Port rpp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 20: // rpp_reader___Px_CbDone
        {
          rpp_reader___Px_CbDone( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 98:
      Tra_0092_0098( oHandler );
      break;
    case 151: // UP: ( BackendFsm >> Active ) => ( BackendFsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 147:
      Tra_0104_0147( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >)
class Reg_0087_0088 extends TsmRegion
{
  private Ini_0088_0089 oIni_0088_0089; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> InitialState )
  private Sub_0088_0090 oSub_0088_0090; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Stopping )
  private Com_0088_0091 oCom_0088_0091; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Idle )
  private Com_0088_0103 oCom_0088_0103; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >> Active )

  public Reg_0087_0088( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0088_0089 = new Ini_0088_0089( this );
    oSub_0088_0090 = new Sub_0088_0090( this );
    oCom_0088_0091 = new Com_0088_0091( this );
    oCom_0088_0103 = new Com_0088_0103( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0088_0089;
    mStates[ 1 ] = oSub_0088_0090;
    mStates[ 2 ] = oCom_0088_0091;
    mStates[ 3 ] = oCom_0088_0103;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0088_0089.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> InitialState ) => ( BackendFsm >> Idle )
  public void Tra_0088_0149( TsmHandler oHandler )
  {
    mCurrentState = oCom_0088_0091; // At: ( BackendFsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )
  public void Tra_0088_0152( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1011( oHandler );
    mCurrentState = oCom_0088_0091; // At: ( BackendFsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
  public void Tra_0092_0098( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1014( oHandler );
    mCurrentState = oCom_0088_0103; // At: ( BackendFsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( BackendFsm >> Active ) => ( BackendFsm >> Stopping )
  public void Tra_0088_0151( TsmHandler oHandler )
  {
    ((Cla_0080_0082)oHandler.Owner).Function_1243( oHandler );
    mCurrentState = oSub_0088_0090; // At: ( BackendFsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 84:
      switch ( Command )
      {
      case 14:
        return TsmProspect.OK|TsmProspect.ANY;
      case 15:
        return TsmProspect.OK|TsmProspect.ANY;
      case 16:
        return TsmProspect.OK|TsmProspect.ANY;
      case 17:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 84
    case 85:
      switch ( Command )
      {
      case 18:
        return TsmProspect.ANY;
      case 19:
        return TsmProspect.ANY;
      case 20:
        return TsmProspect.OK|TsmProspect.ANY;
      case 21:
        return TsmProspect.OK|TsmProspect.ANY;
      case 22:
        return TsmProspect.ANY;
      case 23:
        return TsmProspect.ANY;
      case 24:
        return TsmProspect.ANY;
      default:
        break;
      }
      break; // end of Port 85
    case 86:
      switch ( Command )
      {
      case 25:
        return TsmProspect.ANY;
      case 26:
        return TsmProspect.OK|TsmProspect.ANY;
      case 27:
        return TsmProspect.ANY;
      case 28:
        return TsmProspect.ANY;
      case 29:
        return TsmProspect.ANY;
      case 30:
        return TsmProspect.ANY;
      case 31:
        return TsmProspect.OK|TsmProspect.ANY;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 149:
      Tra_0088_0149( oHandler );
      break;
    case 152:
      Tra_0088_0152( oHandler );
      break;
    case 98:
      Tra_0092_0098( oHandler );
      break;
    case 151:
      Tra_0088_0151( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm )
class Fsm_0082_0087 extends TsmFsm
{
  private Reg_0087_0088 oReg_0087_0088; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm >)

  public Fsm_0082_0087( TsmBase oParent )
  {
    TsmName = "BackendFsm";
    TsmParent = oParent;
    oReg_0087_0088 = new Reg_0087_0088( this );
    mRegions.add( oReg_0087_0088 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )
class Cla_0080_0082 extends TsmProxyUser
{
  private Fsm_0082_0087 oFsm_0082_0087; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm )
  private TsmIPort_ITitlebaseServer rp_titlebase; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rp_titlebase )
  private TsmIPort_IPlayerServer TsmPI__pp_player; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
  private TsmIPort_IPlayerClient pp_player; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > pp_player )
  private TsmIPort_IProxyReaderServer rpp_reader; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
  private TsmIPort_IProxyReaderClient TsmPI__rpp_reader; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_reader )
  private TsmIPort_IProxyDisplayServer rpp_display; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
  private TsmIPort_IProxyDisplayClient TsmPI__rpp_display; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > rpp_display )
  private TsmPSPort mPSMessager;
  private TsmPCPort mPCMessager;
  private eRV frv;
  private int MyFHandle;
  private tChunk MyChunk;

  public Cla_0080_0082( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0082_0087 = new Fsm_0082_0087( this );
    TsmPI__pp_player = new TsmIPort_IPlayerServer( this );
    TsmPI__rpp_reader = new TsmIPort_IProxyReaderClient( this );
    TsmPI__rpp_display = new TsmIPort_IProxyDisplayClient( this );
    mPSMessager = new TsmPSPort();
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0082_0087;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "pp_player" ) )
    {
      return TsmPI__pp_player;
    }
    if ( sPortName.equals( "rpp_reader" ) )
    {
      return TsmPI__rpp_reader;
    }
    if ( sPortName.equals( "rpp_display" ) )
    {
      return TsmPI__rpp_display;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "rp_titlebase" ) )
    {
      rp_titlebase = (TsmIPort_ITitlebaseServer) oProvidedInterface;
      rp_titlebase.Source = this;
      return;
    }
    if ( sPortName.equals( "pp_player" ) )
    {
      pp_player = (TsmIPort_IPlayerClient) oProvidedInterface;
      pp_player.Source = this;
      return;
    }
    if ( sPortName.equals( "rpp_reader" ) )
    {
      rpp_reader = (TsmIPort_IProxyReaderServer) oProvidedInterface;
      rpp_reader.Source = this;
      return;
    }
    if ( sPortName.equals( "rpp_display" ) )
    {
      rpp_display = (TsmIPort_IProxyDisplayServer) oProvidedInterface;
      rpp_display.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0082_0087.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( BackendFsm >> Stopping ) => ( BackendFsm >> Idle )
  public void Function_1011( TsmHandler oHandler )
  {
    pp_player.CbStopped();
  }

  public boolean Guard_1012( String TitleId, tTime AtTime )
  {
    return frv==eRV.OK;
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
  public eRV Function_1013( String TitleId, tTime AtTime )
  {
    return eRV.OK;
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Active >> Starting )
  public void Function_1014( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1013( TitleId, AtTime );

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public eRV Function_1015( String TitleId, tTime AtTime )
  {
    rp_titlebase.CloseTitle();
    return eRV.FAILURE;
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public void Function_1016( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1015( TitleId, AtTime );

    oHandler.Trigger.Ready();
  }

  public boolean Guard_1017( String TitleId, tTime AtTime )
  {
    return MyFHandle==0;
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public eRV Function_1018( String TitleId, tTime AtTime )
  {
    return eRV.INVALID_PARAM;
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle )
  public void Function_1019( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1018( TitleId, AtTime );

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Idle >> ChoiceState ) => ( BackendFsm >> Idle >> ChoiceState )
  public void Function_1020( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    tTime AtTime = lTrigger.AtTime;

    frv=rp_titlebase.SetTime( AtTime );
  }

   // ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Finishing )
  public void Function_1021( TsmHandler oHandler )
  {
    pp_player.CbFinish();
  }

   // ( BackendFsm >> Active >> JuncState ) => ( BackendFsm >> Active >> Error )
  public void Function_1022( TsmHandler oHandler )
  {
    pp_player.CbError();
  }

   // ( BackendFsm >> Active >> Starting ) => ( BackendFsm >> Active >> Play )
  public void Function_1023( TsmHandler oHandler )
  {
    pp_player.CbStarted();
  }

   // ( BackendFsm >> Active >> Pausing ) => ( BackendFsm >> Active >> Paused )
  public void Function_1024( TsmHandler oHandler )
  {
    pp_player.CbPaused();
  }

   // ( BackendFsm >> Active >> Continuing ) => ( BackendFsm >> Active >> Play )
  public void Function_1025( TsmHandler oHandler )
  {
    pp_player.CbContinued();
  }

   // ( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error )
  public void Function_1026( TsmHandler oHandler )
  {
    Tsm.Log( "Error state: ignored by AnyReceiveEvent." );
  }

   // ( BackendFsm > Stopping >> CS_Close >> ChoiceState ) => ( BackendFsm > Stopping >> FinalState )
  public void Function_1027( TsmHandler oHandler )
  {
    rp_titlebase.CloseTitle();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Stopping >> CS_Close >> Base )
  public void Function_1028( TsmHandler oHandler )
  {
    rpp_reader.Px_Close();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPlay >> CS >> Base )
  public void Function_1029( TsmHandler oHandler )
  {
    rpp_display.Px_Start();
  }

  public boolean Guard_1030()
  {
    return frv==eRV.NO_RESOURCE;
  }

  public boolean Guard_1031()
  {
    return MyChunk==null;
  }

   // ( BackendFsm > Tac_StartRead >> ChoiceState ) => ( BackendFsm > Tac_StartRead >> ChoiceState )
  public void Function_1032( TsmHandler oHandler )
  {
    frv=rp_titlebase.GetResult();
  }

  public boolean Guard_1033()
  {
    return frv==eRV.OK;
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Prepare >> Base )
  public void Function_1034( TsmHandler oHandler )
  {
    rpp_display.Px_Prepare();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_Read >> Base )
  public void Function_1035( TsmHandler oHandler )
  {
    frv=rpp_reader.Px_Read( MyChunk );
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> CS_IsFilled >> Base )
  public void Function_1036( TsmHandler oHandler )
  {
    rpp_reader.Px_IsFilled();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartRead >> LeafState )
  public void Function_1037( TsmHandler oHandler )
  {
    rpp_reader.Px_Clear();
    MyChunk=rp_titlebase.GetChunk();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Continuing >> CS >> Base )
  public void Function_1038( TsmHandler oHandler )
  {
    rpp_display.Px_Continue();
  }

  public boolean Guard_1039()
  {
    return frv==eRV.OK;
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Starting >> CS_Open >> Base )
  public void Function_1040( TsmHandler oHandler )
  {
    frv=rpp_reader.Px_Open( MyFHandle );
  }

  public boolean Guard_1041()
  {
    return frv==eRV.OK;
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_StartPause >> CS >> Base )
  public void Function_1042( TsmHandler oHandler )
  {
    frv=rpp_display.Px_Pause();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Display >> Base )
  public void Function_1043( TsmHandler oHandler )
  {
    rpp_display.Px_Stop();
  }

   // ( Xmi > Data > Repository > Player > Decomposition > Backend > BackendClass > BackendFsm > Tac_Stop >> CS_Reader >> Base )
  public void Function_1044( TsmHandler oHandler )
  {
    rpp_reader.Px_Stop();
  }

   // ( BackendFsm >> Idle >> Base ) => ( BackendFsm >> Idle >> ChoiceState )
  public void Function_1228( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;

    MyFHandle=rp_titlebase.OpenTitle(TitleId);
  }

   // ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
  public eRV Function_1229()
  {
    return eRV.OK;
  }

   // ( BackendFsm > Play >> Recover ) => ( BackendFsm > Play > ExitPauseRecover )
  public void Function_1230( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1229();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
  public eRV Function_1231()
  {
    return eRV.OK;
  }

   // ( BackendFsm > Play >> StartPlay ) => ( BackendFsm > Play > ExitPauseStart )
  public void Function_1232( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1231();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
  public eRV Function_1233()
  {
    return eRV.OK;
  }

   // ( BackendFsm > Play >> Base ) => ( BackendFsm > Play > ExitPause )
  public void Function_1234( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1233();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing )
  public eRV Function_1235()
  {
    return eRV.OK_RACE;
  }

   // ( BackendFsm >> Active >> Finishing ) => ( BackendFsm >> Active >> Finishing )
  public void Function_1236( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1235();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error )
  public eRV Function_1237()
  {
    return eRV.OK_RACE;
  }

   // ( BackendFsm >> Active >> Error ) => ( BackendFsm >> Active >> Error )
  public void Function_1238( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1237();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState )
  public eRV Function_1239()
  {
    return eRV.OK;
  }

   // ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> FinalState )
  public void Function_1240( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Continue lTrigger = (TsmTrigger_IPlayerServer___Continue) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1239();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
  public eRV Function_1241()
  {
    return eRV.OK;
  }

   // ( BackendFsm > Paused >> ReadError ) => ( BackendFsm > Paused > ExitReadError )
  public void Function_1242( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Continue lTrigger = (TsmTrigger_IPlayerServer___Continue) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0080_0082)oHandler.Owner).Function_1241();

    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Active ) => ( BackendFsm >> Stopping )
  public void Function_1243( TsmHandler oHandler )
  {
    oHandler.Trigger.Ready();
  }

   // ( BackendFsm >> Active ) => ( BackendFsm >> Active )
  public void Function_1244( TsmHandler oHandler )
  {
    Tsm.Log("CbDone");
  }

   // ( BackendFsm > Tac_StartRead >> CS_IsFilled ) => ( BackendFsm > Tac_StartRead > ExitReadError )
  public void Function_1245( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitReadError )
  public void Function_1246( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
  public void Function_1247( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitReadError )
  public void Function_1248( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Paused >> Base ) => ( BackendFsm > Paused >> ReadError )
  public void Function_1249( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
  public void Function_1250( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;
    int BadSector = lTrigger.BadSector;

    rp_titlebase.ReportReadError( BadSector );
  }

   // ( BackendFsm > Tac_StartPlay >> CS ) => ( BackendFsm > Tac_StartPlay > ExitSynclost )
  public void Function_1251( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;
    tTime BadTime = lTrigger.BadTime;

    rp_titlebase.ReportSynclost( BadTime );
  }

   // ( BackendFsm > Play >> Base ) => ( BackendFsm > Play >> JuncState )
  public void Function_1252( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;
    tTime BadTime = lTrigger.BadTime;

    rp_titlebase.ReportSynclost( BadTime );
  }

   // ( BackendFsm > Tac_StartPause >> CS ) => ( BackendFsm > Tac_StartPause > ExitSynclost )
  public void Function_1253( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;
    tTime BadTime = lTrigger.BadTime;

    rp_titlebase.ReportSynclost( BadTime );
  }

   // ( BackendFsm > Continuing >> CS ) => ( BackendFsm > Continuing >> JuncState )
  public void Function_1254( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;
    tTime BadTime = lTrigger.BadTime;

    rp_titlebase.ReportSynclost( BadTime );
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__pp_player.PortId = 84;
    TsmPI__pp_player.Messager = mPSMessager;
    TsmPI__rpp_reader.PortId = 85;
    TsmPI__rpp_reader.Messager = mPCMessager;
    TsmPI__rpp_display.PortId = 86;
    TsmPI__rpp_display.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    rp_titlebase.SetProxyUser( this );
    rpp_reader.SetProxyUser( this );
    rpp_display.SetProxyUser( this );

    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0082_0087.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > Backend )
class Com_0016_0080 extends TsmPComponent
{
  private Cla_0080_0082 BE_Class; // ( Xmi > Data > Repository > Player > Decomposition > Backend > BE_Class )

  public Com_0016_0080( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    BE_Class = new Cla_0080_0082( this, "BE_Class" );
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = BE_Class;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "d_pp_player" ) )
    {
      return BE_Class.GetProvidedInterface( "pp_player" );
    }
    if ( sPortName.equals( "d_rpp_reader" ) )
    {
      return BE_Class.GetProvidedInterface( "rpp_reader" );
    }
    if ( sPortName.equals( "d_rpp_display" ) )
    {
      return BE_Class.GetProvidedInterface( "rpp_display" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "d_rp_titlebase" ) )
    {
      BE_Class.SetRequiredInterface( "rp_titlebase", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "d_pp_player" ) )
    {
      BE_Class.SetRequiredInterface( "pp_player", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "d_rpp_reader" ) )
    {
      BE_Class.SetRequiredInterface( "rpp_reader", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "d_rpp_display" ) )
    {
      BE_Class.SetRequiredInterface( "rpp_display", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > Backend )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> InitialState )
class Ini_0464_0465 extends TsmPseudo
{
  public Ini_0464_0465( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 514, "( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 514; // TRLS ( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 514: // UP: ( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> InitialState )
class Ini_0467_0468 extends TsmPseudo
{
  public Ini_0467_0468( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 493, "( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 493; // TRLS ( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 493: // UP: ( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> JuncState )
class Jun_0467_0469 extends TsmPseudo
{
  public Jun_0467_0469( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 511, "( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 511; // TRLS ( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0509( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0467_0508( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0467_0510( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 511: // UP: ( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )
      bHigher = true;
      break;
    case 509:
      Tra_0467_0509( oHandler );
      break;
    case 508:
      Tra_0467_0508( oHandler );
      break;
    case 510:
      Tra_0467_0510( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
class Cho_0471_0472 extends TsmPseudo
{
  public Cho_0471_0472( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 484, "( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 483, "( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0458_0460)oHandler.Owner).Guard_1046() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 484; // TRLS ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 483; // TRLS ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0471_0482( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 484: // UP: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
      bHigher = true;
      break;
    case 483: // UP: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
      bHigher = true;
      break;
    case 482:
      Tra_0471_0482( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Play )
class Lea_0471_0473 extends TsmLeaf
{
  public Lea_0471_0473( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 480, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk' ppp_display->Px_Continue" );
    mTransitions[ 1 ] = new TsmTransition( 482, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) : ppp_display->Px_Pause" );
    mTransitions[ 2 ] = new TsmTransition( 476, "( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : 'ProxyOk' ppp_display->Px_Start" );
  }

  public void Tra_0471_0483( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0471_0480( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1255( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 480; // ppp_display.Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 482; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0471_0476( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1268( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 476; // ppp_display.Px_Start
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0467_0505( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0471_0479( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 32: // ppp_display___Px_Continue
        {
          ppp_display___Px_Continue( oHandler );
        }
        break;
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      case 35: // ppp_display___Px_Start
        {
          ppp_display___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 483:
      Tra_0471_0483( oHandler );
      break;
    case 480:
      Tra_0471_0480( oHandler );
      break;
    case 482: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
      bHigher = true;
      break;
    case 476:
      Tra_0471_0476( oHandler );
      break;
    case 505:
      Tra_0467_0505( oHandler );
      break;
    case 479:
      Tra_0471_0479( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Pausing )
class Lea_0471_0474 extends TsmLeaf
{
  public Lea_0471_0474( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 478, "( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) : 'ProxyNok' ppp_display->Px_Pause" );
    mTransitions[ 1 ] = new TsmTransition( 477, "( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused ) : rp_display->CbPaused" );
  }

  public void Tra_0471_0484( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0471_0478( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1259( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 478; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rp_display___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 477; // rp_display.CbPaused
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 39: // rp_display___CbPaused
        {
          rp_display___CbPaused( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 484:
      Tra_0471_0484( oHandler );
      break;
    case 478:
      Tra_0471_0478( oHandler );
      break;
    case 477: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Continuing )
class Lea_0471_0475 extends TsmLeaf
{
  public Lea_0471_0475( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 481, "( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) : 'ProxyNok' ppp_display->Px_Continue" );
    mTransitions[ 1 ] = new TsmTransition( 479, "( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : rp_display->CbContinued" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0471_0481( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1256( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 481; // ppp_display.Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0506( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rp_display___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 479; // rp_display.CbContinued
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 40:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 32: // ppp_display___Px_Continue
        {
          ppp_display___Px_Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 40: // rp_display___CbContinued
        {
          rp_display___CbContinued( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 481:
      Tra_0471_0481( oHandler );
      break;
    case 506:
      Tra_0467_0506( oHandler );
      break;
    case 479: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >)
class Reg_0470_0471 extends TsmRegion
{
  private Cho_0471_0472 oCho_0471_0472; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
  private Lea_0471_0473 oLea_0471_0473; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Play )
  private Lea_0471_0474 oLea_0471_0474; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Pausing )
  private Lea_0471_0475 oLea_0471_0475; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >> Continuing )

  public Reg_0470_0471( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0471_0472 = new Cho_0471_0472( this );
    oLea_0471_0473 = new Lea_0471_0473( this );
    oLea_0471_0474 = new Lea_0471_0474( this );
    oLea_0471_0475 = new Lea_0471_0475( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0471_0472;
    mStates[ 1 ] = oLea_0471_0473;
    mStates[ 2 ] = oLea_0471_0474;
    mStates[ 3 ] = oLea_0471_0475;
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
  public void Tra_0471_0484( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1048( oHandler );
    mCurrentState = oLea_0471_0474; // At: ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Tra_0471_0483( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1050( oHandler );
    mCurrentState = oLea_0471_0473; // At: ( ProxyDisplayFsm >> Active >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
  public void Tra_0467_0506( TsmHandler oHandler )
  {
    mCurrentState = oLea_0471_0475; // Down: ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
  public void Tra_0471_0482( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1258( oHandler );
    mCurrentState = oCho_0471_0472; // At: ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Tra_0467_0505( TsmHandler oHandler )
  {
    mCurrentState = oLea_0471_0473; // Down: ( ProxyDisplayFsm >> Active >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Tra_0471_0479( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1278( oHandler );
    mCurrentState = oLea_0471_0473; // At: ( ProxyDisplayFsm >> Active >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 484:
      Tra_0471_0484( oHandler );
      break;
    case 483:
      Tra_0471_0483( oHandler );
      break;
    case 506:
      Tra_0467_0506( oHandler );
      break;
    case 482:
      Tra_0471_0482( oHandler );
      break;
    case 505:
      Tra_0467_0505( oHandler );
      break;
    case 477: // Up: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 479:
      Tra_0471_0479( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy )
class Com_0467_0470 extends TsmCompound
{
  private Reg_0470_0471 oReg_0470_0471; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy >)

  public Com_0467_0470( TsmBase oParent )
  {
    TsmName = "Busy";
    TsmParent = oParent;
    oReg_0470_0471 = new Reg_0470_0471( this );
    mRegions.add( oReg_0470_0471 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 507, "( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing ) : rp_display->CbFinished" );
    mTransitions[ 1 ] = new TsmTransition( 509, "( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
  }

  public void Tra_0467_0506( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0470_0471.ExecuteHandler( oHandler );
  }

  public void Tra_0467_0505( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0470_0471.ExecuteHandler( oHandler );
  }

  public void rp_display___CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 507; // rp_display.CbFinished
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rp_display___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 509; // rp_display.CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 462:
      switch ( Command )
      {
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 41: // rp_display___CbFinished
        {
          rp_display___CbFinished( oHandler );
        }
        break;
      case 42: // rp_display___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          rp_display___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 506:
      Tra_0467_0506( oHandler );
      break;
    case 505:
      Tra_0467_0505( oHandler );
      break;
    case 477: // UP: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 507: // UP: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 509: // UP: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Ready )
class Lea_0467_0485 extends TsmLeaf
{
  public Lea_0467_0485( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 499, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing ) : 'ProxyNok' ppp_display->Px_Pause" );
    mTransitions[ 1 ] = new TsmTransition( 500, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Ready ) : 'ProxyOk' ppp_display->Px_Prepare" );
    mTransitions[ 2 ] = new TsmTransition( 498, "( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Start" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 499; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0500( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1265( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 500; // ppp_display.Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void ppp_display___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 498; // ppp_display.Px_Start
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0467_0496( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      case 34: // ppp_display___Px_Prepare
        {
          ppp_display___Px_Prepare( oHandler );
        }
        break;
      case 35: // ppp_display___Px_Start
        {
          ppp_display___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 499: // UP: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing )
      bHigher = true;
      break;
    case 500:
      Tra_0467_0500( oHandler );
      break;
    case 498: // UP: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting )
      bHigher = true;
      break;
    case 496:
      Tra_0467_0496( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Preparing )
class Lea_0467_0486 extends TsmLeaf
{
  public Lea_0467_0486( TsmBase oParent )
  {
    TsmName = "Preparing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 497, "( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Preparing ) : 'ProxyNok' ppp_display->Px_Prepare" );
    mTransitions[ 1 ] = new TsmTransition( 496, "( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready ) : rp_display->CbPrepared" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0467_0497( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1266( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 497; // ppp_display.Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0495( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void rp_display___CbPrepared( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 496; // rp_display.CbPrepared
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 34:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 34: // ppp_display___Px_Prepare
        {
          ppp_display___Px_Prepare( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 37: // rp_display___CbPrepared
        {
          rp_display___CbPrepared( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 497:
      Tra_0467_0497( oHandler );
      break;
    case 495:
      Tra_0467_0495( oHandler );
      break;
    case 496: // UP: ( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Idle )
class Lea_0467_0487 extends TsmLeaf
{
  public Lea_0467_0487( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 495, "( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing ) : 'ProxyNok' ppp_display->Px_Prepare" );
    mTransitions[ 1 ] = new TsmTransition( 494, "( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Idle ) : 'ProxyOk' ppp_display->Px_Stop" );
  }

  public void Tra_0467_0493( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void ppp_display___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 495; // ppp_display.Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0494( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1272( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 494; // ppp_display.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 34:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 34: // ppp_display___Px_Prepare
        {
          ppp_display___Px_Prepare( oHandler );
        }
        break;
      case 36: // ppp_display___Px_Stop
        {
          ppp_display___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 493:
      Tra_0467_0493( oHandler );
      break;
    case 495: // UP: ( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing )
      bHigher = true;
      break;
    case 494:
      Tra_0467_0494( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Starting )
class Lea_0467_0488 extends TsmLeaf
{
  public Lea_0467_0488( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 512, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Pause" );
    mTransitions[ 1 ] = new TsmTransition( 501, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting ) : 'ProxyNok' ppp_display->Px_Start" );
    mTransitions[ 2 ] = new TsmTransition( 505, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play ) : rp_display->CbStarted" );
    mTransitions[ 3 ] = new TsmTransition( 508, "( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0467_0512( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1261( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 512; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0498( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0467_0501( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1270( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 501; // ppp_display.Px_Start
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void rp_display___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 505; // rp_display.CbStarted
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void rp_display___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 508; // rp_display.CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 38:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      case 35: // ppp_display___Px_Start
        {
          ppp_display___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 38: // rp_display___CbStarted
        {
          rp_display___CbStarted( oHandler );
        }
        break;
      case 42: // rp_display___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          rp_display___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 512:
      Tra_0467_0512( oHandler );
      break;
    case 498:
      Tra_0467_0498( oHandler );
      break;
    case 501:
      Tra_0467_0501( oHandler );
      break;
    case 505: // UP: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
      bHigher = true;
      break;
    case 508: // UP: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Synclost )
class Lea_0467_0489 extends TsmLeaf
{
  public Lea_0467_0489( TsmBase oParent )
  {
    TsmName = "Synclost";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0467_0511( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 511:
      Tra_0467_0511( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> StartPausing )
class Lea_0467_0490 extends TsmLeaf
{
  public Lea_0467_0490( TsmBase oParent )
  {
    TsmName = "StartPausing";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 502, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> StartPausing ) : 'ProxyNok' ppp_display->Px_Pause" );
    mTransitions[ 1 ] = new TsmTransition( 503, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused ) : rp_display->CbPaused" );
    mTransitions[ 2 ] = new TsmTransition( 510, "( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> JuncState ) : rp_display->CbSynclost" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0467_0499( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0467_0502( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1262( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 502; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void rp_display___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 503; // rp_display.CbPaused
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void rp_display___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 510; // rp_display.CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 39: // rp_display___CbPaused
        {
          rp_display___CbPaused( oHandler );
        }
        break;
      case 42: // rp_display___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          rp_display___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 499:
      Tra_0467_0499( oHandler );
      break;
    case 502:
      Tra_0467_0502( oHandler );
      break;
    case 503: // UP: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused )
      bHigher = true;
      break;
    case 510: // UP: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> JuncState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Paused )
class Lea_0467_0491 extends TsmLeaf
{
  public Lea_0467_0491( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 506, "( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) : 'ProxyNok' ppp_display->Px_Continue" );
    mTransitions[ 1 ] = new TsmTransition( 504, "( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Paused ) : 'ProxyOk' ppp_display->Px_Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void ppp_display___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 506; // ppp_display.Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0467_0504( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1264( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 504; // ppp_display.Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0471_0477( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0467_0503( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 32: // ppp_display___Px_Continue
        {
          ppp_display___Px_Continue( oHandler );
        }
        break;
      case 33: // ppp_display___Px_Pause
        {
          ppp_display___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 506: // UP: ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
      bHigher = true;
      break;
    case 504:
      Tra_0467_0504( oHandler );
      break;
    case 477:
      Tra_0471_0477( oHandler );
      break;
    case 503:
      Tra_0467_0503( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Finishing )
class Lea_0467_0492 extends TsmLeaf
{
  public Lea_0467_0492( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0467_0507( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 507:
      Tra_0467_0507( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >)
class Reg_0466_0467 extends TsmRegion
{
  private Ini_0467_0468 oIni_0467_0468; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> InitialState )
  private Jun_0467_0469 oJun_0467_0469; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> JuncState )
  private Com_0467_0470 oCom_0467_0470; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Busy )
  private Lea_0467_0485 oLea_0467_0485; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Ready )
  private Lea_0467_0486 oLea_0467_0486; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Preparing )
  private Lea_0467_0487 oLea_0467_0487; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Idle )
  private Lea_0467_0488 oLea_0467_0488; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Starting )
  private Lea_0467_0489 oLea_0467_0489; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Synclost )
  private Lea_0467_0490 oLea_0467_0490; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> StartPausing )
  private Lea_0467_0491 oLea_0467_0491; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Paused )
  private Lea_0467_0492 oLea_0467_0492; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >> Finishing )

  public Reg_0466_0467( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0467_0468 = new Ini_0467_0468( this );
    oJun_0467_0469 = new Jun_0467_0469( this );
    oCom_0467_0470 = new Com_0467_0470( this );
    oLea_0467_0485 = new Lea_0467_0485( this );
    oLea_0467_0486 = new Lea_0467_0486( this );
    oLea_0467_0487 = new Lea_0467_0487( this );
    oLea_0467_0488 = new Lea_0467_0488( this );
    oLea_0467_0489 = new Lea_0467_0489( this );
    oLea_0467_0490 = new Lea_0467_0490( this );
    oLea_0467_0491 = new Lea_0467_0491( this );
    oLea_0467_0492 = new Lea_0467_0492( this );
    mNrStates = 11;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0467_0468;
    mStates[ 1 ] = oJun_0467_0469;
    mStates[ 2 ] = oCom_0467_0470;
    mStates[ 3 ] = oLea_0467_0485;
    mStates[ 4 ] = oLea_0467_0486;
    mStates[ 5 ] = oLea_0467_0487;
    mStates[ 6 ] = oLea_0467_0488;
    mStates[ 7 ] = oLea_0467_0489;
    mStates[ 8 ] = oLea_0467_0490;
    mStates[ 9 ] = oLea_0467_0491;
    mStates[ 10 ] = oLea_0467_0492;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0467_0468.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> InitialState ) => ( ProxyDisplayFsm >> Active >> Idle )
  public void Tra_0467_0493( TsmHandler oHandler )
  {
    mCurrentState = oLea_0467_0487; // At: ( ProxyDisplayFsm >> Active >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )
  public void Tra_0467_0511( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1045( oHandler );
    mCurrentState = oLea_0467_0489; // At: ( ProxyDisplayFsm >> Active >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
  public void Tra_0467_0506( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1257( oHandler );
    mCurrentState = oCom_0467_0470; // At: ( ProxyDisplayFsm >> Active >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing )
  public void Tra_0467_0499( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1260( oHandler );
    mCurrentState = oLea_0467_0490; // At: ( ProxyDisplayFsm >> Active >> StartPausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing )
  public void Tra_0467_0495( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1267( oHandler );
    mCurrentState = oLea_0467_0486; // At: ( ProxyDisplayFsm >> Active >> Preparing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting )
  public void Tra_0467_0498( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1269( oHandler );
    mCurrentState = oLea_0467_0488; // At: ( ProxyDisplayFsm >> Active >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready )
  public void Tra_0467_0496( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1274( oHandler );
    mCurrentState = oLea_0467_0485; // At: ( ProxyDisplayFsm >> Active >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Tra_0467_0505( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1275( oHandler );
    mCurrentState = oCom_0467_0470; // At: ( ProxyDisplayFsm >> Active >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
  public void Tra_0471_0477( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1276( oHandler );
    mCurrentState = oLea_0467_0491; // At: ( ProxyDisplayFsm >> Active >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused )
  public void Tra_0467_0503( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1277( oHandler );
    mCurrentState = oLea_0467_0491; // At: ( ProxyDisplayFsm >> Active >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing )
  public void Tra_0467_0507( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1279( oHandler );
    mCurrentState = oLea_0467_0492; // At: ( ProxyDisplayFsm >> Active >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> JuncState )
  public void Tra_0467_0509( TsmHandler oHandler )
  {
    mCurrentState = oJun_0467_0469; // At: ( ProxyDisplayFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> JuncState )
  public void Tra_0467_0508( TsmHandler oHandler )
  {
    mCurrentState = oJun_0467_0469; // At: ( ProxyDisplayFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> JuncState )
  public void Tra_0467_0510( TsmHandler oHandler )
  {
    mCurrentState = oJun_0467_0469; // At: ( ProxyDisplayFsm >> Active >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 493:
      Tra_0467_0493( oHandler );
      break;
    case 511:
      Tra_0467_0511( oHandler );
      break;
    case 506:
      Tra_0467_0506( oHandler );
      break;
    case 499:
      Tra_0467_0499( oHandler );
      break;
    case 495:
      Tra_0467_0495( oHandler );
      break;
    case 498:
      Tra_0467_0498( oHandler );
      break;
    case 496:
      Tra_0467_0496( oHandler );
      break;
    case 505:
      Tra_0467_0505( oHandler );
      break;
    case 477:
      Tra_0471_0477( oHandler );
      break;
    case 503:
      Tra_0467_0503( oHandler );
      break;
    case 507:
      Tra_0467_0507( oHandler );
      break;
    case 509:
      Tra_0467_0509( oHandler );
      break;
    case 508:
      Tra_0467_0508( oHandler );
      break;
    case 510:
      Tra_0467_0510( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active )
class Com_0464_0466 extends TsmCompound
{
  private Reg_0466_0467 oReg_0466_0467; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active >)

  public Com_0464_0466( TsmBase oParent )
  {
    TsmName = "Active";
    TsmParent = oParent;
    oReg_0466_0467 = new Reg_0466_0467( this );
    mRegions.add( oReg_0466_0467 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 515, "( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping ) : 'ProxyNok' ppp_display->Px_Stop" );
  }

  public void Tra_0464_0514( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void ppp_display___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 515; // ppp_display.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0464_0516( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 36: // ppp_display___Px_Stop
        {
          ppp_display___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 514:
      Tra_0464_0514( oHandler );
      break;
    case 515: // UP: ( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 516:
      Tra_0464_0516( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Stopping )
class Lea_0464_0513 extends TsmLeaf
{
  public Lea_0464_0513( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 8;
    mTransitions = new TsmTransition[ 8 ];
    mTransitions[ 0 ] = new TsmTransition( 517, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : 'ProxyNok' ppp_display->Px_Stop" );
    mTransitions[ 1 ] = new TsmTransition( 518, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbPrepared" );
    mTransitions[ 2 ] = new TsmTransition( 519, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbStarted" );
    mTransitions[ 3 ] = new TsmTransition( 521, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbPaused" );
    mTransitions[ 4 ] = new TsmTransition( 522, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbContinued" );
    mTransitions[ 5 ] = new TsmTransition( 520, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbFinished" );
    mTransitions[ 6 ] = new TsmTransition( 523, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping ) : rp_display->CbSynclost" );
    mTransitions[ 7 ] = new TsmTransition( 516, "( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active ) : rp_display->CbStopped" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0464_0515( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0464_0517( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1273( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_display___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 517; // ppp_display.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0464_0518( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbPrepared( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 518; // rp_display.CbPrepared
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0464_0519( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 519; // rp_display.CbStarted
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0464_0521( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 521; // rp_display.CbPaused
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void Tra_0464_0522( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 522; // rp_display.CbContinued
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  public void Tra_0464_0520( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 520; // rp_display.CbFinished
    oHandler.bTaken = true;
    mTransitions[ 5 ].bVisit = true;
  }

  public void Tra_0464_0523( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_display___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 523; // rp_display.CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 6 ].bVisit = true;
  }

  public void rp_display___CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 516; // rp_display.CbStopped
    oHandler.bTaken = true;
    mTransitions[ 7 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      case 43:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 461: // Port ppp_display
      switch ( oHandler.Trigger.Command )
      {
      case 36: // ppp_display___Px_Stop
        {
          ppp_display___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 461
    case 462: // Port rp_display
      switch ( oHandler.Trigger.Command )
      {
      case 37: // rp_display___CbPrepared
        {
          rp_display___CbPrepared( oHandler );
        }
        break;
      case 38: // rp_display___CbStarted
        {
          rp_display___CbStarted( oHandler );
        }
        break;
      case 39: // rp_display___CbPaused
        {
          rp_display___CbPaused( oHandler );
        }
        break;
      case 40: // rp_display___CbContinued
        {
          rp_display___CbContinued( oHandler );
        }
        break;
      case 41: // rp_display___CbFinished
        {
          rp_display___CbFinished( oHandler );
        }
        break;
      case 42: // rp_display___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          rp_display___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      case 43: // rp_display___CbStopped
        {
          rp_display___CbStopped( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 515:
      Tra_0464_0515( oHandler );
      break;
    case 517:
      Tra_0464_0517( oHandler );
      break;
    case 518:
      Tra_0464_0518( oHandler );
      break;
    case 519:
      Tra_0464_0519( oHandler );
      break;
    case 521:
      Tra_0464_0521( oHandler );
      break;
    case 522:
      Tra_0464_0522( oHandler );
      break;
    case 520:
      Tra_0464_0520( oHandler );
      break;
    case 523:
      Tra_0464_0523( oHandler );
      break;
    case 516: // UP: ( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >)
class Reg_0463_0464 extends TsmRegion
{
  private Ini_0464_0465 oIni_0464_0465; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> InitialState )
  private Com_0464_0466 oCom_0464_0466; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Active )
  private Lea_0464_0513 oLea_0464_0513; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >> Stopping )

  public Reg_0463_0464( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0464_0465 = new Ini_0464_0465( this );
    oCom_0464_0466 = new Com_0464_0466( this );
    oLea_0464_0513 = new Lea_0464_0513( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0464_0465;
    mStates[ 1 ] = oCom_0464_0466;
    mStates[ 2 ] = oLea_0464_0513;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0464_0465.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> InitialState ) => ( ProxyDisplayFsm >> Active )
  public void Tra_0464_0514( TsmHandler oHandler )
  {
    mCurrentState = oCom_0464_0466; // At: ( ProxyDisplayFsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping )
  public void Tra_0464_0515( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1271( oHandler );
    mCurrentState = oLea_0464_0513; // At: ( ProxyDisplayFsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active )
  public void Tra_0464_0516( TsmHandler oHandler )
  {
    ((Cla_0458_0460)oHandler.Owner).Function_1280( oHandler );
    mCurrentState = oCom_0464_0466; // At: ( ProxyDisplayFsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 461:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 461
    case 462:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      case 43:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 514:
      Tra_0464_0514( oHandler );
      break;
    case 515:
      Tra_0464_0515( oHandler );
      break;
    case 516:
      Tra_0464_0516( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm )
class Fsm_0460_0463 extends TsmFsm
{
  private Reg_0463_0464 oReg_0463_0464; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm >)

  public Fsm_0460_0463( TsmBase oParent )
  {
    TsmName = "ProxyDisplayFsm";
    TsmParent = oParent;
    oReg_0463_0464 = new Reg_0463_0464( this );
    mRegions.add( oReg_0463_0464 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )
class Cla_0458_0460 extends TsmProxy
{
  private Fsm_0460_0463 oFsm_0460_0463; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ProxyDisplayFsm )
  private TsmIPort_IProxyDisplayServer TsmPI__ppp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
  private TsmIPort_IProxyDisplayClient ppp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > ppp_display )
  private TsmIPort_IDisplayServer rp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
  private TsmIPort_IDisplayClient TsmPI__rp_display; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay > rp_display )
  private TsmPSPort mPSMessager;
  private TsmPCPort mPCMessager;
  private eRV frv;

  public Cla_0458_0460( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0460_0463 = new Fsm_0460_0463( this );
    TsmPI__ppp_display = new TsmIPort_IProxyDisplayServer( this );
    TsmPI__rp_display = new TsmIPort_IDisplayClient( this );
    mPSMessager = new TsmPSPort();
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0460_0463;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "ppp_display" ) )
    {
      return TsmPI__ppp_display;
    }
    if ( sPortName.equals( "rp_display" ) )
    {
      return TsmPI__rp_display;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "ppp_display" ) )
    {
      ppp_display = (TsmIPort_IProxyDisplayClient) oProvidedInterface;
      ppp_display.Source = this;
      return;
    }
    if ( sPortName.equals( "rp_display" ) )
    {
      rp_display = (TsmIPort_IDisplayServer) oProvidedInterface;
      rp_display.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > ProxyDisplay )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0460_0463.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( ProxyDisplayFsm >> Active >> JuncState ) => ( ProxyDisplayFsm >> Active >> Synclost )
  public void Function_1045( TsmHandler oHandler )
  {
    TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;
    tTime BadTime = lTrigger.BadTime;

    ppp_display.Px_CbSynclost( BadTime );
  }

  public boolean Guard_1046()
  {
    return frv==eRV.OK;
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
  public eRV Function_1047()
  {
    return frv;
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
  public void Function_1048( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0458_0460)oHandler.Owner).Function_1047();

    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public eRV Function_1049()
  {
    return frv;
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Function_1050( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0458_0460)oHandler.Owner).Function_1049();

    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Function_1255( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
  public void Function_1256( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Busy >> Continuing )
  public void Function_1257( TsmHandler oHandler )
  {
    rp_display.Continue();
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> ChoiceState )
  public void Function_1258( TsmHandler oHandler )
  {
    frv=rp_display.Pause();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Busy >> Pausing )
  public void Function_1259( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> StartPausing )
  public void Function_1260( TsmHandler oHandler )
  {
    rp_display.Pause();
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting )
  public void Function_1261( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> StartPausing )
  public void Function_1262( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Paused )
  public eRV Function_1263()
  {
    return eRV.OK;
  }

   // ( ProxyDisplayFsm >> Active >> Paused ) => ( ProxyDisplayFsm >> Active >> Paused )
  public void Function_1264( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0458_0460)oHandler.Owner).Function_1263();

    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Ready )
  public void Function_1265( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Preparing )
  public void Function_1266( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Preparing )
  public void Function_1267( TsmHandler oHandler )
  {
    rp_display.Prepare();
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Play ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Function_1268( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Active >> Ready ) => ( ProxyDisplayFsm >> Active >> Starting )
  public void Function_1269( TsmHandler oHandler )
  {
    rp_display.Start();
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Starting )
  public void Function_1270( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active ) => ( ProxyDisplayFsm >> Stopping )
  public void Function_1271( TsmHandler oHandler )
  {
    rp_display.Stop();
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Idle ) => ( ProxyDisplayFsm >> Active >> Idle )
  public void Function_1272( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Stopping )
  public void Function_1273( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayFsm >> Active >> Preparing ) => ( ProxyDisplayFsm >> Active >> Ready )
  public void Function_1274( TsmHandler oHandler )
  {
    ppp_display.Px_CbPrepared();
  }

   // ( ProxyDisplayFsm >> Active >> Starting ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Function_1275( TsmHandler oHandler )
  {
    ppp_display.Px_CbStarted();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Pausing ) => ( ProxyDisplayFsm >> Active >> Paused )
  public void Function_1276( TsmHandler oHandler )
  {
    ppp_display.Px_CbPaused();
  }

   // ( ProxyDisplayFsm >> Active >> StartPausing ) => ( ProxyDisplayFsm >> Active >> Paused )
  public void Function_1277( TsmHandler oHandler )
  {
    ppp_display.Px_CbPaused();
  }

   // ( ProxyDisplayFsm >> Active >> Busy >> Continuing ) => ( ProxyDisplayFsm >> Active >> Busy >> Play )
  public void Function_1278( TsmHandler oHandler )
  {
    ppp_display.Px_CbContinued();
  }

   // ( ProxyDisplayFsm >> Active >> Busy ) => ( ProxyDisplayFsm >> Active >> Finishing )
  public void Function_1279( TsmHandler oHandler )
  {
    ppp_display.Px_CbFinished();
  }

   // ( ProxyDisplayFsm >> Stopping ) => ( ProxyDisplayFsm >> Active )
  public void Function_1280( TsmHandler oHandler )
  {
    ppp_display.Px_CbStopped();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__ppp_display.PortId = 461;
    TsmPI__ppp_display.Messager = mPSMessager;
    TsmPI__rp_display.PortId = 462;
    TsmPI__rp_display.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0460_0463.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )
class Com_0016_0458 extends TsmPComponent
{
  private Cla_0458_0460 PxDisplay; // ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay > PxDisplay )

  public Com_0016_0458( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    PxDisplay = new Cla_0458_0460( this, "PxDisplay" );
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = PxDisplay;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "d_ppp_display" ) )
    {
      return PxDisplay.GetProvidedInterface( "ppp_display" );
    }
    if ( sPortName.equals( "d_rp_display" ) )
    {
      return PxDisplay.GetProvidedInterface( "rp_display" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "d_ppp_display" ) )
    {
      PxDisplay.SetRequiredInterface( "ppp_display", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "d_rp_display" ) )
    {
      PxDisplay.SetRequiredInterface( "rp_display", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyDisplay )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> InitialState )
class Ini_0023_0024 extends TsmPseudo
{
  public Ini_0023_0024( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 63, "( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 63; // TRLS ( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 63: // UP: ( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> InitialState )
class Ini_0026_0027 extends TsmPseudo
{
  public Ini_0026_0027( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 30, "( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 30; // TRLS ( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 30: // UP: ( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> ChoiceState )
class Cho_0026_0028 extends TsmPseudo
{
  public Cho_0026_0028( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 32, "( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 34, "( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    if ( ((Cla_0017_0019)oHandler.Owner).Guard_1001( FileHandle ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 32; // TRLS ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 34; // TRLS ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0026_0033( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 32: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
      bHigher = true;
      break;
    case 34: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
      bHigher = true;
      break;
    case 33:
      Tra_0026_0033( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> Base )
class Lea_0026_0029 extends TsmLeaf
{
  public Lea_0026_0029( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 33, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState ) : ppp_reader->Px_Open" );
    mTransitions[ 1 ] = new TsmTransition( 31, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk' ppp_reader->Px_Close" );
    mTransitions[ 2 ] = new TsmTransition( 35, "( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base ) : 'ProxyOk' ppp_reader->Px_Stop" );
  }

  public void Tra_0026_0030( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0026_0034( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void ppp_reader___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 33; // ppp_reader.Px_Open
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0026_0031( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1211( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 31; // ppp_reader.Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0026_0035( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1215( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 35; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 8: // ppp_reader___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          ppp_reader___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // ppp_reader___Px_Close
        {
          ppp_reader___Px_Close( oHandler );
        }
        break;
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 30:
      Tra_0026_0030( oHandler );
      break;
    case 34:
      Tra_0026_0034( oHandler );
      break;
    case 33: // UP: ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState )
      bHigher = true;
      break;
    case 31:
      Tra_0026_0031( oHandler );
      break;
    case 35:
      Tra_0026_0035( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >)
class Reg_0025_0026 extends TsmRegion
{
  private Ini_0026_0027 oIni_0026_0027; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> InitialState )
  private Cho_0026_0028 oCho_0026_0028; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> ChoiceState )
  private Lea_0026_0029 oLea_0026_0029; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >> Base )

  public Reg_0025_0026( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0026_0027 = new Ini_0026_0027( this );
    oCho_0026_0028 = new Cho_0026_0028( this );
    oLea_0026_0029 = new Lea_0026_0029( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0026_0027;
    mStates[ 1 ] = oCho_0026_0028;
    mStates[ 2 ] = oLea_0026_0029;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0026_0027.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Idle >> InitialState ) => ( ProxyReaderFsm >> Idle >> Base )
  public void Tra_0026_0030( TsmHandler oHandler )
  {
    mCurrentState = oLea_0026_0029; // At: ( ProxyReaderFsm >> Idle >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
  public void Tra_0026_0034( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1005( oHandler );
    mCurrentState = oLea_0026_0029; // At: ( ProxyReaderFsm >> Idle >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState )
  public void Tra_0026_0033( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1206( oHandler );
    mCurrentState = oCho_0026_0028; // At: ( ProxyReaderFsm >> Idle >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 30:
      Tra_0026_0030( oHandler );
      break;
    case 32: // Up: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
      mCurrentState = null;
      bHigher = true;
      break;
    case 34:
      Tra_0026_0034( oHandler );
      break;
    case 33:
      Tra_0026_0033( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle )
class Com_0023_0025 extends TsmCompound
{
  private Reg_0025_0026 oReg_0025_0026; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle >)

  public Com_0023_0025( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    oReg_0025_0026 = new Reg_0025_0026( this );
    mRegions.add( oReg_0025_0026 );
    mNrTransitions = 0;
  }

  public void Tra_0023_0063( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0023_0075( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 63:
      Tra_0023_0063( oHandler );
      break;
    case 32: // UP: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 75:
      Tra_0023_0075( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> ChoiceState )
class Cho_0037_0038 extends TsmPseudo
{
  public Cho_0037_0038( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 57, "( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 58, "( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    if ( ((Cla_0017_0019)oHandler.Owner).Guard_1006( Chunk ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 57; // TRLS ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 58; // TRLS ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0037_0056( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 57: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
      bHigher = true;
      break;
    case 58: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
      bHigher = true;
      break;
    case 56:
      Tra_0037_0056( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> InitialState )
class Ini_0040_0041 extends TsmPseudo
{
  public Ini_0040_0041( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 44, "( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 44; // TRLS ( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 44: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
class Lea_0040_0042 extends TsmLeaf
{
  public Lea_0040_0042( TsmBase oParent )
  {
    TsmName = "NotEnough";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 46, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) : rp_reader->CbFilled" );
    mTransitions[ 1 ] = new TsmTransition( 45, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyOk' ppp_reader->Px_Read" );
    mTransitions[ 2 ] = new TsmTransition( 49, "( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyNok' ppp_reader->Px_IsFilled" );
  }

  public void Tra_0040_0044( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 46; // rp_reader.CbFilled
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0040_0045( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1223( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 45; // ppp_reader.Px_Read
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0040_0049( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1226( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_IsFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 49; // ppp_reader.Px_IsFilled
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 7: // rp_reader___CbFilled
        {
          rp_reader___CbFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 12: // ppp_reader___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          ppp_reader___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      case 13: // ppp_reader___Px_IsFilled
        {
          ppp_reader___Px_IsFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 44:
      Tra_0040_0044( oHandler );
      break;
    case 46: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
      bHigher = true;
      break;
    case 45:
      Tra_0040_0045( oHandler );
      break;
    case 49:
      Tra_0040_0049( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> Enough )
class Lea_0040_0043 extends TsmLeaf
{
  public Lea_0040_0043( TsmBase oParent )
  {
    TsmName = "Enough";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 47, "( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbDone" );
    mTransitions[ 1 ] = new TsmTransition( 48, "( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) : 'ProxyOk' ppp_reader->Px_IsFilled" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 47; // rp_reader.CbDone
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0040_0046( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0040_0048( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1227( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_IsFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 48; // ppp_reader.Px_IsFilled
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 3: // rp_reader___CbDone
        {
          rp_reader___CbDone( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 13: // ppp_reader___Px_IsFilled
        {
          ppp_reader___Px_IsFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 47: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 46:
      Tra_0040_0046( oHandler );
      break;
    case 48:
      Tra_0040_0048( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >)
class Reg_0039_0040 extends TsmRegion
{
  private Ini_0040_0041 oIni_0040_0041; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> InitialState )
  private Lea_0040_0042 oLea_0040_0042; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  private Lea_0040_0043 oLea_0040_0043; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >> Enough )

  public Reg_0039_0040( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0040_0041 = new Ini_0040_0041( this );
    oLea_0040_0042 = new Lea_0040_0042( this );
    oLea_0040_0043 = new Lea_0040_0043( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0040_0041;
    mStates[ 1 ] = oLea_0040_0042;
    mStates[ 2 ] = oLea_0040_0043;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0040_0041.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0040_0044( TsmHandler oHandler )
  {
    mCurrentState = oLea_0040_0042; // At: ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
  public void Tra_0040_0046( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1205( oHandler );
    mCurrentState = oLea_0040_0043; // At: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 44:
      Tra_0040_0044( oHandler );
      break;
    case 47: // Up: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
      mCurrentState = null;
      bHigher = true;
      break;
    case 46:
      Tra_0040_0046( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading )
class Com_0037_0039 extends TsmCompound
{
  private Reg_0039_0040 oReg_0039_0040; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading >)

  public Com_0037_0039( TsmBase oParent )
  {
    TsmName = "Reading";
    TsmParent = oParent;
    oReg_0039_0040 = new Reg_0039_0040( this );
    mRegions.add( oReg_0039_0040 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 55, "( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error ) : rp_reader->CbError" );
  }

  public void rp_reader___CbError( int Sector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 55; // rp_reader.CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0023_0071( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 4:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 4: // rp_reader___CbError
        {
          TsmTrigger_IReaderClient___CbError lTrigger = (TsmTrigger_IReaderClient___CbError) oHandler.Trigger;

          rp_reader___CbError( lTrigger.Sector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 47: // UP: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 55: // UP: ( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 71:
      Tra_0023_0071( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Open )
class Lea_0037_0050 extends TsmLeaf
{
  public Lea_0037_0050( TsmBase oParent )
  {
    TsmName = "Open";
    TsmParent = oParent;
    mNrTransitions = 5;
    mTransitions = new TsmTransition[ 5 ];
    mTransitions[ 0 ] = new TsmTransition( 52, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : 'ProxyOk' ppp_reader->Px_Open" );
    mTransitions[ 1 ] = new TsmTransition( 73, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing ) : 'ProxyNok' ppp_reader->Px_Close" );
    mTransitions[ 2 ] = new TsmTransition( 53, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : 'ProxyOk' ppp_reader->Px_Stop" );
    mTransitions[ 3 ] = new TsmTransition( 54, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open ) : ppp_reader->Px_Clear" );
    mTransitions[ 4 ] = new TsmTransition( 56, "( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState ) : ppp_reader->Px_Read" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0023_0066( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0023_0069( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0040_0047( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0037_0052( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1208( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 52; // ppp_reader.Px_Open
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void ppp_reader___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 73; // ppp_reader.Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0037_0053( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1217( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 53; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0037_0054( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1221( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Clear( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 54; // ppp_reader.Px_Clear
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void ppp_reader___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 56; // ppp_reader.Px_Read
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 8: // ppp_reader___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          ppp_reader___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // ppp_reader___Px_Close
        {
          ppp_reader___Px_Close( oHandler );
        }
        break;
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      case 11: // ppp_reader___Px_Clear
        {
          ppp_reader___Px_Clear( oHandler );
        }
        break;
      case 12: // ppp_reader___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          ppp_reader___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 66:
      Tra_0023_0066( oHandler );
      break;
    case 69:
      Tra_0023_0069( oHandler );
      break;
    case 47:
      Tra_0040_0047( oHandler );
      break;
    case 52:
      Tra_0037_0052( oHandler );
      break;
    case 73: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
      bHigher = true;
      break;
    case 53:
      Tra_0037_0053( oHandler );
      break;
    case 54:
      Tra_0037_0054( oHandler );
      break;
    case 56: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Error )
class Lea_0037_0051 extends TsmLeaf
{
  public Lea_0037_0051( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0037_0058( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0037_0055( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 58:
      Tra_0037_0058( oHandler );
      break;
    case 55:
      Tra_0037_0055( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >)
class Reg_0036_0037 extends TsmRegion
{
  private Cho_0037_0038 oCho_0037_0038; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> ChoiceState )
  private Com_0037_0039 oCom_0037_0039; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Reading )
  private Lea_0037_0050 oLea_0037_0050; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Open )
  private Lea_0037_0051 oLea_0037_0051; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >> Error )

  public Reg_0036_0037( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0037_0038 = new Cho_0037_0038( this );
    oCom_0037_0039 = new Com_0037_0039( this );
    oLea_0037_0050 = new Lea_0037_0050( this );
    oLea_0037_0051 = new Lea_0037_0051( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0037_0038;
    mStates[ 1 ] = oCom_0037_0039;
    mStates[ 2 ] = oLea_0037_0050;
    mStates[ 3 ] = oLea_0037_0051;
  }

   // At: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
  public void Tra_0037_0058( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1010( oHandler );
    mCurrentState = oLea_0037_0051; // At: ( ProxyReaderFsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Tra_0023_0066( TsmHandler oHandler )
  {
    mCurrentState = oLea_0037_0050; // Down: ( ProxyReaderFsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Tra_0023_0069( TsmHandler oHandler )
  {
    mCurrentState = oLea_0037_0050; // Down: ( ProxyReaderFsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Tra_0040_0047( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1201( oHandler );
    mCurrentState = oLea_0037_0050; // At: ( ProxyReaderFsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error )
  public void Tra_0037_0055( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1202( oHandler );
    mCurrentState = oLea_0037_0051; // At: ( ProxyReaderFsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading )
  public void Tra_0023_0071( TsmHandler oHandler )
  {
    mCurrentState = oCom_0037_0039; // Down: ( ProxyReaderFsm >> CompoundState >> Reading )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState )
  public void Tra_0037_0056( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1224( oHandler );
    mCurrentState = oCho_0037_0038; // At: ( ProxyReaderFsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 57: // Up: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
      mCurrentState = null;
      bHigher = true;
      break;
    case 58:
      Tra_0037_0058( oHandler );
      break;
    case 66:
      Tra_0023_0066( oHandler );
      break;
    case 69:
      Tra_0023_0069( oHandler );
      break;
    case 47:
      Tra_0040_0047( oHandler );
      break;
    case 55:
      Tra_0037_0055( oHandler );
      break;
    case 71:
      Tra_0023_0071( oHandler );
      break;
    case 73: // Up: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
      mCurrentState = null;
      bHigher = true;
      break;
    case 56:
      Tra_0037_0056( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState )
class Com_0023_0036 extends TsmCompound
{
  private Reg_0036_0037 oReg_0036_0037; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState >)

  public Com_0023_0036( TsmBase oParent )
  {
    TsmName = "CS_36";
    TsmParent = oParent;
    oReg_0036_0037 = new Reg_0036_0037( this );
    mRegions.add( oReg_0036_0037 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 67, "( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping ) : 'ProxyNok' ppp_reader->Px_Stop" );
  }

  public void Tra_0023_0066( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0036_0037.ExecuteHandler( oHandler );
  }

  public void Tra_0023_0069( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0036_0037.ExecuteHandler( oHandler );
  }

  public void Tra_0023_0071( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0036_0037.ExecuteHandler( oHandler );
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 67; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 21:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 57: // UP: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 66:
      Tra_0023_0066( oHandler );
      break;
    case 69:
      Tra_0023_0069( oHandler );
      break;
    case 71:
      Tra_0023_0071( oHandler );
      break;
    case 73: // UP: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 67: // UP: ( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Opening )
class Lea_0023_0059 extends TsmLeaf
{
  public Lea_0023_0059( TsmBase oParent )
  {
    TsmName = "Opening";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 66, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbOpened" );
    mTransitions[ 1 ] = new TsmTransition( 64, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Open" );
    mTransitions[ 2 ] = new TsmTransition( 65, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Close" );
    mTransitions[ 3 ] = new TsmTransition( 79, "( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening ) : 'ProxyNok' ppp_reader->Px_Stop" );
  }

  public void Tra_0026_0032( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbOpened( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 66; // rp_reader.CbOpened
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0023_0064( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1210( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 64; // ppp_reader.Px_Open
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0023_0065( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1213( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 65; // ppp_reader.Px_Close
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0023_0079( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1218( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 79; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 1:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 1: // rp_reader___CbOpened
        {
          rp_reader___CbOpened( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 8: // ppp_reader___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          ppp_reader___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // ppp_reader___Px_Close
        {
          ppp_reader___Px_Close( oHandler );
        }
        break;
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 32:
      Tra_0026_0032( oHandler );
      break;
    case 66: // UP: ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 64:
      Tra_0023_0064( oHandler );
      break;
    case 65:
      Tra_0023_0065( oHandler );
      break;
    case 79:
      Tra_0023_0079( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Stopping )
class Lea_0023_0060 extends TsmLeaf
{
  public Lea_0023_0060( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 5;
    mTransitions = new TsmTransition[ 5 ];
    mTransitions[ 0 ] = new TsmTransition( 69, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open ) : rp_reader->CbStopped" );
    mTransitions[ 1 ] = new TsmTransition( 78, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbDone" );
    mTransitions[ 2 ] = new TsmTransition( 76, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbError" );
    mTransitions[ 3 ] = new TsmTransition( 77, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : rp_reader->CbFilled" );
    mTransitions[ 4 ] = new TsmTransition( 68, "( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping ) : 'ProxyNok' ppp_reader->Px_Stop" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 69; // rp_reader.CbStopped
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0023_0078( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 78; // rp_reader.CbDone
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0023_0076( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbError( int Sector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 76; // rp_reader.CbError
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0023_0077( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 77; // rp_reader.CbFilled
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void Tra_0023_0067( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0023_0068( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1219( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 68; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 2:
        return TsmProspect.OK;
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 2: // rp_reader___CbStopped
        {
          rp_reader___CbStopped( oHandler );
        }
        break;
      case 3: // rp_reader___CbDone
        {
          rp_reader___CbDone( oHandler );
        }
        break;
      case 4: // rp_reader___CbError
        {
          TsmTrigger_IReaderClient___CbError lTrigger = (TsmTrigger_IReaderClient___CbError) oHandler.Trigger;

          rp_reader___CbError( lTrigger.Sector, oHandler );
        }
        break;
      case 7: // rp_reader___CbFilled
        {
          rp_reader___CbFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 69: // UP: ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 78:
      Tra_0023_0078( oHandler );
      break;
    case 76:
      Tra_0023_0076( oHandler );
      break;
    case 77:
      Tra_0023_0077( oHandler );
      break;
    case 67:
      Tra_0023_0067( oHandler );
      break;
    case 68:
      Tra_0023_0068( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Closing )
class Lea_0023_0061 extends TsmLeaf
{
  public Lea_0023_0061( TsmBase oParent )
  {
    TsmName = "Closing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 75, "( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle ) : rp_reader->CbClosed" );
    mTransitions[ 1 ] = new TsmTransition( 74, "( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Closing ) : 'ProxyNok' ppp_reader->Px_Close" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbClosed( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 75; // rp_reader.CbClosed
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0023_0073( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0023_0074( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1214( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 74; // ppp_reader.Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 5:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 9:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 5: // rp_reader___CbClosed
        {
          rp_reader___CbClosed( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 9: // ppp_reader___Px_Close
        {
          ppp_reader___Px_Close( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 75: // UP: ( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle )
      bHigher = true;
      break;
    case 73:
      Tra_0023_0073( oHandler );
      break;
    case 74:
      Tra_0023_0074( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Seeking )
class Lea_0023_0062 extends TsmLeaf
{
  public Lea_0023_0062( TsmBase oParent )
  {
    TsmName = "Seeking";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 71, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading ) : rp_reader->CbReading" );
    mTransitions[ 1 ] = new TsmTransition( 70, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok' ppp_reader->Px_Stop" );
    mTransitions[ 2 ] = new TsmTransition( 72, "( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking ) : 'ProxyNok' ppp_reader->Px_Read" );
  }

  public void Tra_0037_0057( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void rp_reader___CbReading( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 71; // rp_reader.CbReading
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0023_0070( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1220( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 70; // ppp_reader.Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0023_0072( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1225( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void ppp_reader___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 72; // ppp_reader.Px_Read
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 6:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 20: // Port rp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 6: // rp_reader___CbReading
        {
          rp_reader___CbReading( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port 20
    case 21: // Port ppp_reader
      switch ( oHandler.Trigger.Command )
      {
      case 10: // ppp_reader___Px_Stop
        {
          ppp_reader___Px_Stop( oHandler );
        }
        break;
      case 12: // ppp_reader___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          ppp_reader___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 57:
      Tra_0037_0057( oHandler );
      break;
    case 71: // UP: ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading )
      bHigher = true;
      break;
    case 70:
      Tra_0023_0070( oHandler );
      break;
    case 72:
      Tra_0023_0072( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >)
class Reg_0022_0023 extends TsmRegion
{
  private Ini_0023_0024 oIni_0023_0024; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> InitialState )
  private Com_0023_0025 oCom_0023_0025; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Idle )
  private Com_0023_0036 oCom_0023_0036; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> CompoundState )
  private Lea_0023_0059 oLea_0023_0059; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Opening )
  private Lea_0023_0060 oLea_0023_0060; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Stopping )
  private Lea_0023_0061 oLea_0023_0061; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Closing )
  private Lea_0023_0062 oLea_0023_0062; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >> Seeking )

  public Reg_0022_0023( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0023_0024 = new Ini_0023_0024( this );
    oCom_0023_0025 = new Com_0023_0025( this );
    oCom_0023_0036 = new Com_0023_0036( this );
    oLea_0023_0059 = new Lea_0023_0059( this );
    oLea_0023_0060 = new Lea_0023_0060( this );
    oLea_0023_0061 = new Lea_0023_0061( this );
    oLea_0023_0062 = new Lea_0023_0062( this );
    mNrStates = 7;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0023_0024;
    mStates[ 1 ] = oCom_0023_0025;
    mStates[ 2 ] = oCom_0023_0036;
    mStates[ 3 ] = oLea_0023_0059;
    mStates[ 4 ] = oLea_0023_0060;
    mStates[ 5 ] = oLea_0023_0061;
    mStates[ 6 ] = oLea_0023_0062;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0023_0024.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> InitialState ) => ( ProxyReaderFsm >> Idle )
  public void Tra_0023_0063( TsmHandler oHandler )
  {
    mCurrentState = oCom_0023_0025; // At: ( ProxyReaderFsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
  public void Tra_0026_0032( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1003( oHandler );
    mCurrentState = oLea_0023_0059; // At: ( ProxyReaderFsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
  public void Tra_0037_0057( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1008( oHandler );
    mCurrentState = oLea_0023_0062; // At: ( ProxyReaderFsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Tra_0023_0066( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1199( oHandler );
    mCurrentState = oCom_0023_0036; // At: ( ProxyReaderFsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Tra_0023_0069( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1200( oHandler );
    mCurrentState = oCom_0023_0036; // At: ( ProxyReaderFsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle )
  public void Tra_0023_0075( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1203( oHandler );
    mCurrentState = oCom_0023_0025; // At: ( ProxyReaderFsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading )
  public void Tra_0023_0071( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1204( oHandler );
    mCurrentState = oCom_0023_0036; // At: ( ProxyReaderFsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
  public void Tra_0023_0073( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1212( oHandler );
    mCurrentState = oLea_0023_0061; // At: ( ProxyReaderFsm >> Closing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping )
  public void Tra_0023_0067( TsmHandler oHandler )
  {
    ((Cla_0017_0019)oHandler.Owner).Function_1216( oHandler );
    mCurrentState = oLea_0023_0060; // At: ( ProxyReaderFsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 20:
      switch ( Command )
      {
      case 1:
        return TsmProspect.OK;
      case 2:
        return TsmProspect.OK;
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 5:
        return TsmProspect.OK;
      case 6:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port 20
    case 21:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 63:
      Tra_0023_0063( oHandler );
      break;
    case 32:
      Tra_0026_0032( oHandler );
      break;
    case 57:
      Tra_0037_0057( oHandler );
      break;
    case 66:
      Tra_0023_0066( oHandler );
      break;
    case 69:
      Tra_0023_0069( oHandler );
      break;
    case 75:
      Tra_0023_0075( oHandler );
      break;
    case 71:
      Tra_0023_0071( oHandler );
      break;
    case 73:
      Tra_0023_0073( oHandler );
      break;
    case 67:
      Tra_0023_0067( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm )
class Fsm_0019_0022 extends TsmFsm
{
  private Reg_0022_0023 oReg_0022_0023; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm >)

  public Fsm_0019_0022( TsmBase oParent )
  {
    TsmName = "ProxyReaderFsm";
    TsmParent = oParent;
    oReg_0022_0023 = new Reg_0022_0023( this );
    mRegions.add( oReg_0022_0023 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )
class Cla_0017_0019 extends TsmProxy
{
  private Fsm_0019_0022 oFsm_0019_0022; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ProxyReaderFsm )
  private TsmIPort_IReaderServer rp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
  private TsmIPort_IReaderClient TsmPI__rp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > rp_reader )
  private TsmIPort_IProxyReaderServer TsmPI__ppp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
  private TsmIPort_IProxyReaderClient ppp_reader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader > ppp_reader )
  private TsmPSPort mPSMessager;
  private TsmPCPort mPCMessager;
  private eRV frv;

  public Cla_0017_0019( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0019_0022 = new Fsm_0019_0022( this );
    TsmPI__rp_reader = new TsmIPort_IReaderClient( this );
    TsmPI__ppp_reader = new TsmIPort_IProxyReaderServer( this );
    mPSMessager = new TsmPSPort();
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0019_0022;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "rp_reader" ) )
    {
      return TsmPI__rp_reader;
    }
    if ( sPortName.equals( "ppp_reader" ) )
    {
      return TsmPI__ppp_reader;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "rp_reader" ) )
    {
      rp_reader = (TsmIPort_IReaderServer) oProvidedInterface;
      rp_reader.Source = this;
      return;
    }
    if ( sPortName.equals( "ppp_reader" ) )
    {
      ppp_reader = (TsmIPort_IProxyReaderClient) oProvidedInterface;
      ppp_reader.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > ProxyReader )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0019_0022.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1001( int FileHandle )
  {
    return frv==eRV.OK;
  }

   // ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
  public eRV Function_1002( int FileHandle )
  {
    return frv;
  }

   // ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Opening )
  public void Function_1003( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1002( FileHandle );

    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
  public eRV Function_1004( int FileHandle )
  {
    return frv;
  }

   // ( ProxyReaderFsm >> Idle >> ChoiceState ) => ( ProxyReaderFsm >> Idle >> Base )
  public void Function_1005( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1004( FileHandle );

    SetProxyOk();
  }

  public boolean Guard_1006( tChunk Chunk )
  {
    return frv==eRV.OK;
  }

   // ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
  public eRV Function_1007( tChunk Chunk )
  {
    return frv;
  }

   // ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> Seeking )
  public void Function_1008( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1007( Chunk );

    SetProxyNok();
  }

   // ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
  public eRV Function_1009( tChunk Chunk )
  {
    return frv;
  }

   // ( ProxyReaderFsm >> CompoundState >> ChoiceState ) => ( ProxyReaderFsm >> CompoundState >> Error )
  public void Function_1010( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1009( Chunk );

    SetProxyOk();
  }

   // ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1199( TsmHandler oHandler )
  {
    ppp_reader.Px_CbOpened();
  }

   // ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1200( TsmHandler oHandler )
  {
    ppp_reader.Px_CbStopped();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1201( TsmHandler oHandler )
  {
    ppp_reader.Px_CbDone();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading ) => ( ProxyReaderFsm >> CompoundState >> Error )
  public void Function_1202( TsmHandler oHandler )
  {
    TsmTrigger_IReaderClient___CbError lTrigger = (TsmTrigger_IReaderClient___CbError) oHandler.Trigger;
    int Sector = lTrigger.Sector;

    ppp_reader.Px_CbError( Sector );
  }

   // ( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Idle )
  public void Function_1203( TsmHandler oHandler )
  {
    ppp_reader.Px_CbClosed();
  }

   // ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> CompoundState >> Reading )
  public void Function_1204( TsmHandler oHandler )
  {
    ppp_reader.Px_CbReading();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
  public void Function_1205( TsmHandler oHandler )
  {
    ppp_reader.Px_CbFilled();
  }

   // ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> ChoiceState )
  public void Function_1206( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    frv = rp_reader.Open( FileHandle );
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public eRV Function_1207( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1208( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1207( FileHandle );

    SetProxyOk();
  }

   // ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening )
  public eRV Function_1209( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening )
  public void Function_1210( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1209( FileHandle );

    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base )
  public void Function_1211( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> Closing )
  public void Function_1212( TsmHandler oHandler )
  {
    rp_reader.Close();
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening )
  public void Function_1213( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Closing ) => ( ProxyReaderFsm >> Closing )
  public void Function_1214( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Idle >> Base ) => ( ProxyReaderFsm >> Idle >> Base )
  public void Function_1215( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyReaderFsm >> CompoundState ) => ( ProxyReaderFsm >> Stopping )
  public void Function_1216( TsmHandler oHandler )
  {
    rp_reader.Stop();
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1217( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyReaderFsm >> Opening ) => ( ProxyReaderFsm >> Opening )
  public void Function_1218( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Stopping ) => ( ProxyReaderFsm >> Stopping )
  public void Function_1219( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking )
  public void Function_1220( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> Open )
  public void Function_1221( TsmHandler oHandler )
  {
    rp_reader.Clear();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  public eRV Function_1222( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  public void Function_1223( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0017_0019)oHandler.Owner).Function_1222( Chunk );

    SetProxyOk();
  }

   // ( ProxyReaderFsm >> CompoundState >> Open ) => ( ProxyReaderFsm >> CompoundState >> ChoiceState )
  public void Function_1224( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    frv=rp_reader.Read( Chunk );
  }

   // ( ProxyReaderFsm >> Seeking ) => ( ProxyReaderFsm >> Seeking )
  public void Function_1225( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> NotEnough )
  public void Function_1226( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderFsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderFsm >> CompoundState >> Reading >> Enough )
  public void Function_1227( TsmHandler oHandler )
  {
    SetProxyOk();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__rp_reader.PortId = 20;
    TsmPI__rp_reader.Messager = mPCMessager;
    TsmPI__ppp_reader.PortId = 21;
    TsmPI__ppp_reader.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0019_0022.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )
class Com_0016_0017 extends TsmPComponent
{
  private Cla_0017_0019 PxReader; // ( Xmi > Data > Repository > Player > Decomposition > ProxyReader > PxReader )

  public Com_0016_0017( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    PxReader = new Cla_0017_0019( this, "PxReader" );
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = PxReader;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "d_rp_reader" ) )
    {
      return PxReader.GetProvidedInterface( "rp_reader" );
    }
    if ( sPortName.equals( "d_ppp_reader" ) )
    {
      return PxReader.GetProvidedInterface( "ppp_reader" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "d_rp_reader" ) )
    {
      PxReader.SetRequiredInterface( "rp_reader", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "d_ppp_reader" ) )
    {
      PxReader.SetRequiredInterface( "ppp_reader", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Decomposition > ProxyReader )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Repository > Player > Player )
class Com_0011_0012 extends TsmAComponent
{
  private Com_0016_0080 PlayerBackend; // ( Xmi > Data > Repository > Player > Player > PlayerBackend )
  private Com_0016_0458 PlayerProxyDisplay; // ( Xmi > Data > Repository > Player > Player > PlayerProxyDisplay )
  private Com_0016_0017 PlayerProxyReader; // ( Xmi > Data > Repository > Player > Player > PlayerProxyReader )
  private TsmIPort_IReaderClient TsmPI__dd_rp_reader; // ( Xmi > Data > Repository > Player > Player > dd_rp_reader )
  private TsmACPort TsmMr__dd_rp_reader;
  private TsmIPort_IPlayerServer TsmPI__dd_pp_player; // ( Xmi > Data > Repository > Player > Player > dd_pp_player )
  private TsmASPort TsmMr__dd_pp_player;
  private TsmIPort_IDisplayClient TsmPI__dd_rp_display; // ( Xmi > Data > Repository > Player > Player > dd_rp_display )
  private TsmACPort TsmMr__dd_rp_display;

  public Com_0011_0012( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    PlayerBackend = new Com_0016_0080( this, "PlayerBackend" );
    PlayerProxyDisplay = new Com_0016_0458( this, "PlayerProxyDisplay" );
    PlayerProxyReader = new Com_0016_0017( this, "PlayerProxyReader" );
    mNrComponents = 3;
    mComponents = new TsmComponent[ 3 ];
    mComponents[ 0 ] = PlayerBackend;
    mComponents[ 1 ] = PlayerProxyDisplay;
    mComponents[ 2 ] = PlayerProxyReader;
    TsmPI__dd_rp_reader = new TsmIPort_IReaderClient( this );
    TsmMr__dd_rp_reader = new TsmACPort();
    TsmPI__dd_pp_player = new TsmIPort_IPlayerServer( this );
    TsmMr__dd_pp_player = new TsmASPort();
    TsmPI__dd_rp_display = new TsmIPort_IDisplayClient( this );
    TsmMr__dd_rp_display = new TsmACPort();
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "dd_rp_reader" ) )
    {
      return TsmPI__dd_rp_reader;
    }
    if ( sPortName.equals( "dd_pp_player" ) )
    {
      return TsmPI__dd_pp_player;
    }
    if ( sPortName.equals( "dd_rp_display" ) )
    {
      return TsmPI__dd_rp_display;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Player )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "dd_rp_reader" ) )
    {
      PlayerProxyReader.SetRequiredInterface( "d_rp_reader", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "dd_pp_player" ) )
    {
      PlayerBackend.SetRequiredInterface( "d_pp_player", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "dd_rp_titlebase" ) )
    {
      PlayerBackend.SetRequiredInterface( "d_rp_titlebase", oProvidedInterface );
      return;
    }
    if ( sPortName.equals( "dd_rp_display" ) )
    {
      PlayerProxyDisplay.SetRequiredInterface( "d_rp_display", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > Player )";
    throw new TsmException( s );
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    super.TsmInitialise( oObject );
    TsmMr__dd_rp_reader.setThread( this.getThread() );
    TsmPI__dd_rp_reader.Messager = TsmMr__dd_rp_reader;
    TsmMr__dd_pp_player.setThread( this.getThread() );
    TsmPI__dd_pp_player.Messager = TsmMr__dd_pp_player;
    TsmMr__dd_rp_display.setThread( this.getThread() );
    TsmPI__dd_rp_display.Messager = TsmMr__dd_rp_display;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    TsmInterfacePort ClassPort;
    ClassPort = PlayerProxyReader.GetProvidedInterface( "d_rp_reader" );
    TsmPI__dd_rp_reader.PortId = ClassPort.PortId;
    TsmMr__dd_rp_reader.Target = ClassPort.Messager.Target;
    ClassPort = PlayerBackend.GetProvidedInterface( "d_pp_player" );
    TsmPI__dd_pp_player.PortId = ClassPort.PortId;
    TsmMr__dd_pp_player.Target = ClassPort.Messager.Target;
    ClassPort = PlayerProxyDisplay.GetProvidedInterface( "d_rp_display" );
    TsmPI__dd_rp_display.PortId = ClassPort.PortId;
    TsmMr__dd_rp_display.Target = ClassPort.Messager.Target;
    DoAssembly( PlayerBackend, "d_rpp_reader", PlayerProxyReader, "d_ppp_reader" );
    DoAssembly( PlayerProxyReader, "d_ppp_reader", PlayerBackend, "d_rpp_reader" );
    DoAssembly( PlayerBackend, "d_rpp_display", PlayerProxyDisplay, "d_ppp_display" );
    DoAssembly( PlayerProxyDisplay, "d_ppp_display", PlayerBackend, "d_rpp_display" );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Player > Decomposition )
 ********************************************************************/

 // ( Xmi > Data > Repository > Player > Decomposition )
class Pac_0011_0016 extends TsmPackage
{
  public Pac_0011_0016( TsmBase oParent )
  {
    TsmName = "Decomposition";
    TsmParent = oParent;
  }
}

interface IProxyDisplayServer
{
  public void Px_Continue();
  public eRV Px_Pause();
  public void Px_Prepare();
  public void Px_Start();
  public void Px_Stop();
}

class TsmTrigger_IProxyDisplayServer___Px_Continue extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayServer___Px_Continue()
  {
    super( 32 );
  }
}

class TsmTrigger_IProxyDisplayServer___Px_Pause extends TsmTrigger
{
  public eRV _RetVal;

  public TsmTrigger_IProxyDisplayServer___Px_Pause()
  {
    super( 33 );
  }
}

class TsmTrigger_IProxyDisplayServer___Px_Prepare extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayServer___Px_Prepare()
  {
    super( 34 );
  }
}

class TsmTrigger_IProxyDisplayServer___Px_Start extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayServer___Px_Start()
  {
    super( 35 );
  }
}

class TsmTrigger_IProxyDisplayServer___Px_Stop extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayServer___Px_Stop()
  {
    super( 36 );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > IProxyDisplayServer )
class TsmIPort_IProxyDisplayServer extends TsmInterfacePort implements IProxyDisplayServer
{
  public TsmIPort_IProxyDisplayServer( TsmBase oParent )
  {
    TsmName = "IProxyDisplayServer";
    TsmParent = oParent;
  }

  public void Px_Continue()
  {
    TsmTrigger_IProxyDisplayServer___Px_Continue tt = new TsmTrigger_IProxyDisplayServer___Px_Continue();
    TsmRecorder.AddCall( "Px_Continue", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV Px_Pause()
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause tt = new TsmTrigger_IProxyDisplayServer___Px_Pause();
    TsmRecorder.AddCall( "Px_Pause", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Px_Prepare()
  {
    TsmTrigger_IProxyDisplayServer___Px_Prepare tt = new TsmTrigger_IProxyDisplayServer___Px_Prepare();
    TsmRecorder.AddCall( "Px_Prepare", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_Start()
  {
    TsmTrigger_IProxyDisplayServer___Px_Start tt = new TsmTrigger_IProxyDisplayServer___Px_Start();
    TsmRecorder.AddCall( "Px_Start", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_Stop()
  {
    TsmTrigger_IProxyDisplayServer___Px_Stop tt = new TsmTrigger_IProxyDisplayServer___Px_Stop();
    TsmRecorder.AddCall( "Px_Stop", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

interface IProxyDisplayClient
{
  public void Px_CbContinued();
  public void Px_CbFinished();
  public void Px_CbPaused();
  public void Px_CbPrepared();
  public void Px_CbStarted();
  public void Px_CbStopped();
  public void Px_CbSynclost( tTime BadTime );
}

class TsmTrigger_IProxyDisplayClient___Px_CbContinued extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbContinued()
  {
    super( 25 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbFinished extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbFinished()
  {
    super( 26 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbPaused extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbPaused()
  {
    super( 27 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbPrepared extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbPrepared()
  {
    super( 28 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbStarted extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbStarted()
  {
    super( 29 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbStopped extends TsmTrigger
{
  public TsmTrigger_IProxyDisplayClient___Px_CbStopped()
  {
    super( 30 );
  }
}

class TsmTrigger_IProxyDisplayClient___Px_CbSynclost extends TsmTrigger
{
  public tTime BadTime;

  public TsmTrigger_IProxyDisplayClient___Px_CbSynclost( tTime BadTime )
  {
    super( 31 );
    this.BadTime = BadTime;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > IProxyDisplayClient )
class TsmIPort_IProxyDisplayClient extends TsmInterfacePort implements IProxyDisplayClient
{
  public TsmIPort_IProxyDisplayClient( TsmBase oParent )
  {
    TsmName = "IProxyDisplayClient";
    TsmParent = oParent;
  }

  public void Px_CbContinued()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbContinued tt = new TsmTrigger_IProxyDisplayClient___Px_CbContinued();
    TsmRecorder.AddCall( "Px_CbContinued", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbFinished()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbFinished tt = new TsmTrigger_IProxyDisplayClient___Px_CbFinished();
    TsmRecorder.AddCall( "Px_CbFinished", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbPaused()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbPaused tt = new TsmTrigger_IProxyDisplayClient___Px_CbPaused();
    TsmRecorder.AddCall( "Px_CbPaused", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbPrepared()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbPrepared tt = new TsmTrigger_IProxyDisplayClient___Px_CbPrepared();
    TsmRecorder.AddCall( "Px_CbPrepared", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbStarted()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbStarted tt = new TsmTrigger_IProxyDisplayClient___Px_CbStarted();
    TsmRecorder.AddCall( "Px_CbStarted", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbStopped()
  {
    TsmTrigger_IProxyDisplayClient___Px_CbStopped tt = new TsmTrigger_IProxyDisplayClient___Px_CbStopped();
    TsmRecorder.AddCall( "Px_CbStopped", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbSynclost( tTime BadTime )
  {
    TsmTrigger_IProxyDisplayClient___Px_CbSynclost tt = new TsmTrigger_IProxyDisplayClient___Px_CbSynclost( BadTime );
    TsmRecorder.AddCall( "Px_CbSynclost", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> InitialState )
class Ini_0529_0530 extends TsmPseudo
{
  public Ini_0529_0530( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 578, "( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 578; // TRLS ( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 578: // UP: ( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> InitialState )
class Ini_0532_0533 extends TsmPseudo
{
  public Ini_0532_0533( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 558, "( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 558; // TRLS ( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 558: // UP: ( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> JuncState )
class Jun_0532_0534 extends TsmPseudo
{
  public Jun_0532_0534( TsmBase oParent )
  {
    TsmName = "JuncState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 576, "( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 576; // TRLS ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0532_0574( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0573( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0575( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 576: // UP: ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )
      bHigher = true;
      break;
    case 574:
      Tra_0532_0574( oHandler );
      break;
    case 573:
      Tra_0532_0573( oHandler );
      break;
    case 575:
      Tra_0532_0575( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0536_0537 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0536_0537( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 549, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 548, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 549; // TRLS ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 548; // TRLS ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0536_0547( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 549: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
      bHigher = true;
      break;
    case 548: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    case 547:
      Tra_0536_0547( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
class Lea_0536_0538 extends TsmLeaf
{
  public Lea_0536_0538( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 545, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk' Px_Continue" );
    mTransitions[ 1 ] = new TsmTransition( 547, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) : Px_Pause" );
    mTransitions[ 2 ] = new TsmTransition( 541, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) : 'ProxyOk' Px_Start" );
  }

  public void Tra_0536_0548( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0536_0544( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0570( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0536_0545( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1281( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 545; // Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 547; // Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0536_0541( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1294( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 541; // Px_Start
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 32: // Port___Px_Continue
        {
          Port___Px_Continue( oHandler );
        }
        break;
      case 33: // Port___Px_Pause
        {
          Port___Px_Pause( oHandler );
        }
        break;
      case 35: // Port___Px_Start
        {
          Port___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 548:
      Tra_0536_0548( oHandler );
      break;
    case 544:
      Tra_0536_0544( oHandler );
      break;
    case 570:
      Tra_0532_0570( oHandler );
      break;
    case 545:
      Tra_0536_0545( oHandler );
      break;
    case 547: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 541:
      Tra_0536_0541( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
class Lea_0536_0539 extends TsmLeaf
{
  int [] aNatives = { 542 };

  public Lea_0536_0539( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 542, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )" );
    mTransitions[ 1 ] = new TsmTransition( 543, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) : 'ProxyNok' Px_Pause" );
  }

  public void Tra_0536_0549( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0536_0543( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1284( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 543; // Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 542:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 542: // Native: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused ) # Px_CbPaused();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 542;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 33: // Port___Px_Pause
        {
          Port___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 549:
      Tra_0536_0549( oHandler );
      break;
    case 542: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 543:
      Tra_0536_0543( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
class Lea_0536_0540 extends TsmLeaf
{
  int [] aNatives = { 544 };

  public Lea_0536_0540( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 544, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 546, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) : 'ProxyNok' Px_Continue" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0536_0546( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1282( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 546; // Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0532_0571( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 544:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 544: // Native: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) # Px_CbContinued();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 544;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 32: // Port___Px_Continue
        {
          Port___Px_Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 544: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 546:
      Tra_0536_0546( oHandler );
      break;
    case 571:
      Tra_0532_0571( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >)
class Reg_0535_0536 extends TsmRegion
{
  private Cho_0536_0537 oCho_0536_0537; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Lea_0536_0538 oLea_0536_0538; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  private Lea_0536_0539 oLea_0536_0539; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  private Lea_0536_0540 oLea_0536_0540; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )

  public Reg_0535_0536( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0536_0537 = new Cho_0536_0537( this );
    oLea_0536_0538 = new Lea_0536_0538( this );
    oLea_0536_0539 = new Lea_0536_0539( this );
    oLea_0536_0540 = new Lea_0536_0540( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0536_0537;
    mStates[ 1 ] = oLea_0536_0538;
    mStates[ 2 ] = oLea_0536_0539;
    mStates[ 3 ] = oLea_0536_0540;
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  public void Tra_0536_0549( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1052( oHandler );
    mCurrentState = oLea_0536_0539; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0536_0548( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1054( oHandler );
    mCurrentState = oLea_0536_0538; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0536_0544( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1107( oHandler );
    mCurrentState = oLea_0536_0538; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0532_0570( TsmHandler oHandler )
  {
    mCurrentState = oLea_0536_0538; // Down: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
  public void Tra_0532_0571( TsmHandler oHandler )
  {
    mCurrentState = oLea_0536_0540; // Down: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0536_0547( TsmHandler oHandler )
  {
    mCurrentState = oCho_0536_0537; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 542:
        return TsmProspect.OK;
      case 544:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 549:
      Tra_0536_0549( oHandler );
      break;
    case 548:
      Tra_0536_0548( oHandler );
      break;
    case 542: // Up: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 544:
      Tra_0536_0544( oHandler );
      break;
    case 570:
      Tra_0532_0570( oHandler );
      break;
    case 571:
      Tra_0532_0571( oHandler );
      break;
    case 547:
      Tra_0536_0547( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState )
class Com_0532_0535 extends TsmCompound
{
  int [] aNatives = { 572, 574 };
  private Reg_0535_0536 oReg_0535_0536; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState >)

  public Com_0532_0535( TsmBase oParent )
  {
    TsmName = "CS_535";
    TsmParent = oParent;
    oReg_0535_0536 = new Reg_0535_0536( this );
    mRegions.add( oReg_0535_0536 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 572, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )" );
    mTransitions[ 1 ] = new TsmTransition( 574, "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
  }

  public void Tra_0532_0570( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0535_0536.ExecuteHandler( oHandler );
  }

  public void Tra_0532_0571( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0535_0536.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 572:
        return TsmProspect.OK;
      case 574:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 572: // Native: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing ) # Px_CbFinished();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 572;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 574: // Native: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) # Px_CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 574;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 572: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 574: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 542: // UP: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 570:
      Tra_0532_0570( oHandler );
      break;
    case 571:
      Tra_0532_0571( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Ready )
class Lea_0532_0550 extends TsmLeaf
{
  public Lea_0532_0550( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 564, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) : 'ProxyNok' Px_Pause" );
    mTransitions[ 1 ] = new TsmTransition( 565, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready ) : 'ProxyOk' Px_Prepare" );
    mTransitions[ 2 ] = new TsmTransition( 563, "( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting ) : 'ProxyNok' Px_Start" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0532_0561( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 564; // Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0532_0565( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1291( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 565; // Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Port___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 563; // Px_Start
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 527:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 33: // Port___Px_Pause
        {
          Port___Px_Pause( oHandler );
        }
        break;
      case 34: // Port___Px_Prepare
        {
          Port___Px_Prepare( oHandler );
        }
        break;
      case 35: // Port___Px_Start
        {
          Port___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 561:
      Tra_0532_0561( oHandler );
      break;
    case 564: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
      bHigher = true;
      break;
    case 565:
      Tra_0532_0565( oHandler );
      break;
    case 563: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Preparing )
class Lea_0532_0551 extends TsmLeaf
{
  int [] aNatives = { 561 };

  public Lea_0532_0551( TsmBase oParent )
  {
    TsmName = "Preparing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 561, "( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )" );
    mTransitions[ 1 ] = new TsmTransition( 562, "( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) : 'ProxyNok' Px_Prepare" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0532_0562( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1292( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 562; // Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0532_0560( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 561:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 34:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 561: // Native: ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready ) # Px_CbPrepared();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 561;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 34: // Port___Px_Prepare
        {
          Port___Px_Prepare( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 561: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 562:
      Tra_0532_0562( oHandler );
      break;
    case 560:
      Tra_0532_0560( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Idle )
class Lea_0532_0552 extends TsmLeaf
{
  public Lea_0532_0552( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 560, "( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) : 'ProxyNok' Px_Prepare" );
    mTransitions[ 1 ] = new TsmTransition( 559, "( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle ) : 'ProxyOk' Px_Stop" );
  }

  public void Tra_0532_0558( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 560; // Px_Prepare
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0532_0559( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1298( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 559; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 527:
      switch ( Command )
      {
      case 34:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 34: // Port___Px_Prepare
        {
          Port___Px_Prepare( oHandler );
        }
        break;
      case 36: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 558:
      Tra_0532_0558( oHandler );
      break;
    case 560: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
      bHigher = true;
      break;
    case 559:
      Tra_0532_0559( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Starting )
class Lea_0532_0553 extends TsmLeaf
{
  int [] aNatives = { 570, 573 };

  public Lea_0532_0553( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 570, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 573, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
    mTransitions[ 2 ] = new TsmTransition( 566, "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting ) : 'ProxyNok' Px_Start" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0532_0563( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0566( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1296( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 566; // Px_Start
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 570:
        return TsmProspect.OK;
      case 573:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 35:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 570: // Native: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) # Px_CbStarted();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 570;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 573: // Native: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) # Px_CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 573;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 35: // Port___Px_Start
        {
          Port___Px_Start( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 570: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 573: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 563:
      Tra_0532_0563( oHandler );
      break;
    case 566:
      Tra_0532_0566( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Synclost )
class Lea_0532_0554 extends TsmLeaf
{
  public Lea_0532_0554( TsmBase oParent )
  {
    TsmName = "Synclost";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0532_0576( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 576:
      Tra_0532_0576( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> StartPausing )
class Lea_0532_0555 extends TsmLeaf
{
  int [] aNatives = { 568, 575 };

  public Lea_0532_0555( TsmBase oParent )
  {
    TsmName = "StartPausing";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 568, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )" );
    mTransitions[ 1 ] = new TsmTransition( 575, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )" );
    mTransitions[ 2 ] = new TsmTransition( 567, "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) : 'ProxyNok' Px_Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0532_0564( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0567( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1288( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 567; // Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 568:
        return TsmProspect.OK;
      case 575:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 568: // Native: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused ) # Px_CbPaused();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 568;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 575: // Native: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) # Px_CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 575;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 33: // Port___Px_Pause
        {
          Port___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 568: // UP: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 575: // UP: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 564:
      Tra_0532_0564( oHandler );
      break;
    case 567:
      Tra_0532_0567( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Paused )
class Lea_0532_0556 extends TsmLeaf
{
  public Lea_0532_0556( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 571, "( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) : 'ProxyNok' Px_Continue" );
    mTransitions[ 1 ] = new TsmTransition( 569, "( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused ) : 'ProxyOk' Px_Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0536_0542( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0532_0568( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Px_Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 571; // Px_Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0532_0569( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1290( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 569; // Px_Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 32: // Port___Px_Continue
        {
          Port___Px_Continue( oHandler );
        }
        break;
      case 33: // Port___Px_Pause
        {
          Port___Px_Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 542:
      Tra_0536_0542( oHandler );
      break;
    case 568:
      Tra_0532_0568( oHandler );
      break;
    case 571: // UP: ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
      bHigher = true;
      break;
    case 569:
      Tra_0532_0569( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Finishing )
class Lea_0532_0557 extends TsmLeaf
{
  public Lea_0532_0557( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0532_0572( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 572:
      Tra_0532_0572( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >)
class Reg_0531_0532 extends TsmRegion
{
  private Ini_0532_0533 oIni_0532_0533; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> InitialState )
  private Jun_0532_0534 oJun_0532_0534; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> JuncState )
  private Com_0532_0535 oCom_0532_0535; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> CompoundState )
  private Lea_0532_0550 oLea_0532_0550; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Ready )
  private Lea_0532_0551 oLea_0532_0551; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Preparing )
  private Lea_0532_0552 oLea_0532_0552; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Idle )
  private Lea_0532_0553 oLea_0532_0553; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Starting )
  private Lea_0532_0554 oLea_0532_0554; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Synclost )
  private Lea_0532_0555 oLea_0532_0555; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  private Lea_0532_0556 oLea_0532_0556; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Paused )
  private Lea_0532_0557 oLea_0532_0557; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >> Finishing )

  public Reg_0531_0532( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0532_0533 = new Ini_0532_0533( this );
    oJun_0532_0534 = new Jun_0532_0534( this );
    oCom_0532_0535 = new Com_0532_0535( this );
    oLea_0532_0550 = new Lea_0532_0550( this );
    oLea_0532_0551 = new Lea_0532_0551( this );
    oLea_0532_0552 = new Lea_0532_0552( this );
    oLea_0532_0553 = new Lea_0532_0553( this );
    oLea_0532_0554 = new Lea_0532_0554( this );
    oLea_0532_0555 = new Lea_0532_0555( this );
    oLea_0532_0556 = new Lea_0532_0556( this );
    oLea_0532_0557 = new Lea_0532_0557( this );
    mNrStates = 11;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0532_0533;
    mStates[ 1 ] = oJun_0532_0534;
    mStates[ 2 ] = oCom_0532_0535;
    mStates[ 3 ] = oLea_0532_0550;
    mStates[ 4 ] = oLea_0532_0551;
    mStates[ 5 ] = oLea_0532_0552;
    mStates[ 6 ] = oLea_0532_0553;
    mStates[ 7 ] = oLea_0532_0554;
    mStates[ 8 ] = oLea_0532_0555;
    mStates[ 9 ] = oLea_0532_0556;
    mStates[ 10 ] = oLea_0532_0557;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0532_0533.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )
  public void Tra_0532_0558( TsmHandler oHandler )
  {
    mCurrentState = oLea_0532_0552; // At: ( ProxyDisplayServerPsm >> CompoundState >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> JuncState ) => ( ProxyDisplayServerPsm >> CompoundState >> Synclost )
  public void Tra_0532_0576( TsmHandler oHandler )
  {
    mCurrentState = oLea_0532_0554; // At: ( ProxyDisplayServerPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
  public void Tra_0532_0572( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1104( oHandler );
    mCurrentState = oLea_0532_0557; // At: ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Tra_0532_0574( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1105( oHandler );
    mCurrentState = oJun_0532_0534; // At: ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public void Tra_0536_0542( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1106( oHandler );
    mCurrentState = oLea_0532_0556; // At: ( ProxyDisplayServerPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
  public void Tra_0532_0561( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1108( oHandler );
    mCurrentState = oLea_0532_0550; // At: ( ProxyDisplayServerPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0532_0570( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1109( oHandler );
    mCurrentState = oCom_0532_0535; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Tra_0532_0573( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1110( oHandler );
    mCurrentState = oJun_0532_0534; // At: ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public void Tra_0532_0568( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1111( oHandler );
    mCurrentState = oLea_0532_0556; // At: ( ProxyDisplayServerPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Tra_0532_0575( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1112( oHandler );
    mCurrentState = oJun_0532_0534; // At: ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
  public void Tra_0532_0571( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1283( oHandler );
    mCurrentState = oCom_0532_0535; // At: ( ProxyDisplayServerPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  public void Tra_0532_0564( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1286( oHandler );
    mCurrentState = oLea_0532_0555; // At: ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
  public void Tra_0532_0560( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1293( oHandler );
    mCurrentState = oLea_0532_0551; // At: ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting )
  public void Tra_0532_0563( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1295( oHandler );
    mCurrentState = oLea_0532_0553; // At: ( ProxyDisplayServerPsm >> CompoundState >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 572:
        return TsmProspect.OK;
      case 574:
        return TsmProspect.OK;
      case 542:
        return TsmProspect.OK;
      case 544:
        return TsmProspect.OK;
      case 561:
        return TsmProspect.OK;
      case 570:
        return TsmProspect.OK;
      case 573:
        return TsmProspect.OK;
      case 568:
        return TsmProspect.OK;
      case 575:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 558:
      Tra_0532_0558( oHandler );
      break;
    case 576:
      Tra_0532_0576( oHandler );
      break;
    case 572:
      Tra_0532_0572( oHandler );
      break;
    case 574:
      Tra_0532_0574( oHandler );
      break;
    case 542:
      Tra_0536_0542( oHandler );
      break;
    case 561:
      Tra_0532_0561( oHandler );
      break;
    case 570:
      Tra_0532_0570( oHandler );
      break;
    case 573:
      Tra_0532_0573( oHandler );
      break;
    case 568:
      Tra_0532_0568( oHandler );
      break;
    case 575:
      Tra_0532_0575( oHandler );
      break;
    case 571:
      Tra_0532_0571( oHandler );
      break;
    case 564:
      Tra_0532_0564( oHandler );
      break;
    case 560:
      Tra_0532_0560( oHandler );
      break;
    case 563:
      Tra_0532_0563( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState )
class Com_0529_0531 extends TsmCompound
{
  private Reg_0531_0532 oReg_0531_0532; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState >)

  public Com_0529_0531( TsmBase oParent )
  {
    TsmName = "CS_531";
    TsmParent = oParent;
    oReg_0531_0532 = new Reg_0531_0532( this );
    mRegions.add( oReg_0531_0532 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 579, "( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
  }

  public void Tra_0529_0578( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0529_0581( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 579; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 527:
      switch ( Command )
      {
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 36: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 578:
      Tra_0529_0578( oHandler );
      break;
    case 581:
      Tra_0529_0581( oHandler );
      break;
    case 579: // UP: ( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> Stopping )
class Lea_0529_0577 extends TsmLeaf
{
  int [] aNatives = { 581 };

  public Lea_0529_0577( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 581, "( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )" );
    mTransitions[ 1 ] = new TsmTransition( 580, "( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0529_0579( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0529_0580( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0525_0526)oHandler.Owner).Function_1299( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 580; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 581:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 581: // Native: ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )
        TsmRecorder.AddNative( "( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState ) # Px_CbStopped();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 581;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 527: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 36: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 581: // UP: ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 579:
      Tra_0529_0579( oHandler );
      break;
    case 580:
      Tra_0529_0580( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >)
class Reg_0528_0529 extends TsmRegion
{
  private Ini_0529_0530 oIni_0529_0530; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> InitialState )
  private Com_0529_0531 oCom_0529_0531; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> CompoundState )
  private Lea_0529_0577 oLea_0529_0577; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >> Stopping )

  public Reg_0528_0529( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0529_0530 = new Ini_0529_0530( this );
    oCom_0529_0531 = new Com_0529_0531( this );
    oLea_0529_0577 = new Lea_0529_0577( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0529_0530;
    mStates[ 1 ] = oCom_0529_0531;
    mStates[ 2 ] = oLea_0529_0577;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0529_0530.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> InitialState ) => ( ProxyDisplayServerPsm >> CompoundState )
  public void Tra_0529_0578( TsmHandler oHandler )
  {
    mCurrentState = oCom_0529_0531; // At: ( ProxyDisplayServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )
  public void Tra_0529_0581( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1113( oHandler );
    mCurrentState = oCom_0529_0531; // At: ( ProxyDisplayServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping )
  public void Tra_0529_0579( TsmHandler oHandler )
  {
    ((Cla_0525_0526)oHandler.Owner).Function_1297( oHandler );
    mCurrentState = oLea_0529_0577; // At: ( ProxyDisplayServerPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 572:
        return TsmProspect.OK;
      case 574:
        return TsmProspect.OK;
      case 542:
        return TsmProspect.OK;
      case 544:
        return TsmProspect.OK;
      case 561:
        return TsmProspect.OK;
      case 570:
        return TsmProspect.OK;
      case 573:
        return TsmProspect.OK;
      case 568:
        return TsmProspect.OK;
      case 575:
        return TsmProspect.OK;
      case 581:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 527:
      switch ( Command )
      {
      case 32:
        return TsmProspect.OK;
      case 33:
        return TsmProspect.OK;
      case 34:
        return TsmProspect.OK;
      case 35:
        return TsmProspect.OK;
      case 36:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 578:
      Tra_0529_0578( oHandler );
      break;
    case 581:
      Tra_0529_0581( oHandler );
      break;
    case 579:
      Tra_0529_0579( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm )
class Fsm_0526_0528 extends TsmFsm
{
  private Reg_0528_0529 oReg_0528_0529; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm >)

  public Fsm_0526_0528( TsmBase oParent )
  {
    TsmName = "ProxyDisplayServerPsm";
    TsmParent = oParent;
    oReg_0528_0529 = new Reg_0528_0529( this );
    mRegions.add( oReg_0528_0529 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )
class Cla_0525_0526 extends TsmProxy
{
  private Fsm_0526_0528 oFsm_0526_0528; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > ProxyDisplayServerPsm )
  private TsmIPort_IProxyDisplayServer TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
  private TsmIPort_IProxyDisplayClient Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer > Port )
  private TsmPSPort mPSMessager;
  private tTime BadTime = null;

  public Cla_0525_0526( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0526_0528 = new Fsm_0526_0528( this );
    TsmPI__Port = new TsmIPort_IProxyDisplayServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0526_0528;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IProxyDisplayClient) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0526_0528.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  public eRV Function_1051()
  {
    return eRV.OK;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  public void Function_1052( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0525_0526)oHandler.Owner).Function_1051();

    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public eRV Function_1053()
  {
    return eRV.OK_RACE;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Function_1054( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0525_0526)oHandler.Owner).Function_1053();

    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> Finishing )
  public void Function_1104( TsmHandler oHandler )
  {
    Port.Px_CbFinished();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Function_1105( TsmHandler oHandler )
  {
    Port.Px_CbSynclost( BadTime );
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public void Function_1106( TsmHandler oHandler )
  {
    Port.Px_CbPaused();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Function_1107( TsmHandler oHandler )
  {
    Port.Px_CbContinued();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
  public void Function_1108( TsmHandler oHandler )
  {
    Port.Px_CbPrepared();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Function_1109( TsmHandler oHandler )
  {
    Port.Px_CbStarted();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Function_1110( TsmHandler oHandler )
  {
    Port.Px_CbSynclost( BadTime );
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public void Function_1111( TsmHandler oHandler )
  {
    Port.Px_CbPaused();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> JuncState )
  public void Function_1112( TsmHandler oHandler )
  {
    Port.Px_CbSynclost( BadTime );
  }

   // ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> CompoundState )
  public void Function_1113( TsmHandler oHandler )
  {
    Port.Px_CbStopped();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Function_1281( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
  public void Function_1282( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Continuing )
  public void Function_1283( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Pausing )
  public void Function_1284( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  public eRV Function_1285()
  {
    return eRV.OK;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  public void Function_1286( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0525_0526)oHandler.Owner).Function_1285();

    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  public eRV Function_1287()
  {
    return eRV.OK;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayServerPsm >> CompoundState >> StartPausing )
  public void Function_1288( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0525_0526)oHandler.Owner).Function_1287();

    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public eRV Function_1289()
  {
    return eRV.OK;
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Paused ) => ( ProxyDisplayServerPsm >> CompoundState >> Paused )
  public void Function_1290( TsmHandler oHandler )
  {
    TsmTrigger_IProxyDisplayServer___Px_Pause lTrigger = (TsmTrigger_IProxyDisplayServer___Px_Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0525_0526)oHandler.Owner).Function_1289();

    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Ready )
  public void Function_1291( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Preparing ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
  public void Function_1292( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Preparing )
  public void Function_1293( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayServerPsm >> CompoundState >> CompoundState >> Play )
  public void Function_1294( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Ready ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting )
  public void Function_1295( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Starting ) => ( ProxyDisplayServerPsm >> CompoundState >> Starting )
  public void Function_1296( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState ) => ( ProxyDisplayServerPsm >> Stopping )
  public void Function_1297( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyDisplayServerPsm >> CompoundState >> Idle ) => ( ProxyDisplayServerPsm >> CompoundState >> Idle )
  public void Function_1298( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyDisplayServerPsm >> Stopping ) => ( ProxyDisplayServerPsm >> Stopping )
  public void Function_1299( TsmHandler oHandler )
  {
    SetProxyNok();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 527;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0526_0528.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> InitialState )
class Ini_0585_0586 extends TsmPseudo
{
  public Ini_0585_0586( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 653, "( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 653; // TRLS ( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 653: // UP: ( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> ChoiceState )
class Cho_0585_0587 extends TsmPseudo
{
  public Cho_0585_0587( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 651, "( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 655, "( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 651; // TRLS ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 655; // TRLS ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping )
      mTransitions[ 1 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0585_0654( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0585_0656( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 651: // UP: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState )
      bHigher = true;
      break;
    case 655: // UP: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping )
      bHigher = true;
      break;
    case 654:
      Tra_0585_0654( oHandler );
      break;
    case 656:
      Tra_0585_0656( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> InitialState )
class Ini_0589_0590 extends TsmPseudo
{
  public Ini_0589_0590( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 629, "( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 629; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 629: // UP: ( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
class Cho_0589_0591 extends TsmPseudo
{
  public Cho_0589_0591( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 636, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 636; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0589_0650( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0635( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 636: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing )
      bHigher = true;
      break;
    case 650:
      Tra_0589_0650( oHandler );
      break;
    case 635:
      Tra_0589_0635( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
class Cho_0589_0592 extends TsmPseudo
{
  public Cho_0589_0592( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 638, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 638; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0589_0637( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 638: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    case 637:
      Tra_0589_0637( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
class Cho_0589_0593 extends TsmPseudo
{
  public Cho_0589_0593( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 640, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 640; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0589_0639( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0641( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 640: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting )
      bHigher = true;
      break;
    case 639:
      Tra_0589_0639( oHandler );
      break;
    case 641:
      Tra_0589_0641( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
class Cho_0589_0594 extends TsmPseudo
{
  public Cho_0589_0594( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 643, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 643; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0589_0642( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0644( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 643: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing )
      bHigher = true;
      break;
    case 642:
      Tra_0589_0642( oHandler );
      break;
    case 644:
      Tra_0589_0644( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
class Cho_0589_0595 extends TsmPseudo
{
  public Cho_0589_0595( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 647, "( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 647; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0589_0648( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 647: // UP: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      bHigher = true;
      break;
    case 648:
      Tra_0589_0648( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0598 extends TsmPseudo
{
  public Cho_0597_0598( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 608, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 608; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0597_0607( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 608: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    case 607:
      Tra_0597_0607( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0599 extends TsmPseudo
{
  public Cho_0597_0599( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 618, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 618; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0597_0617( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0597_0609( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 618: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
      bHigher = true;
      break;
    case 617:
      Tra_0597_0617( oHandler );
      break;
    case 609:
      Tra_0597_0609( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0600 extends TsmPseudo
{
  public Cho_0597_0600( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 611, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 611; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0597_0612( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0649( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 611: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
      bHigher = true;
      break;
    case 612:
      Tra_0597_0612( oHandler );
      break;
    case 649:
      Tra_0589_0649( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0601 extends TsmPseudo
{
  public Cho_0597_0601( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 615, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 615; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0597_0614( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 615: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    case 614:
      Tra_0597_0614( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0602 extends TsmPseudo
{
  public Cho_0597_0602( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 617, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 619, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0525_0582)oHandler.Owner).Guard_1055() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 617; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 619; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0597_0616( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 617: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 619: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 616:
      Tra_0597_0616( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_0597_0603 extends TsmPseudo
{
  public Cho_0597_0603( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 620, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : 'IsProxyOk'" );
  }

  public void Tra_0597_0619( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 620; // TRLS ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 619:
      Tra_0597_0619( oHandler );
      break;
    case 620: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
class Lea_0597_0604 extends TsmLeaf
{
  int [] aNatives = { -607, -614, -616 };

  public Lea_0597_0604( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 607, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 614, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 616, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
  }

  public void Tra_0597_0608( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0597_0615( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0597_0620( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0597_0613( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0634( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 607:
        return TsmProspect.OK;
      case 614:
        return TsmProspect.OK;
      case 616:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 607: // Native: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # Px_Start();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 607;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 614: // Native: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # Px_Continue();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 614;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      case 616: // Native: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # RV=Px_Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 616;
        oHandler.bTaken = true;
        mTransitions[ 2 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 608:
      Tra_0597_0608( oHandler );
      break;
    case 615:
      Tra_0597_0615( oHandler );
      break;
    case 620:
      Tra_0597_0620( oHandler );
      break;
    case 607: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 614: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 616: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 613:
      Tra_0597_0613( oHandler );
      break;
    case 634:
      Tra_0589_0634( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
class Lea_0597_0605 extends TsmLeaf
{
  int [] aNatives = { -609 };

  public Lea_0597_0605( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 609, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 610, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : Px_CbPaused" );
  }

  public void Tra_0597_0618( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 610; // Px_CbPaused
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 609:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 27:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 609: // Native: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # RV=Px_Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 609;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 27: // Port___Px_CbPaused
        {
          Port___Px_CbPaused( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 618:
      Tra_0597_0618( oHandler );
      break;
    case 609: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 610: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
class Lea_0597_0606 extends TsmLeaf
{
  int [] aNatives = { -612 };

  public Lea_0597_0606( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 612, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 613, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : Px_CbContinued" );
  }

  public void Tra_0597_0611( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 613; // Px_CbContinued
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 612:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 25:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 612: // Native: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # Px_Continue();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 612;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 25: // Port___Px_CbContinued
        {
          Port___Px_CbContinued( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 611:
      Tra_0597_0611( oHandler );
      break;
    case 612: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 613: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >)
class Reg_0596_0597 extends TsmRegion
{
  private Cho_0597_0598 oCho_0597_0598; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Cho_0597_0599 oCho_0597_0599; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Cho_0597_0600 oCho_0597_0600; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Cho_0597_0601 oCho_0597_0601; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Cho_0597_0602 oCho_0597_0602; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Cho_0597_0603 oCho_0597_0603; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Lea_0597_0604 oLea_0597_0604; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  private Lea_0597_0605 oLea_0597_0605; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  private Lea_0597_0606 oLea_0597_0606; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )

  public Reg_0596_0597( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0597_0598 = new Cho_0597_0598( this );
    oCho_0597_0599 = new Cho_0597_0599( this );
    oCho_0597_0600 = new Cho_0597_0600( this );
    oCho_0597_0601 = new Cho_0597_0601( this );
    oCho_0597_0602 = new Cho_0597_0602( this );
    oCho_0597_0603 = new Cho_0597_0603( this );
    oLea_0597_0604 = new Lea_0597_0604( this );
    oLea_0597_0605 = new Lea_0597_0605( this );
    oLea_0597_0606 = new Lea_0597_0606( this );
    mNrStates = 9;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0597_0598;
    mStates[ 1 ] = oCho_0597_0599;
    mStates[ 2 ] = oCho_0597_0600;
    mStates[ 3 ] = oCho_0597_0601;
    mStates[ 4 ] = oCho_0597_0602;
    mStates[ 5 ] = oCho_0597_0603;
    mStates[ 6 ] = oLea_0597_0604;
    mStates[ 7 ] = oLea_0597_0605;
    mStates[ 8 ] = oLea_0597_0606;
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0597_0608( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0604; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  public void Tra_0597_0618( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0605; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  public void Tra_0597_0611( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0606; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0597_0615( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0604; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0617( TsmHandler oHandler )
  {
    mCurrentState = oCho_0597_0599; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0619( TsmHandler oHandler )
  {
    mCurrentState = oCho_0597_0603; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0597_0620( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0604; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0607( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1115( oHandler );
    mCurrentState = oCho_0597_0598; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0614( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1116( oHandler );
    mCurrentState = oCho_0597_0601; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0616( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1117( oHandler );
    mCurrentState = oCho_0597_0602; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0609( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1118( oHandler );
    mCurrentState = oCho_0597_0599; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0597_0612( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1119( oHandler );
    mCurrentState = oCho_0597_0600; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0589_0649( TsmHandler oHandler )
  {
    mCurrentState = oCho_0597_0600; // Down: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0597_0613( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0604; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0589_0634( TsmHandler oHandler )
  {
    mCurrentState = oLea_0597_0604; // Down: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 607:
        return TsmProspect.OK;
      case 614:
        return TsmProspect.OK;
      case 616:
        return TsmProspect.OK;
      case 609:
        return TsmProspect.OK;
      case 612:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 25:
        return TsmProspect.OK;
      case 27:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 608:
      Tra_0597_0608( oHandler );
      break;
    case 618:
      Tra_0597_0618( oHandler );
      break;
    case 611:
      Tra_0597_0611( oHandler );
      break;
    case 615:
      Tra_0597_0615( oHandler );
      break;
    case 617:
      Tra_0597_0617( oHandler );
      break;
    case 619:
      Tra_0597_0619( oHandler );
      break;
    case 620:
      Tra_0597_0620( oHandler );
      break;
    case 607:
      Tra_0597_0607( oHandler );
      break;
    case 614:
      Tra_0597_0614( oHandler );
      break;
    case 616:
      Tra_0597_0616( oHandler );
      break;
    case 609:
      Tra_0597_0609( oHandler );
      break;
    case 612:
      Tra_0597_0612( oHandler );
      break;
    case 649:
      Tra_0589_0649( oHandler );
      break;
    case 613:
      Tra_0597_0613( oHandler );
      break;
    case 610: // Up: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 634:
      Tra_0589_0634( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState )
class Com_0589_0596 extends TsmCompound
{
  private Reg_0596_0597 oReg_0596_0597; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState >)

  public Com_0589_0596( TsmBase oParent )
  {
    TsmName = "CS_596";
    TsmParent = oParent;
    oReg_0596_0597 = new Reg_0596_0597( this );
    mRegions.add( oReg_0596_0597 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 645, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Finishing ) : Px_CbFinished" );
    mTransitions[ 1 ] = new TsmTransition( 633, "( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
  }

  public void Tra_0589_0649( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0596_0597.ExecuteHandler( oHandler );
  }

  public void Port___Px_CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 645; // Px_CbFinished
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0589_0634( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0596_0597.ExecuteHandler( oHandler );
  }

  public void Port___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 633; // Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 583:
      switch ( Command )
      {
      case 26:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 26: // Port___Px_CbFinished
        {
          Port___Px_CbFinished( oHandler );
        }
        break;
      case 31: // Port___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          Port___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 649:
      Tra_0589_0649( oHandler );
      break;
    case 645: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 610: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 634:
      Tra_0589_0634( oHandler );
      break;
    case 633: // UP: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Ready )
class Lea_0589_0621 extends TsmLeaf
{
  int [] aNatives = { -637, -639, -642 };

  public Lea_0589_0621( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 637, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 639, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 642, "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
  }

  public void Tra_0589_0638( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0589_0630( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 637:
        return TsmProspect.OK;
      case 639:
        return TsmProspect.OK;
      case 642:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 637: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # Px_Prepare();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 637;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 639: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # Px_Start();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 639;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      case 642: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # RV=Px_Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 642;
        oHandler.bTaken = true;
        mTransitions[ 2 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 638:
      Tra_0589_0638( oHandler );
      break;
    case 637: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 639: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 642: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 630:
      Tra_0589_0630( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Preparing )
class Lea_0589_0622 extends TsmLeaf
{
  int [] aNatives = { -650 };

  public Lea_0589_0622( TsmBase oParent )
  {
    TsmName = "Preparing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 650, "( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 630, "( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready ) : Px_CbPrepared" );
  }

  public void Tra_0589_0636( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbPrepared( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 630; // Px_CbPrepared
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 650:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 28:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 650: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # Px_Prepare();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 650;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 28: // Port___Px_CbPrepared
        {
          Port___Px_CbPrepared( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 636:
      Tra_0589_0636( oHandler );
      break;
    case 650: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 630: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Idle )
class Lea_0589_0623 extends TsmLeaf
{
  int [] aNatives = { -635 };

  public Lea_0589_0623( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 635, "( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
  }

  public void Tra_0589_0629( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 635:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 635: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # Px_Prepare();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 635;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 629:
      Tra_0589_0629( oHandler );
      break;
    case 635: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Starting )
class Lea_0589_0624 extends TsmLeaf
{
  int [] aNatives = { -641 };

  public Lea_0589_0624( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 641, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 634, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) : Px_CbStarted" );
    mTransitions[ 2 ] = new TsmTransition( 631, "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
  }

  public void Tra_0589_0640( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 634; // Px_CbStarted
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Port___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 631; // Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 641:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 29:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 641: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # Px_Start();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 641;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 29: // Port___Px_CbStarted
        {
          Port___Px_CbStarted( oHandler );
        }
        break;
      case 31: // Port___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          Port___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 640:
      Tra_0589_0640( oHandler );
      break;
    case 641: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 634: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 631: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Synclost )
class Lea_0589_0625 extends TsmLeaf
{
  public Lea_0589_0625( TsmBase oParent )
  {
    TsmName = "Synclost";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0589_0633( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0631( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0632( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 633:
      Tra_0589_0633( oHandler );
      break;
    case 631:
      Tra_0589_0631( oHandler );
      break;
    case 632:
      Tra_0589_0632( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> StartPausing )
class Lea_0589_0626 extends TsmLeaf
{
  int [] aNatives = { -644 };

  public Lea_0589_0626( TsmBase oParent )
  {
    TsmName = "StartPausing";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 644, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 646, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused ) : Px_CbPaused" );
    mTransitions[ 2 ] = new TsmTransition( 632, "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost ) : Px_CbSynclost" );
  }

  public void Tra_0589_0643( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 646; // Px_CbPaused
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Port___Px_CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 632; // Px_CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 644:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 27:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 644: // Native: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # RV=Px_Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 644;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 27: // Port___Px_CbPaused
        {
          Port___Px_CbPaused( oHandler );
        }
        break;
      case 31: // Port___Px_CbSynclost
        {
          TsmTrigger_IProxyDisplayClient___Px_CbSynclost lTrigger = (TsmTrigger_IProxyDisplayClient___Px_CbSynclost) oHandler.Trigger;

          Port___Px_CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 643:
      Tra_0589_0643( oHandler );
      break;
    case 644: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 646: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 632: // UP: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Paused )
class Lea_0589_0627 extends TsmLeaf
{
  int [] aNatives = { -648, -649 };

  public Lea_0589_0627( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 648, "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 649, "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
  }

  public void Tra_0589_0647( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0597_0610( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0646( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 648:
        return TsmProspect.OK;
      case 649:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 648: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) # RV=Px_Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 648;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 649: // Native: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # Px_Continue();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 649;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 647:
      Tra_0589_0647( oHandler );
      break;
    case 648: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 649: // UP: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 610:
      Tra_0597_0610( oHandler );
      break;
    case 646:
      Tra_0589_0646( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Finishing )
class Lea_0589_0628 extends TsmLeaf
{
  public Lea_0589_0628( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0589_0645( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 645:
      Tra_0589_0645( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >)
class Reg_0588_0589 extends TsmRegion
{
  private Ini_0589_0590 oIni_0589_0590; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> InitialState )
  private Cho_0589_0591 oCho_0589_0591; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  private Cho_0589_0592 oCho_0589_0592; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  private Cho_0589_0593 oCho_0589_0593; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  private Cho_0589_0594 oCho_0589_0594; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  private Cho_0589_0595 oCho_0589_0595; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  private Com_0589_0596 oCom_0589_0596; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> CompoundState )
  private Lea_0589_0621 oLea_0589_0621; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Ready )
  private Lea_0589_0622 oLea_0589_0622; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Preparing )
  private Lea_0589_0623 oLea_0589_0623; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Idle )
  private Lea_0589_0624 oLea_0589_0624; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Starting )
  private Lea_0589_0625 oLea_0589_0625; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Synclost )
  private Lea_0589_0626 oLea_0589_0626; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> StartPausing )
  private Lea_0589_0627 oLea_0589_0627; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Paused )
  private Lea_0589_0628 oLea_0589_0628; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >> Finishing )

  public Reg_0588_0589( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0589_0590 = new Ini_0589_0590( this );
    oCho_0589_0591 = new Cho_0589_0591( this );
    oCho_0589_0592 = new Cho_0589_0592( this );
    oCho_0589_0593 = new Cho_0589_0593( this );
    oCho_0589_0594 = new Cho_0589_0594( this );
    oCho_0589_0595 = new Cho_0589_0595( this );
    oCom_0589_0596 = new Com_0589_0596( this );
    oLea_0589_0621 = new Lea_0589_0621( this );
    oLea_0589_0622 = new Lea_0589_0622( this );
    oLea_0589_0623 = new Lea_0589_0623( this );
    oLea_0589_0624 = new Lea_0589_0624( this );
    oLea_0589_0625 = new Lea_0589_0625( this );
    oLea_0589_0626 = new Lea_0589_0626( this );
    oLea_0589_0627 = new Lea_0589_0627( this );
    oLea_0589_0628 = new Lea_0589_0628( this );
    mNrStates = 15;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0589_0590;
    mStates[ 1 ] = oCho_0589_0591;
    mStates[ 2 ] = oCho_0589_0592;
    mStates[ 3 ] = oCho_0589_0593;
    mStates[ 4 ] = oCho_0589_0594;
    mStates[ 5 ] = oCho_0589_0595;
    mStates[ 6 ] = oCom_0589_0596;
    mStates[ 7 ] = oLea_0589_0621;
    mStates[ 8 ] = oLea_0589_0622;
    mStates[ 9 ] = oLea_0589_0623;
    mStates[ 10 ] = oLea_0589_0624;
    mStates[ 11 ] = oLea_0589_0625;
    mStates[ 12 ] = oLea_0589_0626;
    mStates[ 13 ] = oLea_0589_0627;
    mStates[ 14 ] = oLea_0589_0628;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0589_0590.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState >> Idle )
  public void Tra_0589_0629( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0623; // At: ( ProxyDisplayClientPsm >> CompoundState >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Preparing )
  public void Tra_0589_0636( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0622; // At: ( ProxyDisplayClientPsm >> CompoundState >> Preparing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
  public void Tra_0589_0638( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0621; // At: ( ProxyDisplayClientPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Starting )
  public void Tra_0589_0640( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0624; // At: ( ProxyDisplayClientPsm >> CompoundState >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> StartPausing )
  public void Tra_0589_0643( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0626; // At: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
  public void Tra_0589_0647( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0627; // At: ( ProxyDisplayClientPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0637( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1120( oHandler );
    mCurrentState = oCho_0589_0592; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0639( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1121( oHandler );
    mCurrentState = oCho_0589_0593; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0642( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1122( oHandler );
    mCurrentState = oCho_0589_0594; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0650( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1123( oHandler );
    mCurrentState = oCho_0589_0591; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0635( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1124( oHandler );
    mCurrentState = oCho_0589_0591; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0641( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1125( oHandler );
    mCurrentState = oCho_0589_0593; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0644( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1126( oHandler );
    mCurrentState = oCho_0589_0594; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0589_0648( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1127( oHandler );
    mCurrentState = oCho_0589_0595; // At: ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_0589_0649( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1128( oHandler );
    mCurrentState = oCom_0589_0596; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Finishing )
  public void Tra_0589_0645( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0628; // At: ( ProxyDisplayClientPsm >> CompoundState >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
  public void Tra_0597_0610( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0627; // At: ( ProxyDisplayClientPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Paused )
  public void Tra_0589_0646( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0627; // At: ( ProxyDisplayClientPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> Ready )
  public void Tra_0589_0630( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0621; // At: ( ProxyDisplayClientPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_0589_0634( TsmHandler oHandler )
  {
    mCurrentState = oCom_0589_0596; // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> CompoundState ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_0589_0633( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0625; // At: ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_0589_0631( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0625; // At: ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_0589_0632( TsmHandler oHandler )
  {
    mCurrentState = oLea_0589_0625; // At: ( ProxyDisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 607:
        return TsmProspect.OK;
      case 614:
        return TsmProspect.OK;
      case 616:
        return TsmProspect.OK;
      case 609:
        return TsmProspect.OK;
      case 612:
        return TsmProspect.OK;
      case 637:
        return TsmProspect.OK;
      case 639:
        return TsmProspect.OK;
      case 642:
        return TsmProspect.OK;
      case 650:
        return TsmProspect.OK;
      case 635:
        return TsmProspect.OK;
      case 641:
        return TsmProspect.OK;
      case 644:
        return TsmProspect.OK;
      case 648:
        return TsmProspect.OK;
      case 649:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 25:
        return TsmProspect.OK;
      case 26:
        return TsmProspect.OK;
      case 27:
        return TsmProspect.OK;
      case 28:
        return TsmProspect.OK;
      case 29:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 629:
      Tra_0589_0629( oHandler );
      break;
    case 636:
      Tra_0589_0636( oHandler );
      break;
    case 638:
      Tra_0589_0638( oHandler );
      break;
    case 640:
      Tra_0589_0640( oHandler );
      break;
    case 643:
      Tra_0589_0643( oHandler );
      break;
    case 647:
      Tra_0589_0647( oHandler );
      break;
    case 637:
      Tra_0589_0637( oHandler );
      break;
    case 639:
      Tra_0589_0639( oHandler );
      break;
    case 642:
      Tra_0589_0642( oHandler );
      break;
    case 650:
      Tra_0589_0650( oHandler );
      break;
    case 635:
      Tra_0589_0635( oHandler );
      break;
    case 641:
      Tra_0589_0641( oHandler );
      break;
    case 644:
      Tra_0589_0644( oHandler );
      break;
    case 648:
      Tra_0589_0648( oHandler );
      break;
    case 649:
      Tra_0589_0649( oHandler );
      break;
    case 645:
      Tra_0589_0645( oHandler );
      break;
    case 610:
      Tra_0597_0610( oHandler );
      break;
    case 646:
      Tra_0589_0646( oHandler );
      break;
    case 630:
      Tra_0589_0630( oHandler );
      break;
    case 634:
      Tra_0589_0634( oHandler );
      break;
    case 633:
      Tra_0589_0633( oHandler );
      break;
    case 631:
      Tra_0589_0631( oHandler );
      break;
    case 632:
      Tra_0589_0632( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState )
class Com_0585_0588 extends TsmCompound
{
  int [] aNatives = { -654 };
  private Reg_0588_0589 oReg_0588_0589; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState >)

  public Com_0585_0588( TsmBase oParent )
  {
    TsmName = "CS_588";
    TsmParent = oParent;
    oReg_0588_0589 = new Reg_0588_0589( this );
    mRegions.add( oReg_0588_0589 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 654, "( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )" );
  }

  public void Tra_0585_0653( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0589_0651( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0585_0657( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 654:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 654: // Native: ( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState ) # Px_Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 654;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 653:
      Tra_0585_0653( oHandler );
      break;
    case 651:
      Tra_0589_0651( oHandler );
      break;
    case 654: // UP: ( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 657:
      Tra_0585_0657( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> Stopping )
class Lea_0585_0652 extends TsmLeaf
{
  int [] aNatives = { -656 };

  public Lea_0585_0652( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 656, "( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 657, "( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> CompoundState ) : Px_CbStopped" );
  }

  public void Tra_0585_0655( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 657; // Px_CbStopped
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 656:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 30:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 656: // Native: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState ) # Px_Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 656;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 583: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 30: // Port___Px_CbStopped
        {
          Port___Px_CbStopped( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 655:
      Tra_0585_0655( oHandler );
      break;
    case 656: // UP: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 657: // UP: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> CompoundState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >)
class Reg_0584_0585 extends TsmRegion
{
  private Ini_0585_0586 oIni_0585_0586; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> InitialState )
  private Cho_0585_0587 oCho_0585_0587; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> ChoiceState )
  private Com_0585_0588 oCom_0585_0588; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> CompoundState )
  private Lea_0585_0652 oLea_0585_0652; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >> Stopping )

  public Reg_0584_0585( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0585_0586 = new Ini_0585_0586( this );
    oCho_0585_0587 = new Cho_0585_0587( this );
    oCom_0585_0588 = new Com_0585_0588( this );
    oLea_0585_0652 = new Lea_0585_0652( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0585_0586;
    mStates[ 1 ] = oCho_0585_0587;
    mStates[ 2 ] = oCom_0585_0588;
    mStates[ 3 ] = oLea_0585_0652;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0585_0586.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> InitialState ) => ( ProxyDisplayClientPsm >> CompoundState )
  public void Tra_0585_0653( TsmHandler oHandler )
  {
    mCurrentState = oCom_0585_0588; // At: ( ProxyDisplayClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> CompoundState )
  public void Tra_0589_0651( TsmHandler oHandler )
  {
    mCurrentState = oCom_0585_0588; // At: ( ProxyDisplayClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> ChoiceState ) => ( ProxyDisplayClientPsm >> Stopping )
  public void Tra_0585_0655( TsmHandler oHandler )
  {
    mCurrentState = oLea_0585_0652; // At: ( ProxyDisplayClientPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )
  public void Tra_0585_0654( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1114( oHandler );
    mCurrentState = oCho_0585_0587; // At: ( ProxyDisplayClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )
  public void Tra_0585_0656( TsmHandler oHandler )
  {
    ((Cla_0525_0582)oHandler.Owner).Function_1129( oHandler );
    mCurrentState = oCho_0585_0587; // At: ( ProxyDisplayClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> CompoundState )
  public void Tra_0585_0657( TsmHandler oHandler )
  {
    mCurrentState = oCom_0585_0588; // At: ( ProxyDisplayClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 654:
        return TsmProspect.OK;
      case 607:
        return TsmProspect.OK;
      case 614:
        return TsmProspect.OK;
      case 616:
        return TsmProspect.OK;
      case 609:
        return TsmProspect.OK;
      case 612:
        return TsmProspect.OK;
      case 637:
        return TsmProspect.OK;
      case 639:
        return TsmProspect.OK;
      case 642:
        return TsmProspect.OK;
      case 650:
        return TsmProspect.OK;
      case 635:
        return TsmProspect.OK;
      case 641:
        return TsmProspect.OK;
      case 644:
        return TsmProspect.OK;
      case 648:
        return TsmProspect.OK;
      case 649:
        return TsmProspect.OK;
      case 656:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 583:
      switch ( Command )
      {
      case 25:
        return TsmProspect.OK;
      case 26:
        return TsmProspect.OK;
      case 27:
        return TsmProspect.OK;
      case 28:
        return TsmProspect.OK;
      case 29:
        return TsmProspect.OK;
      case 30:
        return TsmProspect.OK;
      case 31:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 653:
      Tra_0585_0653( oHandler );
      break;
    case 651:
      Tra_0589_0651( oHandler );
      break;
    case 655:
      Tra_0585_0655( oHandler );
      break;
    case 654:
      Tra_0585_0654( oHandler );
      break;
    case 656:
      Tra_0585_0656( oHandler );
      break;
    case 657:
      Tra_0585_0657( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm )
class Fsm_0582_0584 extends TsmFsm
{
  private Reg_0584_0585 oReg_0584_0585; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm >)

  public Fsm_0582_0584( TsmBase oParent )
  {
    TsmName = "ProxyDisplayClientPsm";
    TsmParent = oParent;
    oReg_0584_0585 = new Reg_0584_0585( this );
    mRegions.add( oReg_0584_0585 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )
class Cla_0525_0582 extends TsmProxyUser
{
  private Fsm_0582_0584 oFsm_0582_0584; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > ProxyDisplayClientPsm )
  private TsmIPort_IProxyDisplayServer Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
  private TsmIPort_IProxyDisplayClient TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient > Port )
  private TsmPCPort mPCMessager;
  private eRV RV = eRV.OK;

  public Cla_0525_0582( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0582_0584 = new Fsm_0582_0584( this );
    TsmPI__Port = new TsmIPort_IProxyDisplayClient( this );
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0582_0584;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IProxyDisplayServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol > ProxyDisplayClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0582_0584.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1055()
  {
    return RV==eRV.OK;
  }

   // ( ProxyDisplayClientPsm >> CompoundState ) => ( ProxyDisplayClientPsm >> ChoiceState )
  public void Function_1114( TsmHandler oHandler )
  {
    Port.Px_Stop();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1115( TsmHandler oHandler )
  {
    Port.Px_Start();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1116( TsmHandler oHandler )
  {
    Port.Px_Continue();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1117( TsmHandler oHandler )
  {
    RV=Port.Px_Pause();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1118( TsmHandler oHandler )
  {
    RV=Port.Px_Pause();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1119( TsmHandler oHandler )
  {
    Port.Px_Continue();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1120( TsmHandler oHandler )
  {
    Port.Px_Prepare();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1121( TsmHandler oHandler )
  {
    Port.Px_Start();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Ready ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1122( TsmHandler oHandler )
  {
    RV=Port.Px_Pause();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Preparing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1123( TsmHandler oHandler )
  {
    Port.Px_Prepare();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Idle ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1124( TsmHandler oHandler )
  {
    Port.Px_Prepare();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Starting ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1125( TsmHandler oHandler )
  {
    Port.Px_Start();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> StartPausing ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1126( TsmHandler oHandler )
  {
    RV=Port.Px_Pause();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> ChoiceState )
  public void Function_1127( TsmHandler oHandler )
  {
    RV=Port.Px_Pause();
  }

   // ( ProxyDisplayClientPsm >> CompoundState >> Paused ) => ( ProxyDisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1128( TsmHandler oHandler )
  {
    Port.Px_Continue();
  }

   // ( ProxyDisplayClientPsm >> Stopping ) => ( ProxyDisplayClientPsm >> ChoiceState )
  public void Function_1129( TsmHandler oHandler )
  {
    Port.Px_Stop();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 583;
    TsmPI__Port.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    Port.SetProxyUser( this );

    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0582_0584.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol )
 ********************************************************************/

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyDisplayProtocol )
class Pac_0524_0525 extends TsmPackage
{
  public Pac_0524_0525( TsmBase oParent )
  {
    TsmName = "ProxyDisplayProtocol";
    TsmParent = oParent;
  }
}

interface IProxyReaderClient
{
  public void Px_CbOpened();
  public void Px_CbStopped();
  public void Px_CbDone();
  public void Px_CbError( int BadSector );
  public void Px_CbClosed();
  public void Px_CbReading();
  public void Px_CbFilled();
}

class TsmTrigger_IProxyReaderClient___Px_CbOpened extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbOpened()
  {
    super( 18 );
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbStopped extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbStopped()
  {
    super( 19 );
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbDone extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbDone()
  {
    super( 20 );
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbError extends TsmTrigger
{
  public int BadSector;

  public TsmTrigger_IProxyReaderClient___Px_CbError( int BadSector )
  {
    super( 21 );
    this.BadSector = BadSector;
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbClosed extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbClosed()
  {
    super( 22 );
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbReading extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbReading()
  {
    super( 23 );
  }
}

class TsmTrigger_IProxyReaderClient___Px_CbFilled extends TsmTrigger
{
  public TsmTrigger_IProxyReaderClient___Px_CbFilled()
  {
    super( 24 );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > IProxyReaderClient )
class TsmIPort_IProxyReaderClient extends TsmInterfacePort implements IProxyReaderClient
{
  public TsmIPort_IProxyReaderClient( TsmBase oParent )
  {
    TsmName = "IProxyReaderClient";
    TsmParent = oParent;
  }

  public void Px_CbOpened()
  {
    TsmTrigger_IProxyReaderClient___Px_CbOpened tt = new TsmTrigger_IProxyReaderClient___Px_CbOpened();
    TsmRecorder.AddCall( "Px_CbOpened", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbStopped()
  {
    TsmTrigger_IProxyReaderClient___Px_CbStopped tt = new TsmTrigger_IProxyReaderClient___Px_CbStopped();
    TsmRecorder.AddCall( "Px_CbStopped", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbDone()
  {
    TsmTrigger_IProxyReaderClient___Px_CbDone tt = new TsmTrigger_IProxyReaderClient___Px_CbDone();
    TsmRecorder.AddCall( "Px_CbDone", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbError( int BadSector )
  {
    TsmTrigger_IProxyReaderClient___Px_CbError tt = new TsmTrigger_IProxyReaderClient___Px_CbError( BadSector );
    TsmRecorder.AddCall( "Px_CbError", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbClosed()
  {
    TsmTrigger_IProxyReaderClient___Px_CbClosed tt = new TsmTrigger_IProxyReaderClient___Px_CbClosed();
    TsmRecorder.AddCall( "Px_CbClosed", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbReading()
  {
    TsmTrigger_IProxyReaderClient___Px_CbReading tt = new TsmTrigger_IProxyReaderClient___Px_CbReading();
    TsmRecorder.AddCall( "Px_CbReading", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_CbFilled()
  {
    TsmTrigger_IProxyReaderClient___Px_CbFilled tt = new TsmTrigger_IProxyReaderClient___Px_CbFilled();
    TsmRecorder.AddCall( "Px_CbFilled", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

interface IProxyReaderServer
{
  public eRV Px_Open( int FileHandle );
  public void Px_Close();
  public void Px_Stop();
  public void Px_Clear();
  public eRV Px_Read( tChunk Chunk );
  public void Px_IsFilled();
}

class TsmTrigger_IProxyReaderServer___Px_Open extends TsmTrigger
{
  public int FileHandle;
  public eRV _RetVal;

  public TsmTrigger_IProxyReaderServer___Px_Open( int FileHandle )
  {
    super( 8 );
    this.FileHandle = FileHandle;
  }
}

class TsmTrigger_IProxyReaderServer___Px_Close extends TsmTrigger
{
  public TsmTrigger_IProxyReaderServer___Px_Close()
  {
    super( 9 );
  }
}

class TsmTrigger_IProxyReaderServer___Px_Stop extends TsmTrigger
{
  public TsmTrigger_IProxyReaderServer___Px_Stop()
  {
    super( 10 );
  }
}

class TsmTrigger_IProxyReaderServer___Px_Clear extends TsmTrigger
{
  public TsmTrigger_IProxyReaderServer___Px_Clear()
  {
    super( 11 );
  }
}

class TsmTrigger_IProxyReaderServer___Px_Read extends TsmTrigger
{
  public tChunk Chunk;
  public eRV _RetVal;

  public TsmTrigger_IProxyReaderServer___Px_Read( tChunk Chunk )
  {
    super( 12 );
    this.Chunk = Chunk;
  }
}

class TsmTrigger_IProxyReaderServer___Px_IsFilled extends TsmTrigger
{
  public TsmTrigger_IProxyReaderServer___Px_IsFilled()
  {
    super( 13 );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > IProxyReaderServer )
class TsmIPort_IProxyReaderServer extends TsmInterfacePort implements IProxyReaderServer
{
  public TsmIPort_IProxyReaderServer( TsmBase oParent )
  {
    TsmName = "IProxyReaderServer";
    TsmParent = oParent;
  }

  public eRV Px_Open( int FileHandle )
  {
    TsmTrigger_IProxyReaderServer___Px_Open tt = new TsmTrigger_IProxyReaderServer___Px_Open( FileHandle );
    TsmRecorder.AddCall( "Px_Open", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Px_Close()
  {
    TsmTrigger_IProxyReaderServer___Px_Close tt = new TsmTrigger_IProxyReaderServer___Px_Close();
    TsmRecorder.AddCall( "Px_Close", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_Stop()
  {
    TsmTrigger_IProxyReaderServer___Px_Stop tt = new TsmTrigger_IProxyReaderServer___Px_Stop();
    TsmRecorder.AddCall( "Px_Stop", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Px_Clear()
  {
    TsmTrigger_IProxyReaderServer___Px_Clear tt = new TsmTrigger_IProxyReaderServer___Px_Clear();
    TsmRecorder.AddCall( "Px_Clear", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV Px_Read( tChunk Chunk )
  {
    TsmTrigger_IProxyReaderServer___Px_Read tt = new TsmTrigger_IProxyReaderServer___Px_Read( Chunk );
    TsmRecorder.AddCall( "Px_Read", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Px_IsFilled()
  {
    TsmTrigger_IProxyReaderServer___Px_IsFilled tt = new TsmTrigger_IProxyReaderServer___Px_IsFilled();
    TsmRecorder.AddCall( "Px_IsFilled", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> InitialState )
class Ini_0662_0663 extends TsmPseudo
{
  public Ini_0662_0663( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 701, "( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 701; // TRLS ( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 701: // UP: ( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> InitialState )
class Ini_0665_0666 extends TsmPseudo
{
  public Ini_0665_0666( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 669, "( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 669; // TRLS ( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 669: // UP: ( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> ChoiceState )
class Cho_0665_0667 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0665_0667( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 671, "( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 673, "( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 671; // TRLS ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 673; // TRLS ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0665_0672( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 671: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
      bHigher = true;
      break;
    case 673: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
      bHigher = true;
      break;
    case 672:
      Tra_0665_0672( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> Base )
class Lea_0665_0668 extends TsmLeaf
{
  public Lea_0665_0668( TsmBase oParent )
  {
    TsmName = "Base";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 672, "( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> ChoiceState ) : Px_Open" );
    mTransitions[ 1 ] = new TsmTransition( 670, "( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> Base ) : 'ProxyOk' Px_Close" );
  }

  public void Tra_0665_0669( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0665_0673( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 672; // Px_Open
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0665_0670( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1304( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 670; // Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 8: // Port___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          Port___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // Port___Px_Close
        {
          Port___Px_Close( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 669:
      Tra_0665_0669( oHandler );
      break;
    case 673:
      Tra_0665_0673( oHandler );
      break;
    case 672: // UP: ( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> ChoiceState )
      bHigher = true;
      break;
    case 670:
      Tra_0665_0670( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >)
class Reg_0664_0665 extends TsmRegion
{
  private Ini_0665_0666 oIni_0665_0666; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> InitialState )
  private Cho_0665_0667 oCho_0665_0667; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> ChoiceState )
  private Lea_0665_0668 oLea_0665_0668; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >> Base )

  public Reg_0664_0665( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0665_0666 = new Ini_0665_0666( this );
    oCho_0665_0667 = new Cho_0665_0667( this );
    oLea_0665_0668 = new Lea_0665_0668( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0665_0666;
    mStates[ 1 ] = oCho_0665_0667;
    mStates[ 2 ] = oLea_0665_0668;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0665_0666.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Idle >> InitialState ) => ( ProxyReaderServerPsm >> Idle >> Base )
  public void Tra_0665_0669( TsmHandler oHandler )
  {
    mCurrentState = oLea_0665_0668; // At: ( ProxyReaderServerPsm >> Idle >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
  public void Tra_0665_0673( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1059( oHandler );
    mCurrentState = oLea_0665_0668; // At: ( ProxyReaderServerPsm >> Idle >> Base )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> ChoiceState )
  public void Tra_0665_0672( TsmHandler oHandler )
  {
    mCurrentState = oCho_0665_0667; // At: ( ProxyReaderServerPsm >> Idle >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 669:
      Tra_0665_0669( oHandler );
      break;
    case 671: // Up: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
      mCurrentState = null;
      bHigher = true;
      break;
    case 673:
      Tra_0665_0673( oHandler );
      break;
    case 672:
      Tra_0665_0672( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle )
class Com_0662_0664 extends TsmCompound
{
  private Reg_0664_0665 oReg_0664_0665; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle >)

  public Com_0662_0664( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    oReg_0664_0665 = new Reg_0664_0665( this );
    mRegions.add( oReg_0664_0665 );
    mNrTransitions = 0;
  }

  public void Tra_0662_0701( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0662_0713( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 701:
      Tra_0662_0701( oHandler );
      break;
    case 671: // UP: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 713:
      Tra_0662_0713( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> ChoiceState )
class Cho_0675_0676 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0675_0676( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 695, "( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok'" );
    mTransitions[ 1 ] = new TsmTransition( 696, "( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error ) : 'ProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 695; // TRLS ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 696; // TRLS ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0675_0694( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 695: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
      bHigher = true;
      break;
    case 696: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
      bHigher = true;
      break;
    case 694:
      Tra_0675_0694( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState )
class Ini_0678_0679 extends TsmPseudo
{
  public Ini_0678_0679( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 682, "( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 682; // TRLS ( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 682: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
class Lea_0678_0680 extends TsmLeaf
{
  int [] aNatives = { 684 };

  public Lea_0678_0680( TsmBase oParent )
  {
    TsmName = "NotEnough";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 684, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )" );
    mTransitions[ 1 ] = new TsmTransition( 683, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyOk' Px_Read" );
    mTransitions[ 2 ] = new TsmTransition( 687, "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) : 'ProxyNok' Px_IsFilled" );
  }

  public void Tra_0678_0682( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0678_0683( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1314( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 683; // Px_Read
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0678_0687( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1317( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_IsFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 687; // Px_IsFilled
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 684:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 684: // Native: ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) # Px_CbFilled();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 684;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 12: // Port___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          Port___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      case 13: // Port___Px_IsFilled
        {
          Port___Px_IsFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 682:
      Tra_0678_0682( oHandler );
      break;
    case 684: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 683:
      Tra_0678_0683( oHandler );
      break;
    case 687:
      Tra_0678_0687( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
class Lea_0678_0681 extends TsmLeaf
{
  int [] aNatives = { 685 };

  public Lea_0678_0681( TsmBase oParent )
  {
    TsmName = "Enough";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 685, "( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
    mTransitions[ 1 ] = new TsmTransition( 686, "( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) : 'ProxyOk' Px_IsFilled" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0678_0684( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0678_0686( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1318( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_IsFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 686; // Px_IsFilled
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 685:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 685: // Native: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) # Px_CbDone();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 685;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 13: // Port___Px_IsFilled
        {
          Port___Px_IsFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 684:
      Tra_0678_0684( oHandler );
      break;
    case 685: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 686:
      Tra_0678_0686( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >)
class Reg_0677_0678 extends TsmRegion
{
  private Ini_0678_0679 oIni_0678_0679; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState )
  private Lea_0678_0680 oLea_0678_0680; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  private Lea_0678_0681 oLea_0678_0681; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )

  public Reg_0677_0678( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0678_0679 = new Ini_0678_0679( this );
    oLea_0678_0680 = new Lea_0678_0680( this );
    oLea_0678_0681 = new Lea_0678_0681( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0678_0679;
    mStates[ 1 ] = oLea_0678_0680;
    mStates[ 2 ] = oLea_0678_0681;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0678_0679.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0678_0682( TsmHandler oHandler )
  {
    mCurrentState = oLea_0678_0680; // At: ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
  public void Tra_0678_0684( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1131( oHandler );
    mCurrentState = oLea_0678_0681; // At: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 684:
        return TsmProspect.OK;
      case 685:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 682:
      Tra_0678_0682( oHandler );
      break;
    case 684:
      Tra_0678_0684( oHandler );
      break;
    case 685: // Up: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading )
class Com_0675_0677 extends TsmCompound
{
  int [] aNatives = { 693 };
  private Reg_0677_0678 oReg_0677_0678; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading >)

  public Com_0675_0677( TsmBase oParent )
  {
    TsmName = "Reading";
    TsmParent = oParent;
    oReg_0677_0678 = new Reg_0677_0678( this );
    mRegions.add( oReg_0677_0678 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 693, "( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )" );
  }

  public void Tra_0662_0709( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 693:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 693: // Native: ( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error ) # Px_CbError( BadSector );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 693;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 693: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 685: // UP: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 709:
      Tra_0662_0709( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Open )
class Lea_0675_0688 extends TsmLeaf
{
  public Lea_0675_0688( TsmBase oParent )
  {
    TsmName = "Open";
    TsmParent = oParent;
    mNrTransitions = 5;
    mTransitions = new TsmTransition[ 5 ];
    mTransitions[ 0 ] = new TsmTransition( 690, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : 'ProxyOk' Px_Open" );
    mTransitions[ 1 ] = new TsmTransition( 711, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing ) : 'ProxyNok' Px_Close" );
    mTransitions[ 2 ] = new TsmTransition( 691, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : 'ProxyOk' Px_Stop" );
    mTransitions[ 3 ] = new TsmTransition( 692, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) : Px_Clear" );
    mTransitions[ 4 ] = new TsmTransition( 694, "( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) : Px_Read" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0678_0685( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0662_0704( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0662_0707( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0675_0690( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1301( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 690; // Px_Open
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 711; // Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0675_0691( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1309( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 691; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0675_0692( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Clear( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 692; // Px_Clear
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void Port___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 694; // Px_Read
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 8: // Port___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          Port___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // Port___Px_Close
        {
          Port___Px_Close( oHandler );
        }
        break;
      case 10: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      case 11: // Port___Px_Clear
        {
          Port___Px_Clear( oHandler );
        }
        break;
      case 12: // Port___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          Port___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 685:
      Tra_0678_0685( oHandler );
      break;
    case 704:
      Tra_0662_0704( oHandler );
      break;
    case 707:
      Tra_0662_0707( oHandler );
      break;
    case 690:
      Tra_0675_0690( oHandler );
      break;
    case 711: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
      bHigher = true;
      break;
    case 691:
      Tra_0675_0691( oHandler );
      break;
    case 692:
      Tra_0675_0692( oHandler );
      break;
    case 694: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Error )
class Lea_0675_0689 extends TsmLeaf
{
  public Lea_0675_0689( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0675_0696( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0675_0693( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 696:
      Tra_0675_0696( oHandler );
      break;
    case 693:
      Tra_0675_0693( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >)
class Reg_0674_0675 extends TsmRegion
{
  private Cho_0675_0676 oCho_0675_0676; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> ChoiceState )
  private Com_0675_0677 oCom_0675_0677; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Reading )
  private Lea_0675_0688 oLea_0675_0688; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Open )
  private Lea_0675_0689 oLea_0675_0689; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >> Error )

  public Reg_0674_0675( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0675_0676 = new Cho_0675_0676( this );
    oCom_0675_0677 = new Com_0675_0677( this );
    oLea_0675_0688 = new Lea_0675_0688( this );
    oLea_0675_0689 = new Lea_0675_0689( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0675_0676;
    mStates[ 1 ] = oCom_0675_0677;
    mStates[ 2 ] = oLea_0675_0688;
    mStates[ 3 ] = oLea_0675_0689;
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
  public void Tra_0675_0696( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1063( oHandler );
    mCurrentState = oLea_0675_0689; // At: ( ProxyReaderServerPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
  public void Tra_0675_0693( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1130( oHandler );
    mCurrentState = oLea_0675_0689; // At: ( ProxyReaderServerPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Tra_0678_0685( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1132( oHandler );
    mCurrentState = oLea_0675_0688; // At: ( ProxyReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Tra_0662_0704( TsmHandler oHandler )
  {
    mCurrentState = oLea_0675_0688; // Down: ( ProxyReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Tra_0662_0707( TsmHandler oHandler )
  {
    mCurrentState = oLea_0675_0688; // Down: ( ProxyReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
  public void Tra_0662_0709( TsmHandler oHandler )
  {
    mCurrentState = oCom_0675_0677; // Down: ( ProxyReaderServerPsm >> CompoundState >> Reading )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> ChoiceState )
  public void Tra_0675_0694( TsmHandler oHandler )
  {
    mCurrentState = oCho_0675_0676; // At: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 693:
        return TsmProspect.OK;
      case 684:
        return TsmProspect.OK;
      case 685:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 695: // Up: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
      mCurrentState = null;
      bHigher = true;
      break;
    case 696:
      Tra_0675_0696( oHandler );
      break;
    case 693:
      Tra_0675_0693( oHandler );
      break;
    case 685:
      Tra_0678_0685( oHandler );
      break;
    case 704:
      Tra_0662_0704( oHandler );
      break;
    case 707:
      Tra_0662_0707( oHandler );
      break;
    case 709:
      Tra_0662_0709( oHandler );
      break;
    case 711: // Up: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
      mCurrentState = null;
      bHigher = true;
      break;
    case 694:
      Tra_0675_0694( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState )
class Com_0662_0674 extends TsmCompound
{
  private Reg_0674_0675 oReg_0674_0675; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState >)

  public Com_0662_0674( TsmBase oParent )
  {
    TsmName = "CS_674";
    TsmParent = oParent;
    oReg_0674_0675 = new Reg_0674_0675( this );
    mRegions.add( oReg_0674_0675 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 705, "( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
  }

  public void Tra_0662_0704( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0674_0675.ExecuteHandler( oHandler );
  }

  public void Tra_0662_0707( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0674_0675.ExecuteHandler( oHandler );
  }

  public void Tra_0662_0709( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0674_0675.ExecuteHandler( oHandler );
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 705; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 660:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 10: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 695: // UP: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 704:
      Tra_0662_0704( oHandler );
      break;
    case 707:
      Tra_0662_0707( oHandler );
      break;
    case 709:
      Tra_0662_0709( oHandler );
      break;
    case 711: // UP: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 705: // UP: ( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Opening )
class Lea_0662_0697 extends TsmLeaf
{
  int [] aNatives = { 704 };

  public Lea_0662_0697( TsmBase oParent )
  {
    TsmName = "Opening";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 704, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
    mTransitions[ 1 ] = new TsmTransition( 702, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Open" );
    mTransitions[ 2 ] = new TsmTransition( 703, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Close" );
    mTransitions[ 3 ] = new TsmTransition( 714, "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening ) : 'ProxyNok' Px_Stop" );
  }

  public void Tra_0665_0671( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0662_0702( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1303( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 702; // Px_Open
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0662_0703( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1306( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 703; // Px_Close
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0662_0714( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1310( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 714; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 704:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 704: // Native: ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) # Px_CbOpened();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 704;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 8: // Port___Px_Open
        {
          TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;

          Port___Px_Open( lTrigger.FileHandle, oHandler );
        }
        break;
      case 9: // Port___Px_Close
        {
          Port___Px_Close( oHandler );
        }
        break;
      case 10: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 671:
      Tra_0665_0671( oHandler );
      break;
    case 704: // UP: ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 702:
      Tra_0662_0702( oHandler );
      break;
    case 703:
      Tra_0662_0703( oHandler );
      break;
    case 714:
      Tra_0662_0714( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Stopping )
class Lea_0662_0698 extends TsmLeaf
{
  int [] aNatives = { 707 };

  public Lea_0662_0698( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 707, "( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )" );
    mTransitions[ 1 ] = new TsmTransition( 706, "( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> Stopping ) : 'ProxyNok' Px_Stop" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0662_0705( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0662_0706( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1311( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 706; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 707:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 707: // Native: ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open ) # Px_CbStopped();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 707;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 10: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 707: // UP: ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 705:
      Tra_0662_0705( oHandler );
      break;
    case 706:
      Tra_0662_0706( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Closing )
class Lea_0662_0699 extends TsmLeaf
{
  int [] aNatives = { 713 };

  public Lea_0662_0699( TsmBase oParent )
  {
    TsmName = "Closing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 713, "( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )" );
    mTransitions[ 1 ] = new TsmTransition( 712, "( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Closing ) : 'ProxyNok' Px_Close" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0662_0711( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0662_0712( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1307( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 712; // Px_Close
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 713:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 9:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 713: // Native: ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle ) # Px_CbClosed();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 713;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 9: // Port___Px_Close
        {
          Port___Px_Close( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 713: // UP: ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 711:
      Tra_0662_0711( oHandler );
      break;
    case 712:
      Tra_0662_0712( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Seeking )
class Lea_0662_0700 extends TsmLeaf
{
  int [] aNatives = { 709 };

  public Lea_0662_0700( TsmBase oParent )
  {
    TsmName = "Seeking";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 709, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )" );
    mTransitions[ 1 ] = new TsmTransition( 708, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok' Px_Stop" );
    mTransitions[ 2 ] = new TsmTransition( 710, "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking ) : 'ProxyNok' Px_Read" );
  }

  public void Tra_0675_0695( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0662_0708( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1312( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 708; // Px_Stop
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0662_0710( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0659)oHandler.Owner).Function_1316( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Px_Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 710; // Px_Read
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 709:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 10:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 709: // Native: ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
        TsmRecorder.AddNative( "( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading ) # Px_CbReading();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 709;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 660: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 10: // Port___Px_Stop
        {
          Port___Px_Stop( oHandler );
        }
        break;
      case 12: // Port___Px_Read
        {
          TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;

          Port___Px_Read( lTrigger.Chunk, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 695:
      Tra_0675_0695( oHandler );
      break;
    case 709: // UP: ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 708:
      Tra_0662_0708( oHandler );
      break;
    case 710:
      Tra_0662_0710( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >)
class Reg_0661_0662 extends TsmRegion
{
  private Ini_0662_0663 oIni_0662_0663; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> InitialState )
  private Com_0662_0664 oCom_0662_0664; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Idle )
  private Com_0662_0674 oCom_0662_0674; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> CompoundState )
  private Lea_0662_0697 oLea_0662_0697; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Opening )
  private Lea_0662_0698 oLea_0662_0698; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Stopping )
  private Lea_0662_0699 oLea_0662_0699; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Closing )
  private Lea_0662_0700 oLea_0662_0700; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >> Seeking )

  public Reg_0661_0662( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0662_0663 = new Ini_0662_0663( this );
    oCom_0662_0664 = new Com_0662_0664( this );
    oCom_0662_0674 = new Com_0662_0674( this );
    oLea_0662_0697 = new Lea_0662_0697( this );
    oLea_0662_0698 = new Lea_0662_0698( this );
    oLea_0662_0699 = new Lea_0662_0699( this );
    oLea_0662_0700 = new Lea_0662_0700( this );
    mNrStates = 7;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0662_0663;
    mStates[ 1 ] = oCom_0662_0664;
    mStates[ 2 ] = oCom_0662_0674;
    mStates[ 3 ] = oLea_0662_0697;
    mStates[ 4 ] = oLea_0662_0698;
    mStates[ 5 ] = oLea_0662_0699;
    mStates[ 6 ] = oLea_0662_0700;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0662_0663.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> InitialState ) => ( ProxyReaderServerPsm >> Idle )
  public void Tra_0662_0701( TsmHandler oHandler )
  {
    mCurrentState = oCom_0662_0664; // At: ( ProxyReaderServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
  public void Tra_0665_0671( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1057( oHandler );
    mCurrentState = oLea_0662_0697; // At: ( ProxyReaderServerPsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
  public void Tra_0675_0695( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1061( oHandler );
    mCurrentState = oLea_0662_0700; // At: ( ProxyReaderServerPsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Tra_0662_0704( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1133( oHandler );
    mCurrentState = oCom_0662_0674; // At: ( ProxyReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Tra_0662_0707( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1134( oHandler );
    mCurrentState = oCom_0662_0674; // At: ( ProxyReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )
  public void Tra_0662_0713( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1135( oHandler );
    mCurrentState = oCom_0662_0664; // At: ( ProxyReaderServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
  public void Tra_0662_0709( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1136( oHandler );
    mCurrentState = oCom_0662_0674; // At: ( ProxyReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
  public void Tra_0662_0711( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1305( oHandler );
    mCurrentState = oLea_0662_0699; // At: ( ProxyReaderServerPsm >> Closing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping )
  public void Tra_0662_0705( TsmHandler oHandler )
  {
    ((Cla_0658_0659)oHandler.Owner).Function_1308( oHandler );
    mCurrentState = oLea_0662_0698; // At: ( ProxyReaderServerPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 693:
        return TsmProspect.OK;
      case 684:
        return TsmProspect.OK;
      case 685:
        return TsmProspect.OK;
      case 704:
        return TsmProspect.OK;
      case 707:
        return TsmProspect.OK;
      case 713:
        return TsmProspect.OK;
      case 709:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 660:
      switch ( Command )
      {
      case 8:
        return TsmProspect.OK;
      case 9:
        return TsmProspect.OK;
      case 10:
        return TsmProspect.OK;
      case 11:
        return TsmProspect.OK;
      case 12:
        return TsmProspect.OK;
      case 13:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 701:
      Tra_0662_0701( oHandler );
      break;
    case 671:
      Tra_0665_0671( oHandler );
      break;
    case 695:
      Tra_0675_0695( oHandler );
      break;
    case 704:
      Tra_0662_0704( oHandler );
      break;
    case 707:
      Tra_0662_0707( oHandler );
      break;
    case 713:
      Tra_0662_0713( oHandler );
      break;
    case 709:
      Tra_0662_0709( oHandler );
      break;
    case 711:
      Tra_0662_0711( oHandler );
      break;
    case 705:
      Tra_0662_0705( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm )
class Fsm_0659_0661 extends TsmFsm
{
  private Reg_0661_0662 oReg_0661_0662; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm >)

  public Fsm_0659_0661( TsmBase oParent )
  {
    TsmName = "ProxyReaderServerPsm";
    TsmParent = oParent;
    oReg_0661_0662 = new Reg_0661_0662( this );
    mRegions.add( oReg_0661_0662 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )
class Cla_0658_0659 extends TsmProxy
{
  private Fsm_0659_0661 oFsm_0659_0661; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > ProxyReaderServerPsm )
  private TsmIPort_IProxyReaderServer TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
  private TsmIPort_IProxyReaderClient Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer > Port )
  private TsmPSPort mPSMessager;
  private int BadSector = 0;

  public Cla_0658_0659( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0659_0661 = new Fsm_0659_0661( this );
    TsmPI__Port = new TsmIPort_IProxyReaderServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0659_0661;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IProxyReaderClient) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0659_0661.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
  public eRV Function_1056( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Opening )
  public void Function_1057( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1056( FileHandle );

    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
  public eRV Function_1058( int FileHandle )
  {
    return eRV.INVALID_PARAM;
  }

   // ( ProxyReaderServerPsm >> Idle >> ChoiceState ) => ( ProxyReaderServerPsm >> Idle >> Base )
  public void Function_1059( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1058( FileHandle );

    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
  public eRV Function_1060( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> Seeking )
  public void Function_1061( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1060( Chunk );

    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
  public eRV Function_1062( tChunk Chunk )
  {
    return eRV.INVALID_PARAM;
  }

   // ( ProxyReaderServerPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
  public void Function_1063( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1062( Chunk );

    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading ) => ( ProxyReaderServerPsm >> CompoundState >> Error )
  public void Function_1130( TsmHandler oHandler )
  {
    Port.Px_CbError( BadSector );
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
  public void Function_1131( TsmHandler oHandler )
  {
    Port.Px_CbFilled();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Function_1132( TsmHandler oHandler )
  {
    Port.Px_CbDone();
  }

   // ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Function_1133( TsmHandler oHandler )
  {
    Port.Px_CbOpened();
  }

   // ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Function_1134( TsmHandler oHandler )
  {
    Port.Px_CbStopped();
  }

   // ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Idle )
  public void Function_1135( TsmHandler oHandler )
  {
    Port.Px_CbClosed();
  }

   // ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> CompoundState >> Reading )
  public void Function_1136( TsmHandler oHandler )
  {
    Port.Px_CbReading();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public eRV Function_1300( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Function_1301( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1300( FileHandle );

    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening )
  public eRV Function_1302( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening )
  public void Function_1303( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Open lTrigger = (TsmTrigger_IProxyReaderServer___Px_Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1302( FileHandle );

    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Idle >> Base ) => ( ProxyReaderServerPsm >> Idle >> Base )
  public void Function_1304( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> Closing )
  public void Function_1305( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening )
  public void Function_1306( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Closing ) => ( ProxyReaderServerPsm >> Closing )
  public void Function_1307( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState ) => ( ProxyReaderServerPsm >> Stopping )
  public void Function_1308( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Open ) => ( ProxyReaderServerPsm >> CompoundState >> Open )
  public void Function_1309( TsmHandler oHandler )
  {
    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> Opening ) => ( ProxyReaderServerPsm >> Opening )
  public void Function_1310( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Stopping ) => ( ProxyReaderServerPsm >> Stopping )
  public void Function_1311( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking )
  public void Function_1312( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  public eRV Function_1313( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  public void Function_1314( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1313( Chunk );

    SetProxyOk();
  }

   // ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking )
  public eRV Function_1315( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ProxyReaderServerPsm >> Seeking ) => ( ProxyReaderServerPsm >> Seeking )
  public void Function_1316( TsmHandler oHandler )
  {
    TsmTrigger_IProxyReaderServer___Px_Read lTrigger = (TsmTrigger_IProxyReaderServer___Px_Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0658_0659)oHandler.Owner).Function_1315( Chunk );

    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  public void Function_1317( TsmHandler oHandler )
  {
    SetProxyNok();
  }

   // ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderServerPsm >> CompoundState >> Reading >> Enough )
  public void Function_1318( TsmHandler oHandler )
  {
    SetProxyOk();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 660;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0659_0661.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> InitialState )
class Ini_0718_0719 extends TsmPseudo
{
  public Ini_0718_0719( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 768, "( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 768; // TRLS ( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 768: // UP: ( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0720 extends TsmPseudo
{
  public Cho_0718_0720( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 769, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 769; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0789( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 769: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
      bHigher = true;
      break;
    case 789:
      Tra_0718_0789( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0721 extends TsmPseudo
{
  public Cho_0718_0721( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 771, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 771; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0770( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 771: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
      bHigher = true;
      break;
    case 770:
      Tra_0718_0770( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0722 extends TsmPseudo
{
  public Cho_0718_0722( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 772, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 772; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0730_0756( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0773( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 772: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing )
      bHigher = true;
      break;
    case 756:
      Tra_0730_0756( oHandler );
      break;
    case 773:
      Tra_0718_0773( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0723 extends TsmPseudo
{
  public Cho_0718_0723( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 775, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 775; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0791( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0774( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 775: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
      bHigher = true;
      break;
    case 791:
      Tra_0718_0791( oHandler );
      break;
    case 774:
      Tra_0718_0774( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0724 extends TsmPseudo
{
  public Cho_0718_0724( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 762, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : 'IsProxyOk'" );
    mTransitions[ 1 ] = new TsmTransition( 777, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 762; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 777; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping )
      mTransitions[ 1 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0776( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0778( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 762: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 777: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping )
      bHigher = true;
      break;
    case 776:
      Tra_0718_0776( oHandler );
      break;
    case 778:
      Tra_0718_0778( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0725 extends TsmPseudo
{
  public Cho_0718_0725( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 780, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 780; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0779( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 780: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
      bHigher = true;
      break;
    case 779:
      Tra_0718_0779( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0726 extends TsmPseudo
{
  public Cho_0718_0726( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 782, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 782; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0730_0760( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0788( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 782: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
      bHigher = true;
      break;
    case 760:
      Tra_0730_0760( oHandler );
      break;
    case 788:
      Tra_0718_0788( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0727 extends TsmPseudo
{
  public Cho_0718_0727( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 784, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 784; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0718_0783( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 784: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
      bHigher = true;
      break;
    case 783:
      Tra_0718_0783( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
class Cho_0718_0728 extends TsmPseudo
{
  public Cho_0718_0728( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 791, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 789, "( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0658_0715)oHandler.Owner).Guard_1064() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 791; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 789; // TRLS ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0718_0790( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 791: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      bHigher = true;
      break;
    case 789: // UP: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      bHigher = true;
      break;
    case 790:
      Tra_0718_0790( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
class Cho_0730_0731 extends TsmPseudo
{
  public Cho_0730_0731( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 754, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 754; // TRLS ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0730_0755( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 754: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 755:
      Tra_0730_0755( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
class Cho_0730_0732 extends TsmPseudo
{
  public Cho_0730_0732( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 760, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 759, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0658_0715)oHandler.Owner).Guard_1065() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 760; // TRLS ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 759; // TRLS ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0730_0758( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 760: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      bHigher = true;
      break;
    case 759: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 758:
      Tra_0730_0758( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
class Cho_0730_0733 extends TsmPseudo
{
  public Cho_0730_0733( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 761, "( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error ) : 'IsProxyOk'" );
  }

  public void Tra_0730_0759( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 761; // TRLS ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 759:
      Tra_0730_0759( oHandler );
      break;
    case 761: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState )
class Ini_0735_0736 extends TsmPseudo
{
  public Ini_0735_0736( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 742, "( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 742; // TRLS ( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 742: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
class Cho_0735_0737 extends TsmPseudo
{
  public Cho_0735_0737( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 747, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 747; // TRLS ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0735_0746( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 747: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    case 746:
      Tra_0735_0746( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
class Cho_0735_0738 extends TsmPseudo
{
  public Cho_0735_0738( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 749, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) : 'IsProxyOk'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyOk() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 749; // TRLS ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0735_0748( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 749: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
      bHigher = true;
      break;
    case 748:
      Tra_0735_0748( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
class Cho_0735_0739 extends TsmPseudo
{
  public Cho_0735_0739( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 751, "( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) : 'IsProxyNok'" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((TsmProxyUser)oHandler.Owner).IsProxyNok() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 751; // TRLS ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.GUARD;
    }
  }

  public void Tra_0735_0750( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 751: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    case 750:
      Tra_0735_0750( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
class Lea_0735_0740 extends TsmLeaf
{
  int [] aNatives = { -746, -750 };

  public Lea_0735_0740( TsmBase oParent )
  {
    TsmName = "NotEnough";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 746, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 750, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 743, "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) : Px_CbFilled" );
  }

  public void Tra_0735_0742( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0735_0747( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0735_0751( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 743; // Px_CbFilled
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 746:
        return TsmProspect.OK;
      case 750:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 24:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 746: // Native: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) # RV=Px_Read( Chunk );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 746;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 750: // Native: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) # Px_IsFilled();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 750;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 24: // Port___Px_CbFilled
        {
          Port___Px_CbFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 742:
      Tra_0735_0742( oHandler );
      break;
    case 747:
      Tra_0735_0747( oHandler );
      break;
    case 751:
      Tra_0735_0751( oHandler );
      break;
    case 746: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 750: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 743: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
class Lea_0735_0741 extends TsmLeaf
{
  int [] aNatives = { -748 };

  public Lea_0735_0741( TsmBase oParent )
  {
    TsmName = "Enough";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 748, "( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 745, "( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbDone" );
  }

  public void Tra_0735_0749( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 745; // Px_CbDone
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0735_0743( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 748:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 20:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 748: // Native: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) # Px_IsFilled();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 748;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 20: // Port___Px_CbDone
        {
          Port___Px_CbDone( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 749:
      Tra_0735_0749( oHandler );
      break;
    case 748: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 745: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 743:
      Tra_0735_0743( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >)
class Reg_0734_0735 extends TsmRegion
{
  private Ini_0735_0736 oIni_0735_0736; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState )
  private Cho_0735_0737 oCho_0735_0737; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  private Cho_0735_0738 oCho_0735_0738; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  private Cho_0735_0739 oCho_0735_0739; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  private Lea_0735_0740 oLea_0735_0740; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  private Lea_0735_0741 oLea_0735_0741; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )

  public Reg_0734_0735( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0735_0736 = new Ini_0735_0736( this );
    oCho_0735_0737 = new Cho_0735_0737( this );
    oCho_0735_0738 = new Cho_0735_0738( this );
    oCho_0735_0739 = new Cho_0735_0739( this );
    oLea_0735_0740 = new Lea_0735_0740( this );
    oLea_0735_0741 = new Lea_0735_0741( this );
    mNrStates = 6;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0735_0736;
    mStates[ 1 ] = oCho_0735_0737;
    mStates[ 2 ] = oCho_0735_0738;
    mStates[ 3 ] = oCho_0735_0739;
    mStates[ 4 ] = oLea_0735_0740;
    mStates[ 5 ] = oLea_0735_0741;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0735_0736.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0735_0742( TsmHandler oHandler )
  {
    mCurrentState = oLea_0735_0740; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0735_0747( TsmHandler oHandler )
  {
    mCurrentState = oLea_0735_0740; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
  public void Tra_0735_0749( TsmHandler oHandler )
  {
    mCurrentState = oLea_0735_0741; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0735_0751( TsmHandler oHandler )
  {
    mCurrentState = oLea_0735_0740; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Tra_0735_0746( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1138( oHandler );
    mCurrentState = oCho_0735_0737; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Tra_0735_0750( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1139( oHandler );
    mCurrentState = oCho_0735_0739; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Tra_0735_0748( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1140( oHandler );
    mCurrentState = oCho_0735_0738; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
  public void Tra_0735_0743( TsmHandler oHandler )
  {
    mCurrentState = oLea_0735_0741; // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 746:
        return TsmProspect.OK;
      case 750:
        return TsmProspect.OK;
      case 748:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 20:
        return TsmProspect.OK;
      case 24:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 742:
      Tra_0735_0742( oHandler );
      break;
    case 747:
      Tra_0735_0747( oHandler );
      break;
    case 749:
      Tra_0735_0749( oHandler );
      break;
    case 751:
      Tra_0735_0751( oHandler );
      break;
    case 746:
      Tra_0735_0746( oHandler );
      break;
    case 750:
      Tra_0735_0750( oHandler );
      break;
    case 748:
      Tra_0735_0748( oHandler );
      break;
    case 745: // Up: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      mCurrentState = null;
      bHigher = true;
      break;
    case 743:
      Tra_0735_0743( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading )
class Com_0730_0734 extends TsmCompound
{
  private Reg_0734_0735 oReg_0734_0735; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading >)

  public Com_0730_0734( TsmBase oParent )
  {
    TsmName = "Reading";
    TsmParent = oParent;
    oReg_0734_0735 = new Reg_0734_0735( this );
    mRegions.add( oReg_0734_0735 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 744, "( ProxyReaderClientPsm >> CompoundState >> Reading ) => ( ProxyReaderClientPsm >> CompoundState >> Error ) : Px_CbError" );
  }

  public void Port___Px_CbError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 744; // Px_CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0718_0781( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 716:
      switch ( Command )
      {
      case 21:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 21: // Port___Px_CbError
        {
          TsmTrigger_IProxyReaderClient___Px_CbError lTrigger = (TsmTrigger_IProxyReaderClient___Px_CbError) oHandler.Trigger;

          Port___Px_CbError( lTrigger.BadSector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 745: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 744: // UP: ( ProxyReaderClientPsm >> CompoundState >> Reading ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 781:
      Tra_0718_0781( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Open )
class Lea_0730_0752 extends TsmLeaf
{
  int [] aNatives = { -755, -756, -757, -758 };

  public Lea_0730_0752( TsmBase oParent )
  {
    TsmName = "Open";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 755, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 756, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 757, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> Open )" );
    mTransitions[ 3 ] = new TsmTransition( 758, "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )" );
  }

  public void Tra_0730_0762( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0730_0754( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0730_0757( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0658_0715)oHandler.Owner).Function_1143( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Tra_0718_0786( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0785( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0735_0745( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 755:
        return TsmProspect.OK;
      case 756:
        return TsmProspect.OK;
      case 757:
        return TsmProspect.OK;
      case 758:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 755: // Native: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) # RV=Px_Open( FileHandle );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 755;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 756: // Native: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Close();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 756;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      case 757: // Native: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) # Px_Clear();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 757;
        oHandler.bTaken = true;
        mTransitions[ 2 ].bVisit = true;
        break;
      case 758: // Native: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) # RV=Px_Read( Chunk );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 758;
        oHandler.bTaken = true;
        mTransitions[ 3 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 762:
      Tra_0730_0762( oHandler );
      break;
    case 754:
      Tra_0730_0754( oHandler );
      break;
    case 755: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 756: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 757:
      Tra_0730_0757( oHandler );
      break;
    case 758: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 786:
      Tra_0718_0786( oHandler );
      break;
    case 785:
      Tra_0718_0785( oHandler );
      break;
    case 745:
      Tra_0735_0745( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Error )
class Lea_0730_0753 extends TsmLeaf
{
  public Lea_0730_0753( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0730_0761( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0735_0744( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 761:
      Tra_0730_0761( oHandler );
      break;
    case 744:
      Tra_0735_0744( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >)
class Reg_0729_0730 extends TsmRegion
{
  private Cho_0730_0731 oCho_0730_0731; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  private Cho_0730_0732 oCho_0730_0732; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  private Cho_0730_0733 oCho_0730_0733; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  private Com_0730_0734 oCom_0730_0734; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Reading )
  private Lea_0730_0752 oLea_0730_0752; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Open )
  private Lea_0730_0753 oLea_0730_0753; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >> Error )

  public Reg_0729_0730( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0730_0731 = new Cho_0730_0731( this );
    oCho_0730_0732 = new Cho_0730_0732( this );
    oCho_0730_0733 = new Cho_0730_0733( this );
    oCom_0730_0734 = new Com_0730_0734( this );
    oLea_0730_0752 = new Lea_0730_0752( this );
    oLea_0730_0753 = new Lea_0730_0753( this );
    mNrStates = 6;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0730_0731;
    mStates[ 1 ] = oCho_0730_0732;
    mStates[ 2 ] = oCho_0730_0733;
    mStates[ 3 ] = oCom_0730_0734;
    mStates[ 4 ] = oLea_0730_0752;
    mStates[ 5 ] = oLea_0730_0753;
  }

   // Down: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0730_0762( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0752; // Down: ( ProxyReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0730_0754( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0752; // At: ( ProxyReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0730_0759( TsmHandler oHandler )
  {
    mCurrentState = oCho_0730_0733; // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
  public void Tra_0730_0761( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0753; // At: ( ProxyReaderClientPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0730_0755( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1141( oHandler );
    mCurrentState = oCho_0730_0731; // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0730_0758( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1144( oHandler );
    mCurrentState = oCho_0730_0732; // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0718_0786( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0752; // Down: ( ProxyReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0718_0785( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0752; // Down: ( ProxyReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0735_0745( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0752; // At: ( ProxyReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Reading ) => ( ProxyReaderClientPsm >> CompoundState >> Error )
  public void Tra_0735_0744( TsmHandler oHandler )
  {
    mCurrentState = oLea_0730_0753; // At: ( ProxyReaderClientPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading )
  public void Tra_0718_0781( TsmHandler oHandler )
  {
    mCurrentState = oCom_0730_0734; // Down: ( ProxyReaderClientPsm >> CompoundState >> Reading )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 746:
        return TsmProspect.OK;
      case 750:
        return TsmProspect.OK;
      case 748:
        return TsmProspect.OK;
      case 755:
        return TsmProspect.OK;
      case 756:
        return TsmProspect.OK;
      case 757:
        return TsmProspect.OK;
      case 758:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 20:
        return TsmProspect.OK;
      case 21:
        return TsmProspect.OK;
      case 24:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 762:
      Tra_0730_0762( oHandler );
      break;
    case 754:
      Tra_0730_0754( oHandler );
      break;
    case 760: // Up: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 759:
      Tra_0730_0759( oHandler );
      break;
    case 761:
      Tra_0730_0761( oHandler );
      break;
    case 755:
      Tra_0730_0755( oHandler );
      break;
    case 756: // Up: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
      mCurrentState = null;
      bHigher = true;
      break;
    case 758:
      Tra_0730_0758( oHandler );
      break;
    case 786:
      Tra_0718_0786( oHandler );
      break;
    case 785:
      Tra_0718_0785( oHandler );
      break;
    case 745:
      Tra_0735_0745( oHandler );
      break;
    case 744:
      Tra_0735_0744( oHandler );
      break;
    case 781:
      Tra_0718_0781( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState )
class Com_0718_0729 extends TsmCompound
{
  int [] aNatives = { -776 };
  private Reg_0729_0730 oReg_0729_0730; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState >)

  public Com_0718_0729( TsmBase oParent )
  {
    TsmName = "CS_729";
    TsmParent = oParent;
    oReg_0729_0730 = new Reg_0729_0730( this );
    mRegions.add( oReg_0729_0730 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 776, "( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )" );
  }

  public void Tra_0730_0762( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0729_0730.ExecuteHandler( oHandler );
  }

  public void Tra_0718_0786( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0729_0730.ExecuteHandler( oHandler );
  }

  public void Tra_0718_0785( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0729_0730.ExecuteHandler( oHandler );
  }

  public void Tra_0718_0781( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0729_0730.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 776:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 776: // Native: ( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 776;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 762:
      Tra_0730_0762( oHandler );
      break;
    case 760: // UP: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 776: // UP: ( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 756: // UP: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 786:
      Tra_0718_0786( oHandler );
      break;
    case 785:
      Tra_0718_0785( oHandler );
      break;
    case 781:
      Tra_0718_0781( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Idle )
class Lea_0718_0763 extends TsmLeaf
{
  int [] aNatives = { -770, -790 };

  public Lea_0718_0763( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 770, "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 790, "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )" );
  }

  public void Tra_0718_0768( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0769( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0771( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0718_0787( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 770:
        return TsmProspect.OK;
      case 790:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 770: // Native: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Close();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 770;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 790: // Native: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState ) # RV=Px_Open( FileHandle );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 790;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 768:
      Tra_0718_0768( oHandler );
      break;
    case 769:
      Tra_0718_0769( oHandler );
      break;
    case 771:
      Tra_0718_0771( oHandler );
      break;
    case 770: // UP: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 790: // UP: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 787:
      Tra_0718_0787( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Opening )
class Lea_0718_0764 extends TsmLeaf
{
  int [] aNatives = { -774, -779 };

  public Lea_0718_0764( TsmBase oParent )
  {
    TsmName = "Opening";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 774, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 779, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 786, "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbOpened" );
  }

  public void Tra_0718_0775( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0780( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbOpened( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 786; // Px_CbOpened
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 774:
        return TsmProspect.OK;
      case 779:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 18:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 774: // Native: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState ) # RV=Px_Open( FileHandle );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 774;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 779: // Native: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Close();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 779;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 18: // Port___Px_CbOpened
        {
          Port___Px_CbOpened( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 775:
      Tra_0718_0775( oHandler );
      break;
    case 780:
      Tra_0718_0780( oHandler );
      break;
    case 774: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 779: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 786: // UP: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Stopping )
class Lea_0718_0765 extends TsmLeaf
{
  int [] aNatives = { -778 };

  public Lea_0718_0765( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 778, "( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 785, "( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open ) : Px_CbStopped" );
  }

  public void Tra_0718_0777( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 785; // Px_CbStopped
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 778:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 19:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 778: // Native: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 778;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 19: // Port___Px_CbStopped
        {
          Port___Px_CbStopped( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 777:
      Tra_0718_0777( oHandler );
      break;
    case 778: // UP: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 785: // UP: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Closing )
class Lea_0718_0766 extends TsmLeaf
{
  int [] aNatives = { -773 };

  public Lea_0718_0766( TsmBase oParent )
  {
    TsmName = "Closing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 773, "( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 787, "( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> Idle ) : Px_CbClosed" );
  }

  public void Tra_0718_0772( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbClosed( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 787; // Px_CbClosed
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 773:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 22:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 773: // Native: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Close();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 773;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 22: // Port___Px_CbClosed
        {
          Port___Px_CbClosed( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 772:
      Tra_0718_0772( oHandler );
      break;
    case 773: // UP: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 787: // UP: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Seeking )
class Lea_0718_0767 extends TsmLeaf
{
  int [] aNatives = { -783, -788 };

  public Lea_0718_0767( TsmBase oParent )
  {
    TsmName = "Seeking";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 783, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 1 ] = new TsmTransition( 788, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 781, "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading ) : Px_CbReading" );
  }

  public void Tra_0718_0782( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0718_0784( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Px_CbReading( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 781; // Px_CbReading
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 783:
        return TsmProspect.OK;
      case 788:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 23:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 783: // Native: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState ) # Px_Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 783;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 788: // Native: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState ) # RV=Px_Read( Chunk );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 788;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break; // end of Port -1
    case 716: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 23: // Port___Px_CbReading
        {
          Port___Px_CbReading( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 782:
      Tra_0718_0782( oHandler );
      break;
    case 784:
      Tra_0718_0784( oHandler );
      break;
    case 783: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 788: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 781: // UP: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >)
class Reg_0717_0718 extends TsmRegion
{
  private Ini_0718_0719 oIni_0718_0719; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> InitialState )
  private Cho_0718_0720 oCho_0718_0720; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0721 oCho_0718_0721; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0722 oCho_0718_0722; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0723 oCho_0718_0723; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0724 oCho_0718_0724; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0725 oCho_0718_0725; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0726 oCho_0718_0726; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0727 oCho_0718_0727; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Cho_0718_0728 oCho_0718_0728; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> ChoiceState )
  private Com_0718_0729 oCom_0718_0729; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> CompoundState )
  private Lea_0718_0763 oLea_0718_0763; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Idle )
  private Lea_0718_0764 oLea_0718_0764; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Opening )
  private Lea_0718_0765 oLea_0718_0765; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Stopping )
  private Lea_0718_0766 oLea_0718_0766; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Closing )
  private Lea_0718_0767 oLea_0718_0767; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >> Seeking )

  public Reg_0717_0718( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0718_0719 = new Ini_0718_0719( this );
    oCho_0718_0720 = new Cho_0718_0720( this );
    oCho_0718_0721 = new Cho_0718_0721( this );
    oCho_0718_0722 = new Cho_0718_0722( this );
    oCho_0718_0723 = new Cho_0718_0723( this );
    oCho_0718_0724 = new Cho_0718_0724( this );
    oCho_0718_0725 = new Cho_0718_0725( this );
    oCho_0718_0726 = new Cho_0718_0726( this );
    oCho_0718_0727 = new Cho_0718_0727( this );
    oCho_0718_0728 = new Cho_0718_0728( this );
    oCom_0718_0729 = new Com_0718_0729( this );
    oLea_0718_0763 = new Lea_0718_0763( this );
    oLea_0718_0764 = new Lea_0718_0764( this );
    oLea_0718_0765 = new Lea_0718_0765( this );
    oLea_0718_0766 = new Lea_0718_0766( this );
    oLea_0718_0767 = new Lea_0718_0767( this );
    mNrStates = 16;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0718_0719;
    mStates[ 1 ] = oCho_0718_0720;
    mStates[ 2 ] = oCho_0718_0721;
    mStates[ 3 ] = oCho_0718_0722;
    mStates[ 4 ] = oCho_0718_0723;
    mStates[ 5 ] = oCho_0718_0724;
    mStates[ 6 ] = oCho_0718_0725;
    mStates[ 7 ] = oCho_0718_0726;
    mStates[ 8 ] = oCho_0718_0727;
    mStates[ 9 ] = oCho_0718_0728;
    mStates[ 10 ] = oCom_0718_0729;
    mStates[ 11 ] = oLea_0718_0763;
    mStates[ 12 ] = oLea_0718_0764;
    mStates[ 13 ] = oLea_0718_0765;
    mStates[ 14 ] = oLea_0718_0766;
    mStates[ 15 ] = oLea_0718_0767;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0718_0719.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> InitialState ) => ( ProxyReaderClientPsm >> Idle )
  public void Tra_0718_0768( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0763; // At: ( ProxyReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
  public void Tra_0718_0769( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0763; // At: ( ProxyReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Idle )
  public void Tra_0718_0771( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0763; // At: ( ProxyReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Closing )
  public void Tra_0718_0772( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0766; // At: ( ProxyReaderClientPsm >> Closing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
  public void Tra_0718_0775( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0764; // At: ( ProxyReaderClientPsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0730_0762( TsmHandler oHandler )
  {
    mCurrentState = oCom_0718_0729; // At: ( ProxyReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Stopping )
  public void Tra_0718_0777( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0765; // At: ( ProxyReaderClientPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Opening )
  public void Tra_0718_0780( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0764; // At: ( ProxyReaderClientPsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
  public void Tra_0718_0782( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0767; // At: ( ProxyReaderClientPsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> Seeking )
  public void Tra_0718_0784( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0767; // At: ( ProxyReaderClientPsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0791( TsmHandler oHandler )
  {
    mCurrentState = oCho_0718_0723; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0789( TsmHandler oHandler )
  {
    mCurrentState = oCho_0718_0720; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> ChoiceState ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0730_0760( TsmHandler oHandler )
  {
    mCurrentState = oCho_0718_0726; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0776( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1137( oHandler );
    mCurrentState = oCho_0718_0724; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0730_0756( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1142( oHandler );
    mCurrentState = oCho_0718_0722; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0770( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1145( oHandler );
    mCurrentState = oCho_0718_0721; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0790( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1146( oHandler );
    mCurrentState = oCho_0718_0728; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0774( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1147( oHandler );
    mCurrentState = oCho_0718_0723; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0779( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1148( oHandler );
    mCurrentState = oCho_0718_0725; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0778( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1149( oHandler );
    mCurrentState = oCho_0718_0724; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0773( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1150( oHandler );
    mCurrentState = oCho_0718_0722; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0783( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1151( oHandler );
    mCurrentState = oCho_0718_0727; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Tra_0718_0788( TsmHandler oHandler )
  {
    ((Cla_0658_0715)oHandler.Owner).Function_1152( oHandler );
    mCurrentState = oCho_0718_0726; // At: ( ProxyReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0718_0786( TsmHandler oHandler )
  {
    mCurrentState = oCom_0718_0729; // At: ( ProxyReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Tra_0718_0785( TsmHandler oHandler )
  {
    mCurrentState = oCom_0718_0729; // At: ( ProxyReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> Idle )
  public void Tra_0718_0787( TsmHandler oHandler )
  {
    mCurrentState = oLea_0718_0763; // At: ( ProxyReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> CompoundState >> Reading )
  public void Tra_0718_0781( TsmHandler oHandler )
  {
    mCurrentState = oCom_0718_0729; // At: ( ProxyReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 776:
        return TsmProspect.OK;
      case 746:
        return TsmProspect.OK;
      case 750:
        return TsmProspect.OK;
      case 748:
        return TsmProspect.OK;
      case 755:
        return TsmProspect.OK;
      case 756:
        return TsmProspect.OK;
      case 757:
        return TsmProspect.OK;
      case 758:
        return TsmProspect.OK;
      case 770:
        return TsmProspect.OK;
      case 790:
        return TsmProspect.OK;
      case 774:
        return TsmProspect.OK;
      case 779:
        return TsmProspect.OK;
      case 778:
        return TsmProspect.OK;
      case 773:
        return TsmProspect.OK;
      case 783:
        return TsmProspect.OK;
      case 788:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 716:
      switch ( Command )
      {
      case 18:
        return TsmProspect.OK;
      case 19:
        return TsmProspect.OK;
      case 20:
        return TsmProspect.OK;
      case 21:
        return TsmProspect.OK;
      case 22:
        return TsmProspect.OK;
      case 23:
        return TsmProspect.OK;
      case 24:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 768:
      Tra_0718_0768( oHandler );
      break;
    case 769:
      Tra_0718_0769( oHandler );
      break;
    case 771:
      Tra_0718_0771( oHandler );
      break;
    case 772:
      Tra_0718_0772( oHandler );
      break;
    case 775:
      Tra_0718_0775( oHandler );
      break;
    case 762:
      Tra_0730_0762( oHandler );
      break;
    case 777:
      Tra_0718_0777( oHandler );
      break;
    case 780:
      Tra_0718_0780( oHandler );
      break;
    case 782:
      Tra_0718_0782( oHandler );
      break;
    case 784:
      Tra_0718_0784( oHandler );
      break;
    case 791:
      Tra_0718_0791( oHandler );
      break;
    case 789:
      Tra_0718_0789( oHandler );
      break;
    case 760:
      Tra_0730_0760( oHandler );
      break;
    case 776:
      Tra_0718_0776( oHandler );
      break;
    case 756:
      Tra_0730_0756( oHandler );
      break;
    case 770:
      Tra_0718_0770( oHandler );
      break;
    case 790:
      Tra_0718_0790( oHandler );
      break;
    case 774:
      Tra_0718_0774( oHandler );
      break;
    case 779:
      Tra_0718_0779( oHandler );
      break;
    case 778:
      Tra_0718_0778( oHandler );
      break;
    case 773:
      Tra_0718_0773( oHandler );
      break;
    case 783:
      Tra_0718_0783( oHandler );
      break;
    case 788:
      Tra_0718_0788( oHandler );
      break;
    case 786:
      Tra_0718_0786( oHandler );
      break;
    case 785:
      Tra_0718_0785( oHandler );
      break;
    case 787:
      Tra_0718_0787( oHandler );
      break;
    case 781:
      Tra_0718_0781( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm )
class Fsm_0715_0717 extends TsmFsm
{
  private Reg_0717_0718 oReg_0717_0718; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm >)

  public Fsm_0715_0717( TsmBase oParent )
  {
    TsmName = "ProxyReaderClientPsm";
    TsmParent = oParent;
    oReg_0717_0718 = new Reg_0717_0718( this );
    mRegions.add( oReg_0717_0718 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )
class Cla_0658_0715 extends TsmProxyUser
{
  private Fsm_0715_0717 oFsm_0715_0717; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > ProxyReaderClientPsm )
  private TsmIPort_IProxyReaderServer Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
  private TsmIPort_IProxyReaderClient TsmPI__Port; // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient > Port )
  private TsmPCPort mPCMessager;
  private eRV RV = eRV.OK;
  private int FileHandle = 0;
  private tChunk Chunk = null;

  public Cla_0658_0715( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0715_0717 = new Fsm_0715_0717( this );
    TsmPI__Port = new TsmIPort_IProxyReaderClient( this );
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0715_0717;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IProxyReaderServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol > ProxyReaderClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0715_0717.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1064()
  {
    return RV==eRV.OK;
  }

  public boolean Guard_1065()
  {
    return RV==eRV.OK;
  }

   // ( ProxyReaderClientPsm >> CompoundState ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1137( TsmHandler oHandler )
  {
    Port.Px_Stop();
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Function_1138( TsmHandler oHandler )
  {
    RV=Port.Px_Read( Chunk );
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Function_1139( TsmHandler oHandler )
  {
    Port.Px_IsFilled();
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ProxyReaderClientPsm >> CompoundState >> Reading >> ChoiceState )
  public void Function_1140( TsmHandler oHandler )
  {
    Port.Px_IsFilled();
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  public void Function_1141( TsmHandler oHandler )
  {
    RV=Port.Px_Open( FileHandle );
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1142( TsmHandler oHandler )
  {
    Port.Px_Close();
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> Open )
  public void Function_1143( TsmHandler oHandler )
  {
    Port.Px_Clear();
  }

   // ( ProxyReaderClientPsm >> CompoundState >> Open ) => ( ProxyReaderClientPsm >> CompoundState >> ChoiceState )
  public void Function_1144( TsmHandler oHandler )
  {
    RV=Port.Px_Read( Chunk );
  }

   // ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1145( TsmHandler oHandler )
  {
    Port.Px_Close();
  }

   // ( ProxyReaderClientPsm >> Idle ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1146( TsmHandler oHandler )
  {
    RV=Port.Px_Open( FileHandle );
  }

   // ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1147( TsmHandler oHandler )
  {
    RV=Port.Px_Open( FileHandle );
  }

   // ( ProxyReaderClientPsm >> Opening ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1148( TsmHandler oHandler )
  {
    Port.Px_Close();
  }

   // ( ProxyReaderClientPsm >> Stopping ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1149( TsmHandler oHandler )
  {
    Port.Px_Stop();
  }

   // ( ProxyReaderClientPsm >> Closing ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1150( TsmHandler oHandler )
  {
    Port.Px_Close();
  }

   // ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1151( TsmHandler oHandler )
  {
    Port.Px_Stop();
  }

   // ( ProxyReaderClientPsm >> Seeking ) => ( ProxyReaderClientPsm >> ChoiceState )
  public void Function_1152( TsmHandler oHandler )
  {
    RV=Port.Px_Read( Chunk );
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 716;
    TsmPI__Port.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    Port.SetProxyUser( this );

    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0715_0717.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol )
 ********************************************************************/

 // ( Xmi > Data > Repository > Player > ProxyProtocols > ProxyReaderProtocol )
class Pac_0524_0658 extends TsmPackage
{
  public Pac_0524_0658( TsmBase oParent )
  {
    TsmName = "ProxyReaderProtocol";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Player > ProxyProtocols )
 ********************************************************************/

 // ( Xmi > Data > Repository > Player > ProxyProtocols )
class Pac_0011_0524 extends TsmPackage
{
  public Pac_0011_0524( TsmBase oParent )
  {
    TsmName = "ProxyProtocols";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Player )
 ********************************************************************/

 // ( Xmi > Data > Repository > Player )
class Pac_0002_0011 extends TsmPackage
{
  public Pac_0002_0011( TsmBase oParent )
  {
    TsmName = "Player";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository )
 ********************************************************************/

 // ( Xmi > Data > Repository )
class Pac_0001_0002 extends TsmPackage
{
  public Pac_0001_0002( TsmBase oParent )
  {
    TsmName = "Repository";
    TsmParent = oParent;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> InitialState )
class Ini_0890_0891 extends TsmPseudo
{
  public Ini_0890_0891( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 925, "( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 925; // TRLS ( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 925: // UP: ( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> ChoiceState )
class Cho_0890_0892 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0890_0892( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 923, "( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )" );
    mTransitions[ 1 ] = new TsmTransition( 921, "( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 923; // TRLS ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 921; // TRLS ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0890_0922( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 923: // UP: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
      bHigher = true;
      break;
    case 921: // UP: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
      bHigher = true;
      break;
    case 922:
      Tra_0890_0922( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> ChoiceState )
class Cho_0894_0895 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0894_0895( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 909, "( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )" );
    mTransitions[ 1 ] = new TsmTransition( 911, "( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 909; // TRLS ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 911; // TRLS ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0894_0908( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 909: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
      bHigher = true;
      break;
    case 911: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
      bHigher = true;
      break;
    case 908:
      Tra_0894_0908( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> InitialState )
class Ini_0897_0898 extends TsmPseudo
{
  public Ini_0897_0898( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 902, "( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 902; // TRLS ( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 902: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
class Lea_0897_0899 extends TsmLeaf
{
  int [] aNatives = { 901 };

  public Lea_0897_0899( TsmBase oParent )
  {
    TsmName = "NotEnough";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 901, "( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )" );
  }

  public void Tra_0897_0902( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 901:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 901: // Native: ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
        TsmRecorder.AddNative( "( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) # CbFilled();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 901;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 902:
      Tra_0897_0902( oHandler );
      break;
    case 901: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> Enough )
class Lea_0897_0900 extends TsmLeaf
{
  int [] aNatives = { 906 };

  public Lea_0897_0900( TsmBase oParent )
  {
    TsmName = "Enough";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 906, "( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0897_0901( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 906:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 906: // Native: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open ) # CbDone();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 906;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 901:
      Tra_0897_0901( oHandler );
      break;
    case 906: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >)
class Reg_0896_0897 extends TsmRegion
{
  private Ini_0897_0898 oIni_0897_0898; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> InitialState )
  private Lea_0897_0899 oLea_0897_0899; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  private Lea_0897_0900 oLea_0897_0900; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >> Enough )

  public Reg_0896_0897( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0897_0898 = new Ini_0897_0898( this );
    oLea_0897_0899 = new Lea_0897_0899( this );
    oLea_0897_0900 = new Lea_0897_0900( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0897_0898;
    mStates[ 1 ] = oLea_0897_0899;
    mStates[ 2 ] = oLea_0897_0900;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0897_0898.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0897_0902( TsmHandler oHandler )
  {
    mCurrentState = oLea_0897_0899; // At: ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
  public void Tra_0897_0901( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1165( oHandler );
    mCurrentState = oLea_0897_0900; // At: ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 901:
        return TsmProspect.OK;
      case 906:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 902:
      Tra_0897_0902( oHandler );
      break;
    case 901:
      Tra_0897_0901( oHandler );
      break;
    case 906: // Up: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading )
class Com_0894_0896 extends TsmCompound
{
  int [] aNatives = { 907 };
  private Reg_0896_0897 oReg_0896_0897; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading >)

  public Com_0894_0896( TsmBase oParent )
  {
    TsmName = "Reading";
    TsmParent = oParent;
    oReg_0896_0897 = new Reg_0896_0897( this );
    mRegions.add( oReg_0896_0897 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 907, "( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )" );
  }

  public void Tra_0890_0918( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 907:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 907: // Native: ( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )
        TsmRecorder.AddNative( "( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error ) # CbError( Sector );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 907;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 907: // UP: ( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 906: // UP: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 918:
      Tra_0890_0918( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Open )
class Lea_0894_0903 extends TsmLeaf
{
  public Lea_0894_0903( TsmBase oParent )
  {
    TsmName = "Open";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 910, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing ) : Close" );
    mTransitions[ 1 ] = new TsmTransition( 908, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState ) : Read" );
    mTransitions[ 2 ] = new TsmTransition( 905, "( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> Open ) : Clear" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0894_0906( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0890_0917( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0890_0919( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Close( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 910; // Close
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___Read( tChunk Chunk, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 908; // Read
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0894_0905( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___Clear( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 905; // Clear
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 888:
      switch ( Command )
      {
      case 50:
        return TsmProspect.OK;
      case 53:
        return TsmProspect.OK;
      case 54:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 888: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 50: // Port___Close
        {
          Port___Close( oHandler );
        }
        break;
      case 53: // Port___Read
        {
          TsmTrigger_IReaderServer___Read lTrigger = (TsmTrigger_IReaderServer___Read) oHandler.Trigger;

          Port___Read( lTrigger.Chunk, oHandler );
        }
        break;
      case 54: // Port___Clear
        {
          Port___Clear( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 906:
      Tra_0894_0906( oHandler );
      break;
    case 917:
      Tra_0890_0917( oHandler );
      break;
    case 919:
      Tra_0890_0919( oHandler );
      break;
    case 910: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
      bHigher = true;
      break;
    case 908: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 905:
      Tra_0894_0905( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Error )
class Lea_0894_0904 extends TsmLeaf
{
  public Lea_0894_0904( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0894_0911( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0894_0907( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 911:
      Tra_0894_0911( oHandler );
      break;
    case 907:
      Tra_0894_0907( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >)
class Reg_0893_0894 extends TsmRegion
{
  private Cho_0894_0895 oCho_0894_0895; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> ChoiceState )
  private Com_0894_0896 oCom_0894_0896; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Reading )
  private Lea_0894_0903 oLea_0894_0903; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Open )
  private Lea_0894_0904 oLea_0894_0904; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >> Error )

  public Reg_0893_0894( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0894_0895 = new Cho_0894_0895( this );
    oCom_0894_0896 = new Com_0894_0896( this );
    oLea_0894_0903 = new Lea_0894_0903( this );
    oLea_0894_0904 = new Lea_0894_0904( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0894_0895;
    mStates[ 1 ] = oCom_0894_0896;
    mStates[ 2 ] = oLea_0894_0903;
    mStates[ 3 ] = oLea_0894_0904;
  }

   // At: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
  public void Tra_0894_0911( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1080( oHandler );
    mCurrentState = oLea_0894_0904; // At: ( ReaderServerPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )
  public void Tra_0894_0907( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1164( oHandler );
    mCurrentState = oLea_0894_0904; // At: ( ReaderServerPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Tra_0894_0906( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1166( oHandler );
    mCurrentState = oLea_0894_0903; // At: ( ReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Tra_0890_0917( TsmHandler oHandler )
  {
    mCurrentState = oLea_0894_0903; // Down: ( ReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
  public void Tra_0890_0918( TsmHandler oHandler )
  {
    mCurrentState = oCom_0894_0896; // Down: ( ReaderServerPsm >> CompoundState >> Reading )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Tra_0890_0919( TsmHandler oHandler )
  {
    mCurrentState = oLea_0894_0903; // Down: ( ReaderServerPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState )
  public void Tra_0894_0908( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1330( oHandler );
    mCurrentState = oCho_0894_0895; // At: ( ReaderServerPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 907:
        return TsmProspect.OK;
      case 901:
        return TsmProspect.OK;
      case 906:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 888:
      switch ( Command )
      {
      case 50:
        return TsmProspect.OK;
      case 53:
        return TsmProspect.OK;
      case 54:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 909: // Up: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
      mCurrentState = null;
      bHigher = true;
      break;
    case 911:
      Tra_0894_0911( oHandler );
      break;
    case 907:
      Tra_0894_0907( oHandler );
      break;
    case 906:
      Tra_0894_0906( oHandler );
      break;
    case 917:
      Tra_0890_0917( oHandler );
      break;
    case 918:
      Tra_0890_0918( oHandler );
      break;
    case 919:
      Tra_0890_0919( oHandler );
      break;
    case 910: // Up: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
      mCurrentState = null;
      bHigher = true;
      break;
    case 908:
      Tra_0894_0908( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState )
class Com_0890_0893 extends TsmCompound
{
  private Reg_0893_0894 oReg_0893_0894; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState >)

  public Com_0890_0893( TsmBase oParent )
  {
    TsmName = "CS_893";
    TsmParent = oParent;
    oReg_0893_0894 = new Reg_0893_0894( this );
    mRegions.add( oReg_0893_0894 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 924, "( ReaderServerPsm >> CompoundState ) => ( ReaderServerPsm >> Stopping ) : Stop" );
  }

  public void Tra_0890_0917( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0893_0894.ExecuteHandler( oHandler );
  }

  public void Tra_0890_0918( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0893_0894.ExecuteHandler( oHandler );
  }

  public void Tra_0890_0919( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0893_0894.ExecuteHandler( oHandler );
  }

  public void Port___Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 924; // Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 888:
      switch ( Command )
      {
      case 51:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 888: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 51: // Port___Stop
        {
          Port___Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 909: // UP: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 917:
      Tra_0890_0917( oHandler );
      break;
    case 918:
      Tra_0890_0918( oHandler );
      break;
    case 919:
      Tra_0890_0919( oHandler );
      break;
    case 910: // UP: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 924: // UP: ( ReaderServerPsm >> CompoundState ) => ( ReaderServerPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Idle )
class Lea_0890_0912 extends TsmLeaf
{
  public Lea_0890_0912( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 922, "( ReaderServerPsm >> Idle ) => ( ReaderServerPsm >> ChoiceState ) : Open" );
  }

  public void Tra_0890_0925( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0890_0921( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0890_0920( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Open( int FileHandle, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 922; // Open
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 888:
      switch ( Command )
      {
      case 52:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 888: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 52: // Port___Open
        {
          TsmTrigger_IReaderServer___Open lTrigger = (TsmTrigger_IReaderServer___Open) oHandler.Trigger;

          Port___Open( lTrigger.FileHandle, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 925:
      Tra_0890_0925( oHandler );
      break;
    case 921:
      Tra_0890_0921( oHandler );
      break;
    case 920:
      Tra_0890_0920( oHandler );
      break;
    case 922: // UP: ( ReaderServerPsm >> Idle ) => ( ReaderServerPsm >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Opening )
class Lea_0890_0913 extends TsmLeaf
{
  int [] aNatives = { 917 };

  public Lea_0890_0913( TsmBase oParent )
  {
    TsmName = "Opening";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 917, "( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )" );
  }

  public void Tra_0890_0923( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 917:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 917: // Native: ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open ) # CbOpened();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 917;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 923:
      Tra_0890_0923( oHandler );
      break;
    case 917: // UP: ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Seeking )
class Lea_0890_0914 extends TsmLeaf
{
  int [] aNatives = { 918 };

  public Lea_0890_0914( TsmBase oParent )
  {
    TsmName = "Seeking";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 918, "( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )" );
  }

  public void Tra_0894_0909( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 918:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 918: // Native: ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
        TsmRecorder.AddNative( "( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading ) # CbReading();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 918;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 909:
      Tra_0894_0909( oHandler );
      break;
    case 918: // UP: ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Stopping )
class Lea_0890_0915 extends TsmLeaf
{
  int [] aNatives = { 919 };

  public Lea_0890_0915( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 919, "( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0890_0924( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 919:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 919: // Native: ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open ) # CbStopped();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 919;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 919: // UP: ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 924:
      Tra_0890_0924( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Closing )
class Lea_0890_0916 extends TsmLeaf
{
  int [] aNatives = { 920 };

  public Lea_0890_0916( TsmBase oParent )
  {
    TsmName = "Closing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 920, "( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0894_0910( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 920:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 920: // Native: ( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )
        TsmRecorder.AddNative( "( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle ) # CbClosed();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 920;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 920: // UP: ( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 910:
      Tra_0894_0910( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >)
class Reg_0889_0890 extends TsmRegion
{
  private Ini_0890_0891 oIni_0890_0891; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> InitialState )
  private Cho_0890_0892 oCho_0890_0892; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> ChoiceState )
  private Com_0890_0893 oCom_0890_0893; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> CompoundState )
  private Lea_0890_0912 oLea_0890_0912; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Idle )
  private Lea_0890_0913 oLea_0890_0913; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Opening )
  private Lea_0890_0914 oLea_0890_0914; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Seeking )
  private Lea_0890_0915 oLea_0890_0915; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Stopping )
  private Lea_0890_0916 oLea_0890_0916; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >> Closing )

  public Reg_0889_0890( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0890_0891 = new Ini_0890_0891( this );
    oCho_0890_0892 = new Cho_0890_0892( this );
    oCom_0890_0893 = new Com_0890_0893( this );
    oLea_0890_0912 = new Lea_0890_0912( this );
    oLea_0890_0913 = new Lea_0890_0913( this );
    oLea_0890_0914 = new Lea_0890_0914( this );
    oLea_0890_0915 = new Lea_0890_0915( this );
    oLea_0890_0916 = new Lea_0890_0916( this );
    mNrStates = 8;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0890_0891;
    mStates[ 1 ] = oCho_0890_0892;
    mStates[ 2 ] = oCom_0890_0893;
    mStates[ 3 ] = oLea_0890_0912;
    mStates[ 4 ] = oLea_0890_0913;
    mStates[ 5 ] = oLea_0890_0914;
    mStates[ 6 ] = oLea_0890_0915;
    mStates[ 7 ] = oLea_0890_0916;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0890_0891.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> InitialState ) => ( ReaderServerPsm >> Idle )
  public void Tra_0890_0925( TsmHandler oHandler )
  {
    mCurrentState = oLea_0890_0912; // At: ( ReaderServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
  public void Tra_0890_0923( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1074( oHandler );
    mCurrentState = oLea_0890_0913; // At: ( ReaderServerPsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
  public void Tra_0890_0921( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1076( oHandler );
    mCurrentState = oLea_0890_0912; // At: ( ReaderServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
  public void Tra_0894_0909( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1078( oHandler );
    mCurrentState = oLea_0890_0914; // At: ( ReaderServerPsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Tra_0890_0917( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1167( oHandler );
    mCurrentState = oCom_0890_0893; // At: ( ReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
  public void Tra_0890_0918( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1168( oHandler );
    mCurrentState = oCom_0890_0893; // At: ( ReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Tra_0890_0919( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1169( oHandler );
    mCurrentState = oCom_0890_0893; // At: ( ReaderServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )
  public void Tra_0890_0920( TsmHandler oHandler )
  {
    ((Cla_0886_0887)oHandler.Owner).Function_1170( oHandler );
    mCurrentState = oLea_0890_0912; // At: ( ReaderServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> Closing )
  public void Tra_0894_0910( TsmHandler oHandler )
  {
    mCurrentState = oLea_0890_0916; // At: ( ReaderServerPsm >> Closing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> CompoundState ) => ( ReaderServerPsm >> Stopping )
  public void Tra_0890_0924( TsmHandler oHandler )
  {
    mCurrentState = oLea_0890_0915; // At: ( ReaderServerPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderServerPsm >> Idle ) => ( ReaderServerPsm >> ChoiceState )
  public void Tra_0890_0922( TsmHandler oHandler )
  {
    mCurrentState = oCho_0890_0892; // At: ( ReaderServerPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 907:
        return TsmProspect.OK;
      case 901:
        return TsmProspect.OK;
      case 906:
        return TsmProspect.OK;
      case 917:
        return TsmProspect.OK;
      case 918:
        return TsmProspect.OK;
      case 919:
        return TsmProspect.OK;
      case 920:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 888:
      switch ( Command )
      {
      case 50:
        return TsmProspect.OK;
      case 51:
        return TsmProspect.OK;
      case 52:
        return TsmProspect.OK;
      case 53:
        return TsmProspect.OK;
      case 54:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 925:
      Tra_0890_0925( oHandler );
      break;
    case 923:
      Tra_0890_0923( oHandler );
      break;
    case 921:
      Tra_0890_0921( oHandler );
      break;
    case 909:
      Tra_0894_0909( oHandler );
      break;
    case 917:
      Tra_0890_0917( oHandler );
      break;
    case 918:
      Tra_0890_0918( oHandler );
      break;
    case 919:
      Tra_0890_0919( oHandler );
      break;
    case 920:
      Tra_0890_0920( oHandler );
      break;
    case 910:
      Tra_0894_0910( oHandler );
      break;
    case 924:
      Tra_0890_0924( oHandler );
      break;
    case 922:
      Tra_0890_0922( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm )
class Fsm_0887_0889 extends TsmFsm
{
  private Reg_0889_0890 oReg_0889_0890; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm >)

  public Fsm_0887_0889( TsmBase oParent )
  {
    TsmName = "ReaderServerPsm";
    TsmParent = oParent;
    oReg_0889_0890 = new Reg_0889_0890( this );
    mRegions.add( oReg_0889_0890 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )
class Cla_0886_0887 extends TsmProtocolClass
{
  private Fsm_0887_0889 oFsm_0887_0889; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > ReaderServerPsm )
  private TsmIPort_IReaderServer TsmPI__Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
  private TsmIPort_IReaderClient Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > Port )
  private TsmPSPort mPSMessager;
  private int Sector = 0;

  public Cla_0886_0887( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0887_0889 = new Fsm_0887_0889( this );
    TsmPI__Port = new TsmIPort_IReaderServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0887_0889;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IReaderClient) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0887_0889.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
  public eRV Function_1073( int FileHandle )
  {
    return eRV.OK;
  }

   // ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Opening )
  public void Function_1074( TsmHandler oHandler )
  {
    TsmTrigger_IReaderServer___Open lTrigger = (TsmTrigger_IReaderServer___Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0886_0887)oHandler.Owner).Function_1073( FileHandle );
  }

   // ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
  public eRV Function_1075( int FileHandle )
  {
    return
    eRV.INVALID_PARAM;
  }

   // ( ReaderServerPsm >> ChoiceState ) => ( ReaderServerPsm >> Idle )
  public void Function_1076( TsmHandler oHandler )
  {
    TsmTrigger_IReaderServer___Open lTrigger = (TsmTrigger_IReaderServer___Open) oHandler.Trigger;
    int FileHandle = lTrigger.FileHandle;

    lTrigger._RetVal = ((Cla_0886_0887)oHandler.Owner).Function_1075( FileHandle );
  }

   // ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
  public eRV Function_1077( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> Seeking )
  public void Function_1078( TsmHandler oHandler )
  {
    TsmTrigger_IReaderServer___Read lTrigger = (TsmTrigger_IReaderServer___Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0886_0887)oHandler.Owner).Function_1077( Chunk );
  }

   // ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
  public eRV Function_1079( tChunk Chunk )
  {
    return
    eRV.INVALID_PARAM;
  }

   // ( ReaderServerPsm >> CompoundState >> ChoiceState ) => ( ReaderServerPsm >> CompoundState >> Error )
  public void Function_1080( TsmHandler oHandler )
  {
    TsmTrigger_IReaderServer___Read lTrigger = (TsmTrigger_IReaderServer___Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0886_0887)oHandler.Owner).Function_1079( Chunk );
  }

   // ( ReaderServerPsm >> CompoundState >> Reading ) => ( ReaderServerPsm >> CompoundState >> Error )
  public void Function_1164( TsmHandler oHandler )
  {
    Port.CbError( Sector );
  }

   // ( ReaderServerPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderServerPsm >> CompoundState >> Reading >> Enough )
  public void Function_1165( TsmHandler oHandler )
  {
    Port.CbFilled();
  }

   // ( ReaderServerPsm >> CompoundState >> Reading >> Enough ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Function_1166( TsmHandler oHandler )
  {
    Port.CbDone();
  }

   // ( ReaderServerPsm >> Opening ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Function_1167( TsmHandler oHandler )
  {
    Port.CbOpened();
  }

   // ( ReaderServerPsm >> Seeking ) => ( ReaderServerPsm >> CompoundState >> Reading )
  public void Function_1168( TsmHandler oHandler )
  {
    Port.CbReading();
  }

   // ( ReaderServerPsm >> Stopping ) => ( ReaderServerPsm >> CompoundState >> Open )
  public void Function_1169( TsmHandler oHandler )
  {
    Port.CbStopped();
  }

   // ( ReaderServerPsm >> Closing ) => ( ReaderServerPsm >> Idle )
  public void Function_1170( TsmHandler oHandler )
  {
    Port.CbClosed();
  }

   // ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState )
  public eRV Function_1329( tChunk Chunk )
  {
    return eRV.OK;
  }

   // ( ReaderServerPsm >> CompoundState >> Open ) => ( ReaderServerPsm >> CompoundState >> ChoiceState )
  public void Function_1330( TsmHandler oHandler )
  {
    TsmTrigger_IReaderServer___Read lTrigger = (TsmTrigger_IReaderServer___Read) oHandler.Trigger;
    tChunk Chunk = lTrigger.Chunk;

    lTrigger._RetVal = ((Cla_0886_0887)oHandler.Owner).Function_1329( Chunk );
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 888;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0887_0889.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Architecture > ExEnv > ReaderMock )
class Com_0793_0001 extends TsmPComponent
{
  private Cla_0886_0887 InsReaderServer; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderServer > InsReaderServer )

  public Com_0793_0001( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    InsReaderServer = new Cla_0886_0887( this, "InsReaderServer" );
    InsReaderServer.IsMock = true;
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = InsReaderServer;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "pp_reader" ) )
    {
      return InsReaderServer.GetProvidedInterface( "Port" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > ReaderMock )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "pp_reader" ) )
    {
      InsReaderServer.SetRequiredInterface( "Port", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > ReaderMock )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> InitialState )
class Ini_0972_0973 extends TsmPseudo
{
  public Ini_0972_0973( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 996, "( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 996; // TRLS ( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 996: // UP: ( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> ChoiceState )
class Cho_0972_0974 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0972_0974( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 999, "( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )" );
    mTransitions[ 1 ] = new TsmTransition( 998, "( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___OpenTitle lTrigger = (TsmTrigger_ITitlebaseServer___OpenTitle) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;

    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "valid TitleId" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 999; // TRLS ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 998; // TRLS ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0972_0997( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 999: // UP: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    case 998: // UP: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
      bHigher = true;
      break;
    case 997:
      Tra_0972_0997( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
class Cho_0976_0977 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0976_0977( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 985, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 984, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___SetTime lTrigger = (TsmTrigger_ITitlebaseServer___SetTime) oHandler.Trigger;
    tTime AtTime = lTrigger.AtTime;

    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "valid AtTime" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 985; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 984; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0976_0983( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 985: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
      bHigher = true;
      break;
    case 984: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    case 983:
      Tra_0976_0983( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
class Cho_0976_0978 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0976_0978( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 994, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 993, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "valid Chunk" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 994; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 993; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0976_0986( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 994: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
      bHigher = true;
      break;
    case 993: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 986:
      Tra_0976_0986( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
class Cho_0976_0979 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0976_0979( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 992, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
    mTransitions[ 1 ] = new TsmTransition( 991, "( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "finished" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 992; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 991; // TRLS ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0976_0990( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 992: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 991: // UP: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 990:
      Tra_0976_0990( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Ready )
class Lea_0976_0980 extends TsmLeaf
{
  public Lea_0976_0980( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 983, "( TbServerPsm >> CompoundState >> Ready ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : SetTime" );
  }

  public void Tra_0972_0999( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0976_0984( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___SetTime( tTime AtTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 983; // SetTime
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 57:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 970: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 57: // Port___SetTime
        {
          TsmTrigger_ITitlebaseServer___SetTime lTrigger = (TsmTrigger_ITitlebaseServer___SetTime) oHandler.Trigger;

          Port___SetTime( lTrigger.AtTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 999:
      Tra_0972_0999( oHandler );
      break;
    case 984:
      Tra_0976_0984( oHandler );
      break;
    case 983: // UP: ( TbServerPsm >> CompoundState >> Ready ) => ( TbServerPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Play )
class Lea_0976_0981 extends TsmLeaf
{
  public Lea_0976_0981( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 986, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : GetChunk" );
    mTransitions[ 1 ] = new TsmTransition( 987, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> Play ) : ReportReadError" );
    mTransitions[ 2 ] = new TsmTransition( 989, "( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> Play ) : ReportSynclost" );
  }

  public void Tra_0976_0985( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0976_0994( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___GetChunk( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 986; // GetChunk
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0976_0987( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___ReportReadError( int BadSector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 987; // ReportReadError
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0976_0989( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Port___ReportSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 989; // ReportSynclost
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 58:
        return TsmProspect.OK;
      case 59:
        return TsmProspect.OK;
      case 60:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 970: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 58: // Port___GetChunk
        {
          Port___GetChunk( oHandler );
        }
        break;
      case 59: // Port___ReportReadError
        {
          TsmTrigger_ITitlebaseServer___ReportReadError lTrigger = (TsmTrigger_ITitlebaseServer___ReportReadError) oHandler.Trigger;

          Port___ReportReadError( lTrigger.BadSector, oHandler );
        }
        break;
      case 60: // Port___ReportSynclost
        {
          TsmTrigger_ITitlebaseServer___ReportSynclost lTrigger = (TsmTrigger_ITitlebaseServer___ReportSynclost) oHandler.Trigger;

          Port___ReportSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 985:
      Tra_0976_0985( oHandler );
      break;
    case 994:
      Tra_0976_0994( oHandler );
      break;
    case 986: // UP: ( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    case 987:
      Tra_0976_0987( oHandler );
      break;
    case 989:
      Tra_0976_0989( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> End )
class Lea_0976_0982 extends TsmLeaf
{
  public Lea_0976_0982( TsmBase oParent )
  {
    TsmName = "End";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 990, "( TbServerPsm >> CompoundState >> End ) => ( TbServerPsm >> CompoundState >> ChoiceState ) : GetResult" );
  }

  public void Tra_0976_0993( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0976_0992( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0976_0991( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___GetResult( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 990; // GetResult
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 61:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 970: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 61: // Port___GetResult
        {
          Port___GetResult( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 993:
      Tra_0976_0993( oHandler );
      break;
    case 992:
      Tra_0976_0992( oHandler );
      break;
    case 991:
      Tra_0976_0991( oHandler );
      break;
    case 990: // UP: ( TbServerPsm >> CompoundState >> End ) => ( TbServerPsm >> CompoundState >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >)
class Reg_0975_0976 extends TsmRegion
{
  private Cho_0976_0977 oCho_0976_0977; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  private Cho_0976_0978 oCho_0976_0978; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  private Cho_0976_0979 oCho_0976_0979; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> ChoiceState )
  private Lea_0976_0980 oLea_0976_0980; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Ready )
  private Lea_0976_0981 oLea_0976_0981; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> Play )
  private Lea_0976_0982 oLea_0976_0982; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >> End )

  public Reg_0975_0976( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0976_0977 = new Cho_0976_0977( this );
    oCho_0976_0978 = new Cho_0976_0978( this );
    oCho_0976_0979 = new Cho_0976_0979( this );
    oLea_0976_0980 = new Lea_0976_0980( this );
    oLea_0976_0981 = new Lea_0976_0981( this );
    oLea_0976_0982 = new Lea_0976_0982( this );
    mNrStates = 6;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0976_0977;
    mStates[ 1 ] = oCho_0976_0978;
    mStates[ 2 ] = oCho_0976_0979;
    mStates[ 3 ] = oLea_0976_0980;
    mStates[ 4 ] = oLea_0976_0981;
    mStates[ 5 ] = oLea_0976_0982;
  }

   // Down: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public void Tra_0972_0999( TsmHandler oHandler )
  {
    mCurrentState = oLea_0976_0980; // Down: ( TbServerPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public void Tra_0976_0985( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1088( oHandler );
    mCurrentState = oLea_0976_0981; // At: ( TbServerPsm >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public void Tra_0976_0984( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1090( oHandler );
    mCurrentState = oLea_0976_0980; // At: ( TbServerPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public void Tra_0976_0994( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1092( oHandler );
    mCurrentState = oLea_0976_0981; // At: ( TbServerPsm >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Tra_0976_0993( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1094( oHandler );
    mCurrentState = oLea_0976_0982; // At: ( TbServerPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Tra_0976_0992( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1096( oHandler );
    mCurrentState = oLea_0976_0982; // At: ( TbServerPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Tra_0976_0991( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1098( oHandler );
    mCurrentState = oLea_0976_0982; // At: ( TbServerPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> Ready ) => ( TbServerPsm >> CompoundState >> ChoiceState )
  public void Tra_0976_0983( TsmHandler oHandler )
  {
    mCurrentState = oCho_0976_0977; // At: ( TbServerPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> Play ) => ( TbServerPsm >> CompoundState >> ChoiceState )
  public void Tra_0976_0986( TsmHandler oHandler )
  {
    mCurrentState = oCho_0976_0978; // At: ( TbServerPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState >> End ) => ( TbServerPsm >> CompoundState >> ChoiceState )
  public void Tra_0976_0990( TsmHandler oHandler )
  {
    mCurrentState = oCho_0976_0979; // At: ( TbServerPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 57:
        return TsmProspect.OK;
      case 58:
        return TsmProspect.OK;
      case 59:
        return TsmProspect.OK;
      case 60:
        return TsmProspect.OK;
      case 61:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 999:
      Tra_0972_0999( oHandler );
      break;
    case 985:
      Tra_0976_0985( oHandler );
      break;
    case 984:
      Tra_0976_0984( oHandler );
      break;
    case 994:
      Tra_0976_0994( oHandler );
      break;
    case 993:
      Tra_0976_0993( oHandler );
      break;
    case 992:
      Tra_0976_0992( oHandler );
      break;
    case 991:
      Tra_0976_0991( oHandler );
      break;
    case 983:
      Tra_0976_0983( oHandler );
      break;
    case 986:
      Tra_0976_0986( oHandler );
      break;
    case 990:
      Tra_0976_0990( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState )
class Com_0972_0975 extends TsmCompound
{
  private Reg_0975_0976 oReg_0975_0976; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState >)

  public Com_0972_0975( TsmBase oParent )
  {
    TsmName = "CS_975";
    TsmParent = oParent;
    oReg_0975_0976 = new Reg_0975_0976( this );
    mRegions.add( oReg_0975_0976 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 988, "( TbServerPsm >> CompoundState ) => ( TbServerPsm >> Idle ) : CloseTitle" );
  }

  public void Tra_0972_0999( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0975_0976.ExecuteHandler( oHandler );
  }

  public void Port___CloseTitle( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 988; // CloseTitle
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 56:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 970: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 56: // Port___CloseTitle
        {
          Port___CloseTitle( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 999:
      Tra_0972_0999( oHandler );
      break;
    case 988: // UP: ( TbServerPsm >> CompoundState ) => ( TbServerPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> Idle )
class Lea_0972_0995 extends TsmLeaf
{
  public Lea_0972_0995( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 997, "( TbServerPsm >> Idle ) => ( TbServerPsm >> ChoiceState ) : OpenTitle" );
  }

  public void Tra_0972_0996( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0972_0998( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___OpenTitle( String TitleId, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 997; // OpenTitle
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0976_0988( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 55:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 970: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 55: // Port___OpenTitle
        {
          TsmTrigger_ITitlebaseServer___OpenTitle lTrigger = (TsmTrigger_ITitlebaseServer___OpenTitle) oHandler.Trigger;

          Port___OpenTitle( lTrigger.TitleId, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 996:
      Tra_0972_0996( oHandler );
      break;
    case 998:
      Tra_0972_0998( oHandler );
      break;
    case 997: // UP: ( TbServerPsm >> Idle ) => ( TbServerPsm >> ChoiceState )
      bHigher = true;
      break;
    case 988:
      Tra_0976_0988( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >)
class Reg_0971_0972 extends TsmRegion
{
  private Ini_0972_0973 oIni_0972_0973; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> InitialState )
  private Cho_0972_0974 oCho_0972_0974; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> ChoiceState )
  private Com_0972_0975 oCom_0972_0975; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> CompoundState )
  private Lea_0972_0995 oLea_0972_0995; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >> Idle )

  public Reg_0971_0972( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0972_0973 = new Ini_0972_0973( this );
    oCho_0972_0974 = new Cho_0972_0974( this );
    oCom_0972_0975 = new Com_0972_0975( this );
    oLea_0972_0995 = new Lea_0972_0995( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0972_0973;
    mStates[ 1 ] = oCho_0972_0974;
    mStates[ 2 ] = oCom_0972_0975;
    mStates[ 3 ] = oLea_0972_0995;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0972_0973.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> InitialState ) => ( TbServerPsm >> Idle )
  public void Tra_0972_0996( TsmHandler oHandler )
  {
    mCurrentState = oLea_0972_0995; // At: ( TbServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public void Tra_0972_0999( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1084( oHandler );
    mCurrentState = oCom_0972_0975; // At: ( TbServerPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
  public void Tra_0972_0998( TsmHandler oHandler )
  {
    ((Cla_0968_0969)oHandler.Owner).Function_1086( oHandler );
    mCurrentState = oLea_0972_0995; // At: ( TbServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> Idle ) => ( TbServerPsm >> ChoiceState )
  public void Tra_0972_0997( TsmHandler oHandler )
  {
    mCurrentState = oCho_0972_0974; // At: ( TbServerPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbServerPsm >> CompoundState ) => ( TbServerPsm >> Idle )
  public void Tra_0976_0988( TsmHandler oHandler )
  {
    mCurrentState = oLea_0972_0995; // At: ( TbServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 970:
      switch ( Command )
      {
      case 55:
        return TsmProspect.OK;
      case 56:
        return TsmProspect.OK;
      case 57:
        return TsmProspect.OK;
      case 58:
        return TsmProspect.OK;
      case 59:
        return TsmProspect.OK;
      case 60:
        return TsmProspect.OK;
      case 61:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 996:
      Tra_0972_0996( oHandler );
      break;
    case 999:
      Tra_0972_0999( oHandler );
      break;
    case 998:
      Tra_0972_0998( oHandler );
      break;
    case 997:
      Tra_0972_0997( oHandler );
      break;
    case 988:
      Tra_0976_0988( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm )
class Fsm_0969_0971 extends TsmFsm
{
  private Reg_0971_0972 oReg_0971_0972; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm >)

  public Fsm_0969_0971( TsmBase oParent )
  {
    TsmName = "TbServerPsm";
    TsmParent = oParent;
    oReg_0971_0972 = new Reg_0971_0972( this );
    mRegions.add( oReg_0971_0972 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer )
class Cla_0968_0969 extends TsmProtocolClass
{
  private Fsm_0969_0971 oFsm_0969_0971; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > TbServerPsm )
  private TsmIPort_ITitlebaseServer TsmPI__Port; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > Port )
  private TsmPSPort mPSMessager;
  private int FileHandle = 12345;
  private tChunk Chunk = new tChunk();

  public Cla_0968_0969( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0969_0971 = new Fsm_0969_0971( this );
    TsmPI__Port = new TsmIPort_ITitlebaseServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0969_0971;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0969_0971.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public int Function_1083( String TitleId )
  {
    Tsm.Assert(0!=FileHandle);
    return FileHandle;
  }

   // ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public void Function_1084( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___OpenTitle lTrigger = (TsmTrigger_ITitlebaseServer___OpenTitle) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1083( TitleId );
  }

   // ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
  public int Function_1085( String TitleId )
  {
    return 0;
  }

   // ( TbServerPsm >> ChoiceState ) => ( TbServerPsm >> Idle )
  public void Function_1086( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___OpenTitle lTrigger = (TsmTrigger_ITitlebaseServer___OpenTitle) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1085( TitleId );
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public eRV Function_1087( tTime AtTime )
  {
    return eRV.OK;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public void Function_1088( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___SetTime lTrigger = (TsmTrigger_ITitlebaseServer___SetTime) oHandler.Trigger;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1087( AtTime );
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public eRV Function_1089( tTime AtTime )
  {
    return eRV.INVALID_PARAM;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Ready )
  public void Function_1090( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___SetTime lTrigger = (TsmTrigger_ITitlebaseServer___SetTime) oHandler.Trigger;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1089( AtTime );
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public tChunk Function_1091()
  {
    Tsm.Assert(null!=Chunk);
    return Chunk;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> Play )
  public void Function_1092( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___GetChunk lTrigger = (TsmTrigger_ITitlebaseServer___GetChunk) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1091();
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public tChunk Function_1093()
  {
    return null;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Function_1094( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___GetChunk lTrigger = (TsmTrigger_ITitlebaseServer___GetChunk) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1093();
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public eRV Function_1095()
  {
    return eRV.NO_RESOURCE;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Function_1096( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___GetResult lTrigger = (TsmTrigger_ITitlebaseServer___GetResult) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1095();
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public eRV Function_1097()
  {
    return eRV.FAILURE;
  }

   // ( TbServerPsm >> CompoundState >> ChoiceState ) => ( TbServerPsm >> CompoundState >> End )
  public void Function_1098( TsmHandler oHandler )
  {
    TsmTrigger_ITitlebaseServer___GetResult lTrigger = (TsmTrigger_ITitlebaseServer___GetResult) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0968_0969)oHandler.Owner).Function_1097();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 970;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0969_0971.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )
class Com_0793_0003 extends TsmPComponent
{
  private Cla_0968_0969 InsTitlebaseServer; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseServer > InsTitlebaseServer )

  public Com_0793_0003( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    InsTitlebaseServer = new Cla_0968_0969( this, "InsTitlebaseServer" );
    InsTitlebaseServer.IsMock = true;
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = InsTitlebaseServer;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "pp_titlebase" ) )
    {
      return InsTitlebaseServer.GetProvidedInterface( "Port" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> InitialState )
class Ini_1084_1085 extends TsmPseudo
{
  public Ini_1084_1085( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1122, "( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1122; // TRLS ( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1122: // UP: ( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> InitialState )
class Ini_1087_1088 extends TsmPseudo
{
  public Ini_1087_1088( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1105, "( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1105; // TRLS ( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1105: // UP: ( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Play )
class Lea_1090_1091 extends TsmLeaf
{
  public Lea_1090_1091( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1094, "( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1090_1096( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1110( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1094; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 64:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 64: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1096:
      Tra_1090_1096( oHandler );
      break;
    case 1110:
      Tra_1087_1110( oHandler );
      break;
    case 1094: // UP: ( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Pausing )
class Lea_1090_1092 extends TsmLeaf
{
  int [] aNatives = { 1095 };

  public Lea_1090_1092( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1095, "( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1090_1094( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1095:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1095: // Native: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused ) # CbPaused();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1095;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1095: // UP: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1094:
      Tra_1090_1094( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Continuing )
class Lea_1090_1093 extends TsmLeaf
{
  int [] aNatives = { 1096 };

  public Lea_1090_1093( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1096, "( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1115( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1096:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1096: // Native: ( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play ) # CbContinued();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1096;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1096: // UP: ( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1115:
      Tra_1087_1115( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >)
class Reg_1089_1090 extends TsmRegion
{
  private Lea_1090_1091 oLea_1090_1091; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Play )
  private Lea_1090_1092 oLea_1090_1092; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Pausing )
  private Lea_1090_1093 oLea_1090_1093; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >> Continuing )

  public Reg_1089_1090( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oLea_1090_1091 = new Lea_1090_1091( this );
    oLea_1090_1092 = new Lea_1090_1092( this );
    oLea_1090_1093 = new Lea_1090_1093( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oLea_1090_1091;
    mStates[ 1 ] = oLea_1090_1092;
    mStates[ 2 ] = oLea_1090_1093;
  }

   // At: ( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )
  public void Tra_1090_1096( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1192( oHandler );
    mCurrentState = oLea_1090_1091; // At: ( DisplayServerPsm >> Active >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
  public void Tra_1087_1110( TsmHandler oHandler )
  {
    mCurrentState = oLea_1090_1091; // Down: ( DisplayServerPsm >> Active >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing )
  public void Tra_1090_1094( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1332( oHandler );
    mCurrentState = oLea_1090_1092; // At: ( DisplayServerPsm >> Active >> Busy >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing )
  public void Tra_1087_1115( TsmHandler oHandler )
  {
    mCurrentState = oLea_1090_1093; // Down: ( DisplayServerPsm >> Active >> Busy >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1095:
        return TsmProspect.OK;
      case 1096:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1082:
      switch ( Command )
      {
      case 64:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1095: // Up: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 1096:
      Tra_1090_1096( oHandler );
      break;
    case 1110:
      Tra_1087_1110( oHandler );
      break;
    case 1094:
      Tra_1090_1094( oHandler );
      break;
    case 1115:
      Tra_1087_1115( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy )
class Com_1087_1089 extends TsmCompound
{
  int [] aNatives = { 1117, 1118 };
  private Reg_1089_1090 oReg_1089_1090; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy >)

  public Com_1087_1089( TsmBase oParent )
  {
    TsmName = "Busy";
    TsmParent = oParent;
    oReg_1089_1090 = new Reg_1089_1090( this );
    mRegions.add( oReg_1089_1090 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1117, "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )" );
    mTransitions[ 1 ] = new TsmTransition( 1118, "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )" );
  }

  public void Tra_1087_1110( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_1089_1090.ExecuteHandler( oHandler );
  }

  public void Tra_1087_1115( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_1089_1090.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1117:
        return TsmProspect.OK;
      case 1118:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1117: // Native: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost ) # CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1117;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 1118: // Native: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing ) # CbFinished();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1118;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1117: // UP: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1118: // UP: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1095: // UP: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1110:
      Tra_1087_1110( oHandler );
      break;
    case 1115:
      Tra_1087_1115( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Ready )
class Lea_1087_1097 extends TsmLeaf
{
  public Lea_1087_1097( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1106, "( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> Starting ) : Start" );
    mTransitions[ 1 ] = new TsmTransition( 1107, "( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1108( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Start( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1106; // Start
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1107; // Pause
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 63:
        return TsmProspect.OK;
      case 64:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 63: // Port___Start
        {
          Port___Start( oHandler );
        }
        break;
      case 64: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1108:
      Tra_1087_1108( oHandler );
      break;
    case 1106: // UP: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> Starting )
      bHigher = true;
      break;
    case 1107: // UP: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Preparing )
class Lea_1087_1098 extends TsmLeaf
{
  int [] aNatives = { 1108 };

  public Lea_1087_1098( TsmBase oParent )
  {
    TsmName = "Preparing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1108, "( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1109( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1108:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1108: // Native: ( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready ) # CbPrepared();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1108;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1108: // UP: ( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1109:
      Tra_1087_1109( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Idle )
class Lea_1087_1099 extends TsmLeaf
{
  public Lea_1087_1099( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1109, "( DisplayServerPsm >> Active >> Idle ) => ( DisplayServerPsm >> Active >> Preparing ) : Prepare" );
  }

  public void Tra_1087_1105( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Prepare( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1109; // Prepare
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 62:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 62: // Port___Prepare
        {
          Port___Prepare( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1105:
      Tra_1087_1105( oHandler );
      break;
    case 1109: // UP: ( DisplayServerPsm >> Active >> Idle ) => ( DisplayServerPsm >> Active >> Preparing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Starting )
class Lea_1087_1100 extends TsmLeaf
{
  int [] aNatives = { 1110, 1111 };

  public Lea_1087_1100( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1110, "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 1111, "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1106( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1110:
        return TsmProspect.OK;
      case 1111:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1110: // Native: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play ) # CbStarted();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1110;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 1111: // Native: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost ) # CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1111;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1110: // UP: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1111: // UP: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1106:
      Tra_1087_1106( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Synclost )
class Lea_1087_1101 extends TsmLeaf
{
  public Lea_1087_1101( TsmBase oParent )
  {
    TsmName = "Synclost";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1112, "( DisplayServerPsm >> Active >> Synclost ) => ( DisplayServerPsm >> Active >> Synclost ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1117( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1111( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1113( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1112( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1336( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1112; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 64:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 64: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1117:
      Tra_1087_1117( oHandler );
      break;
    case 1111:
      Tra_1087_1111( oHandler );
      break;
    case 1113:
      Tra_1087_1113( oHandler );
      break;
    case 1112:
      Tra_1087_1112( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> StartPausing )
class Lea_1087_1102 extends TsmLeaf
{
  int [] aNatives = { 1113, 1114 };

  public Lea_1087_1102( TsmBase oParent )
  {
    TsmName = "StartPausing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1113, "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )" );
    mTransitions[ 1 ] = new TsmTransition( 1114, "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1107( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1113:
        return TsmProspect.OK;
      case 1114:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1113: // Native: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost ) # CbSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1113;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 1114: // Native: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused ) # CbPaused();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1114;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1113: // UP: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1114: // UP: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1107:
      Tra_1087_1107( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Paused )
class Lea_1087_1103 extends TsmLeaf
{
  public Lea_1087_1103( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1115, "( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing ) : Continue" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1090_1095( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1114( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1115; // Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 65:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 65: // Port___Continue
        {
          Port___Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1095:
      Tra_1090_1095( oHandler );
      break;
    case 1114:
      Tra_1087_1114( oHandler );
      break;
    case 1115: // UP: ( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Finishing )
class Lea_1087_1104 extends TsmLeaf
{
  public Lea_1087_1104( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1116, "( DisplayServerPsm >> Active >> Finishing ) => ( DisplayServerPsm >> Active >> Finishing ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1087_1118( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1087_1116( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1338( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1116; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 64:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 64: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1118:
      Tra_1087_1118( oHandler );
      break;
    case 1116:
      Tra_1087_1116( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >)
class Reg_1086_1087 extends TsmRegion
{
  private Ini_1087_1088 oIni_1087_1088; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> InitialState )
  private Com_1087_1089 oCom_1087_1089; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Busy )
  private Lea_1087_1097 oLea_1087_1097; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Ready )
  private Lea_1087_1098 oLea_1087_1098; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Preparing )
  private Lea_1087_1099 oLea_1087_1099; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Idle )
  private Lea_1087_1100 oLea_1087_1100; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Starting )
  private Lea_1087_1101 oLea_1087_1101; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Synclost )
  private Lea_1087_1102 oLea_1087_1102; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> StartPausing )
  private Lea_1087_1103 oLea_1087_1103; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Paused )
  private Lea_1087_1104 oLea_1087_1104; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >> Finishing )

  public Reg_1086_1087( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_1087_1088 = new Ini_1087_1088( this );
    oCom_1087_1089 = new Com_1087_1089( this );
    oLea_1087_1097 = new Lea_1087_1097( this );
    oLea_1087_1098 = new Lea_1087_1098( this );
    oLea_1087_1099 = new Lea_1087_1099( this );
    oLea_1087_1100 = new Lea_1087_1100( this );
    oLea_1087_1101 = new Lea_1087_1101( this );
    oLea_1087_1102 = new Lea_1087_1102( this );
    oLea_1087_1103 = new Lea_1087_1103( this );
    oLea_1087_1104 = new Lea_1087_1104( this );
    mNrStates = 10;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_1087_1088;
    mStates[ 1 ] = oCom_1087_1089;
    mStates[ 2 ] = oLea_1087_1097;
    mStates[ 3 ] = oLea_1087_1098;
    mStates[ 4 ] = oLea_1087_1099;
    mStates[ 5 ] = oLea_1087_1100;
    mStates[ 6 ] = oLea_1087_1101;
    mStates[ 7 ] = oLea_1087_1102;
    mStates[ 8 ] = oLea_1087_1103;
    mStates[ 9 ] = oLea_1087_1104;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_1087_1088.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> InitialState ) => ( DisplayServerPsm >> Active >> Idle )
  public void Tra_1087_1105( TsmHandler oHandler )
  {
    mCurrentState = oLea_1087_1099; // At: ( DisplayServerPsm >> Active >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Tra_1087_1117( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1189( oHandler );
    mCurrentState = oLea_1087_1101; // At: ( DisplayServerPsm >> Active >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )
  public void Tra_1087_1118( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1190( oHandler );
    mCurrentState = oLea_1087_1104; // At: ( DisplayServerPsm >> Active >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
  public void Tra_1090_1095( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1191( oHandler );
    mCurrentState = oLea_1087_1103; // At: ( DisplayServerPsm >> Active >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )
  public void Tra_1087_1108( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1193( oHandler );
    mCurrentState = oLea_1087_1097; // At: ( DisplayServerPsm >> Active >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
  public void Tra_1087_1110( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1194( oHandler );
    mCurrentState = oCom_1087_1089; // At: ( DisplayServerPsm >> Active >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Tra_1087_1111( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1195( oHandler );
    mCurrentState = oLea_1087_1101; // At: ( DisplayServerPsm >> Active >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Tra_1087_1113( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1196( oHandler );
    mCurrentState = oLea_1087_1101; // At: ( DisplayServerPsm >> Active >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )
  public void Tra_1087_1114( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1197( oHandler );
    mCurrentState = oLea_1087_1103; // At: ( DisplayServerPsm >> Active >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Idle ) => ( DisplayServerPsm >> Active >> Preparing )
  public void Tra_1087_1109( TsmHandler oHandler )
  {
    mCurrentState = oLea_1087_1098; // At: ( DisplayServerPsm >> Active >> Preparing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> Starting )
  public void Tra_1087_1106( TsmHandler oHandler )
  {
    mCurrentState = oLea_1087_1100; // At: ( DisplayServerPsm >> Active >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing )
  public void Tra_1087_1107( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1334( oHandler );
    mCurrentState = oLea_1087_1102; // At: ( DisplayServerPsm >> Active >> StartPausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active >> Paused ) => ( DisplayServerPsm >> Active >> Busy >> Continuing )
  public void Tra_1087_1115( TsmHandler oHandler )
  {
    mCurrentState = oCom_1087_1089; // At: ( DisplayServerPsm >> Active >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1117:
        return TsmProspect.OK;
      case 1118:
        return TsmProspect.OK;
      case 1095:
        return TsmProspect.OK;
      case 1096:
        return TsmProspect.OK;
      case 1108:
        return TsmProspect.OK;
      case 1110:
        return TsmProspect.OK;
      case 1111:
        return TsmProspect.OK;
      case 1113:
        return TsmProspect.OK;
      case 1114:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1082:
      switch ( Command )
      {
      case 62:
        return TsmProspect.OK;
      case 63:
        return TsmProspect.OK;
      case 64:
        return TsmProspect.OK;
      case 65:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1105:
      Tra_1087_1105( oHandler );
      break;
    case 1117:
      Tra_1087_1117( oHandler );
      break;
    case 1118:
      Tra_1087_1118( oHandler );
      break;
    case 1095:
      Tra_1090_1095( oHandler );
      break;
    case 1108:
      Tra_1087_1108( oHandler );
      break;
    case 1110:
      Tra_1087_1110( oHandler );
      break;
    case 1111:
      Tra_1087_1111( oHandler );
      break;
    case 1113:
      Tra_1087_1113( oHandler );
      break;
    case 1114:
      Tra_1087_1114( oHandler );
      break;
    case 1109:
      Tra_1087_1109( oHandler );
      break;
    case 1106:
      Tra_1087_1106( oHandler );
      break;
    case 1107:
      Tra_1087_1107( oHandler );
      break;
    case 1115:
      Tra_1087_1115( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active )
class Com_1084_1086 extends TsmCompound
{
  private Reg_1086_1087 oReg_1086_1087; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active >)

  public Com_1084_1086( TsmBase oParent )
  {
    TsmName = "Active";
    TsmParent = oParent;
    oReg_1086_1087 = new Reg_1086_1087( this );
    mRegions.add( oReg_1086_1087 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1120, "( DisplayServerPsm >> Active ) => ( DisplayServerPsm >> Stopping ) : Stop" );
  }

  public void Tra_1084_1122( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1084_1121( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1120; // Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1082:
      switch ( Command )
      {
      case 66:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1082: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 66: // Port___Stop
        {
          Port___Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1122:
      Tra_1084_1122( oHandler );
      break;
    case 1121:
      Tra_1084_1121( oHandler );
      break;
    case 1120: // UP: ( DisplayServerPsm >> Active ) => ( DisplayServerPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Stopping )
class Lea_1084_1119 extends TsmLeaf
{
  int [] aNatives = { 1121 };

  public Lea_1084_1119( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1121, "( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1084_1120( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1121:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1121: // Native: ( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )
        TsmRecorder.AddNative( "( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active ) # CbStopped();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1121;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1121: // UP: ( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1120:
      Tra_1084_1120( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >)
class Reg_1083_1084 extends TsmRegion
{
  private Ini_1084_1085 oIni_1084_1085; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> InitialState )
  private Com_1084_1086 oCom_1084_1086; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Active )
  private Lea_1084_1119 oLea_1084_1119; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >> Stopping )

  public Reg_1083_1084( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_1084_1085 = new Ini_1084_1085( this );
    oCom_1084_1086 = new Com_1084_1086( this );
    oLea_1084_1119 = new Lea_1084_1119( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_1084_1085;
    mStates[ 1 ] = oCom_1084_1086;
    mStates[ 2 ] = oLea_1084_1119;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_1084_1085.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> InitialState ) => ( DisplayServerPsm >> Active )
  public void Tra_1084_1122( TsmHandler oHandler )
  {
    mCurrentState = oCom_1084_1086; // At: ( DisplayServerPsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )
  public void Tra_1084_1121( TsmHandler oHandler )
  {
    ((Cla_1031_1081)oHandler.Owner).Function_1198( oHandler );
    mCurrentState = oCom_1084_1086; // At: ( DisplayServerPsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayServerPsm >> Active ) => ( DisplayServerPsm >> Stopping )
  public void Tra_1084_1120( TsmHandler oHandler )
  {
    mCurrentState = oLea_1084_1119; // At: ( DisplayServerPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1117:
        return TsmProspect.OK;
      case 1118:
        return TsmProspect.OK;
      case 1095:
        return TsmProspect.OK;
      case 1096:
        return TsmProspect.OK;
      case 1108:
        return TsmProspect.OK;
      case 1110:
        return TsmProspect.OK;
      case 1111:
        return TsmProspect.OK;
      case 1113:
        return TsmProspect.OK;
      case 1114:
        return TsmProspect.OK;
      case 1121:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1082:
      switch ( Command )
      {
      case 62:
        return TsmProspect.OK;
      case 63:
        return TsmProspect.OK;
      case 64:
        return TsmProspect.OK;
      case 65:
        return TsmProspect.OK;
      case 66:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1122:
      Tra_1084_1122( oHandler );
      break;
    case 1121:
      Tra_1084_1121( oHandler );
      break;
    case 1120:
      Tra_1084_1120( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm )
class Fsm_1081_1083 extends TsmFsm
{
  private Reg_1083_1084 oReg_1083_1084; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm >)

  public Fsm_1081_1083( TsmBase oParent )
  {
    TsmName = "DisplayServerPsm";
    TsmParent = oParent;
    oReg_1083_1084 = new Reg_1083_1084( this );
    mRegions.add( oReg_1083_1084 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )
class Cla_1031_1081 extends TsmProtocolClass
{
  private Fsm_1081_1083 oFsm_1081_1083; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > DisplayServerPsm )
  private TsmIPort_IDisplayServer TsmPI__Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
  private TsmIPort_IDisplayClient Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > Port )
  private TsmPSPort mPSMessager;
  private tTime BadTime = null;

  public Cla_1031_1081( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_1081_1083 = new Fsm_1081_1083( this );
    TsmPI__Port = new TsmIPort_IDisplayServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_1081_1083;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IDisplayClient) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_1081_1083.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Function_1189( TsmHandler oHandler )
  {
    Port.CbSynclost( BadTime );
  }

   // ( DisplayServerPsm >> Active >> Busy ) => ( DisplayServerPsm >> Active >> Finishing )
  public void Function_1190( TsmHandler oHandler )
  {
    Port.CbFinished();
  }

   // ( DisplayServerPsm >> Active >> Busy >> Pausing ) => ( DisplayServerPsm >> Active >> Paused )
  public void Function_1191( TsmHandler oHandler )
  {
    Port.CbPaused();
  }

   // ( DisplayServerPsm >> Active >> Busy >> Continuing ) => ( DisplayServerPsm >> Active >> Busy >> Play )
  public void Function_1192( TsmHandler oHandler )
  {
    Port.CbContinued();
  }

   // ( DisplayServerPsm >> Active >> Preparing ) => ( DisplayServerPsm >> Active >> Ready )
  public void Function_1193( TsmHandler oHandler )
  {
    Port.CbPrepared();
  }

   // ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Busy >> Play )
  public void Function_1194( TsmHandler oHandler )
  {
    Port.CbStarted();
  }

   // ( DisplayServerPsm >> Active >> Starting ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Function_1195( TsmHandler oHandler )
  {
    Port.CbSynclost( BadTime );
  }

   // ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Function_1196( TsmHandler oHandler )
  {
    Port.CbSynclost( BadTime );
  }

   // ( DisplayServerPsm >> Active >> StartPausing ) => ( DisplayServerPsm >> Active >> Paused )
  public void Function_1197( TsmHandler oHandler )
  {
    Port.CbPaused();
  }

   // ( DisplayServerPsm >> Stopping ) => ( DisplayServerPsm >> Active )
  public void Function_1198( TsmHandler oHandler )
  {
    Port.CbStopped();
  }

   // ( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing )
  public eRV Function_1331()
  {
    return eRV.OK;
  }

   // ( DisplayServerPsm >> Active >> Busy >> Play ) => ( DisplayServerPsm >> Active >> Busy >> Pausing )
  public void Function_1332( TsmHandler oHandler )
  {
    TsmTrigger_IDisplayServer___Pause lTrigger = (TsmTrigger_IDisplayServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_1031_1081)oHandler.Owner).Function_1331();
  }

   // ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing )
  public eRV Function_1333()
  {
    return eRV.OK;
  }

   // ( DisplayServerPsm >> Active >> Ready ) => ( DisplayServerPsm >> Active >> StartPausing )
  public void Function_1334( TsmHandler oHandler )
  {
    TsmTrigger_IDisplayServer___Pause lTrigger = (TsmTrigger_IDisplayServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_1031_1081)oHandler.Owner).Function_1333();
  }

   // ( DisplayServerPsm >> Active >> Synclost ) => ( DisplayServerPsm >> Active >> Synclost )
  public eRV Function_1335()
  {
    return eRV.OK_RACE;
  }

   // ( DisplayServerPsm >> Active >> Synclost ) => ( DisplayServerPsm >> Active >> Synclost )
  public void Function_1336( TsmHandler oHandler )
  {
    TsmTrigger_IDisplayServer___Pause lTrigger = (TsmTrigger_IDisplayServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_1031_1081)oHandler.Owner).Function_1335();
  }

   // ( DisplayServerPsm >> Active >> Finishing ) => ( DisplayServerPsm >> Active >> Finishing )
  public eRV Function_1337()
  {
    return eRV.OK_RACE;
  }

   // ( DisplayServerPsm >> Active >> Finishing ) => ( DisplayServerPsm >> Active >> Finishing )
  public void Function_1338( TsmHandler oHandler )
  {
    TsmTrigger_IDisplayServer___Pause lTrigger = (TsmTrigger_IDisplayServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_1031_1081)oHandler.Owner).Function_1337();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 1082;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_1081_1083.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Architecture > ExEnv > DisplayMock )
class Com_0793_0005 extends TsmPComponent
{
  private Cla_1031_1081 InsDisplayServer; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayServer > InsDisplayServer )

  public Com_0793_0005( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    InsDisplayServer = new Cla_1031_1081( this, "InsDisplayServer" );
    InsDisplayServer.IsMock = true;
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = InsDisplayServer;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "pp_display" ) )
    {
      return InsDisplayServer.GetProvidedInterface( "Port" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > DisplayMock )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "pp_display" ) )
    {
      InsDisplayServer.SetRequiredInterface( "Port", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > DisplayMock )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> InitialState )
class Ini_0843_0844 extends TsmPseudo
{
  public Ini_0843_0844( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 880, "( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 880; // TRLS ( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 880: // UP: ( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> ChoiceState )
class Cho_0843_0845 extends TsmPseudo
{
  public Cho_0843_0845( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 884, "( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )" );
    mTransitions[ 1 ] = new TsmTransition( 885, "( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0801_0840)oHandler.Owner).Guard_1070() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 884; // TRLS ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 885; // TRLS ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0843_0881( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 884: // UP: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )
      bHigher = true;
      break;
    case 885: // UP: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )
      bHigher = true;
      break;
    case 881:
      Tra_0843_0881( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
class Cho_0851_0852 extends TsmPseudo
{
  public Cho_0851_0852( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 860, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )" );
    mTransitions[ 1 ] = new TsmTransition( 861, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0801_0840)oHandler.Owner).Guard_1071() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 860; // TRLS ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 861; // TRLS ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0851_0858( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 860: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
      bHigher = true;
      break;
    case 861: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
      bHigher = true;
      break;
    case 858:
      Tra_0851_0858( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
class Cho_0851_0853 extends TsmPseudo
{
  public Cho_0851_0853( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 862, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )" );
    mTransitions[ 1 ] = new TsmTransition( 863, "( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0801_0840)oHandler.Owner).Guard_1072() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 862; // TRLS ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 863; // TRLS ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0849_0866( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 862: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
      bHigher = true;
      break;
    case 863: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      bHigher = true;
      break;
    case 866:
      Tra_0849_0866( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
class Lea_0851_0854 extends TsmLeaf
{
  public Lea_0851_0854( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 857, "( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused ) : CbPaused" );
  }

  public void Tra_0851_0860( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 857; // CbPaused
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 45:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 45: // Port___CbPaused
        {
          Port___CbPaused( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 860:
      Tra_0851_0860( oHandler );
      break;
    case 857: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Play )
class Lea_0851_0855 extends TsmLeaf
{
  int [] aNatives = { -858 };

  public Lea_0851_0855( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 858, "( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )" );
  }

  public void Tra_0851_0861( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0847_0870( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0851_0859( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 858:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 858: // Native: ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
        TsmRecorder.AddNative( "( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) # RV=Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 858;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 861:
      Tra_0851_0861( oHandler );
      break;
    case 858: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 859:
      Tra_0851_0859( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
class Lea_0851_0856 extends TsmLeaf
{
  public Lea_0851_0856( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 859, "( PlayerClientPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) : CbContinued" );
  }

  public void Tra_0851_0862( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 859; // CbContinued
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 46:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 46: // Port___CbContinued
        {
          Port___CbContinued( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 862:
      Tra_0851_0862( oHandler );
      break;
    case 859: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >)
class Reg_0850_0851 extends TsmRegion
{
  private Cho_0851_0852 oCho_0851_0852; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  private Cho_0851_0853 oCho_0851_0853; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  private Lea_0851_0854 oLea_0851_0854; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
  private Lea_0851_0855 oLea_0851_0855; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Play )
  private Lea_0851_0856 oLea_0851_0856; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >> Continuing )

  public Reg_0850_0851( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0851_0852 = new Cho_0851_0852( this );
    oCho_0851_0853 = new Cho_0851_0853( this );
    oLea_0851_0854 = new Lea_0851_0854( this );
    oLea_0851_0855 = new Lea_0851_0855( this );
    oLea_0851_0856 = new Lea_0851_0856( this );
    mNrStates = 5;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0851_0852;
    mStates[ 1 ] = oCho_0851_0853;
    mStates[ 2 ] = oLea_0851_0854;
    mStates[ 3 ] = oLea_0851_0855;
    mStates[ 4 ] = oLea_0851_0856;
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
  public void Tra_0851_0860( TsmHandler oHandler )
  {
    mCurrentState = oLea_0851_0854; // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0851_0861( TsmHandler oHandler )
  {
    mCurrentState = oLea_0851_0855; // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
  public void Tra_0851_0862( TsmHandler oHandler )
  {
    mCurrentState = oLea_0851_0856; // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  public void Tra_0851_0858( TsmHandler oHandler )
  {
    ((Cla_0801_0840)oHandler.Owner).Function_1161( oHandler );
    mCurrentState = oCho_0851_0852; // At: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  public void Tra_0849_0866( TsmHandler oHandler )
  {
    mCurrentState = oCho_0851_0853; // Down: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0847_0870( TsmHandler oHandler )
  {
    mCurrentState = oLea_0851_0855; // Down: ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0851_0859( TsmHandler oHandler )
  {
    mCurrentState = oLea_0851_0855; // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 858:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 841:
      switch ( Command )
      {
      case 45:
        return TsmProspect.OK;
      case 46:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 860:
      Tra_0851_0860( oHandler );
      break;
    case 861:
      Tra_0851_0861( oHandler );
      break;
    case 862:
      Tra_0851_0862( oHandler );
      break;
    case 863: // Up: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 858:
      Tra_0851_0858( oHandler );
      break;
    case 866:
      Tra_0849_0866( oHandler );
      break;
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 857: // Up: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 859:
      Tra_0851_0859( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy )
class Com_0849_0850 extends TsmCompound
{
  private Reg_0850_0851 oReg_0850_0851; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy >)

  public Com_0849_0850( TsmBase oParent )
  {
    TsmName = "Busy";
    TsmParent = oParent;
    oReg_0850_0851 = new Reg_0850_0851( this );
    mRegions.add( oReg_0850_0851 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 865, "( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing ) : CbFinish" );
  }

  public void Tra_0849_0866( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0850_0851.ExecuteHandler( oHandler );
  }

  public void Tra_0847_0870( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0850_0851.ExecuteHandler( oHandler );
  }

  public void Port___CbFinish( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 865; // CbFinish
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 48:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 48: // Port___CbFinish
        {
          Port___CbFinish( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 863: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 866:
      Tra_0849_0866( oHandler );
      break;
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 857: // UP: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 865: // UP: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Paused )
class Lea_0849_0864 extends TsmLeaf
{
  int [] aNatives = { -866 };

  public Lea_0849_0864( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 866, "( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )" );
  }

  public void Tra_0851_0863( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0851_0857( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 866:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 866: // Native: ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
        TsmRecorder.AddNative( "( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) # RV=Continue();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 866;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 863:
      Tra_0851_0863( oHandler );
      break;
    case 866: // UP: ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 857:
      Tra_0851_0857( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >)
class Reg_0848_0849 extends TsmRegion
{
  private Com_0849_0850 oCom_0849_0850; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Busy )
  private Lea_0849_0864 oLea_0849_0864; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >> Paused )

  public Reg_0848_0849( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCom_0849_0850 = new Com_0849_0850( this );
    oLea_0849_0864 = new Lea_0849_0864( this );
    mNrStates = 2;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCom_0849_0850;
    mStates[ 1 ] = oLea_0849_0864;
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState ) => ( PlayerClientPsm >> Active >> Running >> Paused )
  public void Tra_0851_0863( TsmHandler oHandler )
  {
    mCurrentState = oLea_0849_0864; // At: ( PlayerClientPsm >> Active >> Running >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  public void Tra_0849_0866( TsmHandler oHandler )
  {
    ((Cla_0801_0840)oHandler.Owner).Function_1162( oHandler );
    mCurrentState = oCom_0849_0850; // At: ( PlayerClientPsm >> Active >> Running >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0847_0870( TsmHandler oHandler )
  {
    mCurrentState = oCom_0849_0850; // Down: ( PlayerClientPsm >> Active >> Running >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerClientPsm >> Active >> Running >> Paused )
  public void Tra_0851_0857( TsmHandler oHandler )
  {
    mCurrentState = oLea_0849_0864; // At: ( PlayerClientPsm >> Active >> Running >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 858:
        return TsmProspect.OK;
      case 866:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 841:
      switch ( Command )
      {
      case 45:
        return TsmProspect.OK;
      case 46:
        return TsmProspect.OK;
      case 48:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 863:
      Tra_0851_0863( oHandler );
      break;
    case 866:
      Tra_0849_0866( oHandler );
      break;
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 857:
      Tra_0851_0857( oHandler );
      break;
    case 865: // Up: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
      mCurrentState = null;
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running )
class Com_0847_0848 extends TsmCompound
{
  private Reg_0848_0849 oReg_0848_0849; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running >)

  public Com_0847_0848( TsmBase oParent )
  {
    TsmName = "Running";
    TsmParent = oParent;
    oReg_0848_0849 = new Reg_0848_0849( this );
    mRegions.add( oReg_0848_0849 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 871, "( PlayerClientPsm >> Active >> Running ) => ( PlayerClientPsm >> Active >> Error ) : CbError" );
  }

  public void Tra_0847_0870( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0848_0849.ExecuteHandler( oHandler );
  }

  public void Port___CbError( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 871; // CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 49:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 49: // Port___CbError
        {
          Port___CbError( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 865: // UP: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 871: // UP: ( PlayerClientPsm >> Active >> Running ) => ( PlayerClientPsm >> Active >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Finishing )
class Lea_0847_0867 extends TsmLeaf
{
  public Lea_0847_0867( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0849_0865( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 865:
      Tra_0849_0865( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Starting )
class Lea_0847_0868 extends TsmLeaf
{
  public Lea_0847_0868( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 870, "( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) : CbStarted" );
    mTransitions[ 1 ] = new TsmTransition( 872, "( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Error ) : CbError" );
  }

  public void Tra_0843_0884( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 870; // CbStarted
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___CbError( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 872; // CbError
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 44:
        return TsmProspect.OK;
      case 49:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 44: // Port___CbStarted
        {
          Port___CbStarted( oHandler );
        }
        break;
      case 49: // Port___CbError
        {
          Port___CbError( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 884:
      Tra_0843_0884( oHandler );
      break;
    case 870: // UP: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
      bHigher = true;
      break;
    case 872: // UP: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Error )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Error )
class Lea_0847_0869 extends TsmLeaf
{
  public Lea_0847_0869( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0847_0871( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0847_0872( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 871:
      Tra_0847_0871( oHandler );
      break;
    case 872:
      Tra_0847_0872( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >)
class Reg_0846_0847 extends TsmRegion
{
  private Com_0847_0848 oCom_0847_0848; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Running )
  private Lea_0847_0867 oLea_0847_0867; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Finishing )
  private Lea_0847_0868 oLea_0847_0868; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Starting )
  private Lea_0847_0869 oLea_0847_0869; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >> Error )

  public Reg_0846_0847( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCom_0847_0848 = new Com_0847_0848( this );
    oLea_0847_0867 = new Lea_0847_0867( this );
    oLea_0847_0868 = new Lea_0847_0868( this );
    oLea_0847_0869 = new Lea_0847_0869( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCom_0847_0848;
    mStates[ 1 ] = oLea_0847_0867;
    mStates[ 2 ] = oLea_0847_0868;
    mStates[ 3 ] = oLea_0847_0869;
  }

   // Down: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )
  public void Tra_0843_0884( TsmHandler oHandler )
  {
    mCurrentState = oLea_0847_0868; // Down: ( PlayerClientPsm >> Active >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0847_0870( TsmHandler oHandler )
  {
    mCurrentState = oCom_0847_0848; // At: ( PlayerClientPsm >> Active >> Running )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running >> Busy ) => ( PlayerClientPsm >> Active >> Finishing )
  public void Tra_0849_0865( TsmHandler oHandler )
  {
    mCurrentState = oLea_0847_0867; // At: ( PlayerClientPsm >> Active >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Running ) => ( PlayerClientPsm >> Active >> Error )
  public void Tra_0847_0871( TsmHandler oHandler )
  {
    mCurrentState = oLea_0847_0869; // At: ( PlayerClientPsm >> Active >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active >> Starting ) => ( PlayerClientPsm >> Active >> Error )
  public void Tra_0847_0872( TsmHandler oHandler )
  {
    mCurrentState = oLea_0847_0869; // At: ( PlayerClientPsm >> Active >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 858:
        return TsmProspect.OK;
      case 866:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 841:
      switch ( Command )
      {
      case 44:
        return TsmProspect.OK;
      case 45:
        return TsmProspect.OK;
      case 46:
        return TsmProspect.OK;
      case 48:
        return TsmProspect.OK;
      case 49:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 884:
      Tra_0843_0884( oHandler );
      break;
    case 870:
      Tra_0847_0870( oHandler );
      break;
    case 865:
      Tra_0849_0865( oHandler );
      break;
    case 871:
      Tra_0847_0871( oHandler );
      break;
    case 872:
      Tra_0847_0872( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active )
class Com_0843_0846 extends TsmCompound
{
  int [] aNatives = { -882 };
  private Reg_0846_0847 oReg_0846_0847; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active >)

  public Com_0843_0846( TsmBase oParent )
  {
    TsmName = "Active";
    TsmParent = oParent;
    oReg_0846_0847 = new Reg_0846_0847( this );
    mRegions.add( oReg_0846_0847 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 882, "( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )" );
  }

  public void Tra_0843_0884( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0846_0847.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 882:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 882: // Native: ( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )
        TsmRecorder.AddNative( "( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping ) # Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 882;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 884:
      Tra_0843_0884( oHandler );
      break;
    case 882: // UP: ( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Idle )
class Lea_0843_0873 extends TsmLeaf
{
  int [] aNatives = { -881 };

  public Lea_0843_0873( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 881, "( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )" );
  }

  public void Tra_0843_0880( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0843_0885( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0843_0883( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 881:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 881: // Native: ( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState ) # RV=Start(TitleId,AtTime);" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 881;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 880:
      Tra_0843_0880( oHandler );
      break;
    case 885:
      Tra_0843_0885( oHandler );
      break;
    case 881: // UP: ( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 883:
      Tra_0843_0883( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Stopping )
class Lea_0843_0874 extends TsmLeaf
{
  public Lea_0843_0874( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 6;
    mTransitions = new TsmTransition[ 6 ];
    mTransitions[ 0 ] = new TsmTransition( 875, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbStarted" );
    mTransitions[ 1 ] = new TsmTransition( 877, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbPaused" );
    mTransitions[ 2 ] = new TsmTransition( 878, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbContinued" );
    mTransitions[ 3 ] = new TsmTransition( 883, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Idle ) : CbStopped" );
    mTransitions[ 4 ] = new TsmTransition( 879, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbFinish" );
    mTransitions[ 5 ] = new TsmTransition( 876, "( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Stopping ) : CbError" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0843_0882( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0843_0875( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 875; // CbStarted
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0843_0877( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 877; // CbPaused
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0843_0878( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 878; // CbContinued
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Port___CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 883; // CbStopped
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void Tra_0843_0879( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbFinish( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 879; // CbFinish
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  public void Tra_0843_0876( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbError( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 876; // CbError
    oHandler.bTaken = true;
    mTransitions[ 5 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 841:
      switch ( Command )
      {
      case 44:
        return TsmProspect.OK;
      case 45:
        return TsmProspect.OK;
      case 46:
        return TsmProspect.OK;
      case 47:
        return TsmProspect.OK;
      case 48:
        return TsmProspect.OK;
      case 49:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 841: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 44: // Port___CbStarted
        {
          Port___CbStarted( oHandler );
        }
        break;
      case 45: // Port___CbPaused
        {
          Port___CbPaused( oHandler );
        }
        break;
      case 46: // Port___CbContinued
        {
          Port___CbContinued( oHandler );
        }
        break;
      case 47: // Port___CbStopped
        {
          Port___CbStopped( oHandler );
        }
        break;
      case 48: // Port___CbFinish
        {
          Port___CbFinish( oHandler );
        }
        break;
      case 49: // Port___CbError
        {
          Port___CbError( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 882:
      Tra_0843_0882( oHandler );
      break;
    case 875:
      Tra_0843_0875( oHandler );
      break;
    case 877:
      Tra_0843_0877( oHandler );
      break;
    case 878:
      Tra_0843_0878( oHandler );
      break;
    case 883: // UP: ( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Idle )
      bHigher = true;
      break;
    case 879:
      Tra_0843_0879( oHandler );
      break;
    case 876:
      Tra_0843_0876( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >)
class Reg_0842_0843 extends TsmRegion
{
  private Ini_0843_0844 oIni_0843_0844; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> InitialState )
  private Cho_0843_0845 oCho_0843_0845; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> ChoiceState )
  private Com_0843_0846 oCom_0843_0846; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Active )
  private Lea_0843_0873 oLea_0843_0873; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Idle )
  private Lea_0843_0874 oLea_0843_0874; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >> Stopping )

  public Reg_0842_0843( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0843_0844 = new Ini_0843_0844( this );
    oCho_0843_0845 = new Cho_0843_0845( this );
    oCom_0843_0846 = new Com_0843_0846( this );
    oLea_0843_0873 = new Lea_0843_0873( this );
    oLea_0843_0874 = new Lea_0843_0874( this );
    mNrStates = 5;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0843_0844;
    mStates[ 1 ] = oCho_0843_0845;
    mStates[ 2 ] = oCom_0843_0846;
    mStates[ 3 ] = oLea_0843_0873;
    mStates[ 4 ] = oLea_0843_0874;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0843_0844.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> InitialState ) => ( PlayerClientPsm >> Idle )
  public void Tra_0843_0880( TsmHandler oHandler )
  {
    mCurrentState = oLea_0843_0873; // At: ( PlayerClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Active >> Starting )
  public void Tra_0843_0884( TsmHandler oHandler )
  {
    mCurrentState = oCom_0843_0846; // At: ( PlayerClientPsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> ChoiceState ) => ( PlayerClientPsm >> Idle )
  public void Tra_0843_0885( TsmHandler oHandler )
  {
    mCurrentState = oLea_0843_0873; // At: ( PlayerClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )
  public void Tra_0843_0882( TsmHandler oHandler )
  {
    ((Cla_0801_0840)oHandler.Owner).Function_1160( oHandler );
    mCurrentState = oLea_0843_0874; // At: ( PlayerClientPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )
  public void Tra_0843_0881( TsmHandler oHandler )
  {
    ((Cla_0801_0840)oHandler.Owner).Function_1163( oHandler );
    mCurrentState = oCho_0843_0845; // At: ( PlayerClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerClientPsm >> Stopping ) => ( PlayerClientPsm >> Idle )
  public void Tra_0843_0883( TsmHandler oHandler )
  {
    mCurrentState = oLea_0843_0873; // At: ( PlayerClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 882:
        return TsmProspect.OK;
      case 858:
        return TsmProspect.OK;
      case 866:
        return TsmProspect.OK;
      case 881:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 841:
      switch ( Command )
      {
      case 44:
        return TsmProspect.OK;
      case 45:
        return TsmProspect.OK;
      case 46:
        return TsmProspect.OK;
      case 47:
        return TsmProspect.OK;
      case 48:
        return TsmProspect.OK;
      case 49:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 880:
      Tra_0843_0880( oHandler );
      break;
    case 884:
      Tra_0843_0884( oHandler );
      break;
    case 885:
      Tra_0843_0885( oHandler );
      break;
    case 882:
      Tra_0843_0882( oHandler );
      break;
    case 881:
      Tra_0843_0881( oHandler );
      break;
    case 883:
      Tra_0843_0883( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm )
class Fsm_0840_0842 extends TsmFsm
{
  private Reg_0842_0843 oReg_0842_0843; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm >)

  public Fsm_0840_0842( TsmBase oParent )
  {
    TsmName = "PlayerClientPsm";
    TsmParent = oParent;
    oReg_0842_0843 = new Reg_0842_0843( this );
    mRegions.add( oReg_0842_0843 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )
class Cla_0801_0840 extends TsmProtocolClass
{
  private Fsm_0840_0842 oFsm_0840_0842; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > PlayerClientPsm )
  private TsmIPort_IPlayerServer Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
  private TsmIPort_IPlayerClient TsmPI__Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > Port )
  private TsmPCPort mPCMessager;
  private eRV RV = eRV.OK;
  private String TitleId = null;
  private tTime AtTime = null;

  public Cla_0801_0840( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0840_0842 = new Fsm_0840_0842( this );
    TsmPI__Port = new TsmIPort_IPlayerClient( this );
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0840_0842;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IPlayerServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0840_0842.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1070()
  {
    return RV==eRV.OK;
  }

  public boolean Guard_1071()
  {
    return RV==eRV.OK;
  }

  public boolean Guard_1072()
  {
    return RV==eRV.OK;
  }

   // ( PlayerClientPsm >> Active ) => ( PlayerClientPsm >> Stopping )
  public void Function_1160( TsmHandler oHandler )
  {
    Port.Stop();
  }

   // ( PlayerClientPsm >> Active >> Running >> Busy >> Play ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  public void Function_1161( TsmHandler oHandler )
  {
    RV=Port.Pause();
  }

   // ( PlayerClientPsm >> Active >> Running >> Paused ) => ( PlayerClientPsm >> Active >> Running >> Busy >> ChoiceState )
  public void Function_1162( TsmHandler oHandler )
  {
    RV=Port.Continue();
  }

   // ( PlayerClientPsm >> Idle ) => ( PlayerClientPsm >> ChoiceState )
  public void Function_1163( TsmHandler oHandler )
  {
    RV=Port.Start(TitleId,AtTime);
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 841;
    TsmPI__Port.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0840_0842.ExecuteHandler( lHandler );
  }
}

 // ( Xmi > Data > Architecture > ExEnv > UserMock )
class Com_0793_0007 extends TsmPComponent
{
  private Cla_0801_0840 InsPlayerClient; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerClient > InsPlayerClient )

  public Com_0793_0007( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    InsPlayerClient = new Cla_0801_0840( this, "InsPlayerClient" );
    InsPlayerClient.IsMock = true;
    mNrClasses = 1;
    mClasses = new TsmClass[ 1 ];
    mClasses[ 0 ] = InsPlayerClient;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "rp_player" ) )
    {
      return InsPlayerClient.GetProvidedInterface( "Port" );
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > UserMock )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "rp_player" ) )
    {
      InsPlayerClient.SetRequiredInterface( "Port", oProvidedInterface );
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Architecture > ExEnv > UserMock )";
    throw new TsmException( s );
  }
}

 // ( Xmi > Data > Architecture > ExEnv )
class Com_0792_0793 extends TsmPComponent
{
  private Com_0011_0012 Player; // ( Xmi > Data > Architecture > ExEnv > Player )
  private Com_0793_0001 ReaderMock; // ( Xmi > Data > Architecture > ExEnv > ReaderMock )
  private Com_0793_0003 TitlebaseMock; // ( Xmi > Data > Architecture > ExEnv > TitlebaseMock )
  private Com_0793_0005 DisplayMock; // ( Xmi > Data > Architecture > ExEnv > DisplayMock )
  private Com_0793_0007 UserMock; // ( Xmi > Data > Architecture > ExEnv > UserMock )

  public Com_0792_0793( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    Player = new Com_0011_0012( this, "Player" );
    ReaderMock = new Com_0793_0001( this, "ReaderMock" );
    TitlebaseMock = new Com_0793_0003( this, "TitlebaseMock" );
    DisplayMock = new Com_0793_0005( this, "DisplayMock" );
    UserMock = new Com_0793_0007( this, "UserMock" );
    mNrComponents = 5;
    mComponents = new TsmComponent[ 5 ];
    mComponents[ 0 ] = Player;
    mComponents[ 1 ] = ReaderMock;
    mComponents[ 2 ] = TitlebaseMock;
    mComponents[ 3 ] = DisplayMock;
    mComponents[ 4 ] = UserMock;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    DoAssembly( Player, "dd_rp_reader", ReaderMock, "pp_reader" );
    DoAssembly( ReaderMock, "pp_reader", Player, "dd_rp_reader" );
    DoAssembly( Player, "dd_rp_titlebase", TitlebaseMock, "pp_titlebase" );
    DoAssembly( UserMock, "rp_player", Player, "dd_pp_player" );
    DoAssembly( Player, "dd_pp_player", UserMock, "rp_player" );
    DoAssembly( Player, "dd_rp_display", DisplayMock, "pp_display" );
    DoAssembly( DisplayMock, "pp_display", Player, "dd_rp_display" );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
 ********************************************************************/

 // ( Xmi > Data > Architecture > Sequence Diagrams )
class Pac_0792_0799 extends TsmPackage
{
  public Pac_0792_0799( TsmBase oParent )
  {
    TsmName = "Sequence Diagrams";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Architecture )
 ********************************************************************/

 // ( Xmi > Data > Architecture )
class Pac_0001_0792 extends TsmPackage
{
  public Pac_0001_0792( TsmBase oParent )
  {
    TsmName = "Architecture";
    TsmParent = oParent;
  }
}

interface IPlayerServer
{
  public eRV Start( String TitleId, tTime AtTime );
  public eRV Pause();
  public eRV Continue();
  public void Stop();
}

class TsmTrigger_IPlayerServer___Start extends TsmTrigger
{
  public String TitleId;
  public tTime AtTime;
  public eRV _RetVal;

  public TsmTrigger_IPlayerServer___Start( String TitleId, tTime AtTime )
  {
    super( 14 );
    this.TitleId = TitleId;
    this.AtTime = AtTime;
  }
}

class TsmTrigger_IPlayerServer___Pause extends TsmTrigger
{
  public eRV _RetVal;

  public TsmTrigger_IPlayerServer___Pause()
  {
    super( 15 );
  }
}

class TsmTrigger_IPlayerServer___Continue extends TsmTrigger
{
  public eRV _RetVal;

  public TsmTrigger_IPlayerServer___Continue()
  {
    super( 16 );
  }
}

class TsmTrigger_IPlayerServer___Stop extends TsmTrigger
{
  public TsmTrigger_IPlayerServer___Stop()
  {
    super( 17 );
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > IPlayerServer )
class TsmIPort_IPlayerServer extends TsmInterfacePort implements IPlayerServer
{
  public TsmIPort_IPlayerServer( TsmBase oParent )
  {
    TsmName = "IPlayerServer";
    TsmParent = oParent;
  }

  public eRV Start( String TitleId, tTime AtTime )
  {
    TsmTrigger_IPlayerServer___Start tt = new TsmTrigger_IPlayerServer___Start( TitleId, AtTime );
    TsmRecorder.AddCall( "Start", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public eRV Pause()
  {
    TsmTrigger_IPlayerServer___Pause tt = new TsmTrigger_IPlayerServer___Pause();
    TsmRecorder.AddCall( "Pause", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public eRV Continue()
  {
    TsmTrigger_IPlayerServer___Continue tt = new TsmTrigger_IPlayerServer___Continue();
    TsmRecorder.AddCall( "Continue", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Stop()
  {
    TsmTrigger_IPlayerServer___Stop tt = new TsmTrigger_IPlayerServer___Stop();
    TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

interface IPlayerClient
{
  public void CbStarted();
  public void CbPaused();
  public void CbContinued();
  public void CbStopped();
  public void CbFinish();
  public void CbError();
}

class TsmTrigger_IPlayerClient___CbStarted extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbStarted()
  {
    super( 44 );
  }
}

class TsmTrigger_IPlayerClient___CbPaused extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbPaused()
  {
    super( 45 );
  }
}

class TsmTrigger_IPlayerClient___CbContinued extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbContinued()
  {
    super( 46 );
  }
}

class TsmTrigger_IPlayerClient___CbStopped extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbStopped()
  {
    super( 47 );
  }
}

class TsmTrigger_IPlayerClient___CbFinish extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbFinish()
  {
    super( 48 );
  }
}

class TsmTrigger_IPlayerClient___CbError extends TsmTrigger
{
  public TsmTrigger_IPlayerClient___CbError()
  {
    super( 49 );
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > IPlayerClient )
class TsmIPort_IPlayerClient extends TsmInterfacePort implements IPlayerClient
{
  public TsmIPort_IPlayerClient( TsmBase oParent )
  {
    TsmName = "IPlayerClient";
    TsmParent = oParent;
  }

  public void CbStarted()
  {
    TsmTrigger_IPlayerClient___CbStarted tt = new TsmTrigger_IPlayerClient___CbStarted();
    TsmRecorder.AddCall( "CbStarted", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbPaused()
  {
    TsmTrigger_IPlayerClient___CbPaused tt = new TsmTrigger_IPlayerClient___CbPaused();
    TsmRecorder.AddCall( "CbPaused", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbContinued()
  {
    TsmTrigger_IPlayerClient___CbContinued tt = new TsmTrigger_IPlayerClient___CbContinued();
    TsmRecorder.AddCall( "CbContinued", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbStopped()
  {
    TsmTrigger_IPlayerClient___CbStopped tt = new TsmTrigger_IPlayerClient___CbStopped();
    TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbFinish()
  {
    TsmTrigger_IPlayerClient___CbFinish tt = new TsmTrigger_IPlayerClient___CbFinish();
    TsmRecorder.AddCall( "CbFinish", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbError()
  {
    TsmTrigger_IPlayerClient___CbError tt = new TsmTrigger_IPlayerClient___CbError();
    TsmRecorder.AddCall( "CbError", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> InitialState )
class Ini_0805_0806 extends TsmPseudo
{
  public Ini_0805_0806( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 834, "( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 834; // TRLS ( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 834: // UP: ( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> ChoiceState )
class Cho_0805_0807 extends TsmPseudo
{
  private int MaxNrChoices = 2;

  public Cho_0805_0807( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 838, "( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )" );
    mTransitions[ 1 ] = new TsmTransition( 839, "( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, 1, "ok" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 838; // TRLS ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    if ( TsmSupervisor.ChoiceOK( MaxNrChoices, MaxNrChoices, "else" ) )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 839; // TRLS ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0805_0835( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 838: // UP: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
      bHigher = true;
      break;
    case 839: // UP: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
      bHigher = true;
      break;
    case 835:
      Tra_0805_0835( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
class Lea_0813_0814 extends TsmLeaf
{
  int [] aNatives = { 817 };

  public Lea_0813_0814( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 817, "( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0813_0818( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 817:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 817: // Native: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused ) # CbPaused();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 817;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 817: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 818:
      Tra_0813_0818( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Play )
class Lea_0813_0815 extends TsmLeaf
{
  public Lea_0813_0815( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 818, "( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0813_0819( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0809_0828( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 818; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 15: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 819:
      Tra_0813_0819( oHandler );
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    case 818: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
class Lea_0813_0816 extends TsmLeaf
{
  int [] aNatives = { 819 };

  public Lea_0813_0816( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 819, "( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0811_0822( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 819:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 819: // Native: ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) # CbContinued();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 819;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 819: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 822:
      Tra_0811_0822( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >)
class Reg_0812_0813 extends TsmRegion
{
  private Lea_0813_0814 oLea_0813_0814; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
  private Lea_0813_0815 oLea_0813_0815; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Play )
  private Lea_0813_0816 oLea_0813_0816; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >> Continuing )

  public Reg_0812_0813( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oLea_0813_0814 = new Lea_0813_0814( this );
    oLea_0813_0815 = new Lea_0813_0815( this );
    oLea_0813_0816 = new Lea_0813_0816( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oLea_0813_0814;
    mStates[ 1 ] = oLea_0813_0815;
    mStates[ 2 ] = oLea_0813_0816;
  }

   // At: ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0813_0819( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1156( oHandler );
    mCurrentState = oLea_0813_0815; // At: ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0809_0828( TsmHandler oHandler )
  {
    mCurrentState = oLea_0813_0815; // Down: ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
  public void Tra_0813_0818( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1320( oHandler );
    mCurrentState = oLea_0813_0814; // At: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
  public void Tra_0811_0822( TsmHandler oHandler )
  {
    mCurrentState = oLea_0813_0816; // Down: ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 817:
        return TsmProspect.OK;
      case 819:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 817: // Up: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 819:
      Tra_0813_0819( oHandler );
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    case 818:
      Tra_0813_0818( oHandler );
      break;
    case 822:
      Tra_0811_0822( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy )
class Com_0811_0812 extends TsmCompound
{
  int [] aNatives = { 821 };
  private Reg_0812_0813 oReg_0812_0813; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy >)

  public Com_0811_0812( TsmBase oParent )
  {
    TsmName = "Busy";
    TsmParent = oParent;
    oReg_0812_0813 = new Reg_0812_0813( this );
    mRegions.add( oReg_0812_0813 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 821, "( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )" );
  }

  public void Tra_0809_0828( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0812_0813.ExecuteHandler( oHandler );
  }

  public void Tra_0811_0822( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0812_0813.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 821:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 821: // Native: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing ) # CbFinish();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 821;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 821: // UP: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 817: // UP: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    case 822:
      Tra_0811_0822( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Paused )
class Lea_0811_0820 extends TsmLeaf
{
  public Lea_0811_0820( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 822, "( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) : Continue" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0813_0817( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 822; // Continue
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 16: // Port___Continue
        {
          Port___Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 817:
      Tra_0813_0817( oHandler );
      break;
    case 822: // UP: ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >)
class Reg_0810_0811 extends TsmRegion
{
  private Com_0811_0812 oCom_0811_0812; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Busy )
  private Lea_0811_0820 oLea_0811_0820; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >> Paused )

  public Reg_0810_0811( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCom_0811_0812 = new Com_0811_0812( this );
    oLea_0811_0820 = new Lea_0811_0820( this );
    mNrStates = 2;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCom_0811_0812;
    mStates[ 1 ] = oLea_0811_0820;
  }

   // At: ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
  public void Tra_0813_0817( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1155( oHandler );
    mCurrentState = oLea_0811_0820; // At: ( PlayerServerPsm >> Active >> Running >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0809_0828( TsmHandler oHandler )
  {
    mCurrentState = oCom_0811_0812; // Down: ( PlayerServerPsm >> Active >> Running >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
  public void Tra_0811_0822( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1326( oHandler );
    mCurrentState = oCom_0811_0812; // At: ( PlayerServerPsm >> Active >> Running >> Busy )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 821:
        return TsmProspect.OK;
      case 817:
        return TsmProspect.OK;
      case 819:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 821: // Up: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
      mCurrentState = null;
      bHigher = true;
      break;
    case 817:
      Tra_0813_0817( oHandler );
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    case 822:
      Tra_0811_0822( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running )
class Com_0809_0810 extends TsmCompound
{
  int [] aNatives = { 829 };
  private Reg_0810_0811 oReg_0810_0811; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running >)

  public Com_0809_0810( TsmBase oParent )
  {
    TsmName = "Running";
    TsmParent = oParent;
    oReg_0810_0811 = new Reg_0810_0811( this );
    mRegions.add( oReg_0810_0811 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 829, "( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )" );
  }

  public void Tra_0809_0828( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0810_0811.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 829:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 829: // Native: ( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error ) # CbError();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 829;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 829: // UP: ( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 821: // UP: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Finishing )
class Lea_0809_0823 extends TsmLeaf
{
  public Lea_0809_0823( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 831, "( PlayerServerPsm >> Active >> Finishing ) => ( PlayerServerPsm >> Active >> Finishing ) : Pause" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0811_0821( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0809_0831( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1322( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 831; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 15: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 821:
      Tra_0811_0821( oHandler );
      break;
    case 831:
      Tra_0809_0831( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Starting )
class Lea_0809_0824 extends TsmLeaf
{
  int [] aNatives = { 828, 830 };

  public Lea_0809_0824( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 828, "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 830, "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )" );
  }

  public void Tra_0805_0838( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 828:
        return TsmProspect.OK;
      case 830:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 828: // Native: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) # CbStarted();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 828;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 830: // Native: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error ) # CbError();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 830;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 838:
      Tra_0805_0838( oHandler );
      break;
    case 828: // UP: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 830: // UP: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Error )
class Lea_0809_0825 extends TsmLeaf
{
  public Lea_0809_0825( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 827, "( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error ) : Pause" );
    mTransitions[ 1 ] = new TsmTransition( 826, "( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error ) : Continue" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0809_0829( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0809_0830( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0809_0827( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1324( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Pause( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 827; // Pause
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0809_0826( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1328( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___Continue( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 826; // Continue
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 15: // Port___Pause
        {
          Port___Pause( oHandler );
        }
        break;
      case 16: // Port___Continue
        {
          Port___Continue( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 829:
      Tra_0809_0829( oHandler );
      break;
    case 830:
      Tra_0809_0830( oHandler );
      break;
    case 827:
      Tra_0809_0827( oHandler );
      break;
    case 826:
      Tra_0809_0826( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >)
class Reg_0808_0809 extends TsmRegion
{
  private Com_0809_0810 oCom_0809_0810; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Running )
  private Lea_0809_0823 oLea_0809_0823; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Finishing )
  private Lea_0809_0824 oLea_0809_0824; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Starting )
  private Lea_0809_0825 oLea_0809_0825; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >> Error )

  public Reg_0808_0809( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCom_0809_0810 = new Com_0809_0810( this );
    oLea_0809_0823 = new Lea_0809_0823( this );
    oLea_0809_0824 = new Lea_0809_0824( this );
    oLea_0809_0825 = new Lea_0809_0825( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCom_0809_0810;
    mStates[ 1 ] = oLea_0809_0823;
    mStates[ 2 ] = oLea_0809_0824;
    mStates[ 3 ] = oLea_0809_0825;
  }

   // Down: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
  public void Tra_0805_0838( TsmHandler oHandler )
  {
    mCurrentState = oLea_0809_0824; // Down: ( PlayerServerPsm >> Active >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )
  public void Tra_0809_0829( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1153( oHandler );
    mCurrentState = oLea_0809_0825; // At: ( PlayerServerPsm >> Active >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
  public void Tra_0811_0821( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1154( oHandler );
    mCurrentState = oLea_0809_0823; // At: ( PlayerServerPsm >> Active >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Tra_0809_0828( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1157( oHandler );
    mCurrentState = oCom_0809_0810; // At: ( PlayerServerPsm >> Active >> Running )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )
  public void Tra_0809_0830( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1158( oHandler );
    mCurrentState = oLea_0809_0825; // At: ( PlayerServerPsm >> Active >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 829:
        return TsmProspect.OK;
      case 821:
        return TsmProspect.OK;
      case 817:
        return TsmProspect.OK;
      case 819:
        return TsmProspect.OK;
      case 828:
        return TsmProspect.OK;
      case 830:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 803:
      switch ( Command )
      {
      case 15:
        return TsmProspect.OK;
      case 16:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 838:
      Tra_0805_0838( oHandler );
      break;
    case 829:
      Tra_0809_0829( oHandler );
      break;
    case 821:
      Tra_0811_0821( oHandler );
      break;
    case 828:
      Tra_0809_0828( oHandler );
      break;
    case 830:
      Tra_0809_0830( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active )
class Com_0805_0808 extends TsmCompound
{
  private Reg_0808_0809 oReg_0808_0809; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active >)

  public Com_0805_0808( TsmBase oParent )
  {
    TsmName = "Active";
    TsmParent = oParent;
    oReg_0808_0809 = new Reg_0808_0809( this );
    mRegions.add( oReg_0808_0809 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 836, "( PlayerServerPsm >> Active ) => ( PlayerServerPsm >> Stopping ) : Stop" );
  }

  public void Tra_0805_0838( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0808_0809.ExecuteHandler( oHandler );
  }

  public void Port___Stop( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 836; // Stop
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 17:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 17: // Port___Stop
        {
          Port___Stop( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 838:
      Tra_0805_0838( oHandler );
      break;
    case 836: // UP: ( PlayerServerPsm >> Active ) => ( PlayerServerPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Idle )
class Lea_0805_0832 extends TsmLeaf
{
  public Lea_0805_0832( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 835, "( PlayerServerPsm >> Idle ) => ( PlayerServerPsm >> ChoiceState ) : Start" );
  }

  public void Tra_0805_0834( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0805_0839( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0805_0837( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___Start( String TitleId, tTime AtTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 835; // Start
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 803:
      switch ( Command )
      {
      case 14:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 803: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 14: // Port___Start
        {
          TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;

          Port___Start( lTrigger.TitleId, lTrigger.AtTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 834:
      Tra_0805_0834( oHandler );
      break;
    case 839:
      Tra_0805_0839( oHandler );
      break;
    case 837:
      Tra_0805_0837( oHandler );
      break;
    case 835: // UP: ( PlayerServerPsm >> Idle ) => ( PlayerServerPsm >> ChoiceState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Stopping )
class Lea_0805_0833 extends TsmLeaf
{
  int [] aNatives = { 837 };

  public Lea_0805_0833( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 837, "( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0805_0836( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 837:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 837: // Native: ( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )
        TsmRecorder.AddNative( "( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle ) # CbStopped();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 837;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 837: // UP: ( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 836:
      Tra_0805_0836( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >)
class Reg_0804_0805 extends TsmRegion
{
  private Ini_0805_0806 oIni_0805_0806; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> InitialState )
  private Cho_0805_0807 oCho_0805_0807; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> ChoiceState )
  private Com_0805_0808 oCom_0805_0808; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Active )
  private Lea_0805_0832 oLea_0805_0832; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Idle )
  private Lea_0805_0833 oLea_0805_0833; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >> Stopping )

  public Reg_0804_0805( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0805_0806 = new Ini_0805_0806( this );
    oCho_0805_0807 = new Cho_0805_0807( this );
    oCom_0805_0808 = new Com_0805_0808( this );
    oLea_0805_0832 = new Lea_0805_0832( this );
    oLea_0805_0833 = new Lea_0805_0833( this );
    mNrStates = 5;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0805_0806;
    mStates[ 1 ] = oCho_0805_0807;
    mStates[ 2 ] = oCom_0805_0808;
    mStates[ 3 ] = oLea_0805_0832;
    mStates[ 4 ] = oLea_0805_0833;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0805_0806.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> InitialState ) => ( PlayerServerPsm >> Idle )
  public void Tra_0805_0834( TsmHandler oHandler )
  {
    mCurrentState = oLea_0805_0832; // At: ( PlayerServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
  public void Tra_0805_0838( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1067( oHandler );
    mCurrentState = oCom_0805_0808; // At: ( PlayerServerPsm >> Active )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
  public void Tra_0805_0839( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1069( oHandler );
    mCurrentState = oLea_0805_0832; // At: ( PlayerServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )
  public void Tra_0805_0837( TsmHandler oHandler )
  {
    ((Cla_0801_0802)oHandler.Owner).Function_1159( oHandler );
    mCurrentState = oLea_0805_0832; // At: ( PlayerServerPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Idle ) => ( PlayerServerPsm >> ChoiceState )
  public void Tra_0805_0835( TsmHandler oHandler )
  {
    mCurrentState = oCho_0805_0807; // At: ( PlayerServerPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( PlayerServerPsm >> Active ) => ( PlayerServerPsm >> Stopping )
  public void Tra_0805_0836( TsmHandler oHandler )
  {
    mCurrentState = oLea_0805_0833; // At: ( PlayerServerPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 829:
        return TsmProspect.OK;
      case 821:
        return TsmProspect.OK;
      case 817:
        return TsmProspect.OK;
      case 819:
        return TsmProspect.OK;
      case 828:
        return TsmProspect.OK;
      case 830:
        return TsmProspect.OK;
      case 837:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 803:
      switch ( Command )
      {
      case 14:
        return TsmProspect.OK;
      case 15:
        return TsmProspect.OK;
      case 16:
        return TsmProspect.OK;
      case 17:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 834:
      Tra_0805_0834( oHandler );
      break;
    case 838:
      Tra_0805_0838( oHandler );
      break;
    case 839:
      Tra_0805_0839( oHandler );
      break;
    case 837:
      Tra_0805_0837( oHandler );
      break;
    case 835:
      Tra_0805_0835( oHandler );
      break;
    case 836:
      Tra_0805_0836( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm )
class Fsm_0802_0804 extends TsmFsm
{
  private Reg_0804_0805 oReg_0804_0805; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm >)

  public Fsm_0802_0804( TsmBase oParent )
  {
    TsmName = "PlayerServerPsm";
    TsmParent = oParent;
    oReg_0804_0805 = new Reg_0804_0805( this );
    mRegions.add( oReg_0804_0805 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )
class Cla_0801_0802 extends TsmProtocolClass
{
  private Fsm_0802_0804 oFsm_0802_0804; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > PlayerServerPsm )
  private TsmIPort_IPlayerServer TsmPI__Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
  private TsmIPort_IPlayerClient Port; // ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer > Port )
  private TsmPSPort mPSMessager;

  public Cla_0801_0802( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0802_0804 = new Fsm_0802_0804( this );
    TsmPI__Port = new TsmIPort_IPlayerServer( this );
    mPSMessager = new TsmPSPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0802_0804;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IPlayerClient) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > PlayerProtocol > PlayerServer )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0802_0804.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

   // ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
  public eRV Function_1066( String TitleId, tTime AtTime )
  {
    return eRV.OK;
  }

   // ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Active >> Starting )
  public void Function_1067( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1066( TitleId, AtTime );
  }

   // ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
  public eRV Function_1068( String TitleId, tTime AtTime )
  {
    return
    eRV.INVALID_PARAM;
  }

   // ( PlayerServerPsm >> ChoiceState ) => ( PlayerServerPsm >> Idle )
  public void Function_1069( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Start lTrigger = (TsmTrigger_IPlayerServer___Start) oHandler.Trigger;
    String TitleId = lTrigger.TitleId;
    tTime AtTime = lTrigger.AtTime;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1068( TitleId, AtTime );
  }

   // ( PlayerServerPsm >> Active >> Running ) => ( PlayerServerPsm >> Active >> Error )
  public void Function_1153( TsmHandler oHandler )
  {
    Port.CbError();
  }

   // ( PlayerServerPsm >> Active >> Running >> Busy ) => ( PlayerServerPsm >> Active >> Finishing )
  public void Function_1154( TsmHandler oHandler )
  {
    Port.CbFinish();
  }

   // ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing ) => ( PlayerServerPsm >> Active >> Running >> Paused )
  public void Function_1155( TsmHandler oHandler )
  {
    Port.CbPaused();
  }

   // ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Function_1156( TsmHandler oHandler )
  {
    Port.CbContinued();
  }

   // ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Play )
  public void Function_1157( TsmHandler oHandler )
  {
    Port.CbStarted();
  }

   // ( PlayerServerPsm >> Active >> Starting ) => ( PlayerServerPsm >> Active >> Error )
  public void Function_1158( TsmHandler oHandler )
  {
    Port.CbError();
  }

   // ( PlayerServerPsm >> Stopping ) => ( PlayerServerPsm >> Idle )
  public void Function_1159( TsmHandler oHandler )
  {
    Port.CbStopped();
  }

   // ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
  public eRV Function_1319()
  {
    return eRV.OK;
  }

   // ( PlayerServerPsm >> Active >> Running >> Busy >> Play ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Pausing )
  public void Function_1320( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1319();
  }

   // ( PlayerServerPsm >> Active >> Finishing ) => ( PlayerServerPsm >> Active >> Finishing )
  public eRV Function_1321()
  {
    return eRV.OK_RACE;
  }

   // ( PlayerServerPsm >> Active >> Finishing ) => ( PlayerServerPsm >> Active >> Finishing )
  public void Function_1322( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1321();
  }

   // ( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error )
  public eRV Function_1323()
  {
    return eRV.OK_RACE;
  }

   // ( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error )
  public void Function_1324( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Pause lTrigger = (TsmTrigger_IPlayerServer___Pause) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1323();
  }

   // ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
  public eRV Function_1325()
  {
    return eRV.OK;
  }

   // ( PlayerServerPsm >> Active >> Running >> Paused ) => ( PlayerServerPsm >> Active >> Running >> Busy >> Continuing )
  public void Function_1326( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Continue lTrigger = (TsmTrigger_IPlayerServer___Continue) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1325();
  }

   // ( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error )
  public eRV Function_1327()
  {
    return eRV.OK_RACE;
  }

   // ( PlayerServerPsm >> Active >> Error ) => ( PlayerServerPsm >> Active >> Error )
  public void Function_1328( TsmHandler oHandler )
  {
    TsmTrigger_IPlayerServer___Continue lTrigger = (TsmTrigger_IPlayerServer___Continue) oHandler.Trigger;

    lTrigger._RetVal = ((Cla_0801_0802)oHandler.Owner).Function_1327();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 803;
    TsmPI__Port.Messager = mPSMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPSMessager.Target = this;
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0802_0804.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > PlayerProtocol )
 ********************************************************************/

 // ( Xmi > Data > Protocols > PlayerProtocol )
class Pac_0800_0801 extends TsmPackage
{
  public Pac_0800_0801( TsmBase oParent )
  {
    TsmName = "PlayerProtocol";
    TsmParent = oParent;
  }
}

interface IReaderServer
{
  public void Close();
  public void Stop();
  public eRV Open( int FileHandle );
  public eRV Read( tChunk Chunk );
  public void Clear();
}

class TsmTrigger_IReaderServer___Close extends TsmTrigger
{
  public TsmTrigger_IReaderServer___Close()
  {
    super( 50 );
  }
}

class TsmTrigger_IReaderServer___Stop extends TsmTrigger
{
  public TsmTrigger_IReaderServer___Stop()
  {
    super( 51 );
  }
}

class TsmTrigger_IReaderServer___Open extends TsmTrigger
{
  public int FileHandle;
  public eRV _RetVal;

  public TsmTrigger_IReaderServer___Open( int FileHandle )
  {
    super( 52 );
    this.FileHandle = FileHandle;
  }
}

class TsmTrigger_IReaderServer___Read extends TsmTrigger
{
  public eRV _RetVal;
  public tChunk Chunk;

  public TsmTrigger_IReaderServer___Read( tChunk Chunk )
  {
    super( 53 );
    this.Chunk = Chunk;
  }
}

class TsmTrigger_IReaderServer___Clear extends TsmTrigger
{
  public TsmTrigger_IReaderServer___Clear()
  {
    super( 54 );
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > IReaderServer )
class TsmIPort_IReaderServer extends TsmInterfacePort implements IReaderServer
{
  public TsmIPort_IReaderServer( TsmBase oParent )
  {
    TsmName = "IReaderServer";
    TsmParent = oParent;
  }

  public void Close()
  {
    TsmTrigger_IReaderServer___Close tt = new TsmTrigger_IReaderServer___Close();
    TsmRecorder.AddCall( "Close", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Stop()
  {
    TsmTrigger_IReaderServer___Stop tt = new TsmTrigger_IReaderServer___Stop();
    TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV Open( int FileHandle )
  {
    TsmTrigger_IReaderServer___Open tt = new TsmTrigger_IReaderServer___Open( FileHandle );
    TsmRecorder.AddCall( "Open", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public eRV Read( tChunk Chunk )
  {
    TsmTrigger_IReaderServer___Read tt = new TsmTrigger_IReaderServer___Read( Chunk );
    TsmRecorder.AddCall( "Read", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Clear()
  {
    TsmTrigger_IReaderServer___Clear tt = new TsmTrigger_IReaderServer___Clear();
    TsmRecorder.AddCall( "Clear", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

interface IReaderClient
{
  public void CbOpened();
  public void CbStopped();
  public void CbDone();
  public void CbError( int Sector );
  public void CbClosed();
  public void CbReading();
  public void CbFilled();
}

class TsmTrigger_IReaderClient___CbOpened extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbOpened()
  {
    super( 1 );
  }
}

class TsmTrigger_IReaderClient___CbStopped extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbStopped()
  {
    super( 2 );
  }
}

class TsmTrigger_IReaderClient___CbDone extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbDone()
  {
    super( 3 );
  }
}

class TsmTrigger_IReaderClient___CbError extends TsmTrigger
{
  public int Sector;

  public TsmTrigger_IReaderClient___CbError( int Sector )
  {
    super( 4 );
    this.Sector = Sector;
  }
}

class TsmTrigger_IReaderClient___CbClosed extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbClosed()
  {
    super( 5 );
  }
}

class TsmTrigger_IReaderClient___CbReading extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbReading()
  {
    super( 6 );
  }
}

class TsmTrigger_IReaderClient___CbFilled extends TsmTrigger
{
  public TsmTrigger_IReaderClient___CbFilled()
  {
    super( 7 );
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > IReaderClient )
class TsmIPort_IReaderClient extends TsmInterfacePort implements IReaderClient
{
  public TsmIPort_IReaderClient( TsmBase oParent )
  {
    TsmName = "IReaderClient";
    TsmParent = oParent;
  }

  public void CbOpened()
  {
    TsmTrigger_IReaderClient___CbOpened tt = new TsmTrigger_IReaderClient___CbOpened();
    TsmRecorder.AddCall( "CbOpened", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbStopped()
  {
    TsmTrigger_IReaderClient___CbStopped tt = new TsmTrigger_IReaderClient___CbStopped();
    TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbDone()
  {
    TsmTrigger_IReaderClient___CbDone tt = new TsmTrigger_IReaderClient___CbDone();
    TsmRecorder.AddCall( "CbDone", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbError( int Sector )
  {
    TsmTrigger_IReaderClient___CbError tt = new TsmTrigger_IReaderClient___CbError( Sector );
    TsmRecorder.AddCall( "CbError", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbClosed()
  {
    TsmTrigger_IReaderClient___CbClosed tt = new TsmTrigger_IReaderClient___CbClosed();
    TsmRecorder.AddCall( "CbClosed", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbReading()
  {
    TsmTrigger_IReaderClient___CbReading tt = new TsmTrigger_IReaderClient___CbReading();
    TsmRecorder.AddCall( "CbReading", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbFilled()
  {
    TsmTrigger_IReaderClient___CbFilled tt = new TsmTrigger_IReaderClient___CbFilled();
    TsmRecorder.AddCall( "CbFilled", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> InitialState )
class Ini_0929_0930 extends TsmPseudo
{
  public Ini_0929_0930( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 956, "( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 956; // TRLS ( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 956: // UP: ( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> ChoiceState )
class Cho_0929_0931 extends TsmPseudo
{
  public Cho_0929_0931( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 962, "( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )" );
    mTransitions[ 1 ] = new TsmTransition( 963, "( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0886_0926)oHandler.Owner).Guard_1081() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 962; // TRLS ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 963; // TRLS ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0929_0961( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 962: // UP: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )
      bHigher = true;
      break;
    case 963: // UP: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )
      bHigher = true;
      break;
    case 961:
      Tra_0929_0961( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> ChoiceState )
class Cho_0933_0934 extends TsmPseudo
{
  public Cho_0933_0934( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 949, "( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )" );
    mTransitions[ 1 ] = new TsmTransition( 950, "( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0886_0926)oHandler.Owner).Guard_1082() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 949; // TRLS ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 950; // TRLS ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_0933_0948( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 949: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
      bHigher = true;
      break;
    case 950: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )
      bHigher = true;
      break;
    case 948:
      Tra_0933_0948( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> InitialState )
class Ini_0936_0937 extends TsmPseudo
{
  public Ini_0936_0937( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 940, "( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 940; // TRLS ( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 940: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> Enough )
class Lea_0936_0938 extends TsmLeaf
{
  public Lea_0936_0938( TsmBase oParent )
  {
    TsmName = "Enough";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 946, "( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbDone" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 946; // CbDone
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0936_0941( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 3: // Port___CbDone
        {
          Port___CbDone( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 946: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 941:
      Tra_0936_0941( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
class Lea_0936_0939 extends TsmLeaf
{
  public Lea_0936_0939( TsmBase oParent )
  {
    TsmName = "NotEnough";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 941, "( ReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) : CbFilled" );
  }

  public void Tra_0936_0940( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 941; // CbFilled
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 7: // Port___CbFilled
        {
          Port___CbFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 940:
      Tra_0936_0940( oHandler );
      break;
    case 941: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderClientPsm >> CompoundState >> Reading >> Enough )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >)
class Reg_0935_0936 extends TsmRegion
{
  private Ini_0936_0937 oIni_0936_0937; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> InitialState )
  private Lea_0936_0938 oLea_0936_0938; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> Enough )
  private Lea_0936_0939 oLea_0936_0939; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >> NotEnough )

  public Reg_0935_0936( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0936_0937 = new Ini_0936_0937( this );
    oLea_0936_0938 = new Lea_0936_0938( this );
    oLea_0936_0939 = new Lea_0936_0939( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0936_0937;
    mStates[ 1 ] = oLea_0936_0938;
    mStates[ 2 ] = oLea_0936_0939;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0936_0937.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Reading >> InitialState ) => ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
  public void Tra_0936_0940( TsmHandler oHandler )
  {
    mCurrentState = oLea_0936_0939; // At: ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Reading >> NotEnough ) => ( ReaderClientPsm >> CompoundState >> Reading >> Enough )
  public void Tra_0936_0941( TsmHandler oHandler )
  {
    mCurrentState = oLea_0936_0938; // At: ( ReaderClientPsm >> CompoundState >> Reading >> Enough )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 940:
      Tra_0936_0940( oHandler );
      break;
    case 946: // Up: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
      mCurrentState = null;
      bHigher = true;
      break;
    case 941:
      Tra_0936_0941( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading )
class Com_0933_0935 extends TsmCompound
{
  private Reg_0935_0936 oReg_0935_0936; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading >)

  public Com_0933_0935( TsmBase oParent )
  {
    TsmName = "Reading";
    TsmParent = oParent;
    oReg_0935_0936 = new Reg_0935_0936( this );
    mRegions.add( oReg_0935_0936 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 947, "( ReaderClientPsm >> CompoundState >> Reading ) => ( ReaderClientPsm >> CompoundState >> Error ) : CbError" );
  }

  public void Port___CbError( int Sector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 947; // CbError
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0929_0967( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 4:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 4: // Port___CbError
        {
          TsmTrigger_IReaderClient___CbError lTrigger = (TsmTrigger_IReaderClient___CbError) oHandler.Trigger;

          Port___CbError( lTrigger.Sector, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 946: // UP: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 947: // UP: ( ReaderClientPsm >> CompoundState >> Reading ) => ( ReaderClientPsm >> CompoundState >> Error )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 967:
      Tra_0929_0967( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Open )
class Lea_0933_0942 extends TsmLeaf
{
  int [] aNatives = { -944, -945, -948 };

  public Lea_0933_0942( TsmBase oParent )
  {
    TsmName = "Open";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 944, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> Open )" );
    mTransitions[ 1 ] = new TsmTransition( 945, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )" );
    mTransitions[ 2 ] = new TsmTransition( 948, "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0933_0944( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0886_0926)oHandler.Owner).Function_1172( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Tra_0929_0957( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0929_0959( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0933_0946( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 944:
        return TsmProspect.OK;
      case 945:
        return TsmProspect.OK;
      case 948:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 944: // Native: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> Open )
        TsmRecorder.AddNative( "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> Open ) # Clear();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 944;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 945: // Native: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
        TsmRecorder.AddNative( "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing ) # Close();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 945;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      case 948: // Native: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState ) # RV=Read( Chunk );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 948;
        oHandler.bTaken = true;
        mTransitions[ 2 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 944:
      Tra_0933_0944( oHandler );
      break;
    case 945: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 948: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 957:
      Tra_0929_0957( oHandler );
      break;
    case 959:
      Tra_0929_0959( oHandler );
      break;
    case 946:
      Tra_0933_0946( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Error )
class Lea_0933_0943 extends TsmLeaf
{
  public Lea_0933_0943( TsmBase oParent )
  {
    TsmName = "Error";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  public void Tra_0933_0950( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0933_0947( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 950:
      Tra_0933_0950( oHandler );
      break;
    case 947:
      Tra_0933_0947( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >)
class Reg_0932_0933 extends TsmRegion
{
  private Cho_0933_0934 oCho_0933_0934; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> ChoiceState )
  private Com_0933_0935 oCom_0933_0935; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Reading )
  private Lea_0933_0942 oLea_0933_0942; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Open )
  private Lea_0933_0943 oLea_0933_0943; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >> Error )

  public Reg_0932_0933( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_0933_0934 = new Cho_0933_0934( this );
    oCom_0933_0935 = new Com_0933_0935( this );
    oLea_0933_0942 = new Lea_0933_0942( this );
    oLea_0933_0943 = new Lea_0933_0943( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_0933_0934;
    mStates[ 1 ] = oCom_0933_0935;
    mStates[ 2 ] = oLea_0933_0942;
    mStates[ 3 ] = oLea_0933_0943;
  }

   // At: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> CompoundState >> Error )
  public void Tra_0933_0950( TsmHandler oHandler )
  {
    mCurrentState = oLea_0933_0943; // At: ( ReaderClientPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )
  public void Tra_0933_0948( TsmHandler oHandler )
  {
    ((Cla_0886_0926)oHandler.Owner).Function_1174( oHandler );
    mCurrentState = oCho_0933_0934; // At: ( ReaderClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Tra_0929_0957( TsmHandler oHandler )
  {
    mCurrentState = oLea_0933_0942; // Down: ( ReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Tra_0929_0959( TsmHandler oHandler )
  {
    mCurrentState = oLea_0933_0942; // Down: ( ReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Reading >> Enough ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Tra_0933_0946( TsmHandler oHandler )
  {
    mCurrentState = oLea_0933_0942; // At: ( ReaderClientPsm >> CompoundState >> Open )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Reading ) => ( ReaderClientPsm >> CompoundState >> Error )
  public void Tra_0933_0947( TsmHandler oHandler )
  {
    mCurrentState = oLea_0933_0943; // At: ( ReaderClientPsm >> CompoundState >> Error )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading )
  public void Tra_0929_0967( TsmHandler oHandler )
  {
    mCurrentState = oCom_0933_0935; // Down: ( ReaderClientPsm >> CompoundState >> Reading )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 944:
        return TsmProspect.OK;
      case 945:
        return TsmProspect.OK;
      case 948:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 927:
      switch ( Command )
      {
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 949: // Up: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
      mCurrentState = null;
      bHigher = true;
      break;
    case 950:
      Tra_0933_0950( oHandler );
      break;
    case 945: // Up: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
      mCurrentState = null;
      bHigher = true;
      break;
    case 948:
      Tra_0933_0948( oHandler );
      break;
    case 957:
      Tra_0929_0957( oHandler );
      break;
    case 959:
      Tra_0929_0959( oHandler );
      break;
    case 946:
      Tra_0933_0946( oHandler );
      break;
    case 947:
      Tra_0933_0947( oHandler );
      break;
    case 967:
      Tra_0929_0967( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState )
class Com_0929_0932 extends TsmCompound
{
  int [] aNatives = { -958 };
  private Reg_0932_0933 oReg_0932_0933; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState >)

  public Com_0929_0932( TsmBase oParent )
  {
    TsmName = "CS_932";
    TsmParent = oParent;
    oReg_0932_0933 = new Reg_0932_0933( this );
    mRegions.add( oReg_0932_0933 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 958, "( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )" );
  }

  public void Tra_0929_0957( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0932_0933.ExecuteHandler( oHandler );
  }

  public void Tra_0929_0959( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0932_0933.ExecuteHandler( oHandler );
  }

  public void Tra_0929_0967( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_0932_0933.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 958:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 958: // Native: ( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )
        TsmRecorder.AddNative( "( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping ) # Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 958;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 949: // UP: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 958: // UP: ( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 945: // UP: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 957:
      Tra_0929_0957( oHandler );
      break;
    case 959:
      Tra_0929_0959( oHandler );
      break;
    case 967:
      Tra_0929_0967( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Idle )
class Lea_0929_0951 extends TsmLeaf
{
  int [] aNatives = { -961 };

  public Lea_0929_0951( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 961, "( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )" );
  }

  public void Tra_0929_0956( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_0929_0963( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0929_0960( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 961:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 961: // Native: ( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState ) # RV=Open( FileHandle );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 961;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 956:
      Tra_0929_0956( oHandler );
      break;
    case 963:
      Tra_0929_0963( oHandler );
      break;
    case 961: // UP: ( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 960:
      Tra_0929_0960( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Opening )
class Lea_0929_0952 extends TsmLeaf
{
  public Lea_0929_0952( TsmBase oParent )
  {
    TsmName = "Opening";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 957, "( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbOpened" );
  }

  public void Tra_0929_0962( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbOpened( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 957; // CbOpened
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 1:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 1: // Port___CbOpened
        {
          Port___CbOpened( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 962:
      Tra_0929_0962( oHandler );
      break;
    case 957: // UP: ( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Seeking )
class Lea_0929_0953 extends TsmLeaf
{
  public Lea_0929_0953( TsmBase oParent )
  {
    TsmName = "Seeking";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 967, "( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading ) : CbReading" );
  }

  public void Tra_0933_0949( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbReading( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 967; // CbReading
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 6:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 6: // Port___CbReading
        {
          Port___CbReading( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 949:
      Tra_0933_0949( oHandler );
      break;
    case 967: // UP: ( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Stopping )
class Lea_0929_0954 extends TsmLeaf
{
  public Lea_0929_0954( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 4;
    mTransitions = new TsmTransition[ 4 ];
    mTransitions[ 0 ] = new TsmTransition( 959, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open ) : CbStopped" );
    mTransitions[ 1 ] = new TsmTransition( 966, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbDone" );
    mTransitions[ 2 ] = new TsmTransition( 964, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbError" );
    mTransitions[ 3 ] = new TsmTransition( 965, "( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> Stopping ) : CbFilled" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0929_0958( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 959; // CbStopped
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_0929_0966( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbDone( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 966; // CbDone
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_0929_0964( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbError( int Sector, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 964; // CbError
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_0929_0965( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbFilled( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 965; // CbFilled
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 2:
        return TsmProspect.OK;
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 2: // Port___CbStopped
        {
          Port___CbStopped( oHandler );
        }
        break;
      case 3: // Port___CbDone
        {
          Port___CbDone( oHandler );
        }
        break;
      case 4: // Port___CbError
        {
          TsmTrigger_IReaderClient___CbError lTrigger = (TsmTrigger_IReaderClient___CbError) oHandler.Trigger;

          Port___CbError( lTrigger.Sector, oHandler );
        }
        break;
      case 7: // Port___CbFilled
        {
          Port___CbFilled( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 958:
      Tra_0929_0958( oHandler );
      break;
    case 959: // UP: ( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open )
      bHigher = true;
      break;
    case 966:
      Tra_0929_0966( oHandler );
      break;
    case 964:
      Tra_0929_0964( oHandler );
      break;
    case 965:
      Tra_0929_0965( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Closing )
class Lea_0929_0955 extends TsmLeaf
{
  public Lea_0929_0955( TsmBase oParent )
  {
    TsmName = "Closing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 960, "( ReaderClientPsm >> Closing ) => ( ReaderClientPsm >> Idle ) : CbClosed" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_0933_0945( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbClosed( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 960; // CbClosed
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 927:
      switch ( Command )
      {
      case 5:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 927: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 5: // Port___CbClosed
        {
          Port___CbClosed( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 945:
      Tra_0933_0945( oHandler );
      break;
    case 960: // UP: ( ReaderClientPsm >> Closing ) => ( ReaderClientPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >)
class Reg_0928_0929 extends TsmRegion
{
  private Ini_0929_0930 oIni_0929_0930; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> InitialState )
  private Cho_0929_0931 oCho_0929_0931; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> ChoiceState )
  private Com_0929_0932 oCom_0929_0932; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> CompoundState )
  private Lea_0929_0951 oLea_0929_0951; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Idle )
  private Lea_0929_0952 oLea_0929_0952; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Opening )
  private Lea_0929_0953 oLea_0929_0953; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Seeking )
  private Lea_0929_0954 oLea_0929_0954; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Stopping )
  private Lea_0929_0955 oLea_0929_0955; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >> Closing )

  public Reg_0928_0929( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_0929_0930 = new Ini_0929_0930( this );
    oCho_0929_0931 = new Cho_0929_0931( this );
    oCom_0929_0932 = new Com_0929_0932( this );
    oLea_0929_0951 = new Lea_0929_0951( this );
    oLea_0929_0952 = new Lea_0929_0952( this );
    oLea_0929_0953 = new Lea_0929_0953( this );
    oLea_0929_0954 = new Lea_0929_0954( this );
    oLea_0929_0955 = new Lea_0929_0955( this );
    mNrStates = 8;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_0929_0930;
    mStates[ 1 ] = oCho_0929_0931;
    mStates[ 2 ] = oCom_0929_0932;
    mStates[ 3 ] = oLea_0929_0951;
    mStates[ 4 ] = oLea_0929_0952;
    mStates[ 5 ] = oLea_0929_0953;
    mStates[ 6 ] = oLea_0929_0954;
    mStates[ 7 ] = oLea_0929_0955;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_0929_0930.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> InitialState ) => ( ReaderClientPsm >> Idle )
  public void Tra_0929_0956( TsmHandler oHandler )
  {
    mCurrentState = oLea_0929_0951; // At: ( ReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Opening )
  public void Tra_0929_0962( TsmHandler oHandler )
  {
    mCurrentState = oLea_0929_0952; // At: ( ReaderClientPsm >> Opening )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> ChoiceState ) => ( ReaderClientPsm >> Idle )
  public void Tra_0929_0963( TsmHandler oHandler )
  {
    mCurrentState = oLea_0929_0951; // At: ( ReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> ChoiceState ) => ( ReaderClientPsm >> Seeking )
  public void Tra_0933_0949( TsmHandler oHandler )
  {
    mCurrentState = oLea_0929_0953; // At: ( ReaderClientPsm >> Seeking )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )
  public void Tra_0929_0958( TsmHandler oHandler )
  {
    ((Cla_0886_0926)oHandler.Owner).Function_1171( oHandler );
    mCurrentState = oLea_0929_0954; // At: ( ReaderClientPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
  public void Tra_0933_0945( TsmHandler oHandler )
  {
    ((Cla_0886_0926)oHandler.Owner).Function_1173( oHandler );
    mCurrentState = oLea_0929_0955; // At: ( ReaderClientPsm >> Closing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )
  public void Tra_0929_0961( TsmHandler oHandler )
  {
    ((Cla_0886_0926)oHandler.Owner).Function_1175( oHandler );
    mCurrentState = oCho_0929_0931; // At: ( ReaderClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> Opening ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Tra_0929_0957( TsmHandler oHandler )
  {
    mCurrentState = oCom_0929_0932; // At: ( ReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> Stopping ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Tra_0929_0959( TsmHandler oHandler )
  {
    mCurrentState = oCom_0929_0932; // At: ( ReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> Closing ) => ( ReaderClientPsm >> Idle )
  public void Tra_0929_0960( TsmHandler oHandler )
  {
    mCurrentState = oLea_0929_0951; // At: ( ReaderClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( ReaderClientPsm >> Seeking ) => ( ReaderClientPsm >> CompoundState >> Reading )
  public void Tra_0929_0967( TsmHandler oHandler )
  {
    mCurrentState = oCom_0929_0932; // At: ( ReaderClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 958:
        return TsmProspect.OK;
      case 944:
        return TsmProspect.OK;
      case 945:
        return TsmProspect.OK;
      case 948:
        return TsmProspect.OK;
      case 961:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 927:
      switch ( Command )
      {
      case 1:
        return TsmProspect.OK;
      case 2:
        return TsmProspect.OK;
      case 3:
        return TsmProspect.OK;
      case 4:
        return TsmProspect.OK;
      case 5:
        return TsmProspect.OK;
      case 6:
        return TsmProspect.OK;
      case 7:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 956:
      Tra_0929_0956( oHandler );
      break;
    case 962:
      Tra_0929_0962( oHandler );
      break;
    case 963:
      Tra_0929_0963( oHandler );
      break;
    case 949:
      Tra_0933_0949( oHandler );
      break;
    case 958:
      Tra_0929_0958( oHandler );
      break;
    case 945:
      Tra_0933_0945( oHandler );
      break;
    case 961:
      Tra_0929_0961( oHandler );
      break;
    case 957:
      Tra_0929_0957( oHandler );
      break;
    case 959:
      Tra_0929_0959( oHandler );
      break;
    case 960:
      Tra_0929_0960( oHandler );
      break;
    case 967:
      Tra_0929_0967( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm )
class Fsm_0926_0928 extends TsmFsm
{
  private Reg_0928_0929 oReg_0928_0929; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm >)

  public Fsm_0926_0928( TsmBase oParent )
  {
    TsmName = "ReaderClientPsm";
    TsmParent = oParent;
    oReg_0928_0929 = new Reg_0928_0929( this );
    mRegions.add( oReg_0928_0929 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )
class Cla_0886_0926 extends TsmProtocolClass
{
  private Fsm_0926_0928 oFsm_0926_0928; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > ReaderClientPsm )
  private TsmIPort_IReaderServer Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
  private TsmIPort_IReaderClient TsmPI__Port; // ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient > Port )
  private TsmPCPort mPCMessager;
  private eRV RV = eRV.OK;
  private int FileHandle = 0;
  private tChunk Chunk = null;

  public Cla_0886_0926( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_0926_0928 = new Fsm_0926_0928( this );
    TsmPI__Port = new TsmIPort_IReaderClient( this );
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_0926_0928;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IReaderServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > ReaderProtocol > ReaderClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_0926_0928.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1081()
  {
    return RV==eRV.OK;
  }

  public boolean Guard_1082()
  {
    return RV==eRV.OK;
  }

   // ( ReaderClientPsm >> CompoundState ) => ( ReaderClientPsm >> Stopping )
  public void Function_1171( TsmHandler oHandler )
  {
    Port.Stop();
  }

   // ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> Open )
  public void Function_1172( TsmHandler oHandler )
  {
    Port.Clear();
  }

   // ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> Closing )
  public void Function_1173( TsmHandler oHandler )
  {
    Port.Close();
  }

   // ( ReaderClientPsm >> CompoundState >> Open ) => ( ReaderClientPsm >> CompoundState >> ChoiceState )
  public void Function_1174( TsmHandler oHandler )
  {
    RV=Port.Read( Chunk );
  }

   // ( ReaderClientPsm >> Idle ) => ( ReaderClientPsm >> ChoiceState )
  public void Function_1175( TsmHandler oHandler )
  {
    RV=Port.Open( FileHandle );
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 927;
    TsmPI__Port.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_0926_0928.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > ReaderProtocol )
 ********************************************************************/

 // ( Xmi > Data > Protocols > ReaderProtocol )
class Pac_0800_0886 extends TsmPackage
{
  public Pac_0800_0886( TsmBase oParent )
  {
    TsmName = "ReaderProtocol";
    TsmParent = oParent;
  }
}

interface ITitlebaseServer
{
  public int OpenTitle( String TitleId );
  public void CloseTitle();
  public eRV SetTime( tTime AtTime );
  public tChunk GetChunk();
  public void ReportReadError( int BadSector );
  public void ReportSynclost( tTime BadTime );
  public eRV GetResult();
}

class TsmTrigger_ITitlebaseServer___OpenTitle extends TsmTrigger
{
  public String TitleId;
  public int _RetVal;

  public TsmTrigger_ITitlebaseServer___OpenTitle( String TitleId )
  {
    super( 55 );
    this.TitleId = TitleId;
  }
}

class TsmTrigger_ITitlebaseServer___CloseTitle extends TsmTrigger
{
  public TsmTrigger_ITitlebaseServer___CloseTitle()
  {
    super( 56 );
  }
}

class TsmTrigger_ITitlebaseServer___SetTime extends TsmTrigger
{
  public tTime AtTime;
  public eRV _RetVal;

  public TsmTrigger_ITitlebaseServer___SetTime( tTime AtTime )
  {
    super( 57 );
    this.AtTime = AtTime;
  }
}

class TsmTrigger_ITitlebaseServer___GetChunk extends TsmTrigger
{
  public tChunk _RetVal;

  public TsmTrigger_ITitlebaseServer___GetChunk()
  {
    super( 58 );
  }
}

class TsmTrigger_ITitlebaseServer___ReportReadError extends TsmTrigger
{
  public int BadSector;

  public TsmTrigger_ITitlebaseServer___ReportReadError( int BadSector )
  {
    super( 59 );
    this.BadSector = BadSector;
  }
}

class TsmTrigger_ITitlebaseServer___ReportSynclost extends TsmTrigger
{
  public tTime BadTime;

  public TsmTrigger_ITitlebaseServer___ReportSynclost( tTime BadTime )
  {
    super( 60 );
    this.BadTime = BadTime;
  }
}

class TsmTrigger_ITitlebaseServer___GetResult extends TsmTrigger
{
  public eRV _RetVal;

  public TsmTrigger_ITitlebaseServer___GetResult()
  {
    super( 61 );
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > ITitlebaseServer )
class TsmIPort_ITitlebaseServer extends TsmInterfacePort implements ITitlebaseServer
{
  public TsmIPort_ITitlebaseServer( TsmBase oParent )
  {
    TsmName = "ITitlebaseServer";
    TsmParent = oParent;
  }

  public int OpenTitle( String TitleId )
  {
    TsmTrigger_ITitlebaseServer___OpenTitle tt = new TsmTrigger_ITitlebaseServer___OpenTitle( TitleId );
    TsmRecorder.AddCall( "OpenTitle", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void CloseTitle()
  {
    TsmTrigger_ITitlebaseServer___CloseTitle tt = new TsmTrigger_ITitlebaseServer___CloseTitle();
    TsmRecorder.AddCall( "CloseTitle", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV SetTime( tTime AtTime )
  {
    TsmTrigger_ITitlebaseServer___SetTime tt = new TsmTrigger_ITitlebaseServer___SetTime( AtTime );
    TsmRecorder.AddCall( "SetTime", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public tChunk GetChunk()
  {
    TsmTrigger_ITitlebaseServer___GetChunk tt = new TsmTrigger_ITitlebaseServer___GetChunk();
    TsmRecorder.AddCall( "GetChunk", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void ReportReadError( int BadSector )
  {
    TsmTrigger_ITitlebaseServer___ReportReadError tt = new TsmTrigger_ITitlebaseServer___ReportReadError( BadSector );
    TsmRecorder.AddCall( "ReportReadError", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void ReportSynclost( tTime BadTime )
  {
    TsmTrigger_ITitlebaseServer___ReportSynclost tt = new TsmTrigger_ITitlebaseServer___ReportSynclost( BadTime );
    TsmRecorder.AddCall( "ReportSynclost", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV GetResult()
  {
    TsmTrigger_ITitlebaseServer___GetResult tt = new TsmTrigger_ITitlebaseServer___GetResult();
    TsmRecorder.AddCall( "GetResult", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> InitialState )
class Ini_1003_1004 extends TsmPseudo
{
  public Ini_1003_1004( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1027, "( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1027; // TRLS ( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1027: // UP: ( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> ChoiceState )
class Cho_1003_1005 extends TsmPseudo
{
  public Cho_1003_1005( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1029, "( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )" );
    mTransitions[ 1 ] = new TsmTransition( 1030, "( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0968_1000)oHandler.Owner).Guard_1099() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1029; // TRLS ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1030; // TRLS ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_1003_1028( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1029: // UP: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )
      bHigher = true;
      break;
    case 1030: // UP: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    case 1028:
      Tra_1003_1028( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
class Cho_1007_1008 extends TsmPseudo
{
  public Cho_1007_1008( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1025, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
    mTransitions[ 1 ] = new TsmTransition( 1014, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0968_1000)oHandler.Owner).Guard_1100() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1025; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1014; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_1007_1016( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1025: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 1014: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
      bHigher = true;
      break;
    case 1016:
      Tra_1007_1016( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
class Cho_1007_1009 extends TsmPseudo
{
  public Cho_1007_1009( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1020, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 1021, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0968_1000)oHandler.Owner).Guard_1101() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1020; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1021; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_1007_1019( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1020: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
      bHigher = true;
      break;
    case 1021: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    case 1019:
      Tra_1007_1019( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
class Cho_1007_1010 extends TsmPseudo
{
  public Cho_1007_1010( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1024, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
    mTransitions[ 1 ] = new TsmTransition( 1023, "( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_0968_1000)oHandler.Owner).Guard_1102() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1024; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1023; // TRLS ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_1007_1022( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1024: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 1023: // UP: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
      bHigher = true;
      break;
    case 1022:
      Tra_1007_1022( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Play )
class Lea_1007_1011 extends TsmLeaf
{
  int [] aNatives = { -1015, -1016, -1018 };

  public Lea_1007_1011( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 3;
    mTransitions = new TsmTransition[ 3 ];
    mTransitions[ 0 ] = new TsmTransition( 1015, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )" );
    mTransitions[ 1 ] = new TsmTransition( 1016, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
    mTransitions[ 2 ] = new TsmTransition( 1018, "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )" );
  }

  public void Tra_1007_1014( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1007_1020( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1007_1015( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0968_1000)oHandler.Owner).Function_1177( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  public void Tra_1007_1018( TsmHandler oHandler )
  {
    AtExit( oHandler );
    ((Cla_0968_1000)oHandler.Owner).Function_1179( oHandler );
    AtEntry( oHandler );
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.INITIAL;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1015:
        return TsmProspect.OK;
      case 1016:
        return TsmProspect.OK;
      case 1018:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1015: // Native: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play ) # ReportReadError( BadSector );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1015;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 1016: // Native: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState ) # Chunk=GetChunk();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1016;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      case 1018: // Native: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play ) # ReportSynclost( BadTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1018;
        oHandler.bTaken = true;
        mTransitions[ 2 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1014:
      Tra_1007_1014( oHandler );
      break;
    case 1020:
      Tra_1007_1020( oHandler );
      break;
    case 1015:
      Tra_1007_1015( oHandler );
      break;
    case 1016: // UP: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1018:
      Tra_1007_1018( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Ready )
class Lea_1007_1012 extends TsmLeaf
{
  int [] aNatives = { -1019 };

  public Lea_1007_1012( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1019, "( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
  }

  public void Tra_1003_1030( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1007_1021( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1019:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1019: // Native: ( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState ) # RV=SetTime( AtTime );" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1019;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1030:
      Tra_1003_1030( oHandler );
      break;
    case 1021:
      Tra_1007_1021( oHandler );
      break;
    case 1019: // UP: ( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> End )
class Lea_1007_1013 extends TsmLeaf
{
  int [] aNatives = { -1022 };

  public Lea_1007_1013( TsmBase oParent )
  {
    TsmName = "End";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1022, "( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )" );
  }

  public void Tra_1007_1025( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1007_1024( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1007_1023( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1022:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1022: // Native: ( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState ) # RV=GetResult();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1022;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1025:
      Tra_1007_1025( oHandler );
      break;
    case 1024:
      Tra_1007_1024( oHandler );
      break;
    case 1023:
      Tra_1007_1023( oHandler );
      break;
    case 1022: // UP: ( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >)
class Reg_1006_1007 extends TsmRegion
{
  private Cho_1007_1008 oCho_1007_1008; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  private Cho_1007_1009 oCho_1007_1009; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  private Cho_1007_1010 oCho_1007_1010; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> ChoiceState )
  private Lea_1007_1011 oLea_1007_1011; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Play )
  private Lea_1007_1012 oLea_1007_1012; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> Ready )
  private Lea_1007_1013 oLea_1007_1013; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >> End )

  public Reg_1006_1007( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_1007_1008 = new Cho_1007_1008( this );
    oCho_1007_1009 = new Cho_1007_1009( this );
    oCho_1007_1010 = new Cho_1007_1010( this );
    oLea_1007_1011 = new Lea_1007_1011( this );
    oLea_1007_1012 = new Lea_1007_1012( this );
    oLea_1007_1013 = new Lea_1007_1013( this );
    mNrStates = 6;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_1007_1008;
    mStates[ 1 ] = oCho_1007_1009;
    mStates[ 2 ] = oCho_1007_1010;
    mStates[ 3 ] = oLea_1007_1011;
    mStates[ 4 ] = oLea_1007_1012;
    mStates[ 5 ] = oLea_1007_1013;
  }

   // Down: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
  public void Tra_1003_1030( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1012; // Down: ( TbClientPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
  public void Tra_1007_1025( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1013; // At: ( TbClientPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
  public void Tra_1007_1014( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1011; // At: ( TbClientPsm >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Play )
  public void Tra_1007_1020( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1011; // At: ( TbClientPsm >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
  public void Tra_1007_1021( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1012; // At: ( TbClientPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
  public void Tra_1007_1024( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1013; // At: ( TbClientPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> ChoiceState ) => ( TbClientPsm >> CompoundState >> End )
  public void Tra_1007_1023( TsmHandler oHandler )
  {
    mCurrentState = oLea_1007_1013; // At: ( TbClientPsm >> CompoundState >> End )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Tra_1007_1016( TsmHandler oHandler )
  {
    ((Cla_0968_1000)oHandler.Owner).Function_1178( oHandler );
    mCurrentState = oCho_1007_1008; // At: ( TbClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Tra_1007_1019( TsmHandler oHandler )
  {
    ((Cla_0968_1000)oHandler.Owner).Function_1180( oHandler );
    mCurrentState = oCho_1007_1009; // At: ( TbClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Tra_1007_1022( TsmHandler oHandler )
  {
    ((Cla_0968_1000)oHandler.Owner).Function_1181( oHandler );
    mCurrentState = oCho_1007_1010; // At: ( TbClientPsm >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1015:
        return TsmProspect.OK;
      case 1016:
        return TsmProspect.OK;
      case 1018:
        return TsmProspect.OK;
      case 1019:
        return TsmProspect.OK;
      case 1022:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1030:
      Tra_1003_1030( oHandler );
      break;
    case 1025:
      Tra_1007_1025( oHandler );
      break;
    case 1014:
      Tra_1007_1014( oHandler );
      break;
    case 1020:
      Tra_1007_1020( oHandler );
      break;
    case 1021:
      Tra_1007_1021( oHandler );
      break;
    case 1024:
      Tra_1007_1024( oHandler );
      break;
    case 1023:
      Tra_1007_1023( oHandler );
      break;
    case 1016:
      Tra_1007_1016( oHandler );
      break;
    case 1019:
      Tra_1007_1019( oHandler );
      break;
    case 1022:
      Tra_1007_1022( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState )
class Com_1003_1006 extends TsmCompound
{
  int [] aNatives = { -1017 };
  private Reg_1006_1007 oReg_1006_1007; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState >)

  public Com_1003_1006( TsmBase oParent )
  {
    TsmName = "CS_1006";
    TsmParent = oParent;
    oReg_1006_1007 = new Reg_1006_1007( this );
    mRegions.add( oReg_1006_1007 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1017, "( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )" );
  }

  public void Tra_1003_1030( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_1006_1007.ExecuteHandler( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1017:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1017: // Native: ( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )
        TsmRecorder.AddNative( "( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle ) # CloseTitle();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1017;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1030:
      Tra_1003_1030( oHandler );
      break;
    case 1017: // UP: ( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> Idle )
class Lea_1003_1026 extends TsmLeaf
{
  int [] aNatives = { -1028 };

  public Lea_1003_1026( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1028, "( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )" );
  }

  public void Tra_1003_1027( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1003_1029( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1007_1017( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1028:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1028: // Native: ( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )
        TsmRecorder.AddNative( "( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState ) # FileHandle=OpenTitle(TitleId);" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1028;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1027:
      Tra_1003_1027( oHandler );
      break;
    case 1029:
      Tra_1003_1029( oHandler );
      break;
    case 1017:
      Tra_1007_1017( oHandler );
      break;
    case 1028: // UP: ( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >)
class Reg_1002_1003 extends TsmRegion
{
  private Ini_1003_1004 oIni_1003_1004; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> InitialState )
  private Cho_1003_1005 oCho_1003_1005; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> ChoiceState )
  private Com_1003_1006 oCom_1003_1006; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> CompoundState )
  private Lea_1003_1026 oLea_1003_1026; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >> Idle )

  public Reg_1002_1003( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_1003_1004 = new Ini_1003_1004( this );
    oCho_1003_1005 = new Cho_1003_1005( this );
    oCom_1003_1006 = new Com_1003_1006( this );
    oLea_1003_1026 = new Lea_1003_1026( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_1003_1004;
    mStates[ 1 ] = oCho_1003_1005;
    mStates[ 2 ] = oCom_1003_1006;
    mStates[ 3 ] = oLea_1003_1026;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_1003_1004.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> InitialState ) => ( TbClientPsm >> Idle )
  public void Tra_1003_1027( TsmHandler oHandler )
  {
    mCurrentState = oLea_1003_1026; // At: ( TbClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> Idle )
  public void Tra_1003_1029( TsmHandler oHandler )
  {
    mCurrentState = oLea_1003_1026; // At: ( TbClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> ChoiceState ) => ( TbClientPsm >> CompoundState >> Ready )
  public void Tra_1003_1030( TsmHandler oHandler )
  {
    mCurrentState = oCom_1003_1006; // At: ( TbClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )
  public void Tra_1007_1017( TsmHandler oHandler )
  {
    ((Cla_0968_1000)oHandler.Owner).Function_1176( oHandler );
    mCurrentState = oLea_1003_1026; // At: ( TbClientPsm >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )
  public void Tra_1003_1028( TsmHandler oHandler )
  {
    ((Cla_0968_1000)oHandler.Owner).Function_1182( oHandler );
    mCurrentState = oCho_1003_1005; // At: ( TbClientPsm >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1017:
        return TsmProspect.OK;
      case 1015:
        return TsmProspect.OK;
      case 1016:
        return TsmProspect.OK;
      case 1018:
        return TsmProspect.OK;
      case 1019:
        return TsmProspect.OK;
      case 1022:
        return TsmProspect.OK;
      case 1028:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1027:
      Tra_1003_1027( oHandler );
      break;
    case 1029:
      Tra_1003_1029( oHandler );
      break;
    case 1030:
      Tra_1003_1030( oHandler );
      break;
    case 1017:
      Tra_1007_1017( oHandler );
      break;
    case 1028:
      Tra_1003_1028( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm )
class Fsm_1000_1002 extends TsmFsm
{
  private Reg_1002_1003 oReg_1002_1003; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm >)

  public Fsm_1000_1002( TsmBase oParent )
  {
    TsmName = "TbClientPsm";
    TsmParent = oParent;
    oReg_1002_1003 = new Reg_1002_1003( this );
    mRegions.add( oReg_1002_1003 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient )
class Cla_0968_1000 extends TsmProtocolClass
{
  private Fsm_1000_1002 oFsm_1000_1002; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > TbClientPsm )
  private TsmIPort_ITitlebaseServer Port; // ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient > Port )
  private eRV RV = eRV.OK;
  private int FileHandle = 0;
  private tChunk Chunk = null;
  private String TitleId = null;
  private tTime AtTime = null;
  private int BadSector = 0;
  private tTime BadTime = null;

  public Cla_0968_1000( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_1000_1002 = new Fsm_1000_1002( this );
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_1000_1002;
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_ITitlebaseServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > TitlebaseProtocol > TitlebaseClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_1000_1002.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1099()
  {
    return FileHandle == 0;
  }

  public boolean Guard_1100()
  {
    return Chunk == null;
  }

  public boolean Guard_1101()
  {
    return RV==eRV.OK;
  }

  public boolean Guard_1102()
  {
    return RV==eRV.NO_RESOURCE;
  }

   // ( TbClientPsm >> CompoundState ) => ( TbClientPsm >> Idle )
  public void Function_1176( TsmHandler oHandler )
  {
    Port.CloseTitle();
  }

   // ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )
  public void Function_1177( TsmHandler oHandler )
  {
    Port.ReportReadError( BadSector );
  }

   // ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Function_1178( TsmHandler oHandler )
  {
    Chunk=Port.GetChunk();
  }

   // ( TbClientPsm >> CompoundState >> Play ) => ( TbClientPsm >> CompoundState >> Play )
  public void Function_1179( TsmHandler oHandler )
  {
    Port.ReportSynclost( BadTime );
  }

   // ( TbClientPsm >> CompoundState >> Ready ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Function_1180( TsmHandler oHandler )
  {
    RV=Port.SetTime( AtTime );
  }

   // ( TbClientPsm >> CompoundState >> End ) => ( TbClientPsm >> CompoundState >> ChoiceState )
  public void Function_1181( TsmHandler oHandler )
  {
    RV=Port.GetResult();
  }

   // ( TbClientPsm >> Idle ) => ( TbClientPsm >> ChoiceState )
  public void Function_1182( TsmHandler oHandler )
  {
    FileHandle=Port.OpenTitle(TitleId);
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_1000_1002.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > TitlebaseProtocol )
 ********************************************************************/

 // ( Xmi > Data > Protocols > TitlebaseProtocol )
class Pac_0800_0968 extends TsmPackage
{
  public Pac_0800_0968( TsmBase oParent )
  {
    TsmName = "TitlebaseProtocol";
    TsmParent = oParent;
  }
}

interface IDisplayClient
{
  public void CbPrepared();
  public void CbStarted();
  public void CbPaused();
  public void CbContinued();
  public void CbFinished();
  public void CbSynclost( tTime BadTime );
  public void CbStopped();
}

class TsmTrigger_IDisplayClient___CbPrepared extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbPrepared()
  {
    super( 37 );
  }
}

class TsmTrigger_IDisplayClient___CbStarted extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbStarted()
  {
    super( 38 );
  }
}

class TsmTrigger_IDisplayClient___CbPaused extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbPaused()
  {
    super( 39 );
  }
}

class TsmTrigger_IDisplayClient___CbContinued extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbContinued()
  {
    super( 40 );
  }
}

class TsmTrigger_IDisplayClient___CbFinished extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbFinished()
  {
    super( 41 );
  }
}

class TsmTrigger_IDisplayClient___CbSynclost extends TsmTrigger
{
  public tTime BadTime;

  public TsmTrigger_IDisplayClient___CbSynclost( tTime BadTime )
  {
    super( 42 );
    this.BadTime = BadTime;
  }
}

class TsmTrigger_IDisplayClient___CbStopped extends TsmTrigger
{
  public TsmTrigger_IDisplayClient___CbStopped()
  {
    super( 43 );
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > IDisplayClient )
class TsmIPort_IDisplayClient extends TsmInterfacePort implements IDisplayClient
{
  public TsmIPort_IDisplayClient( TsmBase oParent )
  {
    TsmName = "IDisplayClient";
    TsmParent = oParent;
  }

  public void CbPrepared()
  {
    TsmTrigger_IDisplayClient___CbPrepared tt = new TsmTrigger_IDisplayClient___CbPrepared();
    TsmRecorder.AddCall( "CbPrepared", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbStarted()
  {
    TsmTrigger_IDisplayClient___CbStarted tt = new TsmTrigger_IDisplayClient___CbStarted();
    TsmRecorder.AddCall( "CbStarted", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbPaused()
  {
    TsmTrigger_IDisplayClient___CbPaused tt = new TsmTrigger_IDisplayClient___CbPaused();
    TsmRecorder.AddCall( "CbPaused", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbContinued()
  {
    TsmTrigger_IDisplayClient___CbContinued tt = new TsmTrigger_IDisplayClient___CbContinued();
    TsmRecorder.AddCall( "CbContinued", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbFinished()
  {
    TsmTrigger_IDisplayClient___CbFinished tt = new TsmTrigger_IDisplayClient___CbFinished();
    TsmRecorder.AddCall( "CbFinished", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbSynclost( tTime BadTime )
  {
    TsmTrigger_IDisplayClient___CbSynclost tt = new TsmTrigger_IDisplayClient___CbSynclost( BadTime );
    TsmRecorder.AddCall( "CbSynclost", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void CbStopped()
  {
    TsmTrigger_IDisplayClient___CbStopped tt = new TsmTrigger_IDisplayClient___CbStopped();
    TsmRecorder.AddCall( "CbStopped", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

interface IDisplayServer
{
  public void Prepare();
  public void Start();
  public eRV Pause();
  public void Continue();
  public void Stop();
}

class TsmTrigger_IDisplayServer___Prepare extends TsmTrigger
{
  public TsmTrigger_IDisplayServer___Prepare()
  {
    super( 62 );
  }
}

class TsmTrigger_IDisplayServer___Start extends TsmTrigger
{
  public TsmTrigger_IDisplayServer___Start()
  {
    super( 63 );
  }
}

class TsmTrigger_IDisplayServer___Pause extends TsmTrigger
{
  public eRV _RetVal;

  public TsmTrigger_IDisplayServer___Pause()
  {
    super( 64 );
  }
}

class TsmTrigger_IDisplayServer___Continue extends TsmTrigger
{
  public TsmTrigger_IDisplayServer___Continue()
  {
    super( 65 );
  }
}

class TsmTrigger_IDisplayServer___Stop extends TsmTrigger
{
  public TsmTrigger_IDisplayServer___Stop()
  {
    super( 66 );
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > IDisplayServer )
class TsmIPort_IDisplayServer extends TsmInterfacePort implements IDisplayServer
{
  public TsmIPort_IDisplayServer( TsmBase oParent )
  {
    TsmName = "IDisplayServer";
    TsmParent = oParent;
  }

  public void Prepare()
  {
    TsmTrigger_IDisplayServer___Prepare tt = new TsmTrigger_IDisplayServer___Prepare();
    TsmRecorder.AddCall( "Prepare", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Start()
  {
    TsmTrigger_IDisplayServer___Start tt = new TsmTrigger_IDisplayServer___Start();
    TsmRecorder.AddCall( "Start", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public eRV Pause()
  {
    TsmTrigger_IDisplayServer___Pause tt = new TsmTrigger_IDisplayServer___Pause();
    TsmRecorder.AddCall( "Pause", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
    return tt._RetVal;
  }

  public void Continue()
  {
    TsmTrigger_IDisplayServer___Continue tt = new TsmTrigger_IDisplayServer___Continue();
    TsmRecorder.AddCall( "Continue", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }

  public void Stop()
  {
    TsmTrigger_IDisplayServer___Stop tt = new TsmTrigger_IDisplayServer___Stop();
    TsmRecorder.AddCall( "Stop", this.Source, this.Messager );
    tt.PortId = this.PortId;
    tt.IsForeign = (this.Source==null);
    this.Messager.Handle( tt );
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> InitialState )
class Ini_1035_1036 extends TsmPseudo
{
  public Ini_1035_1036( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1072, "( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1072; // TRLS ( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1072: // UP: ( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> InitialState )
class Ini_1038_1039 extends TsmPseudo
{
  public Ini_1038_1039( TsmBase oParent )
  {
    TsmName = "InitialState";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1059, "( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1059; // TRLS ( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1059: // UP: ( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
class Cho_1041_1042 extends TsmPseudo
{
  public Cho_1041_1042( TsmBase oParent )
  {
    TsmName = "ChoiceState";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1049, "( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )" );
    mTransitions[ 1 ] = new TsmTransition( 1050, "( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    if ( ((Cla_1031_1032)oHandler.Owner).Guard_1103() )
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1049; // TRLS ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
      mTransitions[ 0 ].bVisit = true;
    }
    else
    {
      oHandler.Action = TsmHandlerAction.TRANSITION;
      oHandler.Index  = 1050; // TRLS ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
      mTransitions[ 1 ].bVisit = true;
    }
  }

  public void Tra_1041_1046( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1049: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
      bHigher = true;
      break;
    case 1050: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    case 1046:
      Tra_1041_1046( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Play )
class Lea_1041_1043 extends TsmLeaf
{
  int [] aNatives = { -1046 };

  public Lea_1041_1043( TsmBase oParent )
  {
    TsmName = "Play";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1046, "( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )" );
  }

  public void Tra_1041_1050( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1067( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1041_1048( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1046:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1046: // Native: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) # RV=Pause();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1046;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1050:
      Tra_1041_1050( oHandler );
      break;
    case 1046: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1067:
      Tra_1038_1067( oHandler );
      break;
    case 1048:
      Tra_1041_1048( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
class Lea_1041_1044 extends TsmLeaf
{
  public Lea_1041_1044( TsmBase oParent )
  {
    TsmName = "Pausing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1047, "( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused ) : CbPaused" );
  }

  public void Tra_1041_1049( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1047; // CbPaused
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 39: // Port___CbPaused
        {
          Port___CbPaused( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1049:
      Tra_1041_1049( oHandler );
      break;
    case 1047: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
class Lea_1041_1045 extends TsmLeaf
{
  public Lea_1041_1045( TsmBase oParent )
  {
    TsmName = "Continuing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1048, "( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) : CbContinued" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1064( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1048; // CbContinued
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 40:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 40: // Port___CbContinued
        {
          Port___CbContinued( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1064:
      Tra_1038_1064( oHandler );
      break;
    case 1048: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >)
class Reg_1040_1041 extends TsmRegion
{
  private Cho_1041_1042 oCho_1041_1042; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  private Lea_1041_1043 oLea_1041_1043; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  private Lea_1041_1044 oLea_1041_1044; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  private Lea_1041_1045 oLea_1041_1045; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )

  public Reg_1040_1041( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oCho_1041_1042 = new Cho_1041_1042( this );
    oLea_1041_1043 = new Lea_1041_1043( this );
    oLea_1041_1044 = new Lea_1041_1044( this );
    oLea_1041_1045 = new Lea_1041_1045( this );
    mNrStates = 4;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oCho_1041_1042;
    mStates[ 1 ] = oLea_1041_1043;
    mStates[ 2 ] = oLea_1041_1044;
    mStates[ 3 ] = oLea_1041_1045;
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
  public void Tra_1041_1049( TsmHandler oHandler )
  {
    mCurrentState = oLea_1041_1044; // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_1041_1050( TsmHandler oHandler )
  {
    mCurrentState = oLea_1041_1043; // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Tra_1041_1046( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1184( oHandler );
    mCurrentState = oCho_1041_1042; // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  public void Tra_1038_1064( TsmHandler oHandler )
  {
    mCurrentState = oLea_1041_1045; // Down: ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // Down: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_1038_1067( TsmHandler oHandler )
  {
    mCurrentState = oLea_1041_1043; // Down: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_1041_1048( TsmHandler oHandler )
  {
    mCurrentState = oLea_1041_1043; // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1046:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1033:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1049:
      Tra_1041_1049( oHandler );
      break;
    case 1050:
      Tra_1041_1050( oHandler );
      break;
    case 1046:
      Tra_1041_1046( oHandler );
      break;
    case 1064:
      Tra_1038_1064( oHandler );
      break;
    case 1067:
      Tra_1038_1067( oHandler );
      break;
    case 1047: // Up: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
      mCurrentState = null;
      bHigher = true;
      break;
    case 1048:
      Tra_1041_1048( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState )
class Com_1038_1040 extends TsmCompound
{
  private Reg_1040_1041 oReg_1040_1041; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState >)

  public Com_1038_1040( TsmBase oParent )
  {
    TsmName = "CS_1040";
    TsmParent = oParent;
    oReg_1040_1041 = new Reg_1040_1041( this );
    mRegions.add( oReg_1040_1041 );
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1070, "( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Finishing ) : CbFinished" );
    mTransitions[ 1 ] = new TsmTransition( 1069, "( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
  }

  public void Tra_1038_1064( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_1040_1041.ExecuteHandler( oHandler );
  }

  public void Tra_1038_1067( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    oReg_1040_1041.ExecuteHandler( oHandler );
  }

  public void Port___CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1070; // CbFinished
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1069; // CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 41: // Port___CbFinished
        {
          Port___CbFinished( oHandler );
        }
        break;
      case 42: // Port___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          Port___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1064:
      Tra_1038_1064( oHandler );
      break;
    case 1067:
      Tra_1038_1067( oHandler );
      break;
    case 1047: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1070: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Finishing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1069: // UP: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Synclost )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Ready )
class Lea_1038_1051 extends TsmLeaf
{
  int [] aNatives = { -1060, -1061 };

  public Lea_1038_1051( TsmBase oParent )
  {
    TsmName = "Ready";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1060, "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )" );
    mTransitions[ 1 ] = new TsmTransition( 1061, "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1062( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1060:
        return TsmProspect.OK;
      case 1061:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1060: // Native: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting ) # Start();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1060;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      case 1061: // Native: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing ) # RV=Pause();#Tsm.Assert(RV==eRV.OK);" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1061;
        oHandler.bTaken = true;
        mTransitions[ 1 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1060: // UP: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1061: // UP: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1062:
      Tra_1038_1062( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Preparing )
class Lea_1038_1052 extends TsmLeaf
{
  public Lea_1038_1052( TsmBase oParent )
  {
    TsmName = "Preparing";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1062, "( DisplayClientPsm >> CompoundState >> Preparing ) => ( DisplayClientPsm >> CompoundState >> Ready ) : CbPrepared" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1063( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbPrepared( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1062; // CbPrepared
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 37: // Port___CbPrepared
        {
          Port___CbPrepared( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1063:
      Tra_1038_1063( oHandler );
      break;
    case 1062: // UP: ( DisplayClientPsm >> CompoundState >> Preparing ) => ( DisplayClientPsm >> CompoundState >> Ready )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Idle )
class Lea_1038_1053 extends TsmLeaf
{
  int [] aNatives = { -1063 };

  public Lea_1038_1053( TsmBase oParent )
  {
    TsmName = "Idle";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1063, "( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )" );
  }

  public void Tra_1038_1059( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1063:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1063: // Native: ( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing ) # Prepare();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1063;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1059:
      Tra_1038_1059( oHandler );
      break;
    case 1063: // UP: ( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )
      AtExit( oHandler );
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Finishing )
class Lea_1038_1054 extends TsmLeaf
{
  public Lea_1038_1054( TsmBase oParent )
  {
    TsmName = "Finishing";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1070( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1070:
      Tra_1038_1070( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Paused )
class Lea_1038_1055 extends TsmLeaf
{
  int [] aNatives = { -1064 };

  public Lea_1038_1055( TsmBase oParent )
  {
    TsmName = "Paused";
    TsmParent = oParent;
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1064, "( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1041_1047( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1038_1065( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1064:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1064: // Native: ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing ) # Continue();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1064;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1064: // UP: ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1047:
      Tra_1041_1047( oHandler );
      break;
    case 1065:
      Tra_1038_1065( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> StartPausing )
class Lea_1038_1056 extends TsmLeaf
{
  public Lea_1038_1056( TsmBase oParent )
  {
    TsmName = "StartPausing";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1065, "( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Paused ) : CbPaused" );
    mTransitions[ 1 ] = new TsmTransition( 1066, "( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1061( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1065; // CbPaused
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1066; // CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 39:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 39: // Port___CbPaused
        {
          Port___CbPaused( oHandler );
        }
        break;
      case 42: // Port___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          Port___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1061:
      Tra_1038_1061( oHandler );
      break;
    case 1065: // UP: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
      bHigher = true;
      break;
    case 1066: // UP: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Synclost )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Starting )
class Lea_1038_1057 extends TsmLeaf
{
  public Lea_1038_1057( TsmBase oParent )
  {
    TsmName = "Starting";
    TsmParent = oParent;
    mNrTransitions = 2;
    mTransitions = new TsmTransition[ 2 ];
    mTransitions[ 0 ] = new TsmTransition( 1067, "( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) : CbStarted" );
    mTransitions[ 1 ] = new TsmTransition( 1068, "( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> Synclost ) : CbSynclost" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1060( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Port___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1067; // CbStarted
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Port___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1068; // CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 38:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 38: // Port___CbStarted
        {
          Port___CbStarted( oHandler );
        }
        break;
      case 42: // Port___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          Port___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1060:
      Tra_1038_1060( oHandler );
      break;
    case 1067: // UP: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
      bHigher = true;
      break;
    case 1068: // UP: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> Synclost )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Synclost )
class Lea_1038_1058 extends TsmLeaf
{
  public Lea_1038_1058( TsmBase oParent )
  {
    TsmName = "Synclost";
    TsmParent = oParent;
    mNrTransitions = 0;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1038_1069( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1038_1066( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1038_1068( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1069:
      Tra_1038_1069( oHandler );
      break;
    case 1066:
      Tra_1038_1066( oHandler );
      break;
    case 1068:
      Tra_1038_1068( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >)
class Reg_1037_1038 extends TsmRegion
{
  private Ini_1038_1039 oIni_1038_1039; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> InitialState )
  private Com_1038_1040 oCom_1038_1040; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> CompoundState )
  private Lea_1038_1051 oLea_1038_1051; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Ready )
  private Lea_1038_1052 oLea_1038_1052; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Preparing )
  private Lea_1038_1053 oLea_1038_1053; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Idle )
  private Lea_1038_1054 oLea_1038_1054; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Finishing )
  private Lea_1038_1055 oLea_1038_1055; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Paused )
  private Lea_1038_1056 oLea_1038_1056; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> StartPausing )
  private Lea_1038_1057 oLea_1038_1057; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Starting )
  private Lea_1038_1058 oLea_1038_1058; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >> Synclost )

  public Reg_1037_1038( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_1038_1039 = new Ini_1038_1039( this );
    oCom_1038_1040 = new Com_1038_1040( this );
    oLea_1038_1051 = new Lea_1038_1051( this );
    oLea_1038_1052 = new Lea_1038_1052( this );
    oLea_1038_1053 = new Lea_1038_1053( this );
    oLea_1038_1054 = new Lea_1038_1054( this );
    oLea_1038_1055 = new Lea_1038_1055( this );
    oLea_1038_1056 = new Lea_1038_1056( this );
    oLea_1038_1057 = new Lea_1038_1057( this );
    oLea_1038_1058 = new Lea_1038_1058( this );
    mNrStates = 10;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_1038_1039;
    mStates[ 1 ] = oCom_1038_1040;
    mStates[ 2 ] = oLea_1038_1051;
    mStates[ 3 ] = oLea_1038_1052;
    mStates[ 4 ] = oLea_1038_1053;
    mStates[ 5 ] = oLea_1038_1054;
    mStates[ 6 ] = oLea_1038_1055;
    mStates[ 7 ] = oLea_1038_1056;
    mStates[ 8 ] = oLea_1038_1057;
    mStates[ 9 ] = oLea_1038_1058;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_1038_1039.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> InitialState ) => ( DisplayClientPsm >> CompoundState >> Idle )
  public void Tra_1038_1059( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1053; // At: ( DisplayClientPsm >> CompoundState >> Idle )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )
  public void Tra_1038_1060( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1185( oHandler );
    mCurrentState = oLea_1038_1057; // At: ( DisplayClientPsm >> CompoundState >> Starting )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )
  public void Tra_1038_1061( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1186( oHandler );
    mCurrentState = oLea_1038_1056; // At: ( DisplayClientPsm >> CompoundState >> StartPausing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )
  public void Tra_1038_1063( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1187( oHandler );
    mCurrentState = oLea_1038_1052; // At: ( DisplayClientPsm >> CompoundState >> Preparing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  public void Tra_1038_1064( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1188( oHandler );
    mCurrentState = oCom_1038_1040; // At: ( DisplayClientPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Preparing ) => ( DisplayClientPsm >> CompoundState >> Ready )
  public void Tra_1038_1062( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1051; // At: ( DisplayClientPsm >> CompoundState >> Ready )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Play )
  public void Tra_1038_1067( TsmHandler oHandler )
  {
    mCurrentState = oCom_1038_1040; // At: ( DisplayClientPsm >> CompoundState >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState >> Pausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
  public void Tra_1041_1047( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1055; // At: ( DisplayClientPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Paused )
  public void Tra_1038_1065( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1055; // At: ( DisplayClientPsm >> CompoundState >> Paused )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Finishing )
  public void Tra_1038_1070( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1054; // At: ( DisplayClientPsm >> CompoundState >> Finishing )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> CompoundState ) => ( DisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_1038_1069( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1058; // At: ( DisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> StartPausing ) => ( DisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_1038_1066( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1058; // At: ( DisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState >> Starting ) => ( DisplayClientPsm >> CompoundState >> Synclost )
  public void Tra_1038_1068( TsmHandler oHandler )
  {
    mCurrentState = oLea_1038_1058; // At: ( DisplayClientPsm >> CompoundState >> Synclost )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1046:
        return TsmProspect.OK;
      case 1060:
        return TsmProspect.OK;
      case 1061:
        return TsmProspect.OK;
      case 1063:
        return TsmProspect.OK;
      case 1064:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1033:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1059:
      Tra_1038_1059( oHandler );
      break;
    case 1060:
      Tra_1038_1060( oHandler );
      break;
    case 1061:
      Tra_1038_1061( oHandler );
      break;
    case 1063:
      Tra_1038_1063( oHandler );
      break;
    case 1064:
      Tra_1038_1064( oHandler );
      break;
    case 1062:
      Tra_1038_1062( oHandler );
      break;
    case 1067:
      Tra_1038_1067( oHandler );
      break;
    case 1047:
      Tra_1041_1047( oHandler );
      break;
    case 1065:
      Tra_1038_1065( oHandler );
      break;
    case 1070:
      Tra_1038_1070( oHandler );
      break;
    case 1069:
      Tra_1038_1069( oHandler );
      break;
    case 1066:
      Tra_1038_1066( oHandler );
      break;
    case 1068:
      Tra_1038_1068( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState )
class Com_1035_1037 extends TsmCompound
{
  int [] aNatives = { -1073 };
  private Reg_1037_1038 oReg_1037_1038; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState >)

  public Com_1035_1037( TsmBase oParent )
  {
    TsmName = "CS_1037";
    TsmParent = oParent;
    oReg_1037_1038 = new Reg_1037_1038( this );
    mRegions.add( oReg_1037_1038 );
    mNrTransitions = 1;
    mTransitions = new TsmTransition[ 1 ];
    mTransitions[ 0 ] = new TsmTransition( 1073, "( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )" );
  }

  public void Tra_1035_1072( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1035_1074( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
    TsmSupervisor.NativeEntry( oHandler.Owner, aNatives );
  }

  @Override
  public void AtMyExit( TsmHandler oHandler )
  {
    TsmSupervisor.NativeExit( oHandler.Owner, aNatives );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1073:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTriggerCompound( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case -1: // Port NativePort
      switch ( oHandler.Trigger.Command )
      {
      case 1073: // Native: ( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )
        TsmRecorder.AddNative( "( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping ) # Stop();" );
        oHandler.Action = TsmHandlerAction.TRANSITION;
        oHandler.Index  = 1073;
        oHandler.bTaken = true;
        mTransitions[ 0 ].bVisit = true;
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1072:
      Tra_1035_1072( oHandler );
      break;
    case 1073: // UP: ( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )
      AtExit( oHandler );
      bHigher = true;
      break;
    case 1074:
      Tra_1035_1074( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> Stopping )
class Lea_1035_1071 extends TsmLeaf
{
  public Lea_1035_1071( TsmBase oParent )
  {
    TsmName = "Stopping";
    TsmParent = oParent;
    mNrTransitions = 7;
    mTransitions = new TsmTransition[ 7 ];
    mTransitions[ 0 ] = new TsmTransition( 1075, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbPrepared" );
    mTransitions[ 1 ] = new TsmTransition( 1076, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbStarted" );
    mTransitions[ 2 ] = new TsmTransition( 1077, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbPaused" );
    mTransitions[ 3 ] = new TsmTransition( 1078, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbContinued" );
    mTransitions[ 4 ] = new TsmTransition( 1079, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbFinished" );
    mTransitions[ 5 ] = new TsmTransition( 1080, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> Stopping ) : CbSynclost" );
    mTransitions[ 6 ] = new TsmTransition( 1074, "( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> CompoundState ) : CbStopped" );
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Tra_1035_1073( TsmHandler oHandler )
  {
    AtEntry( oHandler );
    Initial( oHandler );
  }

  public void Tra_1035_1075( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbPrepared( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1075; // CbPrepared
    oHandler.bTaken = true;
    mTransitions[ 0 ].bVisit = true;
  }

  public void Tra_1035_1076( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbStarted( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1076; // CbStarted
    oHandler.bTaken = true;
    mTransitions[ 1 ].bVisit = true;
  }

  public void Tra_1035_1077( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbPaused( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1077; // CbPaused
    oHandler.bTaken = true;
    mTransitions[ 2 ].bVisit = true;
  }

  public void Tra_1035_1078( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbContinued( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1078; // CbContinued
    oHandler.bTaken = true;
    mTransitions[ 3 ].bVisit = true;
  }

  public void Tra_1035_1079( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbFinished( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1079; // CbFinished
    oHandler.bTaken = true;
    mTransitions[ 4 ].bVisit = true;
  }

  public void Tra_1035_1080( TsmHandler oHandler )
  {
    oHandler.bTaken = true;
    oHandler.Action = TsmHandlerAction.OK;
  }

  public void Port___CbSynclost( tTime BadTime, TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1080; // CbSynclost
    oHandler.bTaken = true;
    mTransitions[ 5 ].bVisit = true;
  }

  public void Port___CbStopped( TsmHandler oHandler )
  {
    oHandler.Action = TsmHandlerAction.TRANSITION;
    oHandler.Index  = 1074; // CbStopped
    oHandler.bTaken = true;
    mTransitions[ 6 ].bVisit = true;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case 1033:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      case 43:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public void ExecuteTrigger( TsmHandler oHandler )
  {
    switch ( oHandler.Trigger.PortId )
    {
    case 1033: // Port Port
      switch ( oHandler.Trigger.Command )
      {
      case 37: // Port___CbPrepared
        {
          Port___CbPrepared( oHandler );
        }
        break;
      case 38: // Port___CbStarted
        {
          Port___CbStarted( oHandler );
        }
        break;
      case 39: // Port___CbPaused
        {
          Port___CbPaused( oHandler );
        }
        break;
      case 40: // Port___CbContinued
        {
          Port___CbContinued( oHandler );
        }
        break;
      case 41: // Port___CbFinished
        {
          Port___CbFinished( oHandler );
        }
        break;
      case 42: // Port___CbSynclost
        {
          TsmTrigger_IDisplayClient___CbSynclost lTrigger = (TsmTrigger_IDisplayClient___CbSynclost) oHandler.Trigger;

          Port___CbSynclost( lTrigger.BadTime, oHandler );
        }
        break;
      case 43: // Port___CbStopped
        {
          Port___CbStopped( oHandler );
        }
        break;
      default:
        oHandler.Action = TsmHandlerAction.NOK;
        break;
      }
      break;
    default:
      oHandler.Action = TsmHandlerAction.NOK;
      break;
    }
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1073:
      Tra_1035_1073( oHandler );
      break;
    case 1075:
      Tra_1035_1075( oHandler );
      break;
    case 1076:
      Tra_1035_1076( oHandler );
      break;
    case 1077:
      Tra_1035_1077( oHandler );
      break;
    case 1078:
      Tra_1035_1078( oHandler );
      break;
    case 1079:
      Tra_1035_1079( oHandler );
      break;
    case 1080:
      Tra_1035_1080( oHandler );
      break;
    case 1074: // UP: ( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> CompoundState )
      bHigher = true;
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >)
class Reg_1034_1035 extends TsmRegion
{
  private Ini_1035_1036 oIni_1035_1036; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> InitialState )
  private Com_1035_1037 oCom_1035_1037; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> CompoundState )
  private Lea_1035_1071 oLea_1035_1071; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >> Stopping )

  public Reg_1034_1035( TsmBase oParent )
  {
    TsmName = "";
    TsmParent = oParent;
    oIni_1035_1036 = new Ini_1035_1036( this );
    oCom_1035_1037 = new Com_1035_1037( this );
    oLea_1035_1071 = new Lea_1035_1071( this );
    mNrStates = 3;
    mStates = new TsmState[ mNrStates ];
    mStates[ 0 ] = oIni_1035_1036;
    mStates[ 1 ] = oCom_1035_1037;
    mStates[ 2 ] = oLea_1035_1071;
  }

  @Override
  public void Initial( TsmHandler oHandler )
  {
    mbFinal = false;
    oHandler.Action = TsmHandlerAction.ENTER;
    oIni_1035_1036.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> InitialState ) => ( DisplayClientPsm >> CompoundState )
  public void Tra_1035_1072( TsmHandler oHandler )
  {
    mCurrentState = oCom_1035_1037; // At: ( DisplayClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )
  public void Tra_1035_1073( TsmHandler oHandler )
  {
    ((Cla_1031_1032)oHandler.Owner).Function_1183( oHandler );
    mCurrentState = oLea_1035_1071; // At: ( DisplayClientPsm >> Stopping )
    mCurrentState.ExecuteHandler( oHandler );
  }

   // At: ( DisplayClientPsm >> Stopping ) => ( DisplayClientPsm >> CompoundState )
  public void Tra_1035_1074( TsmHandler oHandler )
  {
    mCurrentState = oCom_1035_1037; // At: ( DisplayClientPsm >> CompoundState )
    mCurrentState.ExecuteHandler( oHandler );
  }

  @Override
  public int GetProspect( int PortId, int Command )
  {
    switch ( PortId )
    {
    case -1:
      switch ( Command )
      {
      case 1073:
        return TsmProspect.OK;
      case 1046:
        return TsmProspect.OK;
      case 1060:
        return TsmProspect.OK;
      case 1061:
        return TsmProspect.OK;
      case 1063:
        return TsmProspect.OK;
      case 1064:
        return TsmProspect.OK;
      default:
        break;
      }
      break; // end of Port -1
    case 1033:
      switch ( Command )
      {
      case 37:
        return TsmProspect.OK;
      case 38:
        return TsmProspect.OK;
      case 39:
        return TsmProspect.OK;
      case 40:
        return TsmProspect.OK;
      case 41:
        return TsmProspect.OK;
      case 42:
        return TsmProspect.OK;
      case 43:
        return TsmProspect.OK;
      default:
        break;
      }
      break;
    default:
      break;
    }

    return TsmProspect.NOK;
  }

  @Override
  public boolean ExecuteTransition( TsmHandler oHandler )
  {
    boolean bHigher = false;
    switch ( oHandler.Index )
    {
    case 1072:
      Tra_1035_1072( oHandler );
      break;
    case 1073:
      Tra_1035_1073( oHandler );
      break;
    case 1074:
      Tra_1035_1074( oHandler );
      break;
    default:
      throw new TsmException( "Unknown Index " + oHandler.Index );
    }
    return bHigher;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm )
class Fsm_1032_1034 extends TsmFsm
{
  private Reg_1034_1035 oReg_1034_1035; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm >)

  public Fsm_1032_1034( TsmBase oParent )
  {
    TsmName = "DisplayClientPsm";
    TsmParent = oParent;
    oReg_1034_1035 = new Reg_1034_1035( this );
    mRegions.add( oReg_1034_1035 );
    mNrTransitions = 0;
  }

  @Override
  public void AtEntry( TsmHandler oHandler )
  {
    bVisit = true;
  }
}

 // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )
class Cla_1031_1032 extends TsmProtocolClass
{
  private Fsm_1032_1034 oFsm_1032_1034; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > DisplayClientPsm )
  private TsmIPort_IDisplayServer Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
  private TsmIPort_IDisplayClient TsmPI__Port; // ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient > Port )
  private TsmPCPort mPCMessager;
  private eRV RV = eRV.OK;

  public Cla_1031_1032( TsmBase oParent, String sInstanceName )
  {
    TsmName = sInstanceName;
    TsmParent = oParent;
    oFsm_1032_1034 = new Fsm_1032_1034( this );
    TsmPI__Port = new TsmIPort_IDisplayClient( this );
    mPCMessager = new TsmPCPort();
    oFsms = new TsmFsm[ 1 ];
    oFsms[ 0 ] = oFsm_1032_1034;
  }

  @Override
  public TsmInterfacePort GetProvidedInterface( String sPortName )
  {
    if ( sPortName.equals( "Port" ) )
    {
      return TsmPI__Port;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )";
    throw new TsmException( s );
  }

  @Override
  public void SetRequiredInterface( String sPortName, TsmInterfacePort oProvidedInterface )
  {
    if ( sPortName.equals( "Port" ) )
    {
      Port = (TsmIPort_IDisplayServer) oProvidedInterface;
      Port.Source = this;
      return;
    }
    String s;
    s = "No port '" + sPortName + "' @ ( Xmi > Data > Protocols > DisplayProtocol > DisplayClient )";
    throw new TsmException( s );
  }

  @Override
  public void ExecuteTrigger( TsmTrigger oTrigger )
  {
    SnapCall = oTrigger.Snap();
    TsmHandler lHandler = new TsmHandler( this, oTrigger );
    oFsm_1032_1034.ExecuteTriggerFsm( lHandler );
    SnapCall = "";
    SnapState = null;
  }

  public boolean Guard_1103()
  {
    return RV==eRV.OK;
  }

   // ( DisplayClientPsm >> CompoundState ) => ( DisplayClientPsm >> Stopping )
  public void Function_1183( TsmHandler oHandler )
  {
    Port.Stop();
  }

   // ( DisplayClientPsm >> CompoundState >> CompoundState >> Play ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> ChoiceState )
  public void Function_1184( TsmHandler oHandler )
  {
    RV=Port.Pause();
  }

   // ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> Starting )
  public void Function_1185( TsmHandler oHandler )
  {
    Port.Start();
  }

   // ( DisplayClientPsm >> CompoundState >> Ready ) => ( DisplayClientPsm >> CompoundState >> StartPausing )
  public void Function_1186( TsmHandler oHandler )
  {
    RV=Port.Pause();
    Tsm.Assert(RV==eRV.OK);
  }

   // ( DisplayClientPsm >> CompoundState >> Idle ) => ( DisplayClientPsm >> CompoundState >> Preparing )
  public void Function_1187( TsmHandler oHandler )
  {
    Port.Prepare();
  }

   // ( DisplayClientPsm >> CompoundState >> Paused ) => ( DisplayClientPsm >> CompoundState >> CompoundState >> Continuing )
  public void Function_1188( TsmHandler oHandler )
  {
    Port.Continue();
  }

  @Override
  public void TsmInitialise( Object oObject )
  {
    TsmPI__Port.PortId = 1033;
    TsmPI__Port.Messager = mPCMessager;
  }

  @Override
  public void TsmConnect( Object oObject )
  {
    mPCMessager.Target = this;
    mPCMessager.setIntQueue( (TsmIntQueue) oObject );
  }

  @Override
  public void TsmPrepare( Object oObject )
  {
    TsmHandler lHandler = new TsmHandler( this );
    lHandler.Action = TsmHandlerAction.ENTER;
    oFsm_1032_1034.ExecuteHandler( lHandler );
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > DisplayProtocol )
 ********************************************************************/

 // ( Xmi > Data > Protocols > DisplayProtocol )
class Pac_0800_1031 extends TsmPackage
{
  public Pac_0800_1031( TsmBase oParent )
  {
    TsmName = "DisplayProtocol";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols )
 ********************************************************************/

 // ( Xmi > Data > Protocols )
class Pac_0001_0800 extends TsmPackage
{
  public Pac_0001_0800( TsmBase oParent )
  {
    TsmName = "Protocols";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > TypeDefinitions )
 ********************************************************************/

 // ( Xmi > Data > TypeDefinitions )
class Pac_0001_1123 extends TsmPackage
{
  public Pac_0001_1123( TsmBase oParent )
  {
    TsmName = "TypeDefinitions";
    TsmParent = oParent;
  }
}

/********************************************************************
 * PACKAGE: ( Xmi > Data > TismStereotypes )
 ********************************************************************/

 // ( Xmi > Data > TismStereotypes )
class Pac_0001_1124 extends TsmPackage
{
  public Pac_0001_1124( TsmBase oParent )
  {
    TsmName = "TismStereotypes";
    TsmParent = oParent;
  }
}

 // ( Xmi )
public class TsmSystem extends TsmExecComponent
{
  private Com_0792_0793 ExEnv; // ( Xmi > Data > Architecture > ExEnv )

  public TsmSystem( TsmBase oParent )
  {
    TsmName = "Xmi";
    TsmParent = oParent;
    mNrComponents = 1;
    mComponents = new TsmComponent[ 1 ];
    ExEnv = new Com_0792_0793( null, "ExEnv" );
    mComponents[ 0 ] = ExEnv;
  }
}

